/* UserGame.c generated by valac 0.54.8, the Vala compiler
 * generated from UserGame.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <sqlite3.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;
typedef struct _GameHubDataRunnablePrivate GameHubDataRunnablePrivate;
typedef enum  {
	GAME_HUB_DATA_PLATFORM_LINUX,
	GAME_HUB_DATA_PLATFORM_WINDOWS,
	GAME_HUB_DATA_PLATFORM_MACOS,
	GAME_HUB_DATA_PLATFORM_EMULATED
} GameHubDataPlatform;

#define GAME_HUB_DATA_TYPE_PLATFORM (game_hub_data_platform_get_type ())
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD
} GameHubDataRunnableInstallerInstallMode;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALL_MODE (game_hub_data_runnable_installer_install_mode_get_type ())

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;
typedef struct _GameHubDataGamePrivate GameHubDataGamePrivate;

#define GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT (game_hub_data_game_achievement_get_type ())
#define GAME_HUB_DATA_GAME_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievement))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))

typedef struct _GameHubDataGameAchievement GameHubDataGameAchievement;
typedef struct _GameHubDataGameAchievementClass GameHubDataGameAchievementClass;

#define GAME_HUB_DATA_GAME_TYPE_STATUS (game_hub_data_game_status_get_type ())
#define GAME_HUB_DATA_GAME_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatus))
#define GAME_HUB_DATA_GAME_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))
#define GAME_HUB_DATA_GAME_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))

typedef struct _GameHubDataGameStatus GameHubDataGameStatus;
typedef struct _GameHubDataGameStatusClass GameHubDataGameStatusClass;

#define GAME_HUB_DATA_GAME_TYPE_OVERLAY (game_hub_data_game_overlay_get_type ())
#define GAME_HUB_DATA_GAME_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay))
#define GAME_HUB_DATA_GAME_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))
#define GAME_HUB_DATA_GAME_IS_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_IS_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))

typedef struct _GameHubDataGameOverlay GameHubDataGameOverlay;
typedef struct _GameHubDataGameOverlayClass GameHubDataGameOverlayClass;

#define GAME_HUB_DATA_TYPE_TWEAKABLE_GAME (game_hub_data_tweakable_game_get_type ())
#define GAME_HUB_DATA_TWEAKABLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_TWEAKABLE_GAME, GameHubDataTweakableGame))
#define GAME_HUB_DATA_IS_TWEAKABLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_TWEAKABLE_GAME))
#define GAME_HUB_DATA_TWEAKABLE_GAME_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GAME_HUB_DATA_TYPE_TWEAKABLE_GAME, GameHubDataTweakableGameIface))

typedef struct _GameHubDataTweakableGame GameHubDataTweakableGame;
typedef struct _GameHubDataTweakableGameIface GameHubDataTweakableGameIface;

#define GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME (game_hub_data_sources_user_user_game_get_type ())
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGame))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGameClass))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGameClass))

typedef struct _GameHubDataSourcesUserUserGame GameHubDataSourcesUserUserGame;
typedef struct _GameHubDataSourcesUserUserGameClass GameHubDataSourcesUserUserGameClass;
typedef struct _GameHubDataSourcesUserUserGamePrivate GameHubDataSourcesUserUserGamePrivate;

#define GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER (game_hub_data_runnable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))

typedef struct _GameHubDataRunnableInstaller GameHubDataRunnableInstaller;
typedef struct _GameHubDataRunnableInstallerClass GameHubDataRunnableInstallerClass;

#define GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER (game_hub_data_runnable_file_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, GameHubDataRunnableFileInstaller))
#define GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, GameHubDataRunnableFileInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_FILE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_FILE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, GameHubDataRunnableFileInstallerClass))

typedef struct _GameHubDataRunnableFileInstaller GameHubDataRunnableFileInstaller;
typedef struct _GameHubDataRunnableFileInstallerClass GameHubDataRunnableFileInstallerClass;

#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER (game_hub_data_sources_user_user_game_installer_get_type ())
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstaller))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstallerClass))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER))
#define GAME_HUB_DATA_SOURCES_USER_USER_GAME_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstallerClass))

typedef struct _GameHubDataSourcesUserUserGameInstaller GameHubDataSourcesUserUserGameInstaller;
typedef struct _GameHubDataSourcesUserUserGameInstallerClass GameHubDataSourcesUserUserGameInstallerClass;
enum  {
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_0_PROPERTY,
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_TWEAKS_PROPERTY,
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_sources_user_user_game_properties[GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_PROPERTIES];
#define _game_hub_data_runnable_installer_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_installer_unref (var), NULL)))

#define GAME_HUB_DATA_TYPE_GAME_SOURCE (game_hub_data_game_source_get_type ())
#define GAME_HUB_DATA_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSource))
#define GAME_HUB_DATA_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))
#define GAME_HUB_DATA_IS_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_IS_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_GAME_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))

typedef struct _GameHubDataGameSource GameHubDataGameSource;
typedef struct _GameHubDataGameSourceClass GameHubDataGameSourceClass;

#define GAME_HUB_DATA_SOURCES_USER_TYPE_USER (game_hub_data_sources_user_user_get_type ())
#define GAME_HUB_DATA_SOURCES_USER_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUser))
#define GAME_HUB_DATA_SOURCES_USER_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUserClass))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER))
#define GAME_HUB_DATA_SOURCES_USER_IS_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_USER_TYPE_USER))
#define GAME_HUB_DATA_SOURCES_USER_USER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUserClass))

typedef struct _GameHubDataSourcesUserUser GameHubDataSourcesUserUser;
typedef struct _GameHubDataSourcesUserUserClass GameHubDataSourcesUserUserClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

#define GAME_HUB_DATA_DB_TABLE_TYPE_FIELD (game_hub_data_db_table_field_get_type ())
#define GAME_HUB_DATA_DB_TABLE_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableField))
#define GAME_HUB_DATA_DB_TABLE_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))

typedef struct _GameHubDataDBTableField GameHubDataDBTableField;
typedef struct _GameHubDataDBTableFieldClass GameHubDataDBTableFieldClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG (game_hub_data_db_tables_tags_tag_get_type ())
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTag))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))

typedef struct _GameHubDataDBTablesTagsTag GameHubDataDBTablesTagsTag;
typedef struct _GameHubDataDBTablesTagsTagClass GameHubDataDBTablesTagsTagClass;
typedef struct _GameHubDataSourcesUserUserGameUpdateGameInfoData GameHubDataSourcesUserUserGameUpdateGameInfoData;

#define GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG (game_hub_ui_dialogs_install_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialog))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))

typedef struct _GameHubUIDialogsInstallDialog GameHubUIDialogsInstallDialog;
typedef struct _GameHubUIDialogsInstallDialogClass GameHubUIDialogsInstallDialogClass;
typedef struct _GameHubDataSourcesUserUserGameInstallData GameHubDataSourcesUserUserGameInstallData;
typedef struct _GameHubDataSourcesUserUserGameUninstallData GameHubDataSourcesUserUserGameUninstallData;
typedef enum  {
	GAME_HUB_DATA_GAME_STATE_UNINSTALLED,
	GAME_HUB_DATA_GAME_STATE_INSTALLED,
	GAME_HUB_DATA_GAME_STATE_DOWNLOADING,
	GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY,
	GAME_HUB_DATA_GAME_STATE_INSTALLING
} GameHubDataGameState;

#define GAME_HUB_DATA_GAME_TYPE_STATE (game_hub_data_game_state_get_type ())

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD (game_hub_utils_downloader_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownload))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))

typedef struct _GameHubUtilsDownloaderDownload GameHubUtilsDownloaderDownload;
typedef struct _GameHubUtilsDownloaderDownloadClass GameHubUtilsDownloaderDownloadClass;
#define _game_hub_data_game_status_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_status_unref (var), NULL)))
typedef struct _GameHubDataGameStatusPrivate GameHubDataGameStatusPrivate;
typedef struct _GameHubDataRunnableInstallerPrivate GameHubDataRunnableInstallerPrivate;

#define GAME_HUB_DATA_TYPE_COMPAT_TOOL (game_hub_data_compat_tool_get_type ())
#define GAME_HUB_DATA_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatTool))
#define GAME_HUB_DATA_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))
#define GAME_HUB_DATA_IS_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_IS_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_COMPAT_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))

typedef struct _GameHubDataCompatTool GameHubDataCompatTool;
typedef struct _GameHubDataCompatToolClass GameHubDataCompatToolClass;
typedef struct _GameHubDataRunnableFileInstallerPrivate GameHubDataRunnableFileInstallerPrivate;
typedef struct _GameHubDataSourcesUserUserGameInstallerPrivate GameHubDataSourcesUserUserGameInstallerPrivate;
enum  {
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_REMOVED_SIGNAL,
	GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_SIGNALS
};
static guint game_hub_data_sources_user_user_game_signals[GAME_HUB_DATA_SOURCES_USER_USER_GAME_NUM_SIGNALS] = {0};

struct _GameHubDataRunnable {
	GObject parent_instance;
	GameHubDataRunnablePrivate * priv;
};

struct _GameHubDataRunnableClass {
	GObjectClass parent_class;
	gboolean (*is_supported) (GameHubDataRunnable* self, GameHubDataPlatform* platform, gboolean with_compat);
	void (*install) (GameHubDataRunnable* self, GameHubDataRunnableInstallerInstallMode install_mode, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run) (GameHubDataRunnable* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	gboolean (*can_be_launched) (GameHubDataRunnable* self, gboolean is_launch_attempt);
	void (*run_with_compat) (GameHubDataRunnable* self, gboolean is_opened_from_menu, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_with_compat_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	GtkFileChooser* (*setup_executable_chooser) (GameHubDataRunnable* self);
	void (*choose_executable) (GameHubDataRunnable* self, gboolean update);
	void (*set_chosen_executable) (GameHubDataRunnable* self, GFile* file, gboolean update);
	void (*save) (GameHubDataRunnable* self);
	void (*update_status) (GameHubDataRunnable* self);
	void (*import) (GameHubDataRunnable* self, gboolean update);
	GFile* (*get_executable) (GameHubDataRunnable* self);
	void (*set_executable) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_work_dir) (GameHubDataRunnable* self);
	void (*set_work_dir) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_default_install_dir) (GameHubDataRunnable* self);
};

struct _GameHubDataGame {
	GameHubDataRunnable parent_instance;
	GameHubDataGamePrivate * priv;
	GameHubDataGameStatus* _status;
	GeeArrayList* overlays;
	gchar* executable_path;
	gchar* work_dir_path;
};

struct _GameHubDataGameClass {
	GameHubDataRunnableClass parent_class;
	void (*uninstall) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*uninstall_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*update_game_info) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*update_game_info_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*load_achievements) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeArrayList* (*load_achievements_finish) (GameHubDataGame* self, GAsyncResult* _res_);
};

struct _GameHubDataTweakableGameIface {
	GTypeInterface parent_iface;
	gchar** (*get_tweaks) (GameHubDataTweakableGame* self, gint* result_length1);
	void (*set_tweaks) (GameHubDataTweakableGame* self, gchar** value, gint value_length1);
};

struct _GameHubDataSourcesUserUserGame {
	GameHubDataGame parent_instance;
	GameHubDataSourcesUserUserGamePrivate * priv;
};

struct _GameHubDataSourcesUserUserGameClass {
	GameHubDataGameClass parent_class;
};

struct _GameHubDataSourcesUserUserGamePrivate {
	gchar** _tweaks;
	gint _tweaks_length1;
	gint __tweaks_size_;
	gboolean is_removed;
	GameHubDataSourcesUserUserGameInstaller* installer;
};

struct _GameHubDataSourcesUserUserGameUpdateGameInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesUserUserGame* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GameHubDataSourcesUserUserGameInstaller* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	JsonObject* i;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	JsonNode* _tmp11_;
	JsonNode* _tmp12_;
	JsonObject* _tmp13_;
	JsonObject* _tmp14_;
	JsonObject* _tmp15_;
	JsonObject* _tmp16_;
	const gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	GameHubDataSourcesUserUserGameInstaller* _tmp20_;
};

struct _GameHubDataSourcesUserUserGameInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesUserUserGame* self;
	GameHubDataRunnableInstallerInstallMode install_mode;
	GameHubDataSourcesUserUserGameInstaller* _tmp0_;
	GeeArrayList* installers;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GameHubDataSourcesUserUserGameInstaller* _tmp3_;
	GeeArrayList* _tmp4_;
	GameHubUIDialogsInstallDialog* _tmp5_;
	GameHubUIDialogsInstallDialog* _tmp6_;
};

struct _GameHubDataSourcesUserUserGameUninstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesUserUserGame* self;
};

struct _GameHubDataGameStatus {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataGameStatusPrivate * priv;
	GameHubDataGameState state;
	GameHubDataGame* game;
	GameHubUtilsDownloaderDownload* download;
};

struct _GameHubDataGameStatusClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataGameStatus *self);
};

struct _GameHubDataRunnableInstaller {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableInstallerPrivate * priv;
};

struct _GameHubDataRunnableInstallerClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableInstaller *self);
	void (*install) (GameHubDataRunnableInstaller* self, GameHubDataRunnable* runnable, GameHubDataCompatTool* tool, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnableInstaller* self, GAsyncResult* _res_);
	gchar* (*get_name) (GameHubDataRunnableInstaller* self);
};

struct _GameHubDataRunnableFileInstaller {
	GameHubDataRunnableInstaller parent_instance;
	GameHubDataRunnableFileInstallerPrivate * priv;
};

struct _GameHubDataRunnableFileInstallerClass {
	GameHubDataRunnableInstallerClass parent_class;
};

struct _GameHubDataSourcesUserUserGameInstaller {
	GameHubDataRunnableFileInstaller parent_instance;
	GameHubDataSourcesUserUserGameInstallerPrivate * priv;
};

struct _GameHubDataSourcesUserUserGameInstallerClass {
	GameHubDataRunnableFileInstallerClass parent_class;
};

struct _GameHubDataSourcesUserUserGameInstallerPrivate {
	gchar* game_name;
};

static gint GameHubDataSourcesUserUserGame_private_offset;
static gpointer game_hub_data_sources_user_user_game_parent_class = NULL;
VALA_EXTERN GameHubDataSourcesUserUser* game_hub_data_sources_user_user_instance;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_ID;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_NAME;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_INFO;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_INFO_DETAILED;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_ICON;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_IMAGE;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_INSTALL_PATH;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_EXECUTABLE;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_WORK_DIR;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_COMPAT_TOOL;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_COMPAT_TOOL_SETTINGS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_ARGUMENTS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_LAST_LAUNCH;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_PLAYTIME_SOURCE;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_PLAYTIME_TRACKED;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_IMAGE_VERTICAL;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_PLATFORMS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_TAGS;
VALA_EXTERN GeeArrayList* game_hub_data_db_tables_tags_TAGS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_TWEAKS;
VALA_EXTERN GameHubDataDBTablesTagsTag* game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
VALA_EXTERN GameHubDataDBTablesTagsTag* game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
static gint GameHubDataSourcesUserUserGameInstaller_private_offset;
static gpointer game_hub_data_sources_user_user_game_installer_parent_class = NULL;
static GameHubDataTweakableGameIface * game_hub_data_sources_user_user_game_game_hub_data_tweakable_game_parent_iface = NULL;

VALA_EXTERN GType game_hub_data_runnable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnable, g_object_unref)
VALA_EXTERN GType game_hub_data_platform_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType game_hub_data_runnable_installer_install_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType game_hub_data_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGame, g_object_unref)
VALA_EXTERN gpointer game_hub_data_game_achievement_ref (gpointer instance);
VALA_EXTERN void game_hub_data_game_achievement_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_game_param_spec_achievement (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags);
VALA_EXTERN void game_hub_data_game_value_set_achievement (GValue* value,
                                               gpointer v_object);
VALA_EXTERN void game_hub_data_game_value_take_achievement (GValue* value,
                                                gpointer v_object);
VALA_EXTERN gpointer game_hub_data_game_value_get_achievement (const GValue* value);
VALA_EXTERN GType game_hub_data_game_achievement_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameAchievement, game_hub_data_game_achievement_unref)
VALA_EXTERN gpointer game_hub_data_game_status_ref (gpointer instance);
VALA_EXTERN void game_hub_data_game_status_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_game_param_spec_status (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void game_hub_data_game_value_set_status (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void game_hub_data_game_value_take_status (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer game_hub_data_game_value_get_status (const GValue* value);
VALA_EXTERN GType game_hub_data_game_status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameStatus, game_hub_data_game_status_unref)
VALA_EXTERN GType game_hub_data_game_overlay_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameOverlay, g_object_unref)
VALA_EXTERN GType game_hub_data_tweakable_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataTweakableGame, g_object_unref)
VALA_EXTERN GType game_hub_data_sources_user_user_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesUserUserGame, g_object_unref)
VALA_EXTERN gpointer game_hub_data_runnable_installer_ref (gpointer instance);
VALA_EXTERN void game_hub_data_runnable_installer_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_runnable_param_spec_installer (const gchar* name,
                                                         const gchar* nick,
                                                         const gchar* blurb,
                                                         GType object_type,
                                                         GParamFlags flags);
VALA_EXTERN void game_hub_data_runnable_value_set_installer (GValue* value,
                                                 gpointer v_object);
VALA_EXTERN void game_hub_data_runnable_value_take_installer (GValue* value,
                                                  gpointer v_object);
VALA_EXTERN gpointer game_hub_data_runnable_value_get_installer (const GValue* value);
VALA_EXTERN GType game_hub_data_runnable_installer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableInstaller, game_hub_data_runnable_installer_unref)
VALA_EXTERN GType game_hub_data_runnable_file_installer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableFileInstaller, game_hub_data_runnable_installer_unref)
VALA_EXTERN GType game_hub_data_sources_user_user_game_installer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesUserUserGameInstaller, game_hub_data_runnable_installer_unref)
VALA_EXTERN void game_hub_data_game_update_game_info (GameHubDataGame* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_update_game_info_finish (GameHubDataGame* self,
                                                 GAsyncResult* _res_);
VALA_EXTERN void game_hub_data_runnable_install (GameHubDataRunnable* self,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
VALA_EXTERN void game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                            GAsyncResult* _res_);
VALA_EXTERN void game_hub_data_game_uninstall (GameHubDataGame* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_uninstall_finish (GameHubDataGame* self,
                                          GAsyncResult* _res_);
VALA_EXTERN void game_hub_data_runnable_save (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_data_runnable_update_status (GameHubDataRunnable* self);
VALA_EXTERN GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_new (const gchar* name,
                                                                          GFile* dir,
                                                                          GFile* exec,
                                                                          const gchar* args,
                                                                          gboolean is_installer);
VALA_EXTERN GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_construct (GType object_type,
                                                                                const gchar* name,
                                                                                GFile* dir,
                                                                                GFile* exec,
                                                                                const gchar* args,
                                                                                gboolean is_installer);
VALA_EXTERN GameHubDataGame* game_hub_data_game_construct (GType object_type);
VALA_EXTERN gpointer game_hub_data_game_source_ref (gpointer instance);
VALA_EXTERN void game_hub_data_game_source_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_param_spec_game_source (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void game_hub_data_value_set_game_source (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void game_hub_data_value_take_game_source (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer game_hub_data_value_get_game_source (const GValue* value);
VALA_EXTERN GType game_hub_data_game_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameSource, game_hub_data_game_source_unref)
VALA_EXTERN GType game_hub_data_sources_user_user_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesUserUser, game_hub_data_game_source_unref)
VALA_EXTERN void game_hub_data_game_set_source (GameHubDataGame* self,
                                    GameHubDataGameSource* value);
VALA_EXTERN gchar* game_hub_utils_md5 (const gchar* s);
VALA_EXTERN void game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                                    const gchar* value);
VALA_EXTERN void game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                      const gchar* value);
VALA_EXTERN GeeArrayList* game_hub_data_runnable_get_platforms (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                             GFile* value);
VALA_EXTERN void game_hub_data_runnable_set_work_dir (GameHubDataRunnable* self,
                                          GFile* value);
VALA_EXTERN void game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                           const gchar* value);
VALA_EXTERN void game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                            GFile* value);
VALA_EXTERN GameHubDataSourcesUserUserGameInstaller* game_hub_data_sources_user_user_game_installer_new (GameHubDataSourcesUserUserGame* game,
                                                                                             GFile* installer);
VALA_EXTERN GameHubDataSourcesUserUserGameInstaller* game_hub_data_sources_user_user_game_installer_construct (GType object_type,
                                                                                                   GameHubDataSourcesUserUserGame* game,
                                                                                                   GFile* installer);
VALA_EXTERN void game_hub_data_game_set_info (GameHubDataGame* self,
                                  const gchar* value);
static void _vala_JsonNode_free (JsonNode* self);
VALA_EXTERN GameHubDataGameSource* game_hub_data_game_get_source (GameHubDataGame* self);
VALA_EXTERN void game_hub_data_sources_user_user_add_game (GameHubDataSourcesUserUser* self,
                                               GameHubDataSourcesUserUserGame* game);
VALA_EXTERN void game_hub_data_game_mount_overlays (GameHubDataGame* self,
                                        GFile* persist,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_mount_overlays_finish (GameHubDataGame* self,
                                               GAsyncResult* _res_);
VALA_EXTERN GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_new_from_db (GameHubDataSourcesUserUser* src,
                                                                                  sqlite3_stmt* s);
VALA_EXTERN GameHubDataSourcesUserUserGame* game_hub_data_sources_user_user_game_construct_from_db (GType object_type,
                                                                                        GameHubDataSourcesUserUser* src,
                                                                                        sqlite3_stmt* s);
VALA_EXTERN gpointer game_hub_data_db_table_field_ref (gpointer instance);
VALA_EXTERN void game_hub_data_db_table_field_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_db_table_param_spec_field (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
VALA_EXTERN void game_hub_data_db_table_value_set_field (GValue* value,
                                             gpointer v_object);
VALA_EXTERN void game_hub_data_db_table_value_take_field (GValue* value,
                                              gpointer v_object);
VALA_EXTERN gpointer game_hub_data_db_table_value_get_field (const GValue* value);
VALA_EXTERN GType game_hub_data_db_table_field_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTableField, game_hub_data_db_table_field_unref)
VALA_EXTERN gchar* game_hub_data_db_table_field_get (GameHubDataDBTableField* self,
                                         sqlite3_stmt* s);
VALA_EXTERN void game_hub_data_game_set_info_detailed (GameHubDataGame* self,
                                           const gchar* value);
VALA_EXTERN void game_hub_data_game_set_icon (GameHubDataGame* self,
                                  const gchar* value);
VALA_EXTERN void game_hub_data_game_set_image (GameHubDataGame* self,
                                   const gchar* value);
VALA_EXTERN GFile* game_hub_utils_fs_utils_file (const gchar* path,
                                     const gchar* file,
                                     GeeHashMap* variables);
VALA_EXTERN void game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                             const gchar* value);
VALA_EXTERN void game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                      const gchar* value);
VALA_EXTERN gint64 game_hub_data_db_table_field_get_int64 (GameHubDataDBTableField* self,
                                               sqlite3_stmt* s);
VALA_EXTERN void game_hub_data_game_set_last_launch (GameHubDataGame* self,
                                         gint64 value);
VALA_EXTERN void game_hub_data_game_set_playtime_source (GameHubDataGame* self,
                                             gint64 value);
VALA_EXTERN void game_hub_data_game_set_playtime_tracked (GameHubDataGame* self,
                                              gint64 value);
VALA_EXTERN void game_hub_data_game_set_image_vertical (GameHubDataGame* self,
                                            const gchar* value);
VALA_EXTERN gchar* game_hub_data_platform_id (GameHubDataPlatform self);
VALA_EXTERN GType game_hub_data_db_tables_tags_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTablesTagsTag, g_object_unref)
VALA_EXTERN GeeArrayList* game_hub_data_game_get_tags (GameHubDataGame* self);
VALA_EXTERN const gchar* game_hub_data_db_tables_tags_tag_get_id (GameHubDataDBTablesTagsTag* self);
VALA_EXTERN void game_hub_data_tweakable_game_set_tweaks (GameHubDataTweakableGame* self,
                                              gchar** value,
                                              gint value_length1);
static void game_hub_data_sources_user_user_game_real_update_game_info_data_free (gpointer _data);
static void game_hub_data_sources_user_user_game_real_update_game_info (GameHubDataGame* base,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_);
static gboolean game_hub_data_sources_user_user_game_real_update_game_info_co (GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_);
static void game_hub_data_sources_user_user_game_update_game_info_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
VALA_EXTERN const gchar* game_hub_data_game_get_info (GameHubDataGame* self);
VALA_EXTERN JsonNode* game_hub_utils_parser_parse_json (const gchar* json);
static void game_hub_data_sources_user_user_game_real_install_data_free (gpointer _data);
static void game_hub_data_sources_user_user_game_real_install (GameHubDataRunnable* base,
                                                        GameHubDataRunnableInstallerInstallMode install_mode,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static gboolean game_hub_data_sources_user_user_game_real_install_co (GameHubDataSourcesUserUserGameInstallData* _data_);
static void game_hub_data_sources_user_user_game_install_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static gboolean _game_hub_data_sources_user_user_game_real_install_co_gsource_func (gpointer self);
VALA_EXTERN GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_new (GameHubDataRunnable* runnable,
                                                                       GeeArrayList* installers,
                                                                       GameHubDataRunnableInstallerInstallMode install_mode,
                                                                       GSourceFunc callback,
                                                                       gpointer callback_target,
                                                                       GDestroyNotify callback_target_destroy_notify);
VALA_EXTERN GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_construct (GType object_type,
                                                                             GameHubDataRunnable* runnable,
                                                                             GeeArrayList* installers,
                                                                             GameHubDataRunnableInstallerInstallMode install_mode,
                                                                             GSourceFunc callback,
                                                                             gpointer callback_target,
                                                                             GDestroyNotify callback_target_destroy_notify);
VALA_EXTERN GType game_hub_ui_dialogs_install_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIDialogsInstallDialog, g_object_unref)
static void game_hub_data_sources_user_user_game_real_uninstall_data_free (gpointer _data);
static void game_hub_data_sources_user_user_game_real_uninstall (GameHubDataGame* base,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static gboolean game_hub_data_sources_user_user_game_real_uninstall_co (GameHubDataSourcesUserUserGameUninstallData* _data_);
VALA_EXTERN void game_hub_data_game_umount_overlays (GameHubDataGame* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_umount_overlays_finish (GameHubDataGame* self,
                                                GAsyncResult* _res_);
static void game_hub_data_sources_user_user_game_uninstall_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
VALA_EXTERN void game_hub_data_sources_user_user_game_remove (GameHubDataSourcesUserUserGame* self);
VALA_EXTERN void game_hub_data_sources_user_user_remove_game (GameHubDataSourcesUserUser* self,
                                                  GameHubDataSourcesUserUserGame* game);
static void game_hub_data_sources_user_user_game_real_save (GameHubDataRunnable* base);
static void game_hub_data_sources_user_user_game_real_update_status (GameHubDataRunnable* base);
VALA_EXTERN GFile* game_hub_data_runnable_get_executable (GameHubDataRunnable* self);
VALA_EXTERN GType game_hub_data_game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer game_hub_utils_downloader_download_ref (gpointer instance);
VALA_EXTERN void game_hub_utils_downloader_download_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_utils_downloader_param_spec_download (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags);
VALA_EXTERN void game_hub_utils_downloader_value_set_download (GValue* value,
                                                   gpointer v_object);
VALA_EXTERN void game_hub_utils_downloader_value_take_download (GValue* value,
                                                    gpointer v_object);
VALA_EXTERN gpointer game_hub_utils_downloader_value_get_download (const GValue* value);
VALA_EXTERN GType game_hub_utils_downloader_download_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownload, game_hub_utils_downloader_download_unref)
VALA_EXTERN GameHubDataGameStatus* game_hub_data_game_status_new (GameHubDataGameState state,
                                                      GameHubDataGame* game,
                                                      GameHubUtilsDownloaderDownload* download);
VALA_EXTERN GameHubDataGameStatus* game_hub_data_game_status_construct (GType object_type,
                                                            GameHubDataGameState state,
                                                            GameHubDataGame* game,
                                                            GameHubUtilsDownloaderDownload* download);
VALA_EXTERN void game_hub_data_game_set_status (GameHubDataGame* self,
                                    GameHubDataGameStatus* value);
VALA_EXTERN GameHubDataGameStatus* game_hub_data_game_get_status (GameHubDataGame* self);
VALA_EXTERN void game_hub_data_game_remove_tag (GameHubDataGame* self,
                                    GameHubDataDBTablesTagsTag* tag);
VALA_EXTERN void game_hub_data_game_add_tag (GameHubDataGame* self,
                                 GameHubDataDBTablesTagsTag* tag);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
VALA_EXTERN GType game_hub_data_compat_tool_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataCompatTool, g_object_unref)
VALA_EXTERN gchar* game_hub_data_runnable_installer_get_name (GameHubDataRunnableInstaller* self);
VALA_EXTERN GameHubDataRunnableFileInstaller* game_hub_data_runnable_file_installer_construct (GType object_type);
VALA_EXTERN const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                              const gchar* value);
VALA_EXTERN void game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                                    GameHubDataPlatform value);
VALA_EXTERN void game_hub_data_runnable_file_installer_set_file (GameHubDataRunnableFileInstaller* self,
                                                     GFile* value);
static void game_hub_data_sources_user_user_game_installer_finalize (GameHubDataRunnableInstaller * obj);
static GType game_hub_data_sources_user_user_game_installer_get_type_once (void);
VALA_EXTERN gchar** game_hub_data_tweakable_game_get_tweaks (GameHubDataTweakableGame* self,
                                                 gint* result_length1);
static void game_hub_data_sources_user_user_game_finalize (GObject * obj);
static GType game_hub_data_sources_user_user_game_get_type_once (void);
static void _vala_game_hub_data_sources_user_user_game_get_property (GObject * object,
                                                              guint property_id,
                                                              GValue * value,
                                                              GParamSpec * pspec);
static void _vala_game_hub_data_sources_user_user_game_set_property (GObject * object,
                                                              guint property_id,
                                                              const GValue * value,
                                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const GameHubDataPlatform GAME_HUB_DATA_PLATFORM_PLATFORMS[4];

static inline gpointer
game_hub_data_sources_user_user_game_get_instance_private (GameHubDataSourcesUserUserGame* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataSourcesUserUserGame_private_offset);
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 51 "../src/data/sources/user/UserGame.vala"
	g_boxed_free (json_node_get_type (), self);
#line 786 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_construct (GType object_type,
                                                const gchar* name,
                                                GFile* dir,
                                                GFile* exec,
                                                const gchar* args,
                                                gboolean is_installer)
{
	GameHubDataSourcesUserUserGame * self = NULL;
	GameHubDataSourcesUserUser* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	gchar* path = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GameHubDataPlatform _tmp13_ = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GameHubDataGameSource* _tmp32_;
	GameHubDataGameSource* _tmp33_;
#line 34 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 34 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 34 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (exec != NULL, NULL);
#line 34 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (args != NULL, NULL);
#line 34 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) game_hub_data_game_construct (object_type);
#line 36 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_sources_user_user_instance;
#line 36 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_source ((GameHubDataGame*) self, (GameHubDataGameSource*) _tmp0_);
#line 38 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = g_strdup_printf ("%u", g_random_int ());
#line 38 "../src/data/sources/user/UserGame.vala"
	_tmp2_ = _tmp1_;
#line 38 "../src/data/sources/user/UserGame.vala"
	_tmp3_ = g_strconcat (name, _tmp2_, NULL);
#line 38 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = _tmp3_;
#line 38 "../src/data/sources/user/UserGame.vala"
	_tmp5_ = game_hub_utils_md5 (_tmp4_);
#line 38 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = _tmp5_;
#line 38 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp6_);
#line 38 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp6_);
#line 38 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp4_);
#line 38 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp2_);
#line 39 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, name);
#line 41 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 41 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = _tmp7_;
#line 41 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp8_);
#line 43 "../src/data/sources/user/UserGame.vala"
	_tmp9_ = g_file_get_path (exec);
#line 43 "../src/data/sources/user/UserGame.vala"
	_tmp10_ = _tmp9_;
#line 43 "../src/data/sources/user/UserGame.vala"
	_tmp11_ = g_utf8_strdown (_tmp10_, (gssize) -1);
#line 43 "../src/data/sources/user/UserGame.vala"
	_tmp12_ = _tmp11_;
#line 43 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp10_);
#line 43 "../src/data/sources/user/UserGame.vala"
	path = _tmp12_;
#line 44 "../src/data/sources/user/UserGame.vala"
	_tmp16_ = path;
#line 44 "../src/data/sources/user/UserGame.vala"
	if (g_str_has_suffix (_tmp16_, ".exe")) {
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp15_ = TRUE;
#line 880 "UserGame.c"
	} else {
		const gchar* _tmp17_;
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp17_ = path;
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp15_ = g_str_has_suffix (_tmp17_, ".bat");
#line 887 "UserGame.c"
	}
#line 44 "../src/data/sources/user/UserGame.vala"
	if (_tmp15_) {
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp14_ = TRUE;
#line 893 "UserGame.c"
	} else {
		const gchar* _tmp18_;
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp18_ = path;
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp14_ = g_str_has_suffix (_tmp18_, ".com");
#line 900 "UserGame.c"
	}
#line 44 "../src/data/sources/user/UserGame.vala"
	if (_tmp14_) {
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp13_ = GAME_HUB_DATA_PLATFORM_WINDOWS;
#line 906 "UserGame.c"
	} else {
#line 44 "../src/data/sources/user/UserGame.vala"
		_tmp13_ = GAME_HUB_DATA_PLATFORM_LINUX;
#line 910 "UserGame.c"
	}
#line 44 "../src/data/sources/user/UserGame.vala"
	_tmp19_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 44 "../src/data/sources/user/UserGame.vala"
	_tmp20_ = _tmp19_;
#line 44 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, (gpointer) ((gintptr) _tmp13_));
#line 46 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, dir);
#line 47 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_work_dir ((GameHubDataRunnable*) self, dir);
#line 49 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_arguments ((GameHubDataRunnable*) self, args);
#line 51 "../src/data/sources/user/UserGame.vala"
	if (!is_installer) {
#line 53 "../src/data/sources/user/UserGame.vala"
		game_hub_data_runnable_set_executable ((GameHubDataRunnable*) self, exec);
#line 928 "UserGame.c"
	} else {
		GameHubDataSourcesUserUserGameInstaller* _tmp21_;
		JsonObject* root_object = NULL;
		JsonObject* _tmp22_;
		JsonObject* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		JsonNode* root_node = NULL;
		JsonNode* _tmp26_;
		JsonNode* _tmp27_;
		JsonObject* _tmp28_;
		JsonNode* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 57 "../src/data/sources/user/UserGame.vala"
		_tmp21_ = game_hub_data_sources_user_user_game_installer_new (self, exec);
#line 57 "../src/data/sources/user/UserGame.vala"
		_game_hub_data_runnable_installer_unref0 (self->priv->installer);
#line 57 "../src/data/sources/user/UserGame.vala"
		self->priv->installer = _tmp21_;
#line 58 "../src/data/sources/user/UserGame.vala"
		_tmp22_ = json_object_new ();
#line 58 "../src/data/sources/user/UserGame.vala"
		root_object = _tmp22_;
#line 59 "../src/data/sources/user/UserGame.vala"
		_tmp23_ = root_object;
#line 59 "../src/data/sources/user/UserGame.vala"
		_tmp24_ = g_file_get_path (exec);
#line 59 "../src/data/sources/user/UserGame.vala"
		_tmp25_ = _tmp24_;
#line 59 "../src/data/sources/user/UserGame.vala"
		json_object_set_string_member (_tmp23_, "installer", _tmp25_);
#line 59 "../src/data/sources/user/UserGame.vala"
		_g_free0 (_tmp25_);
#line 60 "../src/data/sources/user/UserGame.vala"
		_tmp26_ = json_node_new (JSON_NODE_OBJECT);
#line 60 "../src/data/sources/user/UserGame.vala"
		root_node = _tmp26_;
#line 61 "../src/data/sources/user/UserGame.vala"
		_tmp27_ = root_node;
#line 61 "../src/data/sources/user/UserGame.vala"
		_tmp28_ = root_object;
#line 61 "../src/data/sources/user/UserGame.vala"
		json_node_set_object (_tmp27_, _tmp28_);
#line 62 "../src/data/sources/user/UserGame.vala"
		_tmp29_ = root_node;
#line 62 "../src/data/sources/user/UserGame.vala"
		_tmp30_ = json_to_string (_tmp29_, FALSE);
#line 62 "../src/data/sources/user/UserGame.vala"
		_tmp31_ = _tmp30_;
#line 62 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_set_info ((GameHubDataGame*) self, _tmp31_);
#line 62 "../src/data/sources/user/UserGame.vala"
		_g_free0 (_tmp31_);
#line 63 "../src/data/sources/user/UserGame.vala"
		game_hub_data_runnable_save ((GameHubDataRunnable*) self);
#line 51 "../src/data/sources/user/UserGame.vala"
		__vala_JsonNode_free0 (root_node);
#line 51 "../src/data/sources/user/UserGame.vala"
		_json_object_unref0 (root_object);
#line 989 "UserGame.c"
	}
#line 66 "../src/data/sources/user/UserGame.vala"
	_tmp32_ = game_hub_data_game_get_source ((GameHubDataGame*) self);
#line 66 "../src/data/sources/user/UserGame.vala"
	_tmp33_ = _tmp32_;
#line 66 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_add_game (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUser), self);
#line 68 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) self, NULL, NULL, NULL);
#line 69 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 34 "../src/data/sources/user/UserGame.vala"
	_g_free0 (path);
#line 34 "../src/data/sources/user/UserGame.vala"
	return self;
#line 1005 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_new (const gchar* name,
                                          GFile* dir,
                                          GFile* exec,
                                          const gchar* args,
                                          gboolean is_installer)
{
#line 34 "../src/data/sources/user/UserGame.vala"
	return game_hub_data_sources_user_user_game_construct (GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, name, dir, exec, args, is_installer);
#line 1017 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_construct_from_db (GType object_type,
                                                        GameHubDataSourcesUserUser* src,
                                                        sqlite3_stmt* s)
{
	GameHubDataSourcesUserUserGame * self = NULL;
	GameHubDataDBTableField* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GameHubDataDBTableField* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GameHubDataDBTableField* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GameHubDataDBTableField* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GameHubDataDBTableField* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GameHubDataDBTableField* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GFile* _tmp18_ = NULL;
	GameHubDataDBTableField* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gboolean _tmp22_;
	GameHubDataDBTableField* _tmp27_;
	gchar* _tmp28_;
	GameHubDataDBTableField* _tmp29_;
	gchar* _tmp30_;
	GameHubDataDBTableField* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GameHubDataDBTableField* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GameHubDataDBTableField* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	GameHubDataDBTableField* _tmp40_;
	GameHubDataDBTableField* _tmp41_;
	GameHubDataDBTableField* _tmp42_;
	GameHubDataDBTableField* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GeeArrayList* _tmp46_;
	GeeArrayList* _tmp47_;
	gchar** pls = NULL;
	GameHubDataDBTableField* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar** _tmp51_;
	gchar** _tmp52_;
	gchar** _tmp53_;
	gint _tmp53__length1;
	gint pls_length1;
	gint _pls_size_;
	gchar** _tmp54_;
	gint _tmp54__length1;
	GeeArrayList* _tmp62_;
	GeeArrayList* _tmp63_;
	gchar* _tmp64_ = NULL;
	GameHubDataDBTableField* _tmp65_;
	gchar* _tmp66_;
	gchar** tag_ids = NULL;
	gchar** _tmp68_;
	gchar** _tmp69_;
	gint tag_ids_length1;
	gint _tag_ids_size_;
	gchar** _tmp70_;
	gint _tmp70__length1;
	gchar* tweaks_string = NULL;
	GameHubDataDBTableField* _tmp90_;
	gchar* _tmp91_;
	const gchar* _tmp92_;
#line 72 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 72 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 72 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) game_hub_data_game_construct (object_type);
#line 74 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_source ((GameHubDataGame*) self, (GameHubDataGameSource*) src);
#line 75 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_db_tables_games_ID;
#line 75 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = game_hub_data_db_table_field_get (_tmp0_, s);
#line 75 "../src/data/sources/user/UserGame.vala"
	_tmp2_ = _tmp1_;
#line 75 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp2_);
#line 75 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp2_);
#line 76 "../src/data/sources/user/UserGame.vala"
	_tmp3_ = game_hub_data_db_tables_games_NAME;
#line 76 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = game_hub_data_db_table_field_get (_tmp3_, s);
#line 76 "../src/data/sources/user/UserGame.vala"
	_tmp5_ = _tmp4_;
#line 76 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, _tmp5_);
#line 76 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp5_);
#line 77 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = game_hub_data_db_tables_games_INFO;
#line 77 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = game_hub_data_db_table_field_get (_tmp6_, s);
#line 77 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = _tmp7_;
#line 77 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_info ((GameHubDataGame*) self, _tmp8_);
#line 77 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp8_);
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp9_ = game_hub_data_db_tables_games_INFO_DETAILED;
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp10_ = game_hub_data_db_table_field_get (_tmp9_, s);
#line 78 "../src/data/sources/user/UserGame.vala"
	_tmp11_ = _tmp10_;
#line 78 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_info_detailed ((GameHubDataGame*) self, _tmp11_);
#line 78 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp11_);
#line 79 "../src/data/sources/user/UserGame.vala"
	_tmp12_ = game_hub_data_db_tables_games_ICON;
#line 79 "../src/data/sources/user/UserGame.vala"
	_tmp13_ = game_hub_data_db_table_field_get (_tmp12_, s);
#line 79 "../src/data/sources/user/UserGame.vala"
	_tmp14_ = _tmp13_;
#line 79 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_icon ((GameHubDataGame*) self, _tmp14_);
#line 79 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp14_);
#line 80 "../src/data/sources/user/UserGame.vala"
	_tmp15_ = game_hub_data_db_tables_games_IMAGE;
#line 80 "../src/data/sources/user/UserGame.vala"
	_tmp16_ = game_hub_data_db_table_field_get (_tmp15_, s);
#line 80 "../src/data/sources/user/UserGame.vala"
	_tmp17_ = _tmp16_;
#line 80 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_image ((GameHubDataGame*) self, _tmp17_);
#line 80 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp17_);
#line 81 "../src/data/sources/user/UserGame.vala"
	_tmp19_ = game_hub_data_db_tables_games_INSTALL_PATH;
#line 81 "../src/data/sources/user/UserGame.vala"
	_tmp20_ = game_hub_data_db_table_field_get (_tmp19_, s);
#line 81 "../src/data/sources/user/UserGame.vala"
	_tmp21_ = _tmp20_;
#line 81 "../src/data/sources/user/UserGame.vala"
	_tmp22_ = _tmp21_ != NULL;
#line 81 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp21_);
#line 81 "../src/data/sources/user/UserGame.vala"
	if (_tmp22_) {
#line 1178 "UserGame.c"
		GameHubDataDBTableField* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GFile* _tmp26_;
#line 81 "../src/data/sources/user/UserGame.vala"
		_tmp23_ = game_hub_data_db_tables_games_INSTALL_PATH;
#line 81 "../src/data/sources/user/UserGame.vala"
		_tmp24_ = game_hub_data_db_table_field_get (_tmp23_, s);
#line 81 "../src/data/sources/user/UserGame.vala"
		_tmp25_ = _tmp24_;
#line 81 "../src/data/sources/user/UserGame.vala"
		_tmp26_ = game_hub_utils_fs_utils_file (_tmp25_, NULL, NULL);
#line 81 "../src/data/sources/user/UserGame.vala"
		_g_object_unref0 (_tmp18_);
#line 81 "../src/data/sources/user/UserGame.vala"
		_tmp18_ = _tmp26_;
#line 81 "../src/data/sources/user/UserGame.vala"
		_g_free0 (_tmp25_);
#line 1197 "UserGame.c"
	} else {
#line 81 "../src/data/sources/user/UserGame.vala"
		_g_object_unref0 (_tmp18_);
#line 81 "../src/data/sources/user/UserGame.vala"
		_tmp18_ = NULL;
#line 1203 "UserGame.c"
	}
#line 81 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, _tmp18_);
#line 82 "../src/data/sources/user/UserGame.vala"
	_tmp27_ = game_hub_data_db_tables_games_EXECUTABLE;
#line 82 "../src/data/sources/user/UserGame.vala"
	_tmp28_ = game_hub_data_db_table_field_get (_tmp27_, s);
#line 82 "../src/data/sources/user/UserGame.vala"
	_g_free0 (((GameHubDataGame*) self)->executable_path);
#line 82 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGame*) self)->executable_path = _tmp28_;
#line 83 "../src/data/sources/user/UserGame.vala"
	_tmp29_ = game_hub_data_db_tables_games_WORK_DIR;
#line 83 "../src/data/sources/user/UserGame.vala"
	_tmp30_ = game_hub_data_db_table_field_get (_tmp29_, s);
#line 83 "../src/data/sources/user/UserGame.vala"
	_g_free0 (((GameHubDataGame*) self)->work_dir_path);
#line 83 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGame*) self)->work_dir_path = _tmp30_;
#line 84 "../src/data/sources/user/UserGame.vala"
	_tmp31_ = game_hub_data_db_tables_games_COMPAT_TOOL;
#line 84 "../src/data/sources/user/UserGame.vala"
	_tmp32_ = game_hub_data_db_table_field_get (_tmp31_, s);
#line 84 "../src/data/sources/user/UserGame.vala"
	_tmp33_ = _tmp32_;
#line 84 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_compat_tool ((GameHubDataRunnable*) self, _tmp33_);
#line 84 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp33_);
#line 85 "../src/data/sources/user/UserGame.vala"
	_tmp34_ = game_hub_data_db_tables_games_COMPAT_TOOL_SETTINGS;
#line 85 "../src/data/sources/user/UserGame.vala"
	_tmp35_ = game_hub_data_db_table_field_get (_tmp34_, s);
#line 85 "../src/data/sources/user/UserGame.vala"
	_tmp36_ = _tmp35_;
#line 85 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_compat_tool_settings ((GameHubDataRunnable*) self, _tmp36_);
#line 85 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp36_);
#line 86 "../src/data/sources/user/UserGame.vala"
	_tmp37_ = game_hub_data_db_tables_games_ARGUMENTS;
#line 86 "../src/data/sources/user/UserGame.vala"
	_tmp38_ = game_hub_data_db_table_field_get (_tmp37_, s);
#line 86 "../src/data/sources/user/UserGame.vala"
	_tmp39_ = _tmp38_;
#line 86 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_set_arguments ((GameHubDataRunnable*) self, _tmp39_);
#line 86 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp39_);
#line 87 "../src/data/sources/user/UserGame.vala"
	_tmp40_ = game_hub_data_db_tables_games_LAST_LAUNCH;
#line 87 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_last_launch ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp40_, s));
#line 88 "../src/data/sources/user/UserGame.vala"
	_tmp41_ = game_hub_data_db_tables_games_PLAYTIME_SOURCE;
#line 88 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_playtime_source ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp41_, s));
#line 89 "../src/data/sources/user/UserGame.vala"
	_tmp42_ = game_hub_data_db_tables_games_PLAYTIME_TRACKED;
#line 89 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_playtime_tracked ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp42_, s));
#line 90 "../src/data/sources/user/UserGame.vala"
	_tmp43_ = game_hub_data_db_tables_games_IMAGE_VERTICAL;
#line 90 "../src/data/sources/user/UserGame.vala"
	_tmp44_ = game_hub_data_db_table_field_get (_tmp43_, s);
#line 90 "../src/data/sources/user/UserGame.vala"
	_tmp45_ = _tmp44_;
#line 90 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_image_vertical ((GameHubDataGame*) self, _tmp45_);
#line 90 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp45_);
#line 92 "../src/data/sources/user/UserGame.vala"
	_tmp46_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 92 "../src/data/sources/user/UserGame.vala"
	_tmp47_ = _tmp46_;
#line 92 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp47_);
#line 93 "../src/data/sources/user/UserGame.vala"
	_tmp48_ = game_hub_data_db_tables_games_PLATFORMS;
#line 93 "../src/data/sources/user/UserGame.vala"
	_tmp49_ = game_hub_data_db_table_field_get (_tmp48_, s);
#line 93 "../src/data/sources/user/UserGame.vala"
	_tmp50_ = _tmp49_;
#line 93 "../src/data/sources/user/UserGame.vala"
	_tmp52_ = _tmp51_ = g_strsplit (_tmp50_, ",", 0);
#line 93 "../src/data/sources/user/UserGame.vala"
	_tmp53_ = _tmp52_;
#line 93 "../src/data/sources/user/UserGame.vala"
	_tmp53__length1 = _vala_array_length (_tmp51_);
#line 93 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp50_);
#line 93 "../src/data/sources/user/UserGame.vala"
	pls = _tmp53_;
#line 93 "../src/data/sources/user/UserGame.vala"
	pls_length1 = _tmp53__length1;
#line 93 "../src/data/sources/user/UserGame.vala"
	_pls_size_ = pls_length1;
#line 94 "../src/data/sources/user/UserGame.vala"
	_tmp54_ = pls;
#line 94 "../src/data/sources/user/UserGame.vala"
	_tmp54__length1 = pls_length1;
#line 1305 "UserGame.c"
	{
		gchar** pl_collection = NULL;
		gint pl_collection_length1 = 0;
		gint _pl_collection_size_ = 0;
		gint pl_it = 0;
#line 94 "../src/data/sources/user/UserGame.vala"
		pl_collection = _tmp54_;
#line 94 "../src/data/sources/user/UserGame.vala"
		pl_collection_length1 = _tmp54__length1;
#line 94 "../src/data/sources/user/UserGame.vala"
		for (pl_it = 0; pl_it < pl_collection_length1; pl_it = pl_it + 1) {
#line 1317 "UserGame.c"
			gchar* _tmp55_;
			gchar* pl = NULL;
#line 94 "../src/data/sources/user/UserGame.vala"
			_tmp55_ = g_strdup (pl_collection[pl_it]);
#line 94 "../src/data/sources/user/UserGame.vala"
			pl = _tmp55_;
#line 1324 "UserGame.c"
			{
				{
					GameHubDataPlatform* p_collection = NULL;
					gint p_collection_length1 = 0;
					gint _p_collection_size_ = 0;
					gint p_it = 0;
#line 96 "../src/data/sources/user/UserGame.vala"
					p_collection = GAME_HUB_DATA_PLATFORM_PLATFORMS;
#line 96 "../src/data/sources/user/UserGame.vala"
					p_collection_length1 = G_N_ELEMENTS (GAME_HUB_DATA_PLATFORM_PLATFORMS);
#line 96 "../src/data/sources/user/UserGame.vala"
					for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 1337 "UserGame.c"
						GameHubDataPlatform p = 0;
#line 96 "../src/data/sources/user/UserGame.vala"
						p = p_collection[p_it];
#line 1341 "UserGame.c"
						{
							const gchar* _tmp56_;
							gchar* _tmp57_;
							gchar* _tmp58_;
							gboolean _tmp59_;
#line 98 "../src/data/sources/user/UserGame.vala"
							_tmp56_ = pl;
#line 98 "../src/data/sources/user/UserGame.vala"
							_tmp57_ = game_hub_data_platform_id (p);
#line 98 "../src/data/sources/user/UserGame.vala"
							_tmp58_ = _tmp57_;
#line 98 "../src/data/sources/user/UserGame.vala"
							_tmp59_ = g_strcmp0 (_tmp56_, _tmp58_) == 0;
#line 98 "../src/data/sources/user/UserGame.vala"
							_g_free0 (_tmp58_);
#line 98 "../src/data/sources/user/UserGame.vala"
							if (_tmp59_) {
#line 1359 "UserGame.c"
								GeeArrayList* _tmp60_;
								GeeArrayList* _tmp61_;
#line 100 "../src/data/sources/user/UserGame.vala"
								_tmp60_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 100 "../src/data/sources/user/UserGame.vala"
								_tmp61_ = _tmp60_;
#line 100 "../src/data/sources/user/UserGame.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, (gpointer) ((gintptr) p));
#line 101 "../src/data/sources/user/UserGame.vala"
								break;
#line 1370 "UserGame.c"
							}
						}
					}
				}
#line 94 "../src/data/sources/user/UserGame.vala"
				_g_free0 (pl);
#line 1377 "UserGame.c"
			}
		}
	}
#line 106 "../src/data/sources/user/UserGame.vala"
	_tmp62_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 106 "../src/data/sources/user/UserGame.vala"
	_tmp63_ = _tmp62_;
#line 106 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp63_);
#line 107 "../src/data/sources/user/UserGame.vala"
	_tmp65_ = game_hub_data_db_tables_games_TAGS;
#line 107 "../src/data/sources/user/UserGame.vala"
	_tmp66_ = game_hub_data_db_table_field_get (_tmp65_, s);
#line 107 "../src/data/sources/user/UserGame.vala"
	_tmp64_ = _tmp66_;
#line 107 "../src/data/sources/user/UserGame.vala"
	if (_tmp64_ == NULL) {
#line 1395 "UserGame.c"
		gchar* _tmp67_;
#line 107 "../src/data/sources/user/UserGame.vala"
		_tmp67_ = g_strdup ("");
#line 107 "../src/data/sources/user/UserGame.vala"
		_g_free0 (_tmp64_);
#line 107 "../src/data/sources/user/UserGame.vala"
		_tmp64_ = _tmp67_;
#line 1403 "UserGame.c"
	}
#line 107 "../src/data/sources/user/UserGame.vala"
	_tmp69_ = _tmp68_ = g_strsplit (_tmp64_, ",", 0);
#line 107 "../src/data/sources/user/UserGame.vala"
	tag_ids = _tmp69_;
#line 107 "../src/data/sources/user/UserGame.vala"
	tag_ids_length1 = _vala_array_length (_tmp68_);
#line 107 "../src/data/sources/user/UserGame.vala"
	_tag_ids_size_ = tag_ids_length1;
#line 108 "../src/data/sources/user/UserGame.vala"
	_tmp70_ = tag_ids;
#line 108 "../src/data/sources/user/UserGame.vala"
	_tmp70__length1 = tag_ids_length1;
#line 1417 "UserGame.c"
	{
		gchar** tid_collection = NULL;
		gint tid_collection_length1 = 0;
		gint _tid_collection_size_ = 0;
		gint tid_it = 0;
#line 108 "../src/data/sources/user/UserGame.vala"
		tid_collection = _tmp70_;
#line 108 "../src/data/sources/user/UserGame.vala"
		tid_collection_length1 = _tmp70__length1;
#line 108 "../src/data/sources/user/UserGame.vala"
		for (tid_it = 0; tid_it < tid_collection_length1; tid_it = tid_it + 1) {
#line 1429 "UserGame.c"
			gchar* _tmp71_;
			gchar* tid = NULL;
#line 108 "../src/data/sources/user/UserGame.vala"
			_tmp71_ = g_strdup (tid_collection[tid_it]);
#line 108 "../src/data/sources/user/UserGame.vala"
			tid = _tmp71_;
#line 1436 "UserGame.c"
			{
				{
					GeeArrayList* _t_list = NULL;
					GeeArrayList* _tmp72_;
					gint _t_size = 0;
					GeeArrayList* _tmp73_;
					gint _tmp74_;
					gint _tmp75_;
					gint _t_index = 0;
#line 110 "../src/data/sources/user/UserGame.vala"
					_tmp72_ = game_hub_data_db_tables_tags_TAGS;
#line 110 "../src/data/sources/user/UserGame.vala"
					_t_list = _tmp72_;
#line 110 "../src/data/sources/user/UserGame.vala"
					_tmp73_ = _t_list;
#line 110 "../src/data/sources/user/UserGame.vala"
					_tmp74_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp73_);
#line 110 "../src/data/sources/user/UserGame.vala"
					_tmp75_ = _tmp74_;
#line 110 "../src/data/sources/user/UserGame.vala"
					_t_size = _tmp75_;
#line 110 "../src/data/sources/user/UserGame.vala"
					_t_index = -1;
#line 110 "../src/data/sources/user/UserGame.vala"
					while (TRUE) {
#line 1462 "UserGame.c"
						gint _tmp76_;
						gint _tmp77_;
						GameHubDataDBTablesTagsTag* t = NULL;
						GeeArrayList* _tmp78_;
						gpointer _tmp79_;
						const gchar* _tmp80_;
						GameHubDataDBTablesTagsTag* _tmp81_;
						const gchar* _tmp82_;
						const gchar* _tmp83_;
#line 110 "../src/data/sources/user/UserGame.vala"
						_t_index = _t_index + 1;
#line 110 "../src/data/sources/user/UserGame.vala"
						_tmp76_ = _t_index;
#line 110 "../src/data/sources/user/UserGame.vala"
						_tmp77_ = _t_size;
#line 110 "../src/data/sources/user/UserGame.vala"
						if (!(_tmp76_ < _tmp77_)) {
#line 110 "../src/data/sources/user/UserGame.vala"
							break;
#line 1482 "UserGame.c"
						}
#line 110 "../src/data/sources/user/UserGame.vala"
						_tmp78_ = _t_list;
#line 110 "../src/data/sources/user/UserGame.vala"
						_tmp79_ = gee_abstract_list_get ((GeeAbstractList*) _tmp78_, _t_index);
#line 110 "../src/data/sources/user/UserGame.vala"
						t = (GameHubDataDBTablesTagsTag*) _tmp79_;
#line 112 "../src/data/sources/user/UserGame.vala"
						_tmp80_ = tid;
#line 112 "../src/data/sources/user/UserGame.vala"
						_tmp81_ = t;
#line 112 "../src/data/sources/user/UserGame.vala"
						_tmp82_ = game_hub_data_db_tables_tags_tag_get_id (_tmp81_);
#line 112 "../src/data/sources/user/UserGame.vala"
						_tmp83_ = _tmp82_;
#line 112 "../src/data/sources/user/UserGame.vala"
						if (g_strcmp0 (_tmp80_, _tmp83_) == 0) {
#line 1500 "UserGame.c"
							GeeArrayList* _tmp84_;
							GeeArrayList* _tmp85_;
							GameHubDataDBTablesTagsTag* _tmp86_;
#line 114 "../src/data/sources/user/UserGame.vala"
							_tmp84_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 114 "../src/data/sources/user/UserGame.vala"
							_tmp85_ = _tmp84_;
#line 114 "../src/data/sources/user/UserGame.vala"
							_tmp86_ = t;
#line 114 "../src/data/sources/user/UserGame.vala"
							if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp85_, _tmp86_)) {
#line 1512 "UserGame.c"
								GeeArrayList* _tmp87_;
								GeeArrayList* _tmp88_;
								GameHubDataDBTablesTagsTag* _tmp89_;
#line 114 "../src/data/sources/user/UserGame.vala"
								_tmp87_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 114 "../src/data/sources/user/UserGame.vala"
								_tmp88_ = _tmp87_;
#line 114 "../src/data/sources/user/UserGame.vala"
								_tmp89_ = t;
#line 114 "../src/data/sources/user/UserGame.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp88_, _tmp89_);
#line 1524 "UserGame.c"
							}
#line 115 "../src/data/sources/user/UserGame.vala"
							_g_object_unref0 (t);
#line 115 "../src/data/sources/user/UserGame.vala"
							break;
#line 1530 "UserGame.c"
						}
#line 110 "../src/data/sources/user/UserGame.vala"
						_g_object_unref0 (t);
#line 1534 "UserGame.c"
					}
				}
#line 108 "../src/data/sources/user/UserGame.vala"
				_g_free0 (tid);
#line 1539 "UserGame.c"
			}
		}
	}
#line 120 "../src/data/sources/user/UserGame.vala"
	_tmp90_ = game_hub_data_db_tables_games_TWEAKS;
#line 120 "../src/data/sources/user/UserGame.vala"
	_tmp91_ = game_hub_data_db_table_field_get (_tmp90_, s);
#line 120 "../src/data/sources/user/UserGame.vala"
	tweaks_string = _tmp91_;
#line 121 "../src/data/sources/user/UserGame.vala"
	_tmp92_ = tweaks_string;
#line 121 "../src/data/sources/user/UserGame.vala"
	if (_tmp92_ != NULL) {
#line 1553 "UserGame.c"
		const gchar* _tmp93_;
		gchar** _tmp94_;
		gchar** _tmp95_;
		gchar** _tmp96_;
		gint _tmp96__length1;
#line 123 "../src/data/sources/user/UserGame.vala"
		_tmp93_ = tweaks_string;
#line 123 "../src/data/sources/user/UserGame.vala"
		_tmp95_ = _tmp94_ = g_strsplit (_tmp93_, ",", 0);
#line 123 "../src/data/sources/user/UserGame.vala"
		_tmp96_ = _tmp95_;
#line 123 "../src/data/sources/user/UserGame.vala"
		_tmp96__length1 = _vala_array_length (_tmp94_);
#line 123 "../src/data/sources/user/UserGame.vala"
		game_hub_data_tweakable_game_set_tweaks ((GameHubDataTweakableGame*) self, _tmp96_, _vala_array_length (_tmp94_));
#line 123 "../src/data/sources/user/UserGame.vala"
		_tmp96_ = (_vala_array_free (_tmp96_, _tmp96__length1, (GDestroyNotify) g_free), NULL);
#line 1571 "UserGame.c"
	}
#line 126 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) self, NULL, NULL, NULL);
#line 127 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 72 "../src/data/sources/user/UserGame.vala"
	_g_free0 (tweaks_string);
#line 72 "../src/data/sources/user/UserGame.vala"
	tag_ids = (_vala_array_free (tag_ids, tag_ids_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp64_);
#line 72 "../src/data/sources/user/UserGame.vala"
	pls = (_vala_array_free (pls, pls_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_tmp18_);
#line 72 "../src/data/sources/user/UserGame.vala"
	return self;
#line 1589 "UserGame.c"
}

GameHubDataSourcesUserUserGame*
game_hub_data_sources_user_user_game_new_from_db (GameHubDataSourcesUserUser* src,
                                                  sqlite3_stmt* s)
{
#line 72 "../src/data/sources/user/UserGame.vala"
	return game_hub_data_sources_user_user_game_construct_from_db (GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, src, s);
#line 1598 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_update_game_info_data_free (gpointer _data)
{
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_slice_free (GameHubDataSourcesUserUserGameUpdateGameInfoData, _data_);
#line 1610 "UserGame.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 25 "../src/data/sources/user/UserGame.vala"
	return self ? g_object_ref (self) : NULL;
#line 1618 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_update_game_info (GameHubDataGame* base,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_)
{
	GameHubDataSourcesUserUserGame * self;
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
	GameHubDataSourcesUserUserGame* _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesUserUserGameUpdateGameInfoData);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_user_user_game_real_update_game_info_data_free);
#line 25 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_update_game_info_co (_data_);
#line 1643 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_update_game_info_finish (GameHubDataGame* base,
                                                              GAsyncResult* _res_)
{
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1653 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_update_game_info_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_;
#line 132 "../src/data/sources/user/UserGame.vala"
	_data_ = _user_data_;
#line 132 "../src/data/sources/user/UserGame.vala"
	_data_->_source_object_ = source_object;
#line 132 "../src/data/sources/user/UserGame.vala"
	_data_->_res_ = _res_;
#line 132 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_update_game_info_co (_data_);
#line 1670 "UserGame.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 137 "../src/data/sources/user/UserGame.vala"
	return self ? json_object_ref (self) : NULL;
#line 1678 "UserGame.c"
}

static gboolean
game_hub_data_sources_user_user_game_real_update_game_info_co (GameHubDataSourcesUserUserGameUpdateGameInfoData* _data_)
{
#line 130 "../src/data/sources/user/UserGame.vala"
	switch (_data_->_state_) {
#line 130 "../src/data/sources/user/UserGame.vala"
		case 0:
#line 1688 "UserGame.c"
		goto _state_0;
#line 130 "../src/data/sources/user/UserGame.vala"
		case 1:
#line 1692 "UserGame.c"
		goto _state_1;
		default:
#line 130 "../src/data/sources/user/UserGame.vala"
		g_assert_not_reached ();
#line 1697 "UserGame.c"
	}
	_state_0:
#line 132 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 1;
#line 132 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) _data_->self, NULL, game_hub_data_sources_user_user_game_update_game_info_ready, _data_);
#line 132 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 1706 "UserGame.c"
	_state_1:
#line 132 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_mount_overlays_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 133 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 135 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp2_ = _data_->self->priv->installer;
#line 135 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp2_ == NULL) {
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp3_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp1_ = _data_->_tmp4_ != NULL;
#line 1722 "UserGame.c"
	} else {
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp1_ = FALSE;
#line 1726 "UserGame.c"
	}
#line 135 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp1_) {
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp5_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp7_ = strlen (_data_->_tmp6_);
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp0_ = _data_->_tmp8_ > 0;
#line 1740 "UserGame.c"
	} else {
#line 135 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp0_ = FALSE;
#line 1744 "UserGame.c"
	}
#line 135 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp0_) {
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp9_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp11_ = game_hub_utils_parser_parse_json (_data_->_tmp10_);
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp13_ = json_node_get_object (_data_->_tmp12_);
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp14_ = _json_object_ref0 (_data_->_tmp13_);
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 137 "../src/data/sources/user/UserGame.vala"
		__vala_JsonNode_free0 (_data_->_tmp12_);
#line 137 "../src/data/sources/user/UserGame.vala"
		_data_->i = _data_->_tmp15_;
#line 138 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp16_ = _data_->i;
#line 138 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp17_ = json_object_get_string_member (_data_->_tmp16_, "installer");
#line 138 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp18_ = g_file_new_for_path (_data_->_tmp17_);
#line 138 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 138 "../src/data/sources/user/UserGame.vala"
		_data_->_tmp20_ = game_hub_data_sources_user_user_game_installer_new (_data_->self, _data_->_tmp19_);
#line 138 "../src/data/sources/user/UserGame.vala"
		_game_hub_data_runnable_installer_unref0 (_data_->self->priv->installer);
#line 138 "../src/data/sources/user/UserGame.vala"
		_data_->self->priv->installer = _data_->_tmp20_;
#line 138 "../src/data/sources/user/UserGame.vala"
		_g_object_unref0 (_data_->_tmp19_);
#line 135 "../src/data/sources/user/UserGame.vala"
		_json_object_unref0 (_data_->i);
#line 1784 "UserGame.c"
	}
#line 141 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_save ((GameHubDataRunnable*) _data_->self);
#line 130 "../src/data/sources/user/UserGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 130 "../src/data/sources/user/UserGame.vala"
	if (_data_->_state_ != 0) {
#line 130 "../src/data/sources/user/UserGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 130 "../src/data/sources/user/UserGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1796 "UserGame.c"
		}
	}
#line 130 "../src/data/sources/user/UserGame.vala"
	g_object_unref (_data_->_async_result);
#line 130 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 1803 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_install_data_free (gpointer _data)
{
	GameHubDataSourcesUserUserGameInstallData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_slice_free (GameHubDataSourcesUserUserGameInstallData, _data_);
#line 1815 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_install (GameHubDataRunnable* base,
                                                   GameHubDataRunnableInstallerInstallMode install_mode,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	GameHubDataSourcesUserUserGame * self;
	GameHubDataSourcesUserUserGameInstallData* _data_;
	GameHubDataSourcesUserUserGame* _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesUserUserGameInstallData);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_user_user_game_real_install_data_free);
#line 25 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->install_mode = install_mode;
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_install_co (_data_);
#line 1843 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_install_finish (GameHubDataRunnable* base,
                                                     GAsyncResult* _res_)
{
	GameHubDataSourcesUserUserGameInstallData* _data_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1853 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_install_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GameHubDataSourcesUserUserGameInstallData* _data_;
#line 146 "../src/data/sources/user/UserGame.vala"
	_data_ = _user_data_;
#line 146 "../src/data/sources/user/UserGame.vala"
	_data_->_source_object_ = source_object;
#line 146 "../src/data/sources/user/UserGame.vala"
	_data_->_res_ = _res_;
#line 146 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_install_co (_data_);
#line 1870 "UserGame.c"
}

static gboolean
_game_hub_data_sources_user_user_game_real_install_co_gsource_func (gpointer self)
{
	gboolean result;
	result = game_hub_data_sources_user_user_game_real_install_co (self);
#line 150 "../src/data/sources/user/UserGame.vala"
	return result;
#line 1880 "UserGame.c"
}

static gboolean
game_hub_data_sources_user_user_game_real_install_co (GameHubDataSourcesUserUserGameInstallData* _data_)
{
#line 144 "../src/data/sources/user/UserGame.vala"
	switch (_data_->_state_) {
#line 144 "../src/data/sources/user/UserGame.vala"
		case 0:
#line 1890 "UserGame.c"
		goto _state_0;
#line 144 "../src/data/sources/user/UserGame.vala"
		case 1:
#line 1894 "UserGame.c"
		goto _state_1;
#line 144 "../src/data/sources/user/UserGame.vala"
		case 2:
#line 1898 "UserGame.c"
		goto _state_2;
		default:
#line 144 "../src/data/sources/user/UserGame.vala"
		g_assert_not_reached ();
#line 1903 "UserGame.c"
	}
	_state_0:
#line 146 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 1;
#line 146 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_update_game_info ((GameHubDataGame*) _data_->self, game_hub_data_sources_user_user_game_install_ready, _data_);
#line 146 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 1912 "UserGame.c"
	_state_1:
#line 146 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_update_game_info_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 147 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp0_ = _data_->self->priv->installer;
#line 147 "../src/data/sources/user/UserGame.vala"
	if (_data_->_tmp0_ == NULL) {
#line 147 "../src/data/sources/user/UserGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 147 "../src/data/sources/user/UserGame.vala"
		if (_data_->_state_ != 0) {
#line 147 "../src/data/sources/user/UserGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 147 "../src/data/sources/user/UserGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1928 "UserGame.c"
			}
		}
#line 147 "../src/data/sources/user/UserGame.vala"
		g_object_unref (_data_->_async_result);
#line 147 "../src/data/sources/user/UserGame.vala"
		return FALSE;
#line 1935 "UserGame.c"
	}
#line 148 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp1_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, (GBoxedCopyFunc) game_hub_data_runnable_installer_ref, (GDestroyNotify) game_hub_data_runnable_installer_unref, NULL, NULL, NULL);
#line 148 "../src/data/sources/user/UserGame.vala"
	_data_->installers = _data_->_tmp1_;
#line 149 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp2_ = _data_->installers;
#line 149 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp3_ = _data_->self->priv->installer;
#line 149 "../src/data/sources/user/UserGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp2_, (GameHubDataRunnableInstaller*) _data_->_tmp3_);
#line 150 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp4_ = _data_->installers;
#line 150 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp5_ = game_hub_ui_dialogs_install_dialog_new ((GameHubDataRunnable*) _data_->self, _data_->_tmp4_, _data_->install_mode, _game_hub_data_sources_user_user_game_real_install_co_gsource_func, _data_, NULL);
#line 150 "../src/data/sources/user/UserGame.vala"
	g_object_ref_sink (_data_->_tmp5_);
#line 150 "../src/data/sources/user/UserGame.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 150 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 151 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 2;
#line 151 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 1961 "UserGame.c"
	_state_2:
	;
#line 144 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->installers);
#line 144 "../src/data/sources/user/UserGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 144 "../src/data/sources/user/UserGame.vala"
	if (_data_->_state_ != 0) {
#line 144 "../src/data/sources/user/UserGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 144 "../src/data/sources/user/UserGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1974 "UserGame.c"
		}
	}
#line 144 "../src/data/sources/user/UserGame.vala"
	g_object_unref (_data_->_async_result);
#line 144 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 1981 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_uninstall_data_free (gpointer _data)
{
	GameHubDataSourcesUserUserGameUninstallData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_slice_free (GameHubDataSourcesUserUserGameUninstallData, _data_);
#line 1993 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_uninstall (GameHubDataGame* base,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	GameHubDataSourcesUserUserGame * self;
	GameHubDataSourcesUserUserGameUninstallData* _data_;
	GameHubDataSourcesUserUserGame* _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesUserUserGameUninstallData);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_user_user_game_real_uninstall_data_free);
#line 25 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_uninstall_co (_data_);
#line 2018 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_uninstall_finish (GameHubDataGame* base,
                                                       GAsyncResult* _res_)
{
	GameHubDataSourcesUserUserGameUninstallData* _data_;
#line 25 "../src/data/sources/user/UserGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2028 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_uninstall_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GameHubDataSourcesUserUserGameUninstallData* _data_;
#line 156 "../src/data/sources/user/UserGame.vala"
	_data_ = _user_data_;
#line 156 "../src/data/sources/user/UserGame.vala"
	_data_->_source_object_ = source_object;
#line 156 "../src/data/sources/user/UserGame.vala"
	_data_->_res_ = _res_;
#line 156 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_real_uninstall_co (_data_);
#line 2045 "UserGame.c"
}

static gboolean
game_hub_data_sources_user_user_game_real_uninstall_co (GameHubDataSourcesUserUserGameUninstallData* _data_)
{
#line 154 "../src/data/sources/user/UserGame.vala"
	switch (_data_->_state_) {
#line 154 "../src/data/sources/user/UserGame.vala"
		case 0:
#line 2055 "UserGame.c"
		goto _state_0;
#line 154 "../src/data/sources/user/UserGame.vala"
		case 1:
#line 2059 "UserGame.c"
		goto _state_1;
		default:
#line 154 "../src/data/sources/user/UserGame.vala"
		g_assert_not_reached ();
#line 2064 "UserGame.c"
	}
	_state_0:
#line 156 "../src/data/sources/user/UserGame.vala"
	_data_->_state_ = 1;
#line 156 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_umount_overlays ((GameHubDataGame*) _data_->self, game_hub_data_sources_user_user_game_uninstall_ready, _data_);
#line 156 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 2073 "UserGame.c"
	_state_1:
#line 156 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_umount_overlays_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 157 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_remove (_data_->self);
#line 154 "../src/data/sources/user/UserGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 154 "../src/data/sources/user/UserGame.vala"
	if (_data_->_state_ != 0) {
#line 154 "../src/data/sources/user/UserGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 154 "../src/data/sources/user/UserGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2087 "UserGame.c"
		}
	}
#line 154 "../src/data/sources/user/UserGame.vala"
	g_object_unref (_data_->_async_result);
#line 154 "../src/data/sources/user/UserGame.vala"
	return FALSE;
#line 2094 "UserGame.c"
}

void
game_hub_data_sources_user_user_game_remove (GameHubDataSourcesUserUserGame* self)
{
	GameHubDataGameSource* _tmp0_;
	GameHubDataGameSource* _tmp1_;
#line 160 "../src/data/sources/user/UserGame.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/data/sources/user/UserGame.vala"
	self->priv->is_removed = TRUE;
#line 163 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_game_get_source ((GameHubDataGame*) self);
#line 163 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = _tmp0_;
#line 163 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_remove_game (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GAME_HUB_DATA_SOURCES_USER_TYPE_USER, GameHubDataSourcesUserUser), self);
#line 164 "../src/data/sources/user/UserGame.vala"
	g_signal_emit (self, game_hub_data_sources_user_user_game_signals[GAME_HUB_DATA_SOURCES_USER_USER_GAME_REMOVED_SIGNAL], 0);
#line 2114 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_save (GameHubDataRunnable* base)
{
	GameHubDataSourcesUserUserGame * self;
#line 167 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 169 "../src/data/sources/user/UserGame.vala"
	if (!self->priv->is_removed) {
#line 171 "../src/data/sources/user/UserGame.vala"
		GAME_HUB_DATA_RUNNABLE_CLASS (game_hub_data_sources_user_user_game_parent_class)->save ((GameHubDataRunnable*) G_TYPE_CHECK_INSTANCE_CAST (self, GAME_HUB_DATA_TYPE_GAME, GameHubDataGame));
#line 2127 "UserGame.c"
	}
}

static void
game_hub_data_sources_user_user_game_real_update_status (GameHubDataRunnable* base)
{
	GameHubDataSourcesUserUserGame * self;
	GFile* exec = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GameHubDataGameState _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp4_;
	GameHubDataGameStatus* _tmp6_;
	GameHubDataGameStatus* _tmp7_;
	GameHubDataGameStatus* _tmp8_;
	GameHubDataGameStatus* _tmp9_;
#line 175 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 177 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) self);
#line 177 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = _tmp0_;
#line 177 "../src/data/sources/user/UserGame.vala"
	exec = _tmp1_;
#line 178 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = exec;
#line 178 "../src/data/sources/user/UserGame.vala"
	if (_tmp4_ != NULL) {
#line 2157 "UserGame.c"
		GFile* _tmp5_;
#line 178 "../src/data/sources/user/UserGame.vala"
		_tmp5_ = exec;
#line 178 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = g_file_query_exists (_tmp5_, NULL);
#line 2163 "UserGame.c"
	} else {
#line 178 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = FALSE;
#line 2167 "UserGame.c"
	}
#line 178 "../src/data/sources/user/UserGame.vala"
	if (_tmp3_) {
#line 178 "../src/data/sources/user/UserGame.vala"
		_tmp2_ = GAME_HUB_DATA_GAME_STATE_INSTALLED;
#line 2173 "UserGame.c"
	} else {
#line 178 "../src/data/sources/user/UserGame.vala"
		_tmp2_ = GAME_HUB_DATA_GAME_STATE_UNINSTALLED;
#line 2177 "UserGame.c"
	}
#line 178 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = game_hub_data_game_status_new (_tmp2_, (GameHubDataGame*) self, NULL);
#line 178 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = _tmp6_;
#line 178 "../src/data/sources/user/UserGame.vala"
	game_hub_data_game_set_status ((GameHubDataGame*) self, _tmp7_);
#line 178 "../src/data/sources/user/UserGame.vala"
	_game_hub_data_game_status_unref0 (_tmp7_);
#line 179 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = game_hub_data_game_get_status ((GameHubDataGame*) self);
#line 179 "../src/data/sources/user/UserGame.vala"
	_tmp9_ = _tmp8_;
#line 179 "../src/data/sources/user/UserGame.vala"
	if (_tmp9_->state == GAME_HUB_DATA_GAME_STATE_INSTALLED) {
#line 2193 "UserGame.c"
		GameHubDataDBTablesTagsTag* _tmp10_;
		GameHubDataDBTablesTagsTag* _tmp11_;
#line 181 "../src/data/sources/user/UserGame.vala"
		_tmp10_ = game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
#line 181 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_remove_tag ((GameHubDataGame*) self, _tmp10_);
#line 182 "../src/data/sources/user/UserGame.vala"
		_tmp11_ = game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
#line 182 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_add_tag ((GameHubDataGame*) self, _tmp11_);
#line 2204 "UserGame.c"
	} else {
		GameHubDataDBTablesTagsTag* _tmp12_;
		GameHubDataDBTablesTagsTag* _tmp13_;
#line 186 "../src/data/sources/user/UserGame.vala"
		_tmp12_ = game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
#line 186 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_add_tag ((GameHubDataGame*) self, _tmp12_);
#line 187 "../src/data/sources/user/UserGame.vala"
		_tmp13_ = game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
#line 187 "../src/data/sources/user/UserGame.vala"
		game_hub_data_game_remove_tag ((GameHubDataGame*) self, _tmp13_);
#line 2216 "UserGame.c"
	}
#line 175 "../src/data/sources/user/UserGame.vala"
	_g_object_unref0 (exec);
#line 2220 "UserGame.c"
}

static gchar**
game_hub_data_sources_user_user_game_real_get_tweaks (GameHubDataTweakableGame* base,
                                                      gint* result_length1)
{
	gchar** result;
	GameHubDataSourcesUserUserGame* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 27 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 27 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = self->priv->_tweaks;
#line 27 "../src/data/sources/user/UserGame.vala"
	_tmp0__length1 = self->priv->_tweaks_length1;
#line 27 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = _tmp0_;
#line 27 "../src/data/sources/user/UserGame.vala"
	_tmp1__length1 = _tmp0__length1;
#line 27 "../src/data/sources/user/UserGame.vala"
	if (result_length1) {
#line 27 "../src/data/sources/user/UserGame.vala"
		*result_length1 = _tmp1__length1;
#line 2247 "UserGame.c"
	}
#line 27 "../src/data/sources/user/UserGame.vala"
	result = _tmp1_;
#line 27 "../src/data/sources/user/UserGame.vala"
	return result;
#line 2253 "UserGame.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 27 "../src/data/sources/user/UserGame.vala"
	if (length >= 0) {
#line 2262 "UserGame.c"
		gchar** result;
		gssize i;
#line 27 "../src/data/sources/user/UserGame.vala"
		result = g_new0 (gchar*, length + 1);
#line 27 "../src/data/sources/user/UserGame.vala"
		for (i = 0; i < length; i++) {
#line 2269 "UserGame.c"
			gchar* _tmp0_;
#line 27 "../src/data/sources/user/UserGame.vala"
			_tmp0_ = g_strdup (self[i]);
#line 27 "../src/data/sources/user/UserGame.vala"
			result[i] = _tmp0_;
#line 2275 "UserGame.c"
		}
#line 27 "../src/data/sources/user/UserGame.vala"
		return result;
#line 2279 "UserGame.c"
	}
#line 27 "../src/data/sources/user/UserGame.vala"
	return NULL;
#line 2283 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_real_set_tweaks (GameHubDataTweakableGame* base,
                                                      gchar** value,
                                                      gint value_length1)
{
	GameHubDataSourcesUserUserGame* self;
	gchar** old_value;
	gint old_value_length;
#line 27 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGame*) base;
#line 27 "../src/data/sources/user/UserGame.vala"
	old_value = game_hub_data_sources_user_user_game_real_get_tweaks (base, &old_value_length);
#line 27 "../src/data/sources/user/UserGame.vala"
	if (old_value != value) {
#line 2300 "UserGame.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 27 "../src/data/sources/user/UserGame.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup7 (value, value_length1) : value;
#line 27 "../src/data/sources/user/UserGame.vala"
		_tmp0__length1 = value_length1;
#line 27 "../src/data/sources/user/UserGame.vala"
		self->priv->_tweaks = (_vala_array_free (self->priv->_tweaks, self->priv->_tweaks_length1, (GDestroyNotify) g_free), NULL);
#line 27 "../src/data/sources/user/UserGame.vala"
		self->priv->_tweaks = _tmp0_;
#line 27 "../src/data/sources/user/UserGame.vala"
		self->priv->_tweaks_length1 = _tmp0__length1;
#line 27 "../src/data/sources/user/UserGame.vala"
		self->priv->__tweaks_size_ = self->priv->_tweaks_length1;
#line 27 "../src/data/sources/user/UserGame.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_sources_user_user_game_properties[GAME_HUB_DATA_SOURCES_USER_USER_GAME_TWEAKS_PROPERTY]);
#line 2317 "UserGame.c"
	}
}

static inline gpointer
game_hub_data_sources_user_user_game_installer_get_instance_private (GameHubDataSourcesUserUserGameInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataSourcesUserUserGameInstaller_private_offset);
}

GameHubDataSourcesUserUserGameInstaller*
game_hub_data_sources_user_user_game_installer_construct (GType object_type,
                                                          GameHubDataSourcesUserUserGame* game,
                                                          GFile* installer)
{
	GameHubDataSourcesUserUserGameInstaller* self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GameHubDataPlatform _tmp3_ = 0;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
#line 196 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 196 "../src/data/sources/user/UserGame.vala"
	g_return_val_if_fail (installer != NULL, NULL);
#line 196 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGameInstaller*) game_hub_data_runnable_file_installer_construct (object_type);
#line 198 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 198 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = _tmp0_;
#line 198 "../src/data/sources/user/UserGame.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 198 "../src/data/sources/user/UserGame.vala"
	_g_free0 (self->priv->game_name);
#line 198 "../src/data/sources/user/UserGame.vala"
	self->priv->game_name = _tmp2_;
#line 199 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_installer_set_id ((GameHubDataRunnableInstaller*) self, "installer");
#line 200 "../src/data/sources/user/UserGame.vala"
	_tmp4_ = g_file_get_path (installer);
#line 200 "../src/data/sources/user/UserGame.vala"
	_tmp5_ = _tmp4_;
#line 200 "../src/data/sources/user/UserGame.vala"
	_tmp6_ = g_utf8_strdown (_tmp5_, (gssize) -1);
#line 200 "../src/data/sources/user/UserGame.vala"
	_tmp7_ = _tmp6_;
#line 200 "../src/data/sources/user/UserGame.vala"
	_tmp8_ = g_str_has_suffix (_tmp7_, ".exe");
#line 200 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp7_);
#line 200 "../src/data/sources/user/UserGame.vala"
	_g_free0 (_tmp5_);
#line 200 "../src/data/sources/user/UserGame.vala"
	if (_tmp8_) {
#line 200 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = GAME_HUB_DATA_PLATFORM_WINDOWS;
#line 2378 "UserGame.c"
	} else {
#line 200 "../src/data/sources/user/UserGame.vala"
		_tmp3_ = GAME_HUB_DATA_PLATFORM_LINUX;
#line 2382 "UserGame.c"
	}
#line 200 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_installer_set_platform ((GameHubDataRunnableInstaller*) self, _tmp3_);
#line 201 "../src/data/sources/user/UserGame.vala"
	game_hub_data_runnable_file_installer_set_file ((GameHubDataRunnableFileInstaller*) self, installer);
#line 196 "../src/data/sources/user/UserGame.vala"
	return self;
#line 2390 "UserGame.c"
}

GameHubDataSourcesUserUserGameInstaller*
game_hub_data_sources_user_user_game_installer_new (GameHubDataSourcesUserUserGame* game,
                                                    GFile* installer)
{
#line 196 "../src/data/sources/user/UserGame.vala"
	return game_hub_data_sources_user_user_game_installer_construct (GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, game, installer);
#line 2399 "UserGame.c"
}

static gchar*
game_hub_data_sources_user_user_game_installer_real_get_name (GameHubDataRunnableInstaller* base)
{
	gchar* result;
	GameHubDataSourcesUserUserGameInstaller* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 194 "../src/data/sources/user/UserGame.vala"
	self = (GameHubDataSourcesUserUserGameInstaller*) base;
#line 194 "../src/data/sources/user/UserGame.vala"
	_tmp0_ = self->priv->game_name;
#line 194 "../src/data/sources/user/UserGame.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 194 "../src/data/sources/user/UserGame.vala"
	result = _tmp1_;
#line 194 "../src/data/sources/user/UserGame.vala"
	return result;
#line 2419 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_installer_class_init (GameHubDataSourcesUserUserGameInstallerClass * klass,
                                                           gpointer klass_data)
{
#line 191 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_installer_parent_class = g_type_class_peek_parent (klass);
#line 191 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_sources_user_user_game_installer_finalize;
#line 191 "../src/data/sources/user/UserGame.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataSourcesUserUserGameInstaller_private_offset);
#line 191 "../src/data/sources/user/UserGame.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (klass)->get_name = game_hub_data_sources_user_user_game_installer_real_get_name;
#line 2434 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_installer_instance_init (GameHubDataSourcesUserUserGameInstaller * self,
                                                              gpointer klass)
{
#line 191 "../src/data/sources/user/UserGame.vala"
	self->priv = game_hub_data_sources_user_user_game_installer_get_instance_private (self);
#line 2443 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataSourcesUserUserGameInstaller * self;
#line 191 "../src/data/sources/user/UserGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_USER_USER_GAME_TYPE_INSTALLER, GameHubDataSourcesUserUserGameInstaller);
#line 193 "../src/data/sources/user/UserGame.vala"
	_g_free0 (self->priv->game_name);
#line 191 "../src/data/sources/user/UserGame.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (game_hub_data_sources_user_user_game_installer_parent_class)->finalize (obj);
#line 2456 "UserGame.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_user_user_game_installer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesUserUserGameInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_user_user_game_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesUserUserGameInstaller), 0, (GInstanceInitFunc) game_hub_data_sources_user_user_game_installer_instance_init, NULL };
	GType game_hub_data_sources_user_user_game_installer_type_id;
	game_hub_data_sources_user_user_game_installer_type_id = g_type_register_static (GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, "GameHubDataSourcesUserUserGameInstaller", &g_define_type_info, 0);
	GameHubDataSourcesUserUserGameInstaller_private_offset = g_type_add_instance_private (game_hub_data_sources_user_user_game_installer_type_id, sizeof (GameHubDataSourcesUserUserGameInstallerPrivate));
	return game_hub_data_sources_user_user_game_installer_type_id;
}

GType
game_hub_data_sources_user_user_game_installer_get_type (void)
{
	static volatile gsize game_hub_data_sources_user_user_game_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_user_user_game_installer_type_id__volatile)) {
		GType game_hub_data_sources_user_user_game_installer_type_id;
		game_hub_data_sources_user_user_game_installer_type_id = game_hub_data_sources_user_user_game_installer_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_user_user_game_installer_type_id__volatile, game_hub_data_sources_user_user_game_installer_type_id);
	}
	return game_hub_data_sources_user_user_game_installer_type_id__volatile;
}

static void
game_hub_data_sources_user_user_game_class_init (GameHubDataSourcesUserUserGameClass * klass,
                                                 gpointer klass_data)
{
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/data/sources/user/UserGame.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataSourcesUserUserGame_private_offset);
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->update_game_info = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_user_user_game_real_update_game_info;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->update_game_info_finish = (void (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_sources_user_user_game_update_game_info_finish;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->install = (void (*) (GameHubDataRunnable*, GameHubDataRunnableInstallerInstallMode, GAsyncReadyCallback, gpointer)) game_hub_data_sources_user_user_game_real_install;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->install_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_sources_user_user_game_install_finish;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->uninstall = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_user_user_game_real_uninstall;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataGameClass *) klass)->uninstall_finish = (void (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_sources_user_user_game_uninstall_finish;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->save = (void (*) (GameHubDataRunnable*)) game_hub_data_sources_user_user_game_real_save;
#line 25 "../src/data/sources/user/UserGame.vala"
	((GameHubDataRunnableClass *) klass)->update_status = (void (*) (GameHubDataRunnable*)) game_hub_data_sources_user_user_game_real_update_status;
#line 25 "../src/data/sources/user/UserGame.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_sources_user_user_game_get_property;
#line 25 "../src/data/sources/user/UserGame.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_sources_user_user_game_set_property;
#line 25 "../src/data/sources/user/UserGame.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_sources_user_user_game_finalize;
#line 25 "../src/data/sources/user/UserGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_USER_USER_GAME_TWEAKS_PROPERTY, game_hub_data_sources_user_user_game_properties[GAME_HUB_DATA_SOURCES_USER_USER_GAME_TWEAKS_PROPERTY] = g_param_spec_boxed ("tweaks", "tweaks", "tweaks", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_signals[GAME_HUB_DATA_SOURCES_USER_USER_GAME_REMOVED_SIGNAL] = g_signal_new ("removed", GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2515 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_game_hub_data_tweakable_game_interface_init (GameHubDataTweakableGameIface * iface,
                                                                                  gpointer iface_data)
{
#line 25 "../src/data/sources/user/UserGame.vala"
	game_hub_data_sources_user_user_game_game_hub_data_tweakable_game_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../src/data/sources/user/UserGame.vala"
	iface->get_tweaks = game_hub_data_sources_user_user_game_real_get_tweaks;
#line 25 "../src/data/sources/user/UserGame.vala"
	iface->set_tweaks = game_hub_data_sources_user_user_game_real_set_tweaks;
#line 2528 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_instance_init (GameHubDataSourcesUserUserGame * self,
                                                    gpointer klass)
{
#line 25 "../src/data/sources/user/UserGame.vala"
	self->priv = game_hub_data_sources_user_user_game_get_instance_private (self);
#line 27 "../src/data/sources/user/UserGame.vala"
	self->priv->_tweaks = NULL;
#line 27 "../src/data/sources/user/UserGame.vala"
	self->priv->_tweaks_length1 = 0;
#line 27 "../src/data/sources/user/UserGame.vala"
	self->priv->__tweaks_size_ = self->priv->_tweaks_length1;
#line 29 "../src/data/sources/user/UserGame.vala"
	self->priv->is_removed = FALSE;
#line 2545 "UserGame.c"
}

static void
game_hub_data_sources_user_user_game_finalize (GObject * obj)
{
	GameHubDataSourcesUserUserGame * self;
#line 25 "../src/data/sources/user/UserGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGame);
#line 27 "../src/data/sources/user/UserGame.vala"
	self->priv->_tweaks = (_vala_array_free (self->priv->_tweaks, self->priv->_tweaks_length1, (GDestroyNotify) g_free), NULL);
#line 32 "../src/data/sources/user/UserGame.vala"
	_game_hub_data_runnable_installer_unref0 (self->priv->installer);
#line 25 "../src/data/sources/user/UserGame.vala"
	G_OBJECT_CLASS (game_hub_data_sources_user_user_game_parent_class)->finalize (obj);
#line 2560 "UserGame.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_user_user_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesUserUserGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_user_user_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesUserUserGame), 0, (GInstanceInitFunc) game_hub_data_sources_user_user_game_instance_init, NULL };
	static const GInterfaceInfo game_hub_data_tweakable_game_info = { (GInterfaceInitFunc) game_hub_data_sources_user_user_game_game_hub_data_tweakable_game_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType game_hub_data_sources_user_user_game_type_id;
	game_hub_data_sources_user_user_game_type_id = g_type_register_static (GAME_HUB_DATA_TYPE_GAME, "GameHubDataSourcesUserUserGame", &g_define_type_info, 0);
	g_type_add_interface_static (game_hub_data_sources_user_user_game_type_id, GAME_HUB_DATA_TYPE_TWEAKABLE_GAME, &game_hub_data_tweakable_game_info);
	GameHubDataSourcesUserUserGame_private_offset = g_type_add_instance_private (game_hub_data_sources_user_user_game_type_id, sizeof (GameHubDataSourcesUserUserGamePrivate));
	return game_hub_data_sources_user_user_game_type_id;
}

GType
game_hub_data_sources_user_user_game_get_type (void)
{
	static volatile gsize game_hub_data_sources_user_user_game_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_user_user_game_type_id__volatile)) {
		GType game_hub_data_sources_user_user_game_type_id;
		game_hub_data_sources_user_user_game_type_id = game_hub_data_sources_user_user_game_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_user_user_game_type_id__volatile, game_hub_data_sources_user_user_game_type_id);
	}
	return game_hub_data_sources_user_user_game_type_id__volatile;
}

static void
_vala_game_hub_data_sources_user_user_game_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec)
{
	GameHubDataSourcesUserUserGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGame);
#line 25 "../src/data/sources/user/UserGame.vala"
	switch (property_id) {
#line 25 "../src/data/sources/user/UserGame.vala"
		case GAME_HUB_DATA_SOURCES_USER_USER_GAME_TWEAKS_PROPERTY:
#line 2599 "UserGame.c"
		{
			int length;
#line 25 "../src/data/sources/user/UserGame.vala"
			g_value_set_boxed (value, game_hub_data_tweakable_game_get_tweaks ((GameHubDataTweakableGame*) self, &length));
#line 2604 "UserGame.c"
		}
#line 25 "../src/data/sources/user/UserGame.vala"
		break;
#line 2608 "UserGame.c"
		default:
#line 25 "../src/data/sources/user/UserGame.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/data/sources/user/UserGame.vala"
		break;
#line 2614 "UserGame.c"
	}
}

static void
_vala_game_hub_data_sources_user_user_game_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec)
{
	GameHubDataSourcesUserUserGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_SOURCES_USER_TYPE_USER_GAME, GameHubDataSourcesUserUserGame);
#line 25 "../src/data/sources/user/UserGame.vala"
	switch (property_id) {
#line 25 "../src/data/sources/user/UserGame.vala"
		case GAME_HUB_DATA_SOURCES_USER_USER_GAME_TWEAKS_PROPERTY:
#line 2630 "UserGame.c"
		{
			gpointer boxed;
#line 25 "../src/data/sources/user/UserGame.vala"
			boxed = g_value_get_boxed (value);
#line 25 "../src/data/sources/user/UserGame.vala"
			game_hub_data_tweakable_game_set_tweaks ((GameHubDataTweakableGame*) self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2637 "UserGame.c"
		}
#line 25 "../src/data/sources/user/UserGame.vala"
		break;
#line 2641 "UserGame.c"
		default:
#line 25 "../src/data/sources/user/UserGame.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/data/sources/user/UserGame.vala"
		break;
#line 2647 "UserGame.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

