/* IGDB.c generated by valac 0.54.8, the Vala compiler
 * generated from IGDB.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include <json-glib/json-glib.h>
#include <libsoup/soup.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_SCHEME "https://"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_DOMAIN "igdb.com"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_API_SUBDOMAIN "api-v3."
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_API_BASE_URL GAME_HUB_DATA_PROVIDERS_DATA_IGDB_SCHEME GAME_HUB_DATA_PROVIDERS_DATA_IGDB_API_SUBDOMAIN GAME_HUB_DATA_PROVIDERS_DATA_IGDB_DOMAIN
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_API_KEY_PAGE "https://api.igdb.com/admin/applications"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_ID "id"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_NAME "name"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_URL "url"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_RELEASE_DATE "first_release_date"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_WEBSITES "websites"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__EXPAND ".*"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_PLATFORMS "platforms"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_SUMMARY "summary"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_STORYLINE "storyline"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_GENRES "genres"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_KEYWORDS "keywords"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_POPULARITY "popularity"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING "aggregated_rating"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__COUNT "_count"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING_COUNT GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__COUNT
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING "rating"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING_COUNT GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__COUNT
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING "total_rating"
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING_COUNT GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__COUNT
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GAME_HUB_DATA_PROVIDERS_TYPE_PROVIDER (game_hub_data_providers_provider_get_type ())
#define GAME_HUB_DATA_PROVIDERS_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_PROVIDERS_TYPE_PROVIDER, GameHubDataProvidersProvider))
#define GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_PROVIDERS_TYPE_PROVIDER, GameHubDataProvidersProviderClass))
#define GAME_HUB_DATA_PROVIDERS_IS_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_PROVIDERS_TYPE_PROVIDER))
#define GAME_HUB_DATA_PROVIDERS_IS_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_PROVIDERS_TYPE_PROVIDER))
#define GAME_HUB_DATA_PROVIDERS_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_PROVIDERS_TYPE_PROVIDER, GameHubDataProvidersProviderClass))

typedef struct _GameHubDataProvidersProvider GameHubDataProvidersProvider;
typedef struct _GameHubDataProvidersProviderClass GameHubDataProvidersProviderClass;
typedef struct _GameHubDataProvidersProviderPrivate GameHubDataProvidersProviderPrivate;

#define GAME_HUB_DATA_PROVIDERS_TYPE_DATA_PROVIDER (game_hub_data_providers_data_provider_get_type ())
#define GAME_HUB_DATA_PROVIDERS_DATA_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_PROVIDERS_TYPE_DATA_PROVIDER, GameHubDataProvidersDataProvider))
#define GAME_HUB_DATA_PROVIDERS_DATA_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_PROVIDERS_TYPE_DATA_PROVIDER, GameHubDataProvidersDataProviderClass))
#define GAME_HUB_DATA_PROVIDERS_IS_DATA_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_PROVIDERS_TYPE_DATA_PROVIDER))
#define GAME_HUB_DATA_PROVIDERS_IS_DATA_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_PROVIDERS_TYPE_DATA_PROVIDER))
#define GAME_HUB_DATA_PROVIDERS_DATA_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_PROVIDERS_TYPE_DATA_PROVIDER, GameHubDataProvidersDataProviderClass))

typedef struct _GameHubDataProvidersDataProvider GameHubDataProvidersDataProvider;
typedef struct _GameHubDataProvidersDataProviderClass GameHubDataProvidersDataProviderClass;
typedef struct _GameHubDataProvidersDataProviderPrivate GameHubDataProvidersDataProviderPrivate;

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;

#define GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB (game_hub_data_providers_data_igdb_get_type ())
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB, GameHubDataProvidersDataIGDB))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB, GameHubDataProvidersDataIGDBClass))
#define GAME_HUB_DATA_PROVIDERS_DATA_IS_IGDB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB))
#define GAME_HUB_DATA_PROVIDERS_DATA_IS_IGDB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB, GameHubDataProvidersDataIGDBClass))

typedef struct _GameHubDataProvidersDataIGDB GameHubDataProvidersDataIGDB;
typedef struct _GameHubDataProvidersDataIGDBClass GameHubDataProvidersDataIGDBClass;
typedef struct _GameHubDataProvidersDataIGDBPrivate GameHubDataProvidersDataIGDBPrivate;

#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT (game_hub_data_providers_data_igdb_result_get_type ())
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT, GameHubDataProvidersDataIGDBResult))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT, GameHubDataProvidersDataIGDBResultClass))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT, GameHubDataProvidersDataIGDBResultClass))

typedef struct _GameHubDataProvidersDataIGDBResult GameHubDataProvidersDataIGDBResult;
typedef struct _GameHubDataProvidersDataIGDBResultClass GameHubDataProvidersDataIGDBResultClass;
#define _game_hub_data_providers_provider_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_providers_provider_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GAME_HUB_SETTINGS_TYPE_SETTINGS_SCHEMA (game_hub_settings_settings_schema_get_type ())
#define GAME_HUB_SETTINGS_SETTINGS_SCHEMA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_SETTINGS_TYPE_SETTINGS_SCHEMA, GameHubSettingsSettingsSchema))
#define GAME_HUB_SETTINGS_SETTINGS_SCHEMA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_SETTINGS_TYPE_SETTINGS_SCHEMA, GameHubSettingsSettingsSchemaClass))
#define GAME_HUB_SETTINGS_IS_SETTINGS_SCHEMA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_SETTINGS_TYPE_SETTINGS_SCHEMA))
#define GAME_HUB_SETTINGS_IS_SETTINGS_SCHEMA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_SETTINGS_TYPE_SETTINGS_SCHEMA))
#define GAME_HUB_SETTINGS_SETTINGS_SCHEMA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_SETTINGS_TYPE_SETTINGS_SCHEMA, GameHubSettingsSettingsSchemaClass))

typedef struct _GameHubSettingsSettingsSchema GameHubSettingsSettingsSchema;
typedef struct _GameHubSettingsSettingsSchemaClass GameHubSettingsSettingsSchemaClass;

#define GAME_HUB_SETTINGS_PROVIDERS_DATA_TYPE_IGDB (game_hub_settings_providers_data_igdb_get_type ())
#define GAME_HUB_SETTINGS_PROVIDERS_DATA_IGDB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_SETTINGS_PROVIDERS_DATA_TYPE_IGDB, GameHubSettingsProvidersDataIGDB))
#define GAME_HUB_SETTINGS_PROVIDERS_DATA_IGDB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_SETTINGS_PROVIDERS_DATA_TYPE_IGDB, GameHubSettingsProvidersDataIGDBClass))
#define GAME_HUB_SETTINGS_PROVIDERS_DATA_IS_IGDB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_SETTINGS_PROVIDERS_DATA_TYPE_IGDB))
#define GAME_HUB_SETTINGS_PROVIDERS_DATA_IS_IGDB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_SETTINGS_PROVIDERS_DATA_TYPE_IGDB))
#define GAME_HUB_SETTINGS_PROVIDERS_DATA_IGDB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_SETTINGS_PROVIDERS_DATA_TYPE_IGDB, GameHubSettingsProvidersDataIGDBClass))

typedef struct _GameHubSettingsProvidersDataIGDB GameHubSettingsProvidersDataIGDB;
typedef struct _GameHubSettingsProvidersDataIGDBClass GameHubSettingsProvidersDataIGDBClass;
typedef struct _GameHubDataProvidersDataIgdbDataData GameHubDataProvidersDataIgdbDataData;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _game_hub_data_providers_data_igdb_result_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_providers_data_igdb_result_unref (var), NULL)))
typedef struct _GameHubDataProvidersDataIgdbParseData GameHubDataProvidersDataIgdbParseData;

#define GAME_HUB_UI_VIEWS_TYPE_BASE_VIEW (game_hub_ui_views_base_view_get_type ())
#define GAME_HUB_UI_VIEWS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_VIEWS_TYPE_BASE_VIEW, GameHubUIViewsBaseView))
#define GAME_HUB_UI_VIEWS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_VIEWS_TYPE_BASE_VIEW, GameHubUIViewsBaseViewClass))
#define GAME_HUB_UI_VIEWS_IS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_VIEWS_TYPE_BASE_VIEW))
#define GAME_HUB_UI_VIEWS_IS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_VIEWS_TYPE_BASE_VIEW))
#define GAME_HUB_UI_VIEWS_BASE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_VIEWS_TYPE_BASE_VIEW, GameHubUIViewsBaseViewClass))

typedef struct _GameHubUIViewsBaseView GameHubUIViewsBaseView;
typedef struct _GameHubUIViewsBaseViewClass GameHubUIViewsBaseViewClass;

#define GAME_HUB_UI_VIEWS_GAMES_VIEW_TYPE_GAMES_VIEW (game_hub_ui_views_games_view_games_view_get_type ())
#define GAME_HUB_UI_VIEWS_GAMES_VIEW_GAMES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_VIEWS_GAMES_VIEW_TYPE_GAMES_VIEW, GameHubUIViewsGamesViewGamesView))
#define GAME_HUB_UI_VIEWS_GAMES_VIEW_GAMES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_VIEWS_GAMES_VIEW_TYPE_GAMES_VIEW, GameHubUIViewsGamesViewGamesViewClass))
#define GAME_HUB_UI_VIEWS_GAMES_VIEW_IS_GAMES_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_VIEWS_GAMES_VIEW_TYPE_GAMES_VIEW))
#define GAME_HUB_UI_VIEWS_GAMES_VIEW_IS_GAMES_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_VIEWS_GAMES_VIEW_TYPE_GAMES_VIEW))
#define GAME_HUB_UI_VIEWS_GAMES_VIEW_GAMES_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_VIEWS_GAMES_VIEW_TYPE_GAMES_VIEW, GameHubUIViewsGamesViewGamesViewClass))

typedef struct _GameHubUIViewsGamesViewGamesView GameHubUIViewsGamesViewGamesView;
typedef struct _GameHubUIViewsGamesViewGamesViewClass GameHubUIViewsGamesViewGamesViewClass;
typedef struct _Block45Data Block45Data;

#define GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_TYPE_SETTINGS_DIALOG (game_hub_ui_dialogs_settings_dialog_settings_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_SETTINGS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_TYPE_SETTINGS_DIALOG, GameHubUIDialogsSettingsDialogSettingsDialog))
#define GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_SETTINGS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_TYPE_SETTINGS_DIALOG, GameHubUIDialogsSettingsDialogSettingsDialogClass))
#define GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_IS_SETTINGS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_TYPE_SETTINGS_DIALOG))
#define GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_IS_SETTINGS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_TYPE_SETTINGS_DIALOG))
#define GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_SETTINGS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_SETTINGS_DIALOG_TYPE_SETTINGS_DIALOG, GameHubUIDialogsSettingsDialogSettingsDialogClass))

typedef struct _GameHubUIDialogsSettingsDialogSettingsDialog GameHubUIDialogsSettingsDialogSettingsDialog;
typedef struct _GameHubUIDialogsSettingsDialogSettingsDialogClass GameHubUIDialogsSettingsDialogSettingsDialogClass;

#define GAME_HUB_UI_WIDGETS_TYPE_MODE_BUTTON (game_hub_ui_widgets_mode_button_get_type ())
#define GAME_HUB_UI_WIDGETS_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_WIDGETS_TYPE_MODE_BUTTON, GameHubUIWidgetsModeButton))
#define GAME_HUB_UI_WIDGETS_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_WIDGETS_TYPE_MODE_BUTTON, GameHubUIWidgetsModeButtonClass))
#define GAME_HUB_UI_WIDGETS_IS_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_WIDGETS_TYPE_MODE_BUTTON))
#define GAME_HUB_UI_WIDGETS_IS_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_WIDGETS_TYPE_MODE_BUTTON))
#define GAME_HUB_UI_WIDGETS_MODE_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_WIDGETS_TYPE_MODE_BUTTON, GameHubUIWidgetsModeButtonClass))

typedef struct _GameHubUIWidgetsModeButton GameHubUIWidgetsModeButton;
typedef struct _GameHubUIWidgetsModeButtonClass GameHubUIWidgetsModeButtonClass;
typedef struct _Block46Data Block46Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	GAME_HUB_SETTINGS_PROVIDERS_DATA_IGDB_PREFERRED_DESCRIPTION_GAME = 0,
	GAME_HUB_SETTINGS_PROVIDERS_DATA_IGDB_PREFERRED_DESCRIPTION_IGDB = 1,
	GAME_HUB_SETTINGS_PROVIDERS_DATA_IGDB_PREFERRED_DESCRIPTION_BOTH = 2
} GameHubSettingsProvidersDataIGDBPreferredDescription;

#define GAME_HUB_SETTINGS_PROVIDERS_DATA_IGDB_TYPE_PREFERRED_DESCRIPTION (game_hub_settings_providers_data_igdb_preferred_description_get_type ())
typedef struct _GameHubDataProvidersDataIGDBResultPrivate GameHubDataProvidersDataIGDBResultPrivate;

#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE (game_hub_data_providers_data_igdb_result_website_get_type ())
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE, GameHubDataProvidersDataIGDBResultWebsite))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE, GameHubDataProvidersDataIGDBResultWebsiteClass))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_IS_WEBSITE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_IS_WEBSITE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE, GameHubDataProvidersDataIGDBResultWebsiteClass))

typedef struct _GameHubDataProvidersDataIGDBResultWebsite GameHubDataProvidersDataIGDBResultWebsite;
typedef struct _GameHubDataProvidersDataIGDBResultWebsiteClass GameHubDataProvidersDataIGDBResultWebsiteClass;

#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK (game_hub_data_providers_data_igdb_result_link_get_type ())
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_LINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK, GameHubDataProvidersDataIGDBResultLink))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK, GameHubDataProvidersDataIGDBResultLinkClass))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_IS_LINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_IS_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_LINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK, GameHubDataProvidersDataIGDBResultLinkClass))

typedef struct _GameHubDataProvidersDataIGDBResultLink GameHubDataProvidersDataIGDBResultLink;
typedef struct _GameHubDataProvidersDataIGDBResultLinkClass GameHubDataProvidersDataIGDBResultLinkClass;
typedef struct _GameHubDataProvidersDataIGDBResultLinkPrivate GameHubDataProvidersDataIGDBResultLinkPrivate;
typedef struct _GameHubDataProvidersDataIGDBResultParamSpecLink GameHubDataProvidersDataIGDBResultParamSpecLink;
typedef struct _GameHubDataProvidersDataIGDBResultWebsitePrivate GameHubDataProvidersDataIGDBResultWebsitePrivate;
typedef enum  {
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_UNKNOWN = 0,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_OFFICIAL = 1,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIA = 2,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIPEDIA = 3,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_FACEBOOK = 4,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITTER = 5,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITCH = 6,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_INSTAGRAM = 8,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_YOUTUBE = 9,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPHONE = 10,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPAD = 11,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_ANDROID = 12,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_STEAM = 13,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_REDDIT = 14,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_DISCORD = 15,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_GOOGLE_PLUS = 16,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TUMBLR = 17,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_LINKEDIN = 18,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_PINTEREST = 19,
	GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_SOUNDCLOUD = 20
} GameHubDataProvidersDataIGDBResultWebsiteCategory;

#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_TYPE_CATEGORY (game_hub_data_providers_data_igdb_result_website_category_get_type ())
typedef struct _GameHubDataProvidersDataIGDBResultParamSpecWebsite GameHubDataProvidersDataIGDBResultParamSpecWebsite;
typedef struct _GameHubDataProvidersDataIGDBParamSpecResult GameHubDataProvidersDataIGDBParamSpecResult;

#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS (game_hub_data_providers_data_igdb_fields_get_type ())
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS, GameHubDataProvidersDataIGDBFields))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS, GameHubDataProvidersDataIGDBFieldsClass))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_IS_FIELDS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_IS_FIELDS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS))
#define GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS, GameHubDataProvidersDataIGDBFieldsClass))

typedef struct _GameHubDataProvidersDataIGDBFields GameHubDataProvidersDataIGDBFields;
typedef struct _GameHubDataProvidersDataIGDBFieldsClass GameHubDataProvidersDataIGDBFieldsClass;
typedef struct _GameHubDataProvidersDataIGDBFieldsPrivate GameHubDataProvidersDataIGDBFieldsPrivate;
typedef struct _GameHubDataProvidersDataIGDBParamSpecFields GameHubDataProvidersDataIGDBParamSpecFields;

struct _GameHubDataProvidersProvider {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataProvidersProviderPrivate * priv;
};

struct _GameHubDataProvidersProviderClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataProvidersProvider *self);
	const gchar* (*get_id) (GameHubDataProvidersProvider* self);
	const gchar* (*get_name) (GameHubDataProvidersProvider* self);
	const gchar* (*get_url) (GameHubDataProvidersProvider* self);
	const gchar* (*get_icon) (GameHubDataProvidersProvider* self);
	gboolean (*get_enabled) (GameHubDataProvidersProvider* self);
	void (*set_enabled) (GameHubDataProvidersProvider* self, gboolean value);
	GtkWidget* (*get_settings_widget) (GameHubDataProvidersProvider* self);
};

struct _GameHubDataProvidersDataProvider {
	GameHubDataProvidersProvider parent_instance;
	GameHubDataProvidersDataProviderPrivate * priv;
};

struct _GameHubDataProvidersDataProviderClass {
	GameHubDataProvidersProviderClass parent_class;
	void (*data) (GameHubDataProvidersDataProvider* self, GameHubDataGame* game, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gpointer (*data_finish) (GameHubDataProvidersDataProvider* self, GAsyncResult* _res_);
};

struct _GameHubDataProvidersDataIGDB {
	GameHubDataProvidersDataProvider parent_instance;
	GameHubDataProvidersDataIGDBPrivate * priv;
};

struct _GameHubDataProvidersDataIGDBClass {
	GameHubDataProvidersDataProviderClass parent_class;
};

struct _GameHubDataProvidersDataIGDBPrivate {
	gboolean request_quota_reached;
};

struct _GameHubDataProvidersDataIgdbDataData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataProvidersDataIGDB* self;
	GameHubDataGame* game;
	GeeArrayList* result;
	gchar* cached;
	gchar* _tmp0_;
	gboolean _error_;
	guint status;
	gchar* err_msg;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* res;
	const gchar* _tmp6_;
	gboolean _tmp7_;
	guint _tmp8_;
	gchar* _tmp9_;
	GeeArrayList* _tmp10_;
	gboolean _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeHashMap* headers;
	GeeHashMap* _tmp14_;
	GeeHashMap* _tmp15_;
	GameHubSettingsProvidersDataIGDB* _tmp16_;
	GameHubSettingsProvidersDataIGDB* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* endpoint;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* json;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GeeHashMap* _tmp31_;
	guint _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GeeArrayList* _vala1_res;
	const gchar* _tmp35_;
	gboolean _tmp36_;
	guint _tmp37_;
	gchar* _tmp38_;
	GeeArrayList* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
};

struct _GameHubDataProvidersDataIgdbParseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataProvidersDataIGDB* self;
	GameHubDataGame* game;
	gchar* json;
	gboolean _error_;
	guint status;
	gchar* err_msg;
	GeeArrayList* result;
	JsonNode* json_root;
	JsonNode* _tmp0_;
	gboolean _tmp1_;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* json_array;
	JsonNode* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* _tmp6_;
	gboolean _tmp7_;
	JsonArray* _tmp8_;
	JsonArray* _tmp9_;
	GeeArrayList* results;
	GeeArrayList* _tmp10_;
	JsonArray* _tmp11_;
	GList* _tmp12_;
	GList* node_collection;
	GList* node_it;
	JsonNode* node;
	JsonObject* obj;
	JsonNode* _tmp13_;
	JsonObject* _tmp14_;
	JsonObject* _tmp15_;
	JsonObject* _tmp16_;
	guint _tmp17_;
	gchar* _tmp18_;
	gboolean _tmp19_;
	GeeArrayList* _tmp20_;
	JsonObject* _tmp21_;
	GameHubDataProvidersDataIGDBResult* _tmp22_;
	GameHubDataProvidersDataIGDBResult* _tmp23_;
};

struct _Block45Data {
	int _ref_count_;
	GameHubDataProvidersDataIGDB* self;
	GtkInfoBar* msg;
};

struct _Block46Data {
	int _ref_count_;
	GameHubDataProvidersDataIGDB* self;
	GameHubSettingsProvidersDataIGDB* settings;
	GtkEntry* entry;
	GameHubUIWidgetsModeButton* desc_src;
};

struct _GameHubDataProvidersDataIGDBResult {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataProvidersDataIGDBResultPrivate * priv;
	gint* id;
	gchar* name;
	gchar* url;
	gint64* release_date;
	GameHubDataProvidersDataIGDBResultWebsite** websites;
	gint websites_length1;
	GameHubDataProvidersDataIGDBResultLink** platforms;
	gint platforms_length1;
	gchar* summary;
	gchar* storyline;
	GameHubDataProvidersDataIGDBResultLink** genres;
	gint genres_length1;
	GameHubDataProvidersDataIGDBResultLink** keywords;
	gint keywords_length1;
	gdouble* popularity;
	gdouble* aggregated_rating;
	gint* aggregated_rating_count;
	gdouble* igdb_rating;
	gint* igdb_rating_count;
	gdouble* total_rating;
	gint* total_rating_count;
};

struct _GameHubDataProvidersDataIGDBResultClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataProvidersDataIGDBResult *self);
};

struct _GameHubDataProvidersDataIGDBResultLink {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataProvidersDataIGDBResultLinkPrivate * priv;
	gchar* name;
	gchar* url;
};

struct _GameHubDataProvidersDataIGDBResultLinkClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataProvidersDataIGDBResultLink *self);
};

struct _GameHubDataProvidersDataIGDBResultParamSpecLink {
	GParamSpec parent_instance;
};

struct _GameHubDataProvidersDataIGDBResultWebsite {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataProvidersDataIGDBResultWebsitePrivate * priv;
	gchar* url;
	GameHubDataProvidersDataIGDBResultWebsiteCategory category;
};

struct _GameHubDataProvidersDataIGDBResultWebsiteClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataProvidersDataIGDBResultWebsite *self);
};

struct _GameHubDataProvidersDataIGDBResultParamSpecWebsite {
	GParamSpec parent_instance;
};

struct _GameHubDataProvidersDataIGDBParamSpecResult {
	GParamSpec parent_instance;
};

struct _GameHubDataProvidersDataIGDBFields {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataProvidersDataIGDBFieldsPrivate * priv;
};

struct _GameHubDataProvidersDataIGDBFieldsClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataProvidersDataIGDBFields *self);
};

struct _GameHubDataProvidersDataIGDBParamSpecFields {
	GParamSpec parent_instance;
};

static gint GameHubDataProvidersDataIGDB_private_offset;
static gpointer game_hub_data_providers_data_igdb_parent_class = NULL;
VALA_EXTERN GameHubDataProvidersDataIGDB* game_hub_data_providers_data_igdb_instance;
GameHubDataProvidersDataIGDB* game_hub_data_providers_data_igdb_instance = NULL;
VALA_EXTERN GameHubUIViewsGamesViewGamesView* game_hub_ui_views_games_view_games_view_instance;
static gpointer game_hub_data_providers_data_igdb_result_parent_class = NULL;
static gpointer game_hub_data_providers_data_igdb_result_link_parent_class = NULL;
static gpointer game_hub_data_providers_data_igdb_result_website_parent_class = NULL;
static gpointer game_hub_data_providers_data_igdb_fields_parent_class = NULL;

VALA_EXTERN gpointer game_hub_data_providers_provider_ref (gpointer instance);
VALA_EXTERN void game_hub_data_providers_provider_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_providers_param_spec_provider (const gchar* name,
                                                         const gchar* nick,
                                                         const gchar* blurb,
                                                         GType object_type,
                                                         GParamFlags flags);
VALA_EXTERN void game_hub_data_providers_value_set_provider (GValue* value,
                                                 gpointer v_object);
VALA_EXTERN void game_hub_data_providers_value_take_provider (GValue* value,
                                                  gpointer v_object);
VALA_EXTERN gpointer game_hub_data_providers_value_get_provider (const GValue* value);
VALA_EXTERN GType game_hub_data_providers_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataProvidersProvider, game_hub_data_providers_provider_unref)
VALA_EXTERN GType game_hub_data_providers_data_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataProvidersDataProvider, game_hub_data_providers_provider_unref)
VALA_EXTERN GType game_hub_data_runnable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnable, g_object_unref)
VALA_EXTERN GType game_hub_data_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGame, g_object_unref)
VALA_EXTERN GType game_hub_data_providers_data_igdb_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataProvidersDataIGDB, game_hub_data_providers_provider_unref)
VALA_EXTERN void game_hub_data_providers_data_provider_data (GameHubDataProvidersDataProvider* self,
                                                 GameHubDataGame* game,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN gpointer game_hub_data_providers_data_provider_data_finish (GameHubDataProvidersDataProvider* self,
                                                            GAsyncResult* _res_);
VALA_EXTERN const gchar* game_hub_data_providers_provider_get_id (GameHubDataProvidersProvider* self);
VALA_EXTERN const gchar* game_hub_data_providers_provider_get_name (GameHubDataProvidersProvider* self);
VALA_EXTERN const gchar* game_hub_data_providers_provider_get_url (GameHubDataProvidersProvider* self);
VALA_EXTERN const gchar* game_hub_data_providers_provider_get_icon (GameHubDataProvidersProvider* self);
VALA_EXTERN gboolean game_hub_data_providers_provider_get_enabled (GameHubDataProvidersProvider* self);
VALA_EXTERN void game_hub_data_providers_provider_set_enabled (GameHubDataProvidersProvider* self,
                                                   gboolean value);
VALA_EXTERN GtkWidget* game_hub_data_providers_provider_get_settings_widget (GameHubDataProvidersProvider* self);
VALA_EXTERN GameHubDataProvidersDataIGDB* game_hub_data_providers_data_igdb_new (void);
VALA_EXTERN GameHubDataProvidersDataIGDB* game_hub_data_providers_data_igdb_construct (GType object_type);
VALA_EXTERN GameHubDataProvidersDataProvider* game_hub_data_providers_data_provider_construct (GType object_type,
                                                                                   GType t_type,
                                                                                   GBoxedCopyFunc t_dup_func,
                                                                                   GDestroyNotify t_destroy_func);
VALA_EXTERN gpointer game_hub_data_providers_data_igdb_result_ref (gpointer instance);
VALA_EXTERN void game_hub_data_providers_data_igdb_result_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_providers_data_igdb_param_spec_result (const gchar* name,
                                                                 const gchar* nick,
                                                                 const gchar* blurb,
                                                                 GType object_type,
                                                                 GParamFlags flags);
VALA_EXTERN void game_hub_data_providers_data_igdb_value_set_result (GValue* value,
                                                         gpointer v_object);
VALA_EXTERN void game_hub_data_providers_data_igdb_value_take_result (GValue* value,
                                                          gpointer v_object);
VALA_EXTERN gpointer game_hub_data_providers_data_igdb_value_get_result (const GValue* value);
VALA_EXTERN GType game_hub_data_providers_data_igdb_result_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataProvidersDataIGDBResult, game_hub_data_providers_data_igdb_result_unref)
static void game_hub_data_providers_data_igdb_real_data_data_free (gpointer _data);
static void game_hub_data_providers_data_igdb_real_data (GameHubDataProvidersDataProvider* base,
                                                  GameHubDataGame* game,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static gboolean game_hub_data_providers_data_igdb_real_data_co (GameHubDataProvidersDataIgdbDataData* _data_);
VALA_EXTERN gchar* game_hub_data_db_tables_igdb_data_get (GameHubDataGame* game);
static void game_hub_data_providers_data_igdb_parse (GameHubDataProvidersDataIGDB* self,
                                              GameHubDataGame* game,
                                              const gchar* json,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static GeeArrayList* game_hub_data_providers_data_igdb_parse_finish (GameHubDataProvidersDataIGDB* self,
                                                              GAsyncResult* _res_,
                                                              gboolean* _error_,
                                                              guint* status,
                                                              gchar** err_msg);
static void game_hub_data_providers_data_igdb_data_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
VALA_EXTERN gboolean game_hub_data_db_tables_igdb_data_remove (GameHubDataGame* game);
VALA_EXTERN GType game_hub_settings_settings_schema_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubSettingsSettingsSchema, g_object_unref)
VALA_EXTERN GType game_hub_settings_providers_data_igdb_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubSettingsProvidersDataIGDB, g_object_unref)
VALA_EXTERN GameHubSettingsProvidersDataIGDB* game_hub_settings_providers_data_igdb_get_instance (void);
VALA_EXTERN const gchar* game_hub_settings_providers_data_igdb_get_api_key (GameHubSettingsProvidersDataIGDB* self);
VALA_EXTERN const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_utils_parser_load_remote_file_async (const gchar* url,
                                                   const gchar* method,
                                                   const gchar* auth,
                                                   GeeHashMap* headers,
                                                   GeeHashMap* data,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN gchar* game_hub_utils_parser_load_remote_file_finish (GAsyncResult* _res_,
                                                      guint* status);
VALA_EXTERN gboolean game_hub_data_db_tables_igdb_data_add (GameHubDataGame* game,
                                                const gchar* data);
static void game_hub_data_providers_data_igdb_show_error (GameHubDataProvidersDataIGDB* self,
                                                   guint status,
                                                   const gchar* err_msg);
static void game_hub_data_providers_data_igdb_parse_data_free (gpointer _data);
static gboolean game_hub_data_providers_data_igdb_parse_co (GameHubDataProvidersDataIgdbParseData* _data_);
VALA_EXTERN JsonNode* game_hub_utils_parser_parse_json (const gchar* json);
static void _vala_JsonNode_free (JsonNode* self);
static gboolean game_hub_data_providers_data_igdb_is_error (GameHubDataProvidersDataIGDB* self,
                                                     JsonObject* obj,
                                                     guint* status,
                                                     gchar** err_msg);
VALA_EXTERN GameHubDataProvidersDataIGDBResult* game_hub_data_providers_data_igdb_result_new (JsonObject* obj);
VALA_EXTERN GameHubDataProvidersDataIGDBResult* game_hub_data_providers_data_igdb_result_construct (GType object_type,
                                                                                        JsonObject* obj);
VALA_EXTERN GType game_hub_ui_views_base_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIViewsBaseView, g_object_unref)
VALA_EXTERN GType game_hub_ui_views_games_view_games_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIViewsGamesViewGamesView, g_object_unref)
static gboolean ___lambda176_ (GameHubDataProvidersDataIGDB* self);
static Block45Data* block45_data_ref (Block45Data* _data45_);
static void block45_data_unref (void * _userdata_);
VALA_EXTERN GtkInfoBar* game_hub_ui_views_games_view_games_view_add_message (GameHubUIViewsGamesViewGamesView* self,
                                                                 const gchar* text,
                                                                 GtkMessageType type);
static void __lambda177_ (Block45Data* _data45_);
static gboolean __lambda178_ (Block45Data* _data45_);
static gboolean ___lambda178__gsource_func (gpointer self);
static void ___lambda177__gtk_info_bar_close (GtkInfoBar* _sender,
                                       gpointer self);
static void __lambda179_ (Block45Data* _data45_,
                   gint r);
VALA_EXTERN GameHubUIDialogsSettingsDialogSettingsDialog* game_hub_ui_dialogs_settings_dialog_settings_dialog_new (const gchar* page);
VALA_EXTERN GameHubUIDialogsSettingsDialogSettingsDialog* game_hub_ui_dialogs_settings_dialog_settings_dialog_construct (GType object_type,
                                                                                                             const gchar* page);
VALA_EXTERN GType game_hub_ui_dialogs_settings_dialog_settings_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIDialogsSettingsDialogSettingsDialog, g_object_unref)
static void ___lambda179__gtk_info_bar_response (GtkInfoBar* _sender,
                                          gint response_id,
                                          gpointer self);
static gboolean ____lambda176__gsource_func (gpointer self);
VALA_EXTERN gboolean game_hub_settings_providers_data_igdb_get_enabled (GameHubSettingsProvidersDataIGDB* self);
VALA_EXTERN void game_hub_settings_providers_data_igdb_set_enabled (GameHubSettingsProvidersDataIGDB* self,
                                                        gboolean value);
VALA_EXTERN GType game_hub_ui_widgets_mode_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIWidgetsModeButton, g_object_unref)
static Block46Data* block46_data_ref (Block46Data* _data46_);
static void block46_data_unref (void * _userdata_);
VALA_EXTERN GSettings* game_hub_settings_settings_schema_get_schema (GameHubSettingsSettingsSchema* self);
static void _game_hub_data_providers_data_igdb_settings_widget___lambda261_ (Block46Data* _data46_);
VALA_EXTERN void game_hub_settings_providers_data_igdb_set_api_key (GameHubSettingsProvidersDataIGDB* self,
                                                        const gchar* value);
static void __game_hub_data_providers_data_igdb_settings_widget___lambda261__g_object_notify (GObject* _sender,
                                                                                       GParamSpec* pspec,
                                                                                       gpointer self);
static void _game_hub_data_providers_data_igdb_settings_widget___lambda262_ (Block46Data* _data46_,
                                                                      GtkEntryIconPosition pos,
                                                                      GdkEvent* e);
static void __game_hub_data_providers_data_igdb_settings_widget___lambda262__gtk_entry_icon_press (GtkEntry* _sender,
                                                                                            GtkEntryIconPosition icon_pos,
                                                                                            GdkEvent* event,
                                                                                            gpointer self);
static void _game_hub_data_providers_data_igdb_settings_widget___lambda263_ (GameHubDataProvidersDataIGDB* self);
VALA_EXTERN void game_hub_utils_open_uri (const gchar* uri);
static void __game_hub_data_providers_data_igdb_settings_widget___lambda263__gtk_button_clicked (GtkButton* _sender,
                                                                                          gpointer self);
VALA_EXTERN GameHubUIWidgetsModeButton* game_hub_ui_widgets_mode_button_new (void);
VALA_EXTERN GameHubUIWidgetsModeButton* game_hub_ui_widgets_mode_button_construct (GType object_type);
VALA_EXTERN gint game_hub_ui_widgets_mode_button_append_text (GameHubUIWidgetsModeButton* self,
                                                  const gchar* text,
                                                  const gchar* tooltip,
                                                  gboolean tooltip_markup);
VALA_EXTERN GType game_hub_settings_providers_data_igdb_preferred_description_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameHubSettingsProvidersDataIGDBPreferredDescription game_hub_settings_providers_data_igdb_get_preferred_description (GameHubSettingsProvidersDataIGDB* self);
VALA_EXTERN void game_hub_ui_widgets_mode_button_set_selected (GameHubUIWidgetsModeButton* self,
                                                   gint value);
static void _game_hub_data_providers_data_igdb_settings_widget___lambda264_ (Block46Data* _data46_);
VALA_EXTERN gint game_hub_ui_widgets_mode_button_get_selected (GameHubUIWidgetsModeButton* self);
VALA_EXTERN void game_hub_settings_providers_data_igdb_set_preferred_description (GameHubSettingsProvidersDataIGDB* self,
                                                                      GameHubSettingsProvidersDataIGDBPreferredDescription value);
static void __game_hub_data_providers_data_igdb_settings_widget___lambda264__game_hub_ui_widgets_mode_button_mode_changed (GameHubUIWidgetsModeButton* _sender,
                                                                                                                    GtkWidget* widget,
                                                                                                                    gpointer self);
VALA_EXTERN gpointer game_hub_data_providers_data_igdb_result_website_ref (gpointer instance);
VALA_EXTERN void game_hub_data_providers_data_igdb_result_website_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_providers_data_igdb_result_param_spec_website (const gchar* name,
                                                                         const gchar* nick,
                                                                         const gchar* blurb,
                                                                         GType object_type,
                                                                         GParamFlags flags);
VALA_EXTERN void game_hub_data_providers_data_igdb_result_value_set_website (GValue* value,
                                                                 gpointer v_object);
VALA_EXTERN void game_hub_data_providers_data_igdb_result_value_take_website (GValue* value,
                                                                  gpointer v_object);
VALA_EXTERN gpointer game_hub_data_providers_data_igdb_result_value_get_website (const GValue* value);
VALA_EXTERN GType game_hub_data_providers_data_igdb_result_website_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataProvidersDataIGDBResultWebsite, game_hub_data_providers_data_igdb_result_website_unref)
VALA_EXTERN gpointer game_hub_data_providers_data_igdb_result_link_ref (gpointer instance);
VALA_EXTERN void game_hub_data_providers_data_igdb_result_link_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_providers_data_igdb_result_param_spec_link (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags);
VALA_EXTERN void game_hub_data_providers_data_igdb_result_value_set_link (GValue* value,
                                                              gpointer v_object);
VALA_EXTERN void game_hub_data_providers_data_igdb_result_value_take_link (GValue* value,
                                                               gpointer v_object);
VALA_EXTERN gpointer game_hub_data_providers_data_igdb_result_value_get_link (const GValue* value);
VALA_EXTERN GType game_hub_data_providers_data_igdb_result_link_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataProvidersDataIGDBResultLink, game_hub_data_providers_data_igdb_result_link_unref)
static gint* _int_dup (gint* self);
static gint64* _int64_dup (gint64* self);
static gdouble* _double_dup (gdouble* self);
VALA_EXTERN GameHubDataProvidersDataIGDBResultWebsite* game_hub_data_providers_data_igdb_result_website_new (JsonObject* obj);
VALA_EXTERN GameHubDataProvidersDataIGDBResultWebsite* game_hub_data_providers_data_igdb_result_website_construct (GType object_type,
                                                                                                       JsonObject* obj);
static void _vala_array_add45 (GameHubDataProvidersDataIGDBResultWebsite** * array,
                        gint* length,
                        gint* size,
                        GameHubDataProvidersDataIGDBResultWebsite* value);
static GameHubDataProvidersDataIGDBResultWebsite** _vala_array_dup34 (GameHubDataProvidersDataIGDBResultWebsite** self,
                                                               gssize length);
VALA_EXTERN GameHubDataProvidersDataIGDBResultLink* game_hub_data_providers_data_igdb_result_link_new (JsonObject* obj);
VALA_EXTERN GameHubDataProvidersDataIGDBResultLink* game_hub_data_providers_data_igdb_result_link_construct (GType object_type,
                                                                                                 JsonObject* obj);
static void _vala_array_add46 (GameHubDataProvidersDataIGDBResultLink** * array,
                        gint* length,
                        gint* size,
                        GameHubDataProvidersDataIGDBResultLink* value);
static GameHubDataProvidersDataIGDBResultLink** _vala_array_dup35 (GameHubDataProvidersDataIGDBResultLink** self,
                                                            gssize length);
static void _vala_array_add47 (GameHubDataProvidersDataIGDBResultLink** * array,
                        gint* length,
                        gint* size,
                        GameHubDataProvidersDataIGDBResultLink* value);
static GameHubDataProvidersDataIGDBResultLink** _vala_array_dup36 (GameHubDataProvidersDataIGDBResultLink** self,
                                                            gssize length);
static void _vala_array_add48 (GameHubDataProvidersDataIGDBResultLink** * array,
                        gint* length,
                        gint* size,
                        GameHubDataProvidersDataIGDBResultLink* value);
static GameHubDataProvidersDataIGDBResultLink** _vala_array_dup37 (GameHubDataProvidersDataIGDBResultLink** self,
                                                            gssize length);
static void game_hub_data_providers_data_igdb_result_link_finalize (GameHubDataProvidersDataIGDBResultLink * obj);
static GType game_hub_data_providers_data_igdb_result_link_get_type_once (void);
VALA_EXTERN GType game_hub_data_providers_data_igdb_result_website_category_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameHubDataProvidersDataIGDBResultWebsiteCategory game_hub_data_providers_data_igdb_result_website_category_from_id (gint id);
VALA_EXTERN gint game_hub_data_providers_data_igdb_result_website_category_id (GameHubDataProvidersDataIGDBResultWebsiteCategory self);
VALA_EXTERN gchar* game_hub_data_providers_data_igdb_result_website_category_icon (GameHubDataProvidersDataIGDBResultWebsiteCategory self);
VALA_EXTERN gchar* game_hub_data_providers_data_igdb_result_website_category_description (GameHubDataProvidersDataIGDBResultWebsiteCategory self);
static void game_hub_data_providers_data_igdb_result_website_finalize (GameHubDataProvidersDataIGDBResultWebsite * obj);
static GType game_hub_data_providers_data_igdb_result_website_get_type_once (void);
static void game_hub_data_providers_data_igdb_result_finalize (GameHubDataProvidersDataIGDBResult * obj);
static GType game_hub_data_providers_data_igdb_result_get_type_once (void);
static gpointer game_hub_data_providers_data_igdb_fields_ref (gpointer instance);
static void game_hub_data_providers_data_igdb_fields_unref (gpointer instance);
static GParamSpec* game_hub_data_providers_data_igdb_param_spec_fields (const gchar* name,
                                                                 const gchar* nick,
                                                                 const gchar* blurb,
                                                                 GType object_type,
                                                                 GParamFlags flags) G_GNUC_UNUSED ;
static void game_hub_data_providers_data_igdb_value_set_fields (GValue* value,
                                                         gpointer v_object) G_GNUC_UNUSED ;
static void game_hub_data_providers_data_igdb_value_take_fields (GValue* value,
                                                          gpointer v_object) G_GNUC_UNUSED ;
static gpointer game_hub_data_providers_data_igdb_value_get_fields (const GValue* value) G_GNUC_UNUSED ;
static GType game_hub_data_providers_data_igdb_fields_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataProvidersDataIGDBFields, game_hub_data_providers_data_igdb_fields_unref)
static GameHubDataProvidersDataIGDBFields* game_hub_data_providers_data_igdb_fields_new (void);
static GameHubDataProvidersDataIGDBFields* game_hub_data_providers_data_igdb_fields_construct (GType object_type);
static void game_hub_data_providers_data_igdb_fields_finalize (GameHubDataProvidersDataIGDBFields * obj);
static GType game_hub_data_providers_data_igdb_fields_get_type_once (void);
static void game_hub_data_providers_data_igdb_finalize (GameHubDataProvidersProvider * obj);
static GType game_hub_data_providers_data_igdb_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_REQUEST_FIELDS[17] = {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_ID, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_NAME, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_URL, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_RELEASE_DATE, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_WEBSITES GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__EXPAND, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_PLATFORMS GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__EXPAND, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_SUMMARY, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_STORYLINE, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_GENRES GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__EXPAND, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_KEYWORDS GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS__EXPAND, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_POPULARITY, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING_COUNT, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING_COUNT, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING_COUNT};

static inline gpointer
game_hub_data_providers_data_igdb_get_instance_private (GameHubDataProvidersDataIGDB* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataProvidersDataIGDB_private_offset);
}

static gpointer
_game_hub_data_providers_provider_ref0 (gpointer self)
{
#line 48 "../src/data/providers/data/IGDB.vala"
	return self ? game_hub_data_providers_provider_ref (self) : NULL;
#line 822 "IGDB.c"
}

GameHubDataProvidersDataIGDB*
game_hub_data_providers_data_igdb_construct (GType object_type)
{
	GameHubDataProvidersDataIGDB* self = NULL;
	GameHubDataProvidersDataIGDB* _tmp0_;
#line 46 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) game_hub_data_providers_data_provider_construct (object_type, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 48 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = _game_hub_data_providers_provider_ref0 (self);
#line 48 "../src/data/providers/data/IGDB.vala"
	_game_hub_data_providers_provider_unref0 (game_hub_data_providers_data_igdb_instance);
#line 48 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_instance = _tmp0_;
#line 49 "../src/data/providers/data/IGDB.vala"
	self->priv->request_quota_reached = FALSE;
#line 46 "../src/data/providers/data/IGDB.vala"
	return self;
#line 842 "IGDB.c"
}

GameHubDataProvidersDataIGDB*
game_hub_data_providers_data_igdb_new (void)
{
#line 46 "../src/data/providers/data/IGDB.vala"
	return game_hub_data_providers_data_igdb_construct (GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB);
#line 850 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_real_data_data_free (gpointer _data)
{
	GameHubDataProvidersDataIgdbDataData* _data_;
	_data_ = _data;
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (_data_->game);
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/data/providers/data/IGDB.vala"
	_game_hub_data_providers_provider_unref0 (_data_->self);
#line 24 "../src/data/providers/data/IGDB.vala"
	g_slice_free (GameHubDataProvidersDataIgdbDataData, _data_);
#line 866 "IGDB.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../src/data/providers/data/IGDB.vala"
	return self ? g_object_ref (self) : NULL;
#line 874 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_real_data (GameHubDataProvidersDataProvider* base,
                                             GameHubDataGame* game,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GameHubDataProvidersDataIGDB * self;
	GameHubDataProvidersDataIgdbDataData* _data_;
	GameHubDataProvidersDataIGDB* _tmp0_;
	GameHubDataGame* _tmp1_;
#line 24 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (game != NULL);
#line 24 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_ = g_slice_new0 (GameHubDataProvidersDataIgdbDataData);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 24 "../src/data/providers/data/IGDB.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_providers_data_igdb_real_data_data_free);
#line 24 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = _game_hub_data_providers_provider_ref0 (self);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->self = _tmp0_;
#line 24 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = _g_object_ref0 (game);
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (_data_->game);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->game = _tmp1_;
#line 24 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_real_data_co (_data_);
#line 909 "IGDB.c"
}

static GeeArrayList*
game_hub_data_providers_data_igdb_data_finish (GameHubDataProvidersDataProvider* base,
                                               GAsyncResult* _res_)
{
	GeeArrayList* result;
	GameHubDataProvidersDataIgdbDataData* _data_;
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/data/providers/data/IGDB.vala"
	result = _data_->result;
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->result = NULL;
#line 24 "../src/data/providers/data/IGDB.vala"
	return result;
#line 926 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_data_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	GameHubDataProvidersDataIgdbDataData* _data_;
#line 62 "../src/data/providers/data/IGDB.vala"
	_data_ = _user_data_;
#line 62 "../src/data/providers/data/IGDB.vala"
	_data_->_source_object_ = source_object;
#line 62 "../src/data/providers/data/IGDB.vala"
	_data_->_res_ = _res_;
#line 62 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_real_data_co (_data_);
#line 943 "IGDB.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
#line 1200 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1201 "glib-2.0.vapi"
		separator = "";
#line 957 "IGDB.c"
	}
#line 1203 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 961 "IGDB.c"
		gboolean _tmp1_ = FALSE;
#line 1203 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1203 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 967 "IGDB.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1203 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 972 "IGDB.c"
				const gchar* _tmp3_;
#line 1203 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1203 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 978 "IGDB.c"
			} else {
#line 1203 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 982 "IGDB.c"
			}
#line 1203 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 986 "IGDB.c"
		}
#line 1203 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 990 "IGDB.c"
	} else {
#line 1203 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 994 "IGDB.c"
	}
#line 1203 "glib-2.0.vapi"
	if (_tmp0_) {
#line 998 "IGDB.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1205 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1013 "IGDB.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1206 "glib-2.0.vapi"
			i = 0;
#line 1206 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1206 "glib-2.0.vapi"
			while (TRUE) {
#line 1022 "IGDB.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1206 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1029 "IGDB.c"
					gint _tmp5_;
#line 1206 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1206 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1035 "IGDB.c"
				}
#line 1206 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1206 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1206 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1043 "IGDB.c"
				} else {
#line 1206 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1047 "IGDB.c"
				}
#line 1206 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1206 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1053 "IGDB.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1206 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1058 "IGDB.c"
						const gchar* _tmp9_;
#line 1206 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1206 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1064 "IGDB.c"
					} else {
#line 1206 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1068 "IGDB.c"
					}
#line 1206 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1072 "IGDB.c"
				}
#line 1206 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1206 "glib-2.0.vapi"
					break;
#line 1078 "IGDB.c"
				}
#line 1207 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1207 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1084 "IGDB.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1207 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1207 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1207 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1207 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1096 "IGDB.c"
				} else {
#line 1207 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1100 "IGDB.c"
				}
#line 1207 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1104 "IGDB.c"
			}
		}
#line 1209 "glib-2.0.vapi"
		if (i == 0) {
#line 1109 "IGDB.c"
			gchar* _tmp15_;
#line 1210 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1210 "glib-2.0.vapi"
			result = _tmp15_;
#line 1210 "glib-2.0.vapi"
			return result;
#line 1117 "IGDB.c"
		}
#line 1212 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1213 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1213 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1213 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1215 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1215 "glib-2.0.vapi"
		res = _tmp18_;
#line 1216 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1216 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1135 "IGDB.c"
			const gchar* _tmp21_;
#line 1216 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1216 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1141 "IGDB.c"
		} else {
#line 1216 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1145 "IGDB.c"
		}
#line 1216 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1216 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1216 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1153 "IGDB.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1217 "glib-2.0.vapi"
			i = 1;
#line 1217 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1217 "glib-2.0.vapi"
			while (TRUE) {
#line 1162 "IGDB.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1217 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1171 "IGDB.c"
					gint _tmp25_;
#line 1217 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1217 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1177 "IGDB.c"
				}
#line 1217 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1217 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1217 "glib-2.0.vapi"
					break;
#line 1185 "IGDB.c"
				}
#line 1218 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1218 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1218 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1219 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1219 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1197 "IGDB.c"
					const gchar* _tmp30_;
#line 1219 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1219 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1203 "IGDB.c"
				} else {
#line 1219 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1207 "IGDB.c"
				}
#line 1219 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1219 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1219 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1215 "IGDB.c"
			}
		}
#line 1222 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1222 "glib-2.0.vapi"
		res = NULL;
#line 1222 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1222 "glib-2.0.vapi"
		return result;
#line 1226 "IGDB.c"
	} else {
		gchar* _tmp34_;
#line 1224 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1224 "glib-2.0.vapi"
		result = _tmp34_;
#line 1224 "glib-2.0.vapi"
		return result;
#line 1235 "IGDB.c"
	}
}

static gboolean
game_hub_data_providers_data_igdb_real_data_co (GameHubDataProvidersDataIgdbDataData* _data_)
{
#line 52 "../src/data/providers/data/IGDB.vala"
	switch (_data_->_state_) {
#line 52 "../src/data/providers/data/IGDB.vala"
		case 0:
#line 1246 "IGDB.c"
		goto _state_0;
#line 52 "../src/data/providers/data/IGDB.vala"
		case 1:
#line 1250 "IGDB.c"
		goto _state_1;
#line 52 "../src/data/providers/data/IGDB.vala"
		case 2:
#line 1254 "IGDB.c"
		goto _state_2;
#line 52 "../src/data/providers/data/IGDB.vala"
		case 3:
#line 1258 "IGDB.c"
		goto _state_3;
		default:
#line 52 "../src/data/providers/data/IGDB.vala"
		g_assert_not_reached ();
#line 1263 "IGDB.c"
	}
	_state_0:
#line 54 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp0_ = game_hub_data_db_tables_igdb_data_get (_data_->game);
#line 54 "../src/data/providers/data/IGDB.vala"
	_data_->cached = _data_->_tmp0_;
#line 56 "../src/data/providers/data/IGDB.vala"
	_data_->_error_ = FALSE;
#line 57 "../src/data/providers/data/IGDB.vala"
	_data_->status = (guint) 0;
#line 58 "../src/data/providers/data/IGDB.vala"
	_data_->err_msg = NULL;
#line 60 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp2_ = _data_->cached;
#line 60 "../src/data/providers/data/IGDB.vala"
	if (_data_->_tmp2_ != NULL) {
#line 60 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp3_ = _data_->cached;
#line 60 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp4_ = strlen (_data_->_tmp3_);
#line 60 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 60 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp1_ = _data_->_tmp5_ > 0;
#line 1288 "IGDB.c"
	} else {
#line 60 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp1_ = FALSE;
#line 1292 "IGDB.c"
	}
#line 60 "../src/data/providers/data/IGDB.vala"
	if (_data_->_tmp1_) {
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp6_ = _data_->cached;
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp7_ = FALSE;
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp8_ = 0U;
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp9_ = NULL;
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->_state_ = 1;
#line 62 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_parse (_data_->self, _data_->game, _data_->_tmp6_, game_hub_data_providers_data_igdb_data_ready, _data_);
#line 62 "../src/data/providers/data/IGDB.vala"
		return FALSE;
#line 1310 "IGDB.c"
		_state_1:
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp10_ = game_hub_data_providers_data_igdb_parse_finish (_data_->self, _data_->_res_, &_data_->_tmp7_, &_data_->_tmp8_, &_data_->_tmp9_);
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->_error_ = _data_->_tmp7_;
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->status = _data_->_tmp8_;
#line 62 "../src/data/providers/data/IGDB.vala"
		_g_free0 (_data_->err_msg);
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->err_msg = _data_->_tmp9_;
#line 62 "../src/data/providers/data/IGDB.vala"
		_data_->res = _data_->_tmp10_;
#line 63 "../src/data/providers/data/IGDB.vala"
		if (_data_->_error_) {
#line 63 "../src/data/providers/data/IGDB.vala"
			_data_->_tmp11_ = TRUE;
#line 1328 "IGDB.c"
		} else {
#line 63 "../src/data/providers/data/IGDB.vala"
			_data_->_tmp12_ = _data_->res;
#line 63 "../src/data/providers/data/IGDB.vala"
			_data_->_tmp11_ = _data_->_tmp12_ == NULL;
#line 1334 "IGDB.c"
		}
#line 63 "../src/data/providers/data/IGDB.vala"
		if (_data_->_tmp11_) {
#line 65 "../src/data/providers/data/IGDB.vala"
			game_hub_data_db_tables_igdb_data_remove (_data_->game);
#line 1340 "IGDB.c"
		}
#line 67 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp13_ = _data_->res;
#line 67 "../src/data/providers/data/IGDB.vala"
		if (_data_->_tmp13_ != NULL) {
#line 67 "../src/data/providers/data/IGDB.vala"
			_data_->result = _data_->res;
#line 67 "../src/data/providers/data/IGDB.vala"
			_g_free0 (_data_->err_msg);
#line 67 "../src/data/providers/data/IGDB.vala"
			_g_free0 (_data_->cached);
#line 67 "../src/data/providers/data/IGDB.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 67 "../src/data/providers/data/IGDB.vala"
			if (_data_->_state_ != 0) {
#line 67 "../src/data/providers/data/IGDB.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 67 "../src/data/providers/data/IGDB.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1360 "IGDB.c"
				}
			}
#line 67 "../src/data/providers/data/IGDB.vala"
			g_object_unref (_data_->_async_result);
#line 67 "../src/data/providers/data/IGDB.vala"
			return FALSE;
#line 1367 "IGDB.c"
		}
#line 60 "../src/data/providers/data/IGDB.vala"
		_g_object_unref0 (_data_->res);
#line 1371 "IGDB.c"
	}
#line 70 "../src/data/providers/data/IGDB.vala"
	if (_data_->self->priv->request_quota_reached) {
#line 70 "../src/data/providers/data/IGDB.vala"
		_data_->result = NULL;
#line 70 "../src/data/providers/data/IGDB.vala"
		_g_free0 (_data_->err_msg);
#line 70 "../src/data/providers/data/IGDB.vala"
		_g_free0 (_data_->cached);
#line 70 "../src/data/providers/data/IGDB.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 70 "../src/data/providers/data/IGDB.vala"
		if (_data_->_state_ != 0) {
#line 70 "../src/data/providers/data/IGDB.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 70 "../src/data/providers/data/IGDB.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1389 "IGDB.c"
			}
		}
#line 70 "../src/data/providers/data/IGDB.vala"
		g_object_unref (_data_->_async_result);
#line 70 "../src/data/providers/data/IGDB.vala"
		return FALSE;
#line 1396 "IGDB.c"
	}
#line 72 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp14_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 72 "../src/data/providers/data/IGDB.vala"
	_data_->headers = _data_->_tmp14_;
#line 73 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp15_ = _data_->headers;
#line 73 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp16_ = game_hub_settings_providers_data_igdb_get_instance ();
#line 73 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 73 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp18_ = game_hub_settings_providers_data_igdb_get_api_key (_data_->_tmp17_);
#line 73 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 73 "../src/data/providers/data/IGDB.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp15_, "user-key", _data_->_tmp19_);
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp20_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) _data_->game);
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp21_ = _data_->_tmp20_;
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp22_ = g_uri_escape_string (_data_->_tmp21_, NULL, TRUE);
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp23_ = _data_->_tmp22_;
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp24_ = _vala_g_strjoinv (",", GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_REQUEST_FIELDS, (gint) G_N_ELEMENTS (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_REQUEST_FIELDS));
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp26_ = g_strdup_printf ("/games?search=%s&fields=%s", _data_->_tmp23_, _data_->_tmp25_);
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp27_ = _data_->_tmp26_;
#line 75 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->_tmp25_);
#line 75 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->_tmp23_);
#line 75 "../src/data/providers/data/IGDB.vala"
	_data_->endpoint = _data_->_tmp27_;
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp28_ = _data_->endpoint;
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp29_ = g_strconcat (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_API_BASE_URL, _data_->_tmp28_, NULL);
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp31_ = _data_->headers;
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp32_ = 0U;
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_state_ = 2;
#line 76 "../src/data/providers/data/IGDB.vala"
	game_hub_utils_parser_load_remote_file_async (_data_->_tmp30_, "GET", NULL, _data_->_tmp31_, NULL, game_hub_data_providers_data_igdb_data_ready, _data_);
#line 76 "../src/data/providers/data/IGDB.vala"
	return FALSE;
#line 1452 "IGDB.c"
	_state_2:
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp33_ = game_hub_utils_parser_load_remote_file_finish (_data_->_res_, &_data_->_tmp32_);
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->status = _data_->_tmp32_;
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 76 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->_tmp30_);
#line 76 "../src/data/providers/data/IGDB.vala"
	_data_->json = _data_->_tmp34_;
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp35_ = _data_->json;
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp36_ = FALSE;
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp37_ = 0U;
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp38_ = NULL;
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_state_ = 3;
#line 78 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_parse (_data_->self, _data_->game, _data_->_tmp35_, game_hub_data_providers_data_igdb_data_ready, _data_);
#line 78 "../src/data/providers/data/IGDB.vala"
	return FALSE;
#line 1478 "IGDB.c"
	_state_3:
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp39_ = game_hub_data_providers_data_igdb_parse_finish (_data_->self, _data_->_res_, &_data_->_tmp36_, &_data_->_tmp37_, &_data_->_tmp38_);
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_error_ = _data_->_tmp36_;
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->status = _data_->_tmp37_;
#line 78 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->err_msg);
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->err_msg = _data_->_tmp38_;
#line 78 "../src/data/providers/data/IGDB.vala"
	_data_->_vala1_res = _data_->_tmp39_;
#line 80 "../src/data/providers/data/IGDB.vala"
	if (!_data_->_error_) {
#line 82 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp40_ = _data_->json;
#line 82 "../src/data/providers/data/IGDB.vala"
		game_hub_data_db_tables_igdb_data_add (_data_->game, _data_->_tmp40_);
#line 1498 "IGDB.c"
	} else {
#line 86 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp41_ = _data_->err_msg;
#line 86 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_show_error (_data_->self, _data_->status, _data_->_tmp41_);
#line 1504 "IGDB.c"
	}
#line 89 "../src/data/providers/data/IGDB.vala"
	_data_->result = _data_->_vala1_res;
#line 89 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->json);
#line 89 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->endpoint);
#line 89 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (_data_->headers);
#line 89 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->err_msg);
#line 89 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->cached);
#line 89 "../src/data/providers/data/IGDB.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 89 "../src/data/providers/data/IGDB.vala"
	if (_data_->_state_ != 0) {
#line 89 "../src/data/providers/data/IGDB.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 89 "../src/data/providers/data/IGDB.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1526 "IGDB.c"
		}
	}
#line 89 "../src/data/providers/data/IGDB.vala"
	g_object_unref (_data_->_async_result);
#line 89 "../src/data/providers/data/IGDB.vala"
	return FALSE;
#line 1533 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_parse_data_free (gpointer _data)
{
	GameHubDataProvidersDataIgdbParseData* _data_;
	_data_ = _data;
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (_data_->game);
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->json);
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/data/providers/data/IGDB.vala"
	_game_hub_data_providers_provider_unref0 (_data_->self);
#line 24 "../src/data/providers/data/IGDB.vala"
	g_slice_free (GameHubDataProvidersDataIgdbParseData, _data_);
#line 1551 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_parse (GameHubDataProvidersDataIGDB* self,
                                         GameHubDataGame* game,
                                         const gchar* json,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GameHubDataProvidersDataIgdbParseData* _data_;
	GameHubDataProvidersDataIGDB* _tmp0_;
	GameHubDataGame* _tmp1_;
	gchar* _tmp2_;
#line 24 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (game != NULL);
#line 24 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (json != NULL);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_ = g_slice_new0 (GameHubDataProvidersDataIgdbParseData);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 24 "../src/data/providers/data/IGDB.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_providers_data_igdb_parse_data_free);
#line 24 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = _game_hub_data_providers_provider_ref0 (self);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->self = _tmp0_;
#line 24 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = _g_object_ref0 (game);
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (_data_->game);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->game = _tmp1_;
#line 24 "../src/data/providers/data/IGDB.vala"
	_tmp2_ = g_strdup (json);
#line 24 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->json);
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->json = _tmp2_;
#line 24 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_parse_co (_data_);
#line 1595 "IGDB.c"
}

static GeeArrayList*
game_hub_data_providers_data_igdb_parse_finish (GameHubDataProvidersDataIGDB* self,
                                                GAsyncResult* _res_,
                                                gboolean* _error_,
                                                guint* status,
                                                gchar** err_msg)
{
	GeeArrayList* result;
	GameHubDataProvidersDataIgdbParseData* _data_;
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/data/providers/data/IGDB.vala"
	if (_error_) {
#line 24 "../src/data/providers/data/IGDB.vala"
		*_error_ = _data_->_error_;
#line 1613 "IGDB.c"
	}
#line 24 "../src/data/providers/data/IGDB.vala"
	if (status) {
#line 24 "../src/data/providers/data/IGDB.vala"
		*status = _data_->status;
#line 1619 "IGDB.c"
	}
#line 24 "../src/data/providers/data/IGDB.vala"
	if (err_msg) {
#line 24 "../src/data/providers/data/IGDB.vala"
		*err_msg = _data_->err_msg;
#line 1625 "IGDB.c"
	} else {
#line 24 "../src/data/providers/data/IGDB.vala"
		_g_free0 (_data_->err_msg);
#line 1629 "IGDB.c"
	}
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->err_msg = NULL;
#line 24 "../src/data/providers/data/IGDB.vala"
	result = _data_->result;
#line 24 "../src/data/providers/data/IGDB.vala"
	_data_->result = NULL;
#line 24 "../src/data/providers/data/IGDB.vala"
	return result;
#line 1639 "IGDB.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 99 "../src/data/providers/data/IGDB.vala"
	g_boxed_free (json_node_get_type (), self);
#line 1647 "IGDB.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 100 "../src/data/providers/data/IGDB.vala"
	return self ? json_array_ref (self) : NULL;
#line 1655 "IGDB.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 107 "../src/data/providers/data/IGDB.vala"
	return self ? json_object_ref (self) : NULL;
#line 1663 "IGDB.c"
}

static gboolean
game_hub_data_providers_data_igdb_parse_co (GameHubDataProvidersDataIgdbParseData* _data_)
{
#line 92 "../src/data/providers/data/IGDB.vala"
	switch (_data_->_state_) {
#line 92 "../src/data/providers/data/IGDB.vala"
		case 0:
#line 1673 "IGDB.c"
		goto _state_0;
		default:
#line 92 "../src/data/providers/data/IGDB.vala"
		g_assert_not_reached ();
#line 1678 "IGDB.c"
	}
	_state_0:
#line 94 "../src/data/providers/data/IGDB.vala"
	_data_->_error_ = FALSE;
#line 95 "../src/data/providers/data/IGDB.vala"
	_data_->status = (guint) 0;
#line 96 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_data_->err_msg);
#line 96 "../src/data/providers/data/IGDB.vala"
	_data_->err_msg = NULL;
#line 98 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp0_ = game_hub_utils_parser_parse_json (_data_->json);
#line 98 "../src/data/providers/data/IGDB.vala"
	_data_->json_root = _data_->_tmp0_;
#line 99 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp2_ = _data_->json_root;
#line 99 "../src/data/providers/data/IGDB.vala"
	if (_data_->_tmp2_ == NULL) {
#line 99 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp1_ = TRUE;
#line 1699 "IGDB.c"
	} else {
#line 99 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp3_ = _data_->json_root;
#line 99 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp1_ = json_node_get_node_type (_data_->_tmp3_) != JSON_NODE_ARRAY;
#line 1705 "IGDB.c"
	}
#line 99 "../src/data/providers/data/IGDB.vala"
	if (_data_->_tmp1_) {
#line 99 "../src/data/providers/data/IGDB.vala"
		_data_->result = NULL;
#line 99 "../src/data/providers/data/IGDB.vala"
		__vala_JsonNode_free0 (_data_->json_root);
#line 99 "../src/data/providers/data/IGDB.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 99 "../src/data/providers/data/IGDB.vala"
		if (_data_->_state_ != 0) {
#line 99 "../src/data/providers/data/IGDB.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 99 "../src/data/providers/data/IGDB.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1721 "IGDB.c"
			}
		}
#line 99 "../src/data/providers/data/IGDB.vala"
		g_object_unref (_data_->_async_result);
#line 99 "../src/data/providers/data/IGDB.vala"
		return FALSE;
#line 1728 "IGDB.c"
	}
#line 100 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp4_ = _data_->json_root;
#line 100 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp5_ = json_node_get_array (_data_->_tmp4_);
#line 100 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp6_ = _json_array_ref0 (_data_->_tmp5_);
#line 100 "../src/data/providers/data/IGDB.vala"
	_data_->json_array = _data_->_tmp6_;
#line 101 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp8_ = _data_->json_array;
#line 101 "../src/data/providers/data/IGDB.vala"
	if (_data_->_tmp8_ == NULL) {
#line 101 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp7_ = TRUE;
#line 1744 "IGDB.c"
	} else {
#line 101 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp9_ = _data_->json_array;
#line 101 "../src/data/providers/data/IGDB.vala"
		_data_->_tmp7_ = json_array_get_length (_data_->_tmp9_) < ((guint) 1);
#line 1750 "IGDB.c"
	}
#line 101 "../src/data/providers/data/IGDB.vala"
	if (_data_->_tmp7_) {
#line 101 "../src/data/providers/data/IGDB.vala"
		_data_->result = NULL;
#line 101 "../src/data/providers/data/IGDB.vala"
		_json_array_unref0 (_data_->json_array);
#line 101 "../src/data/providers/data/IGDB.vala"
		__vala_JsonNode_free0 (_data_->json_root);
#line 101 "../src/data/providers/data/IGDB.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 101 "../src/data/providers/data/IGDB.vala"
		if (_data_->_state_ != 0) {
#line 101 "../src/data/providers/data/IGDB.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 101 "../src/data/providers/data/IGDB.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1768 "IGDB.c"
			}
		}
#line 101 "../src/data/providers/data/IGDB.vala"
		g_object_unref (_data_->_async_result);
#line 101 "../src/data/providers/data/IGDB.vala"
		return FALSE;
#line 1775 "IGDB.c"
	}
#line 103 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp10_ = gee_array_list_new (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT, (GBoxedCopyFunc) game_hub_data_providers_data_igdb_result_ref, (GDestroyNotify) game_hub_data_providers_data_igdb_result_unref, NULL, NULL, NULL);
#line 103 "../src/data/providers/data/IGDB.vala"
	_data_->results = _data_->_tmp10_;
#line 105 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp11_ = _data_->json_array;
#line 105 "../src/data/providers/data/IGDB.vala"
	_data_->_tmp12_ = json_array_get_elements (_data_->_tmp11_);
#line 1785 "IGDB.c"
	{
#line 105 "../src/data/providers/data/IGDB.vala"
		_data_->node_collection = _data_->_tmp12_;
#line 105 "../src/data/providers/data/IGDB.vala"
		for (_data_->node_it = _data_->node_collection; _data_->node_it != NULL; _data_->node_it = _data_->node_it->next) {
#line 105 "../src/data/providers/data/IGDB.vala"
			_data_->node = (JsonNode*) _data_->node_it->data;
#line 1793 "IGDB.c"
			{
#line 107 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp13_ = _data_->node;
#line 107 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp14_ = json_node_get_object (_data_->_tmp13_);
#line 107 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp15_ = _json_object_ref0 (_data_->_tmp14_);
#line 107 "../src/data/providers/data/IGDB.vala"
				_data_->obj = _data_->_tmp15_;
#line 109 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp16_ = _data_->obj;
#line 109 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp17_ = 0U;
#line 109 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp18_ = NULL;
#line 109 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp19_ = game_hub_data_providers_data_igdb_is_error (_data_->self, _data_->_tmp16_, &_data_->_tmp17_, &_data_->_tmp18_);
#line 109 "../src/data/providers/data/IGDB.vala"
				_data_->status = _data_->_tmp17_;
#line 109 "../src/data/providers/data/IGDB.vala"
				_g_free0 (_data_->err_msg);
#line 109 "../src/data/providers/data/IGDB.vala"
				_data_->err_msg = _data_->_tmp18_;
#line 109 "../src/data/providers/data/IGDB.vala"
				if (_data_->_tmp19_) {
#line 111 "../src/data/providers/data/IGDB.vala"
					_data_->_error_ = TRUE;
#line 112 "../src/data/providers/data/IGDB.vala"
					_data_->result = NULL;
#line 112 "../src/data/providers/data/IGDB.vala"
					_json_object_unref0 (_data_->obj);
#line 112 "../src/data/providers/data/IGDB.vala"
					(_data_->node_collection == NULL) ? NULL : (_data_->node_collection = (g_list_free (_data_->node_collection), NULL));
#line 112 "../src/data/providers/data/IGDB.vala"
					_g_object_unref0 (_data_->results);
#line 112 "../src/data/providers/data/IGDB.vala"
					_json_array_unref0 (_data_->json_array);
#line 112 "../src/data/providers/data/IGDB.vala"
					__vala_JsonNode_free0 (_data_->json_root);
#line 112 "../src/data/providers/data/IGDB.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 112 "../src/data/providers/data/IGDB.vala"
					if (_data_->_state_ != 0) {
#line 112 "../src/data/providers/data/IGDB.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 112 "../src/data/providers/data/IGDB.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1841 "IGDB.c"
						}
					}
#line 112 "../src/data/providers/data/IGDB.vala"
					g_object_unref (_data_->_async_result);
#line 112 "../src/data/providers/data/IGDB.vala"
					return FALSE;
#line 1848 "IGDB.c"
				}
#line 115 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp20_ = _data_->results;
#line 115 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp21_ = _data_->obj;
#line 115 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp22_ = game_hub_data_providers_data_igdb_result_new (_data_->_tmp21_);
#line 115 "../src/data/providers/data/IGDB.vala"
				_data_->_tmp23_ = _data_->_tmp22_;
#line 115 "../src/data/providers/data/IGDB.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp20_, _data_->_tmp23_);
#line 115 "../src/data/providers/data/IGDB.vala"
				_game_hub_data_providers_data_igdb_result_unref0 (_data_->_tmp23_);
#line 105 "../src/data/providers/data/IGDB.vala"
				_json_object_unref0 (_data_->obj);
#line 1864 "IGDB.c"
			}
		}
#line 105 "../src/data/providers/data/IGDB.vala"
		(_data_->node_collection == NULL) ? NULL : (_data_->node_collection = (g_list_free (_data_->node_collection), NULL));
#line 1869 "IGDB.c"
	}
#line 118 "../src/data/providers/data/IGDB.vala"
	_data_->result = _data_->results;
#line 118 "../src/data/providers/data/IGDB.vala"
	_json_array_unref0 (_data_->json_array);
#line 118 "../src/data/providers/data/IGDB.vala"
	__vala_JsonNode_free0 (_data_->json_root);
#line 118 "../src/data/providers/data/IGDB.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 118 "../src/data/providers/data/IGDB.vala"
	if (_data_->_state_ != 0) {
#line 118 "../src/data/providers/data/IGDB.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 118 "../src/data/providers/data/IGDB.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1885 "IGDB.c"
		}
	}
#line 118 "../src/data/providers/data/IGDB.vala"
	g_object_unref (_data_->_async_result);
#line 118 "../src/data/providers/data/IGDB.vala"
	return FALSE;
#line 1892 "IGDB.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1570 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1571 "glib-2.0.vapi"
	result = self;
#line 1571 "glib-2.0.vapi"
	return result;
#line 1905 "IGDB.c"
}

static gboolean
game_hub_data_providers_data_igdb_is_error (GameHubDataProvidersDataIGDB* self,
                                            JsonObject* obj,
                                            guint* status,
                                            gchar** err_msg)
{
	guint _vala_status = 0U;
	gchar* _vala_err_msg = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result = FALSE;
#line 121 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 123 "../src/data/providers/data/IGDB.vala"
	_vala_status = (guint) 0;
#line 124 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_vala_err_msg);
#line 124 "../src/data/providers/data/IGDB.vala"
	_vala_err_msg = NULL;
#line 126 "../src/data/providers/data/IGDB.vala"
	if (obj == NULL) {
#line 126 "../src/data/providers/data/IGDB.vala"
		result = TRUE;
#line 126 "../src/data/providers/data/IGDB.vala"
		if (status) {
#line 126 "../src/data/providers/data/IGDB.vala"
			*status = _vala_status;
#line 1936 "IGDB.c"
		}
#line 126 "../src/data/providers/data/IGDB.vala"
		if (err_msg) {
#line 126 "../src/data/providers/data/IGDB.vala"
			*err_msg = _vala_err_msg;
#line 1942 "IGDB.c"
		} else {
#line 126 "../src/data/providers/data/IGDB.vala"
			_g_free0 (_vala_err_msg);
#line 1946 "IGDB.c"
		}
#line 126 "../src/data/providers/data/IGDB.vala"
		return result;
#line 1950 "IGDB.c"
	}
#line 128 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, "cause")) {
#line 1954 "IGDB.c"
		const gchar* _tmp1_;
#line 128 "../src/data/providers/data/IGDB.vala"
		_tmp1_ = json_object_get_string_member (obj, "cause");
#line 128 "../src/data/providers/data/IGDB.vala"
		_tmp0_ = _tmp1_;
#line 1960 "IGDB.c"
	} else {
#line 128 "../src/data/providers/data/IGDB.vala"
		_tmp0_ = NULL;
#line 1964 "IGDB.c"
	}
#line 128 "../src/data/providers/data/IGDB.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 128 "../src/data/providers/data/IGDB.vala"
	_g_free0 (_vala_err_msg);
#line 128 "../src/data/providers/data/IGDB.vala"
	_vala_err_msg = _tmp2_;
#line 130 "../src/data/providers/data/IGDB.vala"
	_tmp3_ = _vala_err_msg;
#line 130 "../src/data/providers/data/IGDB.vala"
	if (_tmp3_ != NULL) {
#line 1976 "IGDB.c"
		guint _tmp4_ = 0U;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 132 "../src/data/providers/data/IGDB.vala"
		if (json_object_has_member (obj, "status")) {
#line 132 "../src/data/providers/data/IGDB.vala"
			_tmp4_ = (guint) json_object_get_int_member (obj, "status");
#line 1988 "IGDB.c"
		} else {
#line 132 "../src/data/providers/data/IGDB.vala"
			_tmp4_ = (guint) 0;
#line 1992 "IGDB.c"
		}
#line 132 "../src/data/providers/data/IGDB.vala"
		_vala_status = _tmp4_;
#line 133 "../src/data/providers/data/IGDB.vala"
		_tmp5_ = g_strdup_printf ("%u", _vala_status);
#line 133 "../src/data/providers/data/IGDB.vala"
		_tmp6_ = _tmp5_;
#line 133 "../src/data/providers/data/IGDB.vala"
		_tmp7_ = _vala_err_msg;
#line 133 "../src/data/providers/data/IGDB.vala"
		_tmp8_ = string_to_string (_tmp7_);
#line 133 "../src/data/providers/data/IGDB.vala"
		_tmp9_ = g_strconcat ("[IGDB] Error ", _tmp6_, ": ", _tmp8_, NULL);
#line 133 "../src/data/providers/data/IGDB.vala"
		_tmp10_ = _tmp9_;
#line 133 "../src/data/providers/data/IGDB.vala"
		g_warning ("IGDB.vala:133: %s", _tmp10_);
#line 133 "../src/data/providers/data/IGDB.vala"
		_g_free0 (_tmp10_);
#line 133 "../src/data/providers/data/IGDB.vala"
		_g_free0 (_tmp6_);
#line 134 "../src/data/providers/data/IGDB.vala"
		result = TRUE;
#line 134 "../src/data/providers/data/IGDB.vala"
		if (status) {
#line 134 "../src/data/providers/data/IGDB.vala"
			*status = _vala_status;
#line 2020 "IGDB.c"
		}
#line 134 "../src/data/providers/data/IGDB.vala"
		if (err_msg) {
#line 134 "../src/data/providers/data/IGDB.vala"
			*err_msg = _vala_err_msg;
#line 2026 "IGDB.c"
		} else {
#line 134 "../src/data/providers/data/IGDB.vala"
			_g_free0 (_vala_err_msg);
#line 2030 "IGDB.c"
		}
#line 134 "../src/data/providers/data/IGDB.vala"
		return result;
#line 2034 "IGDB.c"
	}
#line 136 "../src/data/providers/data/IGDB.vala"
	result = FALSE;
#line 136 "../src/data/providers/data/IGDB.vala"
	if (status) {
#line 136 "../src/data/providers/data/IGDB.vala"
		*status = _vala_status;
#line 2042 "IGDB.c"
	}
#line 136 "../src/data/providers/data/IGDB.vala"
	if (err_msg) {
#line 136 "../src/data/providers/data/IGDB.vala"
		*err_msg = _vala_err_msg;
#line 2048 "IGDB.c"
	} else {
#line 136 "../src/data/providers/data/IGDB.vala"
		_g_free0 (_vala_err_msg);
#line 2052 "IGDB.c"
	}
#line 136 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2056 "IGDB.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 2075 "IGDB.c"
}

static Block45Data*
block45_data_ref (Block45Data* _data45_)
{
#line 146 "../src/data/providers/data/IGDB.vala"
	g_atomic_int_inc (&_data45_->_ref_count_);
#line 146 "../src/data/providers/data/IGDB.vala"
	return _data45_;
#line 2085 "IGDB.c"
}

static void
block45_data_unref (void * _userdata_)
{
	Block45Data* _data45_;
	_data45_ = (Block45Data*) _userdata_;
#line 146 "../src/data/providers/data/IGDB.vala"
	if (g_atomic_int_dec_and_test (&_data45_->_ref_count_)) {
#line 2095 "IGDB.c"
		GameHubDataProvidersDataIGDB* self;
#line 146 "../src/data/providers/data/IGDB.vala"
		self = _data45_->self;
#line 146 "../src/data/providers/data/IGDB.vala"
		_g_object_unref0 (_data45_->msg);
#line 146 "../src/data/providers/data/IGDB.vala"
		_game_hub_data_providers_provider_unref0 (self);
#line 146 "../src/data/providers/data/IGDB.vala"
		g_slice_free (Block45Data, _data45_);
#line 2105 "IGDB.c"
	}
}

static gboolean
__lambda178_ (Block45Data* _data45_)
{
	GameHubDataProvidersDataIGDB* self;
	gboolean result = FALSE;
#line 154 "../src/data/providers/data/IGDB.vala"
	self = _data45_->self;
#line 154 "../src/data/providers/data/IGDB.vala"
	gtk_widget_destroy ((GtkWidget*) _data45_->msg);
#line 154 "../src/data/providers/data/IGDB.vala"
	result = G_SOURCE_REMOVE;
#line 154 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2122 "IGDB.c"
}

static gboolean
___lambda178__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda178_ (self);
#line 154 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2132 "IGDB.c"
}

static void
__lambda177_ (Block45Data* _data45_)
{
	GameHubDataProvidersDataIGDB* self;
#line 150 "../src/data/providers/data/IGDB.vala"
	self = _data45_->self;
#line 152 "../src/data/providers/data/IGDB.vala"
	gtk_info_bar_set_revealed (_data45_->msg, FALSE);
#line 154 "../src/data/providers/data/IGDB.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ___lambda178__gsource_func, block45_data_ref (_data45_), block45_data_unref);
#line 2145 "IGDB.c"
}

static void
___lambda177__gtk_info_bar_close (GtkInfoBar* _sender,
                                  gpointer self)
{
#line 150 "../src/data/providers/data/IGDB.vala"
	__lambda177_ (self);
#line 2154 "IGDB.c"
}

static void
__lambda179_ (Block45Data* _data45_,
              gint r)
{
	GameHubDataProvidersDataIGDB* self;
#line 157 "../src/data/providers/data/IGDB.vala"
	self = _data45_->self;
#line 158 "../src/data/providers/data/IGDB.vala"
	switch (r) {
#line 158 "../src/data/providers/data/IGDB.vala"
		case 1:
#line 2168 "IGDB.c"
		{
			GameHubUIDialogsSettingsDialogSettingsDialog* _tmp0_;
			GameHubUIDialogsSettingsDialogSettingsDialog* _tmp1_;
#line 161 "../src/data/providers/data/IGDB.vala"
			_tmp0_ = game_hub_ui_dialogs_settings_dialog_settings_dialog_new ("providers/providers");
#line 161 "../src/data/providers/data/IGDB.vala"
			g_object_ref_sink (_tmp0_);
#line 161 "../src/data/providers/data/IGDB.vala"
			_tmp1_ = _tmp0_;
#line 161 "../src/data/providers/data/IGDB.vala"
			_g_object_unref0 (_tmp1_);
#line 162 "../src/data/providers/data/IGDB.vala"
			break;
#line 2182 "IGDB.c"
		}
#line 158 "../src/data/providers/data/IGDB.vala"
		case GTK_RESPONSE_CLOSE:
#line 2186 "IGDB.c"
		{
#line 165 "../src/data/providers/data/IGDB.vala"
			g_signal_emit_by_name (_data45_->msg, "close");
#line 166 "../src/data/providers/data/IGDB.vala"
			break;
#line 2192 "IGDB.c"
		}
		default:
#line 158 "../src/data/providers/data/IGDB.vala"
		break;
#line 2197 "IGDB.c"
	}
}

static void
___lambda179__gtk_info_bar_response (GtkInfoBar* _sender,
                                     gint response_id,
                                     gpointer self)
{
#line 157 "../src/data/providers/data/IGDB.vala"
	__lambda179_ (self, response_id);
#line 2208 "IGDB.c"
}

static gboolean
___lambda176_ (GameHubDataProvidersDataIGDB* self)
{
	Block45Data* _data45_;
	GameHubUIViewsGamesViewGamesView* _tmp0_;
	GtkInfoBar* _tmp1_;
	gboolean result = FALSE;
#line 146 "../src/data/providers/data/IGDB.vala"
	_data45_ = g_slice_new0 (Block45Data);
#line 146 "../src/data/providers/data/IGDB.vala"
	_data45_->_ref_count_ = 1;
#line 146 "../src/data/providers/data/IGDB.vala"
	_data45_->self = game_hub_data_providers_provider_ref (self);
#line 147 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = game_hub_ui_views_games_view_games_view_instance;
#line 147 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = game_hub_ui_views_games_view_games_view_add_message (_tmp0_, _ ("Monthly IGDB request quota has been reached. Set your own API key to u" \
"se IGDB data or disable IGDB."), GTK_MESSAGE_WARNING);
#line 147 "../src/data/providers/data/IGDB.vala"
	_data45_->msg = _tmp1_;
#line 148 "../src/data/providers/data/IGDB.vala"
	gtk_info_bar_add_button (_data45_->msg, _ ("Settings"), 1);
#line 150 "../src/data/providers/data/IGDB.vala"
	g_signal_connect_data (_data45_->msg, "close", (GCallback) ___lambda177__gtk_info_bar_close, block45_data_ref (_data45_), (GClosureNotify) block45_data_unref, 0);
#line 157 "../src/data/providers/data/IGDB.vala"
	g_signal_connect_data (_data45_->msg, "response", (GCallback) ___lambda179__gtk_info_bar_response, block45_data_ref (_data45_), (GClosureNotify) block45_data_unref, 0);
#line 169 "../src/data/providers/data/IGDB.vala"
	result = G_SOURCE_REMOVE;
#line 169 "../src/data/providers/data/IGDB.vala"
	block45_data_unref (_data45_);
#line 169 "../src/data/providers/data/IGDB.vala"
	_data45_ = NULL;
#line 169 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2244 "IGDB.c"
}

static gboolean
____lambda176__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda176_ ((GameHubDataProvidersDataIGDB*) self);
#line 146 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2254 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_show_error (GameHubDataProvidersDataIGDB* self,
                                              guint status,
                                              const gchar* err_msg)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 139 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/data/providers/data/IGDB.vala"
	if (self->priv->request_quota_reached) {
#line 141 "../src/data/providers/data/IGDB.vala"
		return;
#line 2270 "IGDB.c"
	}
#line 142 "../src/data/providers/data/IGDB.vala"
	if (status == ((guint) SOUP_STATUS_FORBIDDEN)) {
#line 142 "../src/data/providers/data/IGDB.vala"
		_tmp1_ = err_msg != NULL;
#line 2276 "IGDB.c"
	} else {
#line 142 "../src/data/providers/data/IGDB.vala"
		_tmp1_ = FALSE;
#line 2280 "IGDB.c"
	}
#line 142 "../src/data/providers/data/IGDB.vala"
	if (_tmp1_) {
#line 142 "../src/data/providers/data/IGDB.vala"
		_tmp0_ = string_contains (err_msg, "request limit");
#line 2286 "IGDB.c"
	} else {
#line 142 "../src/data/providers/data/IGDB.vala"
		_tmp0_ = FALSE;
#line 2290 "IGDB.c"
	}
#line 142 "../src/data/providers/data/IGDB.vala"
	if (_tmp0_) {
#line 2294 "IGDB.c"
		GameHubUIViewsGamesViewGamesView* _tmp2_;
#line 144 "../src/data/providers/data/IGDB.vala"
		self->priv->request_quota_reached = TRUE;
#line 145 "../src/data/providers/data/IGDB.vala"
		_tmp2_ = game_hub_ui_views_games_view_games_view_instance;
#line 145 "../src/data/providers/data/IGDB.vala"
		if (_tmp2_ == NULL) {
#line 145 "../src/data/providers/data/IGDB.vala"
			return;
#line 2304 "IGDB.c"
		}
#line 146 "../src/data/providers/data/IGDB.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda176__gsource_func, game_hub_data_providers_provider_ref (self), game_hub_data_providers_provider_unref);
#line 2308 "IGDB.c"
	}
}

static const gchar*
game_hub_data_providers_data_igdb_real_get_id (GameHubDataProvidersProvider* base)
{
	const gchar* result;
	GameHubDataProvidersDataIGDB* self;
#line 32 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 32 "../src/data/providers/data/IGDB.vala"
	result = "igdb";
#line 32 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2323 "IGDB.c"
}

static const gchar*
game_hub_data_providers_data_igdb_real_get_name (GameHubDataProvidersProvider* base)
{
	const gchar* result;
	GameHubDataProvidersDataIGDB* self;
#line 33 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 33 "../src/data/providers/data/IGDB.vala"
	result = "IGDB";
#line 33 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2337 "IGDB.c"
}

static const gchar*
game_hub_data_providers_data_igdb_real_get_url (GameHubDataProvidersProvider* base)
{
	const gchar* result;
	GameHubDataProvidersDataIGDB* self;
#line 34 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 34 "../src/data/providers/data/IGDB.vala"
	result = GAME_HUB_DATA_PROVIDERS_DATA_IGDB_SCHEME GAME_HUB_DATA_PROVIDERS_DATA_IGDB_DOMAIN;
#line 34 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2351 "IGDB.c"
}

static const gchar*
game_hub_data_providers_data_igdb_real_get_icon (GameHubDataProvidersProvider* base)
{
	const gchar* result;
	GameHubDataProvidersDataIGDB* self;
#line 35 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 35 "../src/data/providers/data/IGDB.vala"
	result = "provider-data-igdb";
#line 35 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2365 "IGDB.c"
}

static gboolean
game_hub_data_providers_data_igdb_real_get_enabled (GameHubDataProvidersProvider* base)
{
	gboolean result;
	GameHubDataProvidersDataIGDB* self;
	GameHubSettingsProvidersDataIGDB* _tmp0_;
	GameHubSettingsProvidersDataIGDB* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 39 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 39 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = game_hub_settings_providers_data_igdb_get_instance ();
#line 39 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/data/providers/data/IGDB.vala"
	_tmp2_ = game_hub_settings_providers_data_igdb_get_enabled (_tmp1_);
#line 39 "../src/data/providers/data/IGDB.vala"
	_tmp3_ = _tmp2_;
#line 39 "../src/data/providers/data/IGDB.vala"
	result = _tmp3_;
#line 39 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2391 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_real_set_enabled (GameHubDataProvidersProvider* base,
                                                    gboolean value)
{
	GameHubDataProvidersDataIGDB* self;
	GameHubSettingsProvidersDataIGDB* _tmp0_;
	GameHubSettingsProvidersDataIGDB* _tmp1_;
#line 40 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 40 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = game_hub_settings_providers_data_igdb_get_instance ();
#line 40 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = _tmp0_;
#line 40 "../src/data/providers/data/IGDB.vala"
	game_hub_settings_providers_data_igdb_set_enabled (_tmp1_, value);
#line 2409 "IGDB.c"
}

static Block46Data*
block46_data_ref (Block46Data* _data46_)
{
#line 422 "../src/data/providers/data/IGDB.vala"
	g_atomic_int_inc (&_data46_->_ref_count_);
#line 422 "../src/data/providers/data/IGDB.vala"
	return _data46_;
#line 2419 "IGDB.c"
}

static void
block46_data_unref (void * _userdata_)
{
	Block46Data* _data46_;
	_data46_ = (Block46Data*) _userdata_;
#line 422 "../src/data/providers/data/IGDB.vala"
	if (g_atomic_int_dec_and_test (&_data46_->_ref_count_)) {
#line 2429 "IGDB.c"
		GameHubDataProvidersDataIGDB* self;
#line 422 "../src/data/providers/data/IGDB.vala"
		self = _data46_->self;
#line 422 "../src/data/providers/data/IGDB.vala"
		_g_object_unref0 (_data46_->desc_src);
#line 422 "../src/data/providers/data/IGDB.vala"
		_g_object_unref0 (_data46_->entry);
#line 422 "../src/data/providers/data/IGDB.vala"
		_g_object_unref0 (_data46_->settings);
#line 422 "../src/data/providers/data/IGDB.vala"
		_game_hub_data_providers_provider_unref0 (self);
#line 422 "../src/data/providers/data/IGDB.vala"
		g_slice_free (Block46Data, _data46_);
#line 2443 "IGDB.c"
	}
}

static void
_game_hub_data_providers_data_igdb_settings_widget___lambda261_ (Block46Data* _data46_)
{
	GameHubDataProvidersDataIGDB* self;
	GameHubSettingsProvidersDataIGDB* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 441 "../src/data/providers/data/IGDB.vala"
	self = _data46_->self;
#line 441 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = _data46_->settings;
#line 441 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = _data46_->entry;
#line 441 "../src/data/providers/data/IGDB.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 441 "../src/data/providers/data/IGDB.vala"
	_tmp3_ = _tmp2_;
#line 441 "../src/data/providers/data/IGDB.vala"
	game_hub_settings_providers_data_igdb_set_api_key (_tmp0_, _tmp3_);
#line 2467 "IGDB.c"
}

static void
__game_hub_data_providers_data_igdb_settings_widget___lambda261__g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self)
{
#line 441 "../src/data/providers/data/IGDB.vala"
	_game_hub_data_providers_data_igdb_settings_widget___lambda261_ (self);
#line 2477 "IGDB.c"
}

static void
_game_hub_data_providers_data_igdb_settings_widget___lambda262_ (Block46Data* _data46_,
                                                                 GtkEntryIconPosition pos,
                                                                 GdkEvent* e)
{
	GameHubDataProvidersDataIGDB* self;
#line 442 "../src/data/providers/data/IGDB.vala"
	self = _data46_->self;
#line 442 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (e != NULL);
#line 443 "../src/data/providers/data/IGDB.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 2492 "IGDB.c"
		GtkEntry* _tmp0_;
#line 445 "../src/data/providers/data/IGDB.vala"
		_tmp0_ = _data46_->entry;
#line 445 "../src/data/providers/data/IGDB.vala"
		gtk_entry_set_text (_tmp0_, "");
#line 2498 "IGDB.c"
	}
}

static void
__game_hub_data_providers_data_igdb_settings_widget___lambda262__gtk_entry_icon_press (GtkEntry* _sender,
                                                                                       GtkEntryIconPosition icon_pos,
                                                                                       GdkEvent* event,
                                                                                       gpointer self)
{
#line 442 "../src/data/providers/data/IGDB.vala"
	_game_hub_data_providers_data_igdb_settings_widget___lambda262_ (self, icon_pos, event);
#line 2510 "IGDB.c"
}

static void
_game_hub_data_providers_data_igdb_settings_widget___lambda263_ (GameHubDataProvidersDataIGDB* self)
{
#line 461 "../src/data/providers/data/IGDB.vala"
	game_hub_utils_open_uri (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_API_KEY_PAGE);
#line 2518 "IGDB.c"
}

static void
__game_hub_data_providers_data_igdb_settings_widget___lambda263__gtk_button_clicked (GtkButton* _sender,
                                                                                     gpointer self)
{
#line 460 "../src/data/providers/data/IGDB.vala"
	_game_hub_data_providers_data_igdb_settings_widget___lambda263_ ((GameHubDataProvidersDataIGDB*) self);
#line 2527 "IGDB.c"
}

static void
_game_hub_data_providers_data_igdb_settings_widget___lambda264_ (Block46Data* _data46_)
{
	GameHubDataProvidersDataIGDB* self;
	GameHubSettingsProvidersDataIGDB* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 482 "../src/data/providers/data/IGDB.vala"
	self = _data46_->self;
#line 483 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = _data46_->settings;
#line 483 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = game_hub_ui_widgets_mode_button_get_selected (_data46_->desc_src);
#line 483 "../src/data/providers/data/IGDB.vala"
	_tmp2_ = _tmp1_;
#line 483 "../src/data/providers/data/IGDB.vala"
	game_hub_settings_providers_data_igdb_set_preferred_description (_tmp0_, (GameHubSettingsProvidersDataIGDBPreferredDescription) _tmp2_);
#line 2547 "IGDB.c"
}

static void
__game_hub_data_providers_data_igdb_settings_widget___lambda264__game_hub_ui_widgets_mode_button_mode_changed (GameHubUIWidgetsModeButton* _sender,
                                                                                                               GtkWidget* widget,
                                                                                                               gpointer self)
{
#line 482 "../src/data/providers/data/IGDB.vala"
	_game_hub_data_providers_data_igdb_settings_widget___lambda264_ (self);
#line 2557 "IGDB.c"
}

static GtkWidget*
game_hub_data_providers_data_igdb_real_get_settings_widget (GameHubDataProvidersProvider* base)
{
	GtkWidget* result;
	GameHubDataProvidersDataIGDB* self;
	Block46Data* _data46_;
	GameHubSettingsProvidersDataIGDB* _tmp0_;
	GameHubSettingsProvidersDataIGDB* _tmp1_;
	GameHubSettingsProvidersDataIGDB* _tmp2_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	GtkGrid* _tmp5_;
	GtkEntry* _tmp6_;
	GtkEntry* _tmp7_;
	GtkEntry* _tmp8_;
	GameHubSettingsProvidersDataIGDB* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GameHubSettingsProvidersDataIGDB* _tmp12_;
	GSettings* _tmp13_;
	GSettings* _tmp14_;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	const gchar* _tmp17_;
	gboolean _tmp18_;
	GtkEntry* _tmp23_;
	GtkEntry* _tmp24_;
	GtkEntry* _tmp25_;
	GtkEntry* _tmp26_;
	GtkEntry* _tmp27_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp28_;
	GtkBox* entry_wrapper = NULL;
	GtkBox* _tmp29_;
	GtkStyleContext* _tmp30_;
	GtkButton* link = NULL;
	GtkButton* _tmp31_;
	GtkEntry* _tmp32_;
	GtkBox* desc_src_wrapper = NULL;
	GtkBox* _tmp33_;
	GtkLabel* desc_src_label = NULL;
	GtkLabel* _tmp34_;
	GameHubUIWidgetsModeButton* _tmp35_;
	GameHubSettingsProvidersDataIGDB* _tmp36_;
	GameHubSettingsProvidersDataIGDBPreferredDescription _tmp37_;
	GameHubSettingsProvidersDataIGDBPreferredDescription _tmp38_;
	GtkGrid* _tmp39_;
	GtkGrid* _tmp40_;
	GtkGrid* _tmp41_;
#line 422 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDB*) base;
#line 422 "../src/data/providers/data/IGDB.vala"
	_data46_ = g_slice_new0 (Block46Data);
#line 422 "../src/data/providers/data/IGDB.vala"
	_data46_->_ref_count_ = 1;
#line 422 "../src/data/providers/data/IGDB.vala"
	_data46_->self = game_hub_data_providers_provider_ref (self);
#line 424 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = game_hub_settings_providers_data_igdb_get_instance ();
#line 424 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = _tmp0_;
#line 424 "../src/data/providers/data/IGDB.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 424 "../src/data/providers/data/IGDB.vala"
	_data46_->settings = _tmp2_;
#line 426 "../src/data/providers/data/IGDB.vala"
	_tmp3_ = (GtkGrid*) gtk_grid_new ();
#line 426 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp3_);
#line 426 "../src/data/providers/data/IGDB.vala"
	grid = _tmp3_;
#line 427 "../src/data/providers/data/IGDB.vala"
	_tmp4_ = grid;
#line 427 "../src/data/providers/data/IGDB.vala"
	gtk_grid_set_column_spacing (_tmp4_, 12);
#line 428 "../src/data/providers/data/IGDB.vala"
	_tmp5_ = grid;
#line 428 "../src/data/providers/data/IGDB.vala"
	gtk_grid_set_row_spacing (_tmp5_, 4);
#line 430 "../src/data/providers/data/IGDB.vala"
	_tmp6_ = (GtkEntry*) gtk_entry_new ();
#line 430 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp6_);
#line 430 "../src/data/providers/data/IGDB.vala"
	_data46_->entry = _tmp6_;
#line 431 "../src/data/providers/data/IGDB.vala"
	_tmp7_ = _data46_->entry;
#line 431 "../src/data/providers/data/IGDB.vala"
	gtk_entry_set_placeholder_text (_tmp7_, _ ("Default"));
#line 432 "../src/data/providers/data/IGDB.vala"
	_tmp8_ = _data46_->entry;
#line 432 "../src/data/providers/data/IGDB.vala"
	gtk_entry_set_max_length (_tmp8_, 32);
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp9_ = _data46_->settings;
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp10_ = game_hub_settings_providers_data_igdb_get_api_key (_tmp9_);
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp11_ = _tmp10_;
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp12_ = _data46_->settings;
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp13_ = game_hub_settings_settings_schema_get_schema ((GameHubSettingsSettingsSchema*) _tmp12_);
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp14_ = _tmp13_;
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp15_ = g_settings_get_default_value (_tmp14_, "api-key");
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp16_ = _tmp15_;
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp17_ = g_variant_get_string (_tmp16_, NULL);
#line 433 "../src/data/providers/data/IGDB.vala"
	_tmp18_ = g_strcmp0 (_tmp11_, _tmp17_) != 0;
#line 433 "../src/data/providers/data/IGDB.vala"
	_g_variant_unref0 (_tmp16_);
#line 433 "../src/data/providers/data/IGDB.vala"
	if (_tmp18_) {
#line 2678 "IGDB.c"
		GtkEntry* _tmp19_;
		GameHubSettingsProvidersDataIGDB* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 435 "../src/data/providers/data/IGDB.vala"
		_tmp19_ = _data46_->entry;
#line 435 "../src/data/providers/data/IGDB.vala"
		_tmp20_ = _data46_->settings;
#line 435 "../src/data/providers/data/IGDB.vala"
		_tmp21_ = game_hub_settings_providers_data_igdb_get_api_key (_tmp20_);
#line 435 "../src/data/providers/data/IGDB.vala"
		_tmp22_ = _tmp21_;
#line 435 "../src/data/providers/data/IGDB.vala"
		gtk_entry_set_text (_tmp19_, _tmp22_);
#line 2693 "IGDB.c"
	}
#line 437 "../src/data/providers/data/IGDB.vala"
	_tmp23_ = _data46_->entry;
#line 437 "../src/data/providers/data/IGDB.vala"
	g_object_set (_tmp23_, "secondary-icon-name", "edit-delete-symbolic", NULL);
#line 438 "../src/data/providers/data/IGDB.vala"
	_tmp24_ = _data46_->entry;
#line 438 "../src/data/providers/data/IGDB.vala"
	g_object_set (_tmp24_, "secondary-icon-tooltip-text", _ ("Restore default API key"), NULL);
#line 439 "../src/data/providers/data/IGDB.vala"
	_tmp25_ = _data46_->entry;
#line 439 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp25_, 250, -1);
#line 441 "../src/data/providers/data/IGDB.vala"
	_tmp26_ = _data46_->entry;
#line 441 "../src/data/providers/data/IGDB.vala"
	g_signal_connect_data ((GObject*) _tmp26_, "notify::text", (GCallback) __game_hub_data_providers_data_igdb_settings_widget___lambda261__g_object_notify, block46_data_ref (_data46_), (GClosureNotify) block46_data_unref, 0);
#line 442 "../src/data/providers/data/IGDB.vala"
	_tmp27_ = _data46_->entry;
#line 442 "../src/data/providers/data/IGDB.vala"
	g_signal_connect_data (_tmp27_, "icon-press", (GCallback) __game_hub_data_providers_data_igdb_settings_widget___lambda262__gtk_entry_icon_press, block46_data_ref (_data46_), (GClosureNotify) block46_data_unref, 0);
#line 449 "../src/data/providers/data/IGDB.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new (_ ("API key"));
#line 449 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp28_);
#line 449 "../src/data/providers/data/IGDB.vala"
	label = _tmp28_;
#line 450 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_START);
#line 451 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_valign ((GtkWidget*) label, GTK_ALIGN_CENTER);
#line 452 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_hexpand ((GtkWidget*) label, TRUE);
#line 454 "../src/data/providers/data/IGDB.vala"
	_tmp29_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 454 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp29_);
#line 454 "../src/data/providers/data/IGDB.vala"
	entry_wrapper = _tmp29_;
#line 455 "../src/data/providers/data/IGDB.vala"
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) entry_wrapper);
#line 455 "../src/data/providers/data/IGDB.vala"
	gtk_style_context_add_class (_tmp30_, GTK_STYLE_CLASS_LINKED);
#line 457 "../src/data/providers/data/IGDB.vala"
	_tmp31_ = (GtkButton*) gtk_button_new_with_label (_ ("Generate key"));
#line 457 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp31_);
#line 457 "../src/data/providers/data/IGDB.vala"
	link = _tmp31_;
#line 458 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) link, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_API_KEY_PAGE);
#line 460 "../src/data/providers/data/IGDB.vala"
	g_signal_connect (link, "clicked", (GCallback) __game_hub_data_providers_data_igdb_settings_widget___lambda263__gtk_button_clicked, self);
#line 464 "../src/data/providers/data/IGDB.vala"
	_tmp32_ = _data46_->entry;
#line 464 "../src/data/providers/data/IGDB.vala"
	gtk_container_add ((GtkContainer*) entry_wrapper, (GtkWidget*) _tmp32_);
#line 465 "../src/data/providers/data/IGDB.vala"
	gtk_container_add ((GtkContainer*) entry_wrapper, (GtkWidget*) link);
#line 467 "../src/data/providers/data/IGDB.vala"
	_tmp33_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 467 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp33_);
#line 467 "../src/data/providers/data/IGDB.vala"
	desc_src_wrapper = _tmp33_;
#line 469 "../src/data/providers/data/IGDB.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new (C_ ("igdb_preferred_description", "When game has description, show description"));
#line 469 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp34_);
#line 469 "../src/data/providers/data/IGDB.vala"
	desc_src_label = _tmp34_;
#line 470 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_halign ((GtkWidget*) desc_src_label, GTK_ALIGN_START);
#line 471 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_valign ((GtkWidget*) desc_src_label, GTK_ALIGN_CENTER);
#line 472 "../src/data/providers/data/IGDB.vala"
	gtk_widget_set_hexpand ((GtkWidget*) desc_src_label, TRUE);
#line 474 "../src/data/providers/data/IGDB.vala"
	_tmp35_ = game_hub_ui_widgets_mode_button_new ();
#line 474 "../src/data/providers/data/IGDB.vala"
	g_object_ref_sink (_tmp35_);
#line 474 "../src/data/providers/data/IGDB.vala"
	_data46_->desc_src = _tmp35_;
#line 475 "../src/data/providers/data/IGDB.vala"
	gtk_box_set_homogeneous ((GtkBox*) _data46_->desc_src, FALSE);
#line 476 "../src/data/providers/data/IGDB.vala"
	game_hub_ui_widgets_mode_button_append_text (_data46_->desc_src, C_ ("igdb_preferred_description", "of game"), NULL, FALSE);
#line 477 "../src/data/providers/data/IGDB.vala"
	game_hub_ui_widgets_mode_button_append_text (_data46_->desc_src, C_ ("igdb_preferred_description", "from IGDB"), NULL, FALSE);
#line 478 "../src/data/providers/data/IGDB.vala"
	game_hub_ui_widgets_mode_button_append_text (_data46_->desc_src, C_ ("igdb_preferred_description", "both"), NULL, FALSE);
#line 480 "../src/data/providers/data/IGDB.vala"
	_tmp36_ = _data46_->settings;
#line 480 "../src/data/providers/data/IGDB.vala"
	_tmp37_ = game_hub_settings_providers_data_igdb_get_preferred_description (_tmp36_);
#line 480 "../src/data/providers/data/IGDB.vala"
	_tmp38_ = _tmp37_;
#line 480 "../src/data/providers/data/IGDB.vala"
	game_hub_ui_widgets_mode_button_set_selected (_data46_->desc_src, (gint) _tmp38_);
#line 482 "../src/data/providers/data/IGDB.vala"
	g_signal_connect_data (_data46_->desc_src, "mode-changed", (GCallback) __game_hub_data_providers_data_igdb_settings_widget___lambda264__game_hub_ui_widgets_mode_button_mode_changed, block46_data_ref (_data46_), (GClosureNotify) block46_data_unref, 0);
#line 486 "../src/data/providers/data/IGDB.vala"
	gtk_container_add ((GtkContainer*) desc_src_wrapper, (GtkWidget*) desc_src_label);
#line 487 "../src/data/providers/data/IGDB.vala"
	gtk_container_add ((GtkContainer*) desc_src_wrapper, (GtkWidget*) _data46_->desc_src);
#line 489 "../src/data/providers/data/IGDB.vala"
	_tmp39_ = grid;
#line 489 "../src/data/providers/data/IGDB.vala"
	gtk_grid_attach (_tmp39_, (GtkWidget*) label, 0, 0, 1, 1);
#line 490 "../src/data/providers/data/IGDB.vala"
	_tmp40_ = grid;
#line 490 "../src/data/providers/data/IGDB.vala"
	gtk_grid_attach (_tmp40_, (GtkWidget*) entry_wrapper, 1, 0, 1, 1);
#line 491 "../src/data/providers/data/IGDB.vala"
	_tmp41_ = grid;
#line 491 "../src/data/providers/data/IGDB.vala"
	gtk_grid_attach (_tmp41_, (GtkWidget*) desc_src_wrapper, 0, 1, 2, 1);
#line 493 "../src/data/providers/data/IGDB.vala"
	result = (GtkWidget*) grid;
#line 493 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (desc_src_label);
#line 493 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (desc_src_wrapper);
#line 493 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (link);
#line 493 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (entry_wrapper);
#line 493 "../src/data/providers/data/IGDB.vala"
	_g_object_unref0 (label);
#line 493 "../src/data/providers/data/IGDB.vala"
	block46_data_unref (_data46_);
#line 493 "../src/data/providers/data/IGDB.vala"
	_data46_ = NULL;
#line 493 "../src/data/providers/data/IGDB.vala"
	return result;
#line 2829 "IGDB.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 202 "../src/data/providers/data/IGDB.vala"
	dup = g_new0 (gint, 1);
#line 202 "../src/data/providers/data/IGDB.vala"
	memcpy (dup, self, sizeof (gint));
#line 202 "../src/data/providers/data/IGDB.vala"
	return dup;
#line 2842 "IGDB.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 202 "../src/data/providers/data/IGDB.vala"
	return self ? _int_dup (self) : NULL;
#line 2850 "IGDB.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 208 "../src/data/providers/data/IGDB.vala"
	dup = g_new0 (gint64, 1);
#line 208 "../src/data/providers/data/IGDB.vala"
	memcpy (dup, self, sizeof (gint64));
#line 208 "../src/data/providers/data/IGDB.vala"
	return dup;
#line 2863 "IGDB.c"
}

static gpointer
__int64_dup0 (gpointer self)
{
#line 208 "../src/data/providers/data/IGDB.vala"
	return self ? _int64_dup (self) : NULL;
#line 2871 "IGDB.c"
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 216 "../src/data/providers/data/IGDB.vala"
	dup = g_new0 (gdouble, 1);
#line 216 "../src/data/providers/data/IGDB.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 216 "../src/data/providers/data/IGDB.vala"
	return dup;
#line 2884 "IGDB.c"
}

static gpointer
__double_dup0 (gpointer self)
{
#line 216 "../src/data/providers/data/IGDB.vala"
	return self ? _double_dup (self) : NULL;
#line 2892 "IGDB.c"
}

static void
_vala_array_add45 (GameHubDataProvidersDataIGDBResultWebsite** * array,
                   gint* length,
                   gint* size,
                   GameHubDataProvidersDataIGDBResultWebsite* value)
{
#line 239 "../src/data/providers/data/IGDB.vala"
	if ((*length) == (*size)) {
#line 239 "../src/data/providers/data/IGDB.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 239 "../src/data/providers/data/IGDB.vala"
		*array = g_renew (GameHubDataProvidersDataIGDBResultWebsite*, *array, (*size) + 1);
#line 2907 "IGDB.c"
	}
#line 239 "../src/data/providers/data/IGDB.vala"
	(*array)[(*length)++] = value;
#line 239 "../src/data/providers/data/IGDB.vala"
	(*array)[*length] = NULL;
#line 2913 "IGDB.c"
}

static gpointer
_game_hub_data_providers_data_igdb_result_website_ref0 (gpointer self)
{
#line 241 "../src/data/providers/data/IGDB.vala"
	return self ? game_hub_data_providers_data_igdb_result_website_ref (self) : NULL;
#line 2921 "IGDB.c"
}

static GameHubDataProvidersDataIGDBResultWebsite**
_vala_array_dup34 (GameHubDataProvidersDataIGDBResultWebsite** self,
                   gssize length)
{
#line 241 "../src/data/providers/data/IGDB.vala"
	if (length >= 0) {
#line 2930 "IGDB.c"
		GameHubDataProvidersDataIGDBResultWebsite** result;
		gssize i;
#line 241 "../src/data/providers/data/IGDB.vala"
		result = g_new0 (GameHubDataProvidersDataIGDBResultWebsite*, length + 1);
#line 241 "../src/data/providers/data/IGDB.vala"
		for (i = 0; i < length; i++) {
#line 2937 "IGDB.c"
			GameHubDataProvidersDataIGDBResultWebsite* _tmp0_;
#line 241 "../src/data/providers/data/IGDB.vala"
			_tmp0_ = _game_hub_data_providers_data_igdb_result_website_ref0 (self[i]);
#line 241 "../src/data/providers/data/IGDB.vala"
			result[i] = _tmp0_;
#line 2943 "IGDB.c"
		}
#line 241 "../src/data/providers/data/IGDB.vala"
		return result;
#line 2947 "IGDB.c"
	}
#line 241 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 2951 "IGDB.c"
}

static void
_vala_array_add46 (GameHubDataProvidersDataIGDBResultLink** * array,
                   gint* length,
                   gint* size,
                   GameHubDataProvidersDataIGDBResultLink* value)
{
#line 253 "../src/data/providers/data/IGDB.vala"
	if ((*length) == (*size)) {
#line 253 "../src/data/providers/data/IGDB.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 253 "../src/data/providers/data/IGDB.vala"
		*array = g_renew (GameHubDataProvidersDataIGDBResultLink*, *array, (*size) + 1);
#line 2966 "IGDB.c"
	}
#line 253 "../src/data/providers/data/IGDB.vala"
	(*array)[(*length)++] = value;
#line 253 "../src/data/providers/data/IGDB.vala"
	(*array)[*length] = NULL;
#line 2972 "IGDB.c"
}

static gpointer
_game_hub_data_providers_data_igdb_result_link_ref0 (gpointer self)
{
#line 255 "../src/data/providers/data/IGDB.vala"
	return self ? game_hub_data_providers_data_igdb_result_link_ref (self) : NULL;
#line 2980 "IGDB.c"
}

static GameHubDataProvidersDataIGDBResultLink**
_vala_array_dup35 (GameHubDataProvidersDataIGDBResultLink** self,
                   gssize length)
{
#line 255 "../src/data/providers/data/IGDB.vala"
	if (length >= 0) {
#line 2989 "IGDB.c"
		GameHubDataProvidersDataIGDBResultLink** result;
		gssize i;
#line 255 "../src/data/providers/data/IGDB.vala"
		result = g_new0 (GameHubDataProvidersDataIGDBResultLink*, length + 1);
#line 255 "../src/data/providers/data/IGDB.vala"
		for (i = 0; i < length; i++) {
#line 2996 "IGDB.c"
			GameHubDataProvidersDataIGDBResultLink* _tmp0_;
#line 255 "../src/data/providers/data/IGDB.vala"
			_tmp0_ = _game_hub_data_providers_data_igdb_result_link_ref0 (self[i]);
#line 255 "../src/data/providers/data/IGDB.vala"
			result[i] = _tmp0_;
#line 3002 "IGDB.c"
		}
#line 255 "../src/data/providers/data/IGDB.vala"
		return result;
#line 3006 "IGDB.c"
	}
#line 255 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 3010 "IGDB.c"
}

static void
_vala_array_add47 (GameHubDataProvidersDataIGDBResultLink** * array,
                   gint* length,
                   gint* size,
                   GameHubDataProvidersDataIGDBResultLink* value)
{
#line 267 "../src/data/providers/data/IGDB.vala"
	if ((*length) == (*size)) {
#line 267 "../src/data/providers/data/IGDB.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 267 "../src/data/providers/data/IGDB.vala"
		*array = g_renew (GameHubDataProvidersDataIGDBResultLink*, *array, (*size) + 1);
#line 3025 "IGDB.c"
	}
#line 267 "../src/data/providers/data/IGDB.vala"
	(*array)[(*length)++] = value;
#line 267 "../src/data/providers/data/IGDB.vala"
	(*array)[*length] = NULL;
#line 3031 "IGDB.c"
}

static GameHubDataProvidersDataIGDBResultLink**
_vala_array_dup36 (GameHubDataProvidersDataIGDBResultLink** self,
                   gssize length)
{
#line 269 "../src/data/providers/data/IGDB.vala"
	if (length >= 0) {
#line 3040 "IGDB.c"
		GameHubDataProvidersDataIGDBResultLink** result;
		gssize i;
#line 269 "../src/data/providers/data/IGDB.vala"
		result = g_new0 (GameHubDataProvidersDataIGDBResultLink*, length + 1);
#line 269 "../src/data/providers/data/IGDB.vala"
		for (i = 0; i < length; i++) {
#line 3047 "IGDB.c"
			GameHubDataProvidersDataIGDBResultLink* _tmp0_;
#line 269 "../src/data/providers/data/IGDB.vala"
			_tmp0_ = _game_hub_data_providers_data_igdb_result_link_ref0 (self[i]);
#line 269 "../src/data/providers/data/IGDB.vala"
			result[i] = _tmp0_;
#line 3053 "IGDB.c"
		}
#line 269 "../src/data/providers/data/IGDB.vala"
		return result;
#line 3057 "IGDB.c"
	}
#line 269 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 3061 "IGDB.c"
}

static void
_vala_array_add48 (GameHubDataProvidersDataIGDBResultLink** * array,
                   gint* length,
                   gint* size,
                   GameHubDataProvidersDataIGDBResultLink* value)
{
#line 281 "../src/data/providers/data/IGDB.vala"
	if ((*length) == (*size)) {
#line 281 "../src/data/providers/data/IGDB.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 281 "../src/data/providers/data/IGDB.vala"
		*array = g_renew (GameHubDataProvidersDataIGDBResultLink*, *array, (*size) + 1);
#line 3076 "IGDB.c"
	}
#line 281 "../src/data/providers/data/IGDB.vala"
	(*array)[(*length)++] = value;
#line 281 "../src/data/providers/data/IGDB.vala"
	(*array)[*length] = NULL;
#line 3082 "IGDB.c"
}

static GameHubDataProvidersDataIGDBResultLink**
_vala_array_dup37 (GameHubDataProvidersDataIGDBResultLink** self,
                   gssize length)
{
#line 283 "../src/data/providers/data/IGDB.vala"
	if (length >= 0) {
#line 3091 "IGDB.c"
		GameHubDataProvidersDataIGDBResultLink** result;
		gssize i;
#line 283 "../src/data/providers/data/IGDB.vala"
		result = g_new0 (GameHubDataProvidersDataIGDBResultLink*, length + 1);
#line 283 "../src/data/providers/data/IGDB.vala"
		for (i = 0; i < length; i++) {
#line 3098 "IGDB.c"
			GameHubDataProvidersDataIGDBResultLink* _tmp0_;
#line 283 "../src/data/providers/data/IGDB.vala"
			_tmp0_ = _game_hub_data_providers_data_igdb_result_link_ref0 (self[i]);
#line 283 "../src/data/providers/data/IGDB.vala"
			result[i] = _tmp0_;
#line 3104 "IGDB.c"
		}
#line 283 "../src/data/providers/data/IGDB.vala"
		return result;
#line 3108 "IGDB.c"
	}
#line 283 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 3112 "IGDB.c"
}

GameHubDataProvidersDataIGDBResult*
game_hub_data_providers_data_igdb_result_construct (GType object_type,
                                                    JsonObject* obj)
{
	GameHubDataProvidersDataIGDBResult* self = NULL;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp65_ = FALSE;
#line 199 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 199 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDBResult*) g_type_create_instance (object_type);
#line 201 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_ID)) {
#line 3130 "IGDB.c"
		gint _tmp0_;
		gint* _tmp1_;
#line 202 "../src/data/providers/data/IGDB.vala"
		_tmp0_ = (gint) json_object_get_int_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_ID);
#line 202 "../src/data/providers/data/IGDB.vala"
		_tmp1_ = __int_dup0 (&_tmp0_);
#line 202 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->id);
#line 202 "../src/data/providers/data/IGDB.vala"
		self->id = _tmp1_;
#line 3141 "IGDB.c"
	}
#line 203 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_NAME)) {
#line 3145 "IGDB.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 204 "../src/data/providers/data/IGDB.vala"
		_tmp2_ = json_object_get_string_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_NAME);
#line 204 "../src/data/providers/data/IGDB.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 204 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->name);
#line 204 "../src/data/providers/data/IGDB.vala"
		self->name = _tmp3_;
#line 3156 "IGDB.c"
	}
#line 205 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_URL)) {
#line 3160 "IGDB.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 206 "../src/data/providers/data/IGDB.vala"
		_tmp4_ = json_object_get_string_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_URL);
#line 206 "../src/data/providers/data/IGDB.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 206 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->url);
#line 206 "../src/data/providers/data/IGDB.vala"
		self->url = _tmp5_;
#line 3171 "IGDB.c"
	}
#line 207 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_RELEASE_DATE)) {
#line 3175 "IGDB.c"
		gint64 _tmp6_;
		gint64* _tmp7_;
#line 208 "../src/data/providers/data/IGDB.vala"
		_tmp6_ = json_object_get_int_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_RELEASE_DATE);
#line 208 "../src/data/providers/data/IGDB.vala"
		_tmp7_ = __int64_dup0 (&_tmp6_);
#line 208 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->release_date);
#line 208 "../src/data/providers/data/IGDB.vala"
		self->release_date = _tmp7_;
#line 3186 "IGDB.c"
	}
#line 210 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_SUMMARY)) {
#line 3190 "IGDB.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 211 "../src/data/providers/data/IGDB.vala"
		_tmp8_ = json_object_get_string_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_SUMMARY);
#line 211 "../src/data/providers/data/IGDB.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 211 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->summary);
#line 211 "../src/data/providers/data/IGDB.vala"
		self->summary = _tmp9_;
#line 3201 "IGDB.c"
	}
#line 212 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_STORYLINE)) {
#line 3205 "IGDB.c"
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 213 "../src/data/providers/data/IGDB.vala"
		_tmp10_ = json_object_get_string_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_STORYLINE);
#line 213 "../src/data/providers/data/IGDB.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 213 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->storyline);
#line 213 "../src/data/providers/data/IGDB.vala"
		self->storyline = _tmp11_;
#line 3216 "IGDB.c"
	}
#line 215 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_POPULARITY)) {
#line 3220 "IGDB.c"
		gdouble _tmp12_;
		gdouble* _tmp13_;
#line 216 "../src/data/providers/data/IGDB.vala"
		_tmp12_ = json_object_get_double_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_POPULARITY);
#line 216 "../src/data/providers/data/IGDB.vala"
		_tmp13_ = __double_dup0 (&_tmp12_);
#line 216 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->popularity);
#line 216 "../src/data/providers/data/IGDB.vala"
		self->popularity = _tmp13_;
#line 3231 "IGDB.c"
	}
#line 218 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING)) {
#line 3235 "IGDB.c"
		gdouble _tmp14_;
		gdouble* _tmp15_;
#line 219 "../src/data/providers/data/IGDB.vala"
		_tmp14_ = json_object_get_double_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING);
#line 219 "../src/data/providers/data/IGDB.vala"
		_tmp15_ = __double_dup0 (&_tmp14_);
#line 219 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->aggregated_rating);
#line 219 "../src/data/providers/data/IGDB.vala"
		self->aggregated_rating = _tmp15_;
#line 3246 "IGDB.c"
	}
#line 220 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING_COUNT)) {
#line 3250 "IGDB.c"
		gint _tmp16_;
		gint* _tmp17_;
#line 221 "../src/data/providers/data/IGDB.vala"
		_tmp16_ = (gint) json_object_get_int_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_AGGREGATED_RATING_COUNT);
#line 221 "../src/data/providers/data/IGDB.vala"
		_tmp17_ = __int_dup0 (&_tmp16_);
#line 221 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->aggregated_rating_count);
#line 221 "../src/data/providers/data/IGDB.vala"
		self->aggregated_rating_count = _tmp17_;
#line 3261 "IGDB.c"
	}
#line 222 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING)) {
#line 3265 "IGDB.c"
		gdouble _tmp18_;
		gdouble* _tmp19_;
#line 223 "../src/data/providers/data/IGDB.vala"
		_tmp18_ = json_object_get_double_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING);
#line 223 "../src/data/providers/data/IGDB.vala"
		_tmp19_ = __double_dup0 (&_tmp18_);
#line 223 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->igdb_rating);
#line 223 "../src/data/providers/data/IGDB.vala"
		self->igdb_rating = _tmp19_;
#line 3276 "IGDB.c"
	}
#line 224 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING_COUNT)) {
#line 3280 "IGDB.c"
		gint _tmp20_;
		gint* _tmp21_;
#line 225 "../src/data/providers/data/IGDB.vala"
		_tmp20_ = (gint) json_object_get_int_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_IGDB_RATING_COUNT);
#line 225 "../src/data/providers/data/IGDB.vala"
		_tmp21_ = __int_dup0 (&_tmp20_);
#line 225 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->igdb_rating_count);
#line 225 "../src/data/providers/data/IGDB.vala"
		self->igdb_rating_count = _tmp21_;
#line 3291 "IGDB.c"
	}
#line 226 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING)) {
#line 3295 "IGDB.c"
		gdouble _tmp22_;
		gdouble* _tmp23_;
#line 227 "../src/data/providers/data/IGDB.vala"
		_tmp22_ = json_object_get_double_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING);
#line 227 "../src/data/providers/data/IGDB.vala"
		_tmp23_ = __double_dup0 (&_tmp22_);
#line 227 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->total_rating);
#line 227 "../src/data/providers/data/IGDB.vala"
		self->total_rating = _tmp23_;
#line 3306 "IGDB.c"
	}
#line 228 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING_COUNT)) {
#line 3310 "IGDB.c"
		gint _tmp24_;
		gint* _tmp25_;
#line 229 "../src/data/providers/data/IGDB.vala"
		_tmp24_ = (gint) json_object_get_int_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_TOTAL_RATING_COUNT);
#line 229 "../src/data/providers/data/IGDB.vala"
		_tmp25_ = __int_dup0 (&_tmp24_);
#line 229 "../src/data/providers/data/IGDB.vala"
		_g_free0 (self->total_rating_count);
#line 229 "../src/data/providers/data/IGDB.vala"
		self->total_rating_count = _tmp25_;
#line 3321 "IGDB.c"
	}
#line 231 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_WEBSITES)) {
#line 3325 "IGDB.c"
		JsonNode* _tmp27_;
#line 231 "../src/data/providers/data/IGDB.vala"
		_tmp27_ = json_object_get_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_WEBSITES);
#line 231 "../src/data/providers/data/IGDB.vala"
		_tmp26_ = json_node_get_node_type (_tmp27_) == JSON_NODE_ARRAY;
#line 3331 "IGDB.c"
	} else {
#line 231 "../src/data/providers/data/IGDB.vala"
		_tmp26_ = FALSE;
#line 3335 "IGDB.c"
	}
#line 231 "../src/data/providers/data/IGDB.vala"
	if (_tmp26_) {
#line 3339 "IGDB.c"
		JsonArray* websites_array = NULL;
		JsonArray* _tmp28_;
		JsonArray* _tmp29_;
		JsonArray* _tmp30_;
#line 233 "../src/data/providers/data/IGDB.vala"
		_tmp28_ = json_object_get_array_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_WEBSITES);
#line 233 "../src/data/providers/data/IGDB.vala"
		_tmp29_ = _json_array_ref0 (_tmp28_);
#line 233 "../src/data/providers/data/IGDB.vala"
		websites_array = _tmp29_;
#line 234 "../src/data/providers/data/IGDB.vala"
		_tmp30_ = websites_array;
#line 234 "../src/data/providers/data/IGDB.vala"
		if (json_array_get_length (_tmp30_) > ((guint) 0)) {
#line 3354 "IGDB.c"
			GameHubDataProvidersDataIGDBResultWebsite** websites = NULL;
			GameHubDataProvidersDataIGDBResultWebsite** _tmp31_;
			gint websites_length1;
			gint _websites_size_;
			JsonArray* _tmp32_;
			GList* _tmp33_;
			GameHubDataProvidersDataIGDBResultWebsite** _tmp37_;
			gint _tmp37__length1;
			GameHubDataProvidersDataIGDBResultWebsite** _tmp38_;
			gint _tmp38__length1;
#line 236 "../src/data/providers/data/IGDB.vala"
			_tmp31_ = g_new0 (GameHubDataProvidersDataIGDBResultWebsite*, 0 + 1);
#line 236 "../src/data/providers/data/IGDB.vala"
			websites = _tmp31_;
#line 236 "../src/data/providers/data/IGDB.vala"
			websites_length1 = 0;
#line 236 "../src/data/providers/data/IGDB.vala"
			_websites_size_ = websites_length1;
#line 237 "../src/data/providers/data/IGDB.vala"
			_tmp32_ = websites_array;
#line 237 "../src/data/providers/data/IGDB.vala"
			_tmp33_ = json_array_get_elements (_tmp32_);
#line 3377 "IGDB.c"
			{
				GList* node_collection = NULL;
				GList* node_it = NULL;
#line 237 "../src/data/providers/data/IGDB.vala"
				node_collection = _tmp33_;
#line 237 "../src/data/providers/data/IGDB.vala"
				for (node_it = node_collection; node_it != NULL; node_it = node_it->next) {
#line 3385 "IGDB.c"
					JsonNode* node = NULL;
#line 237 "../src/data/providers/data/IGDB.vala"
					node = (JsonNode*) node_it->data;
#line 3389 "IGDB.c"
					{
						JsonNode* _tmp34_;
						JsonObject* _tmp35_;
						GameHubDataProvidersDataIGDBResultWebsite* _tmp36_;
#line 239 "../src/data/providers/data/IGDB.vala"
						_tmp34_ = node;
#line 239 "../src/data/providers/data/IGDB.vala"
						_tmp35_ = json_node_get_object (_tmp34_);
#line 239 "../src/data/providers/data/IGDB.vala"
						_tmp36_ = game_hub_data_providers_data_igdb_result_website_new (_tmp35_);
#line 239 "../src/data/providers/data/IGDB.vala"
						_vala_array_add45 (&websites, &websites_length1, &_websites_size_, _tmp36_);
#line 3402 "IGDB.c"
					}
				}
#line 237 "../src/data/providers/data/IGDB.vala"
				(node_collection == NULL) ? NULL : (node_collection = (g_list_free (node_collection), NULL));
#line 3407 "IGDB.c"
			}
#line 241 "../src/data/providers/data/IGDB.vala"
			_tmp37_ = websites;
#line 241 "../src/data/providers/data/IGDB.vala"
			_tmp37__length1 = websites_length1;
#line 241 "../src/data/providers/data/IGDB.vala"
			_tmp38_ = (_tmp37_ != NULL) ? _vala_array_dup34 (_tmp37_, _tmp37__length1) : _tmp37_;
#line 241 "../src/data/providers/data/IGDB.vala"
			_tmp38__length1 = _tmp37__length1;
#line 241 "../src/data/providers/data/IGDB.vala"
			self->websites = (_vala_array_free (self->websites, self->websites_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_website_unref), NULL);
#line 241 "../src/data/providers/data/IGDB.vala"
			self->websites = _tmp38_;
#line 241 "../src/data/providers/data/IGDB.vala"
			self->websites_length1 = _tmp38__length1;
#line 234 "../src/data/providers/data/IGDB.vala"
			websites = (_vala_array_free (websites, websites_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_website_unref), NULL);
#line 3425 "IGDB.c"
		}
#line 231 "../src/data/providers/data/IGDB.vala"
		_json_array_unref0 (websites_array);
#line 3429 "IGDB.c"
	}
#line 245 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_PLATFORMS)) {
#line 3433 "IGDB.c"
		JsonNode* _tmp40_;
#line 245 "../src/data/providers/data/IGDB.vala"
		_tmp40_ = json_object_get_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_PLATFORMS);
#line 245 "../src/data/providers/data/IGDB.vala"
		_tmp39_ = json_node_get_node_type (_tmp40_) == JSON_NODE_ARRAY;
#line 3439 "IGDB.c"
	} else {
#line 245 "../src/data/providers/data/IGDB.vala"
		_tmp39_ = FALSE;
#line 3443 "IGDB.c"
	}
#line 245 "../src/data/providers/data/IGDB.vala"
	if (_tmp39_) {
#line 3447 "IGDB.c"
		JsonArray* platforms_array = NULL;
		JsonArray* _tmp41_;
		JsonArray* _tmp42_;
		JsonArray* _tmp43_;
#line 247 "../src/data/providers/data/IGDB.vala"
		_tmp41_ = json_object_get_array_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_PLATFORMS);
#line 247 "../src/data/providers/data/IGDB.vala"
		_tmp42_ = _json_array_ref0 (_tmp41_);
#line 247 "../src/data/providers/data/IGDB.vala"
		platforms_array = _tmp42_;
#line 248 "../src/data/providers/data/IGDB.vala"
		_tmp43_ = platforms_array;
#line 248 "../src/data/providers/data/IGDB.vala"
		if (json_array_get_length (_tmp43_) > ((guint) 0)) {
#line 3462 "IGDB.c"
			GameHubDataProvidersDataIGDBResultLink** platforms = NULL;
			GameHubDataProvidersDataIGDBResultLink** _tmp44_;
			gint platforms_length1;
			gint _platforms_size_;
			JsonArray* _tmp45_;
			GList* _tmp46_;
			GameHubDataProvidersDataIGDBResultLink** _tmp50_;
			gint _tmp50__length1;
			GameHubDataProvidersDataIGDBResultLink** _tmp51_;
			gint _tmp51__length1;
#line 250 "../src/data/providers/data/IGDB.vala"
			_tmp44_ = g_new0 (GameHubDataProvidersDataIGDBResultLink*, 0 + 1);
#line 250 "../src/data/providers/data/IGDB.vala"
			platforms = _tmp44_;
#line 250 "../src/data/providers/data/IGDB.vala"
			platforms_length1 = 0;
#line 250 "../src/data/providers/data/IGDB.vala"
			_platforms_size_ = platforms_length1;
#line 251 "../src/data/providers/data/IGDB.vala"
			_tmp45_ = platforms_array;
#line 251 "../src/data/providers/data/IGDB.vala"
			_tmp46_ = json_array_get_elements (_tmp45_);
#line 3485 "IGDB.c"
			{
				GList* node_collection = NULL;
				GList* node_it = NULL;
#line 251 "../src/data/providers/data/IGDB.vala"
				node_collection = _tmp46_;
#line 251 "../src/data/providers/data/IGDB.vala"
				for (node_it = node_collection; node_it != NULL; node_it = node_it->next) {
#line 3493 "IGDB.c"
					JsonNode* node = NULL;
#line 251 "../src/data/providers/data/IGDB.vala"
					node = (JsonNode*) node_it->data;
#line 3497 "IGDB.c"
					{
						JsonNode* _tmp47_;
						JsonObject* _tmp48_;
						GameHubDataProvidersDataIGDBResultLink* _tmp49_;
#line 253 "../src/data/providers/data/IGDB.vala"
						_tmp47_ = node;
#line 253 "../src/data/providers/data/IGDB.vala"
						_tmp48_ = json_node_get_object (_tmp47_);
#line 253 "../src/data/providers/data/IGDB.vala"
						_tmp49_ = game_hub_data_providers_data_igdb_result_link_new (_tmp48_);
#line 253 "../src/data/providers/data/IGDB.vala"
						_vala_array_add46 (&platforms, &platforms_length1, &_platforms_size_, _tmp49_);
#line 3510 "IGDB.c"
					}
				}
#line 251 "../src/data/providers/data/IGDB.vala"
				(node_collection == NULL) ? NULL : (node_collection = (g_list_free (node_collection), NULL));
#line 3515 "IGDB.c"
			}
#line 255 "../src/data/providers/data/IGDB.vala"
			_tmp50_ = platforms;
#line 255 "../src/data/providers/data/IGDB.vala"
			_tmp50__length1 = platforms_length1;
#line 255 "../src/data/providers/data/IGDB.vala"
			_tmp51_ = (_tmp50_ != NULL) ? _vala_array_dup35 (_tmp50_, _tmp50__length1) : _tmp50_;
#line 255 "../src/data/providers/data/IGDB.vala"
			_tmp51__length1 = _tmp50__length1;
#line 255 "../src/data/providers/data/IGDB.vala"
			self->platforms = (_vala_array_free (self->platforms, self->platforms_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 255 "../src/data/providers/data/IGDB.vala"
			self->platforms = _tmp51_;
#line 255 "../src/data/providers/data/IGDB.vala"
			self->platforms_length1 = _tmp51__length1;
#line 248 "../src/data/providers/data/IGDB.vala"
			platforms = (_vala_array_free (platforms, platforms_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 3533 "IGDB.c"
		}
#line 245 "../src/data/providers/data/IGDB.vala"
		_json_array_unref0 (platforms_array);
#line 3537 "IGDB.c"
	}
#line 259 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_GENRES)) {
#line 3541 "IGDB.c"
		JsonNode* _tmp53_;
#line 259 "../src/data/providers/data/IGDB.vala"
		_tmp53_ = json_object_get_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_GENRES);
#line 259 "../src/data/providers/data/IGDB.vala"
		_tmp52_ = json_node_get_node_type (_tmp53_) == JSON_NODE_ARRAY;
#line 3547 "IGDB.c"
	} else {
#line 259 "../src/data/providers/data/IGDB.vala"
		_tmp52_ = FALSE;
#line 3551 "IGDB.c"
	}
#line 259 "../src/data/providers/data/IGDB.vala"
	if (_tmp52_) {
#line 3555 "IGDB.c"
		JsonArray* genres_array = NULL;
		JsonArray* _tmp54_;
		JsonArray* _tmp55_;
		JsonArray* _tmp56_;
#line 261 "../src/data/providers/data/IGDB.vala"
		_tmp54_ = json_object_get_array_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_GENRES);
#line 261 "../src/data/providers/data/IGDB.vala"
		_tmp55_ = _json_array_ref0 (_tmp54_);
#line 261 "../src/data/providers/data/IGDB.vala"
		genres_array = _tmp55_;
#line 262 "../src/data/providers/data/IGDB.vala"
		_tmp56_ = genres_array;
#line 262 "../src/data/providers/data/IGDB.vala"
		if (json_array_get_length (_tmp56_) > ((guint) 0)) {
#line 3570 "IGDB.c"
			GameHubDataProvidersDataIGDBResultLink** genres = NULL;
			GameHubDataProvidersDataIGDBResultLink** _tmp57_;
			gint genres_length1;
			gint _genres_size_;
			JsonArray* _tmp58_;
			GList* _tmp59_;
			GameHubDataProvidersDataIGDBResultLink** _tmp63_;
			gint _tmp63__length1;
			GameHubDataProvidersDataIGDBResultLink** _tmp64_;
			gint _tmp64__length1;
#line 264 "../src/data/providers/data/IGDB.vala"
			_tmp57_ = g_new0 (GameHubDataProvidersDataIGDBResultLink*, 0 + 1);
#line 264 "../src/data/providers/data/IGDB.vala"
			genres = _tmp57_;
#line 264 "../src/data/providers/data/IGDB.vala"
			genres_length1 = 0;
#line 264 "../src/data/providers/data/IGDB.vala"
			_genres_size_ = genres_length1;
#line 265 "../src/data/providers/data/IGDB.vala"
			_tmp58_ = genres_array;
#line 265 "../src/data/providers/data/IGDB.vala"
			_tmp59_ = json_array_get_elements (_tmp58_);
#line 3593 "IGDB.c"
			{
				GList* node_collection = NULL;
				GList* node_it = NULL;
#line 265 "../src/data/providers/data/IGDB.vala"
				node_collection = _tmp59_;
#line 265 "../src/data/providers/data/IGDB.vala"
				for (node_it = node_collection; node_it != NULL; node_it = node_it->next) {
#line 3601 "IGDB.c"
					JsonNode* node = NULL;
#line 265 "../src/data/providers/data/IGDB.vala"
					node = (JsonNode*) node_it->data;
#line 3605 "IGDB.c"
					{
						JsonNode* _tmp60_;
						JsonObject* _tmp61_;
						GameHubDataProvidersDataIGDBResultLink* _tmp62_;
#line 267 "../src/data/providers/data/IGDB.vala"
						_tmp60_ = node;
#line 267 "../src/data/providers/data/IGDB.vala"
						_tmp61_ = json_node_get_object (_tmp60_);
#line 267 "../src/data/providers/data/IGDB.vala"
						_tmp62_ = game_hub_data_providers_data_igdb_result_link_new (_tmp61_);
#line 267 "../src/data/providers/data/IGDB.vala"
						_vala_array_add47 (&genres, &genres_length1, &_genres_size_, _tmp62_);
#line 3618 "IGDB.c"
					}
				}
#line 265 "../src/data/providers/data/IGDB.vala"
				(node_collection == NULL) ? NULL : (node_collection = (g_list_free (node_collection), NULL));
#line 3623 "IGDB.c"
			}
#line 269 "../src/data/providers/data/IGDB.vala"
			_tmp63_ = genres;
#line 269 "../src/data/providers/data/IGDB.vala"
			_tmp63__length1 = genres_length1;
#line 269 "../src/data/providers/data/IGDB.vala"
			_tmp64_ = (_tmp63_ != NULL) ? _vala_array_dup36 (_tmp63_, _tmp63__length1) : _tmp63_;
#line 269 "../src/data/providers/data/IGDB.vala"
			_tmp64__length1 = _tmp63__length1;
#line 269 "../src/data/providers/data/IGDB.vala"
			self->genres = (_vala_array_free (self->genres, self->genres_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 269 "../src/data/providers/data/IGDB.vala"
			self->genres = _tmp64_;
#line 269 "../src/data/providers/data/IGDB.vala"
			self->genres_length1 = _tmp64__length1;
#line 262 "../src/data/providers/data/IGDB.vala"
			genres = (_vala_array_free (genres, genres_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 3641 "IGDB.c"
		}
#line 259 "../src/data/providers/data/IGDB.vala"
		_json_array_unref0 (genres_array);
#line 3645 "IGDB.c"
	}
#line 273 "../src/data/providers/data/IGDB.vala"
	if (json_object_has_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_KEYWORDS)) {
#line 3649 "IGDB.c"
		JsonNode* _tmp66_;
#line 273 "../src/data/providers/data/IGDB.vala"
		_tmp66_ = json_object_get_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_KEYWORDS);
#line 273 "../src/data/providers/data/IGDB.vala"
		_tmp65_ = json_node_get_node_type (_tmp66_) == JSON_NODE_ARRAY;
#line 3655 "IGDB.c"
	} else {
#line 273 "../src/data/providers/data/IGDB.vala"
		_tmp65_ = FALSE;
#line 3659 "IGDB.c"
	}
#line 273 "../src/data/providers/data/IGDB.vala"
	if (_tmp65_) {
#line 3663 "IGDB.c"
		JsonArray* keywords_array = NULL;
		JsonArray* _tmp67_;
		JsonArray* _tmp68_;
		JsonArray* _tmp69_;
#line 275 "../src/data/providers/data/IGDB.vala"
		_tmp67_ = json_object_get_array_member (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_KEYWORDS);
#line 275 "../src/data/providers/data/IGDB.vala"
		_tmp68_ = _json_array_ref0 (_tmp67_);
#line 275 "../src/data/providers/data/IGDB.vala"
		keywords_array = _tmp68_;
#line 276 "../src/data/providers/data/IGDB.vala"
		_tmp69_ = keywords_array;
#line 276 "../src/data/providers/data/IGDB.vala"
		if (json_array_get_length (_tmp69_) > ((guint) 0)) {
#line 3678 "IGDB.c"
			GameHubDataProvidersDataIGDBResultLink** keywords = NULL;
			GameHubDataProvidersDataIGDBResultLink** _tmp70_;
			gint keywords_length1;
			gint _keywords_size_;
			JsonArray* _tmp71_;
			GList* _tmp72_;
			GameHubDataProvidersDataIGDBResultLink** _tmp76_;
			gint _tmp76__length1;
			GameHubDataProvidersDataIGDBResultLink** _tmp77_;
			gint _tmp77__length1;
#line 278 "../src/data/providers/data/IGDB.vala"
			_tmp70_ = g_new0 (GameHubDataProvidersDataIGDBResultLink*, 0 + 1);
#line 278 "../src/data/providers/data/IGDB.vala"
			keywords = _tmp70_;
#line 278 "../src/data/providers/data/IGDB.vala"
			keywords_length1 = 0;
#line 278 "../src/data/providers/data/IGDB.vala"
			_keywords_size_ = keywords_length1;
#line 279 "../src/data/providers/data/IGDB.vala"
			_tmp71_ = keywords_array;
#line 279 "../src/data/providers/data/IGDB.vala"
			_tmp72_ = json_array_get_elements (_tmp71_);
#line 3701 "IGDB.c"
			{
				GList* node_collection = NULL;
				GList* node_it = NULL;
#line 279 "../src/data/providers/data/IGDB.vala"
				node_collection = _tmp72_;
#line 279 "../src/data/providers/data/IGDB.vala"
				for (node_it = node_collection; node_it != NULL; node_it = node_it->next) {
#line 3709 "IGDB.c"
					JsonNode* node = NULL;
#line 279 "../src/data/providers/data/IGDB.vala"
					node = (JsonNode*) node_it->data;
#line 3713 "IGDB.c"
					{
						JsonNode* _tmp73_;
						JsonObject* _tmp74_;
						GameHubDataProvidersDataIGDBResultLink* _tmp75_;
#line 281 "../src/data/providers/data/IGDB.vala"
						_tmp73_ = node;
#line 281 "../src/data/providers/data/IGDB.vala"
						_tmp74_ = json_node_get_object (_tmp73_);
#line 281 "../src/data/providers/data/IGDB.vala"
						_tmp75_ = game_hub_data_providers_data_igdb_result_link_new (_tmp74_);
#line 281 "../src/data/providers/data/IGDB.vala"
						_vala_array_add48 (&keywords, &keywords_length1, &_keywords_size_, _tmp75_);
#line 3726 "IGDB.c"
					}
				}
#line 279 "../src/data/providers/data/IGDB.vala"
				(node_collection == NULL) ? NULL : (node_collection = (g_list_free (node_collection), NULL));
#line 3731 "IGDB.c"
			}
#line 283 "../src/data/providers/data/IGDB.vala"
			_tmp76_ = keywords;
#line 283 "../src/data/providers/data/IGDB.vala"
			_tmp76__length1 = keywords_length1;
#line 283 "../src/data/providers/data/IGDB.vala"
			_tmp77_ = (_tmp76_ != NULL) ? _vala_array_dup37 (_tmp76_, _tmp76__length1) : _tmp76_;
#line 283 "../src/data/providers/data/IGDB.vala"
			_tmp77__length1 = _tmp76__length1;
#line 283 "../src/data/providers/data/IGDB.vala"
			self->keywords = (_vala_array_free (self->keywords, self->keywords_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 283 "../src/data/providers/data/IGDB.vala"
			self->keywords = _tmp77_;
#line 283 "../src/data/providers/data/IGDB.vala"
			self->keywords_length1 = _tmp77__length1;
#line 276 "../src/data/providers/data/IGDB.vala"
			keywords = (_vala_array_free (keywords, keywords_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 3749 "IGDB.c"
		}
#line 273 "../src/data/providers/data/IGDB.vala"
		_json_array_unref0 (keywords_array);
#line 3753 "IGDB.c"
	}
#line 199 "../src/data/providers/data/IGDB.vala"
	return self;
#line 3757 "IGDB.c"
}

GameHubDataProvidersDataIGDBResult*
game_hub_data_providers_data_igdb_result_new (JsonObject* obj)
{
#line 199 "../src/data/providers/data/IGDB.vala"
	return game_hub_data_providers_data_igdb_result_construct (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT, obj);
#line 3765 "IGDB.c"
}

GameHubDataProvidersDataIGDBResultLink*
game_hub_data_providers_data_igdb_result_link_construct (GType object_type,
                                                         JsonObject* obj)
{
	GameHubDataProvidersDataIGDBResultLink* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 293 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 293 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDBResultLink*) g_type_create_instance (object_type);
#line 295 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = json_object_get_string_member (obj, "name");
#line 295 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 295 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->name);
#line 295 "../src/data/providers/data/IGDB.vala"
	self->name = _tmp1_;
#line 296 "../src/data/providers/data/IGDB.vala"
	_tmp2_ = json_object_get_string_member (obj, "url");
#line 296 "../src/data/providers/data/IGDB.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 296 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->url);
#line 296 "../src/data/providers/data/IGDB.vala"
	self->url = _tmp3_;
#line 293 "../src/data/providers/data/IGDB.vala"
	return self;
#line 3799 "IGDB.c"
}

GameHubDataProvidersDataIGDBResultLink*
game_hub_data_providers_data_igdb_result_link_new (JsonObject* obj)
{
#line 293 "../src/data/providers/data/IGDB.vala"
	return game_hub_data_providers_data_igdb_result_link_construct (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK, obj);
#line 3807 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_value_link_init (GValue* value)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	value->data[0].v_pointer = NULL;
#line 3815 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_value_link_free_value (GValue* value)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	if (value->data[0].v_pointer) {
#line 288 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_link_unref (value->data[0].v_pointer);
#line 3825 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_result_value_link_copy_value (const GValue* src_value,
                                                                GValue* dest_value)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	if (src_value->data[0].v_pointer) {
#line 288 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = game_hub_data_providers_data_igdb_result_link_ref (src_value->data[0].v_pointer);
#line 3837 "IGDB.c"
	} else {
#line 288 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3841 "IGDB.c"
	}
}

static gpointer
game_hub_data_providers_data_igdb_result_value_link_peek_pointer (const GValue* value)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 3850 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_result_value_link_collect_value (GValue* value,
                                                                   guint n_collect_values,
                                                                   GTypeCValue* collect_values,
                                                                   guint collect_flags)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	if (collect_values[0].v_pointer) {
#line 3861 "IGDB.c"
		GameHubDataProvidersDataIGDBResultLink * object;
		object = collect_values[0].v_pointer;
#line 288 "../src/data/providers/data/IGDB.vala"
		if (object->parent_instance.g_class == NULL) {
#line 288 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3868 "IGDB.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 288 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3872 "IGDB.c"
		}
#line 288 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = game_hub_data_providers_data_igdb_result_link_ref (object);
#line 3876 "IGDB.c"
	} else {
#line 288 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 3880 "IGDB.c"
	}
#line 288 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 3884 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_result_value_link_lcopy_value (const GValue* value,
                                                                 guint n_collect_values,
                                                                 GTypeCValue* collect_values,
                                                                 guint collect_flags)
{
	GameHubDataProvidersDataIGDBResultLink ** object_p;
	object_p = collect_values[0].v_pointer;
#line 288 "../src/data/providers/data/IGDB.vala"
	if (!object_p) {
#line 288 "../src/data/providers/data/IGDB.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3899 "IGDB.c"
	}
#line 288 "../src/data/providers/data/IGDB.vala"
	if (!value->data[0].v_pointer) {
#line 288 "../src/data/providers/data/IGDB.vala"
		*object_p = NULL;
#line 3905 "IGDB.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 288 "../src/data/providers/data/IGDB.vala"
		*object_p = value->data[0].v_pointer;
#line 3909 "IGDB.c"
	} else {
#line 288 "../src/data/providers/data/IGDB.vala"
		*object_p = game_hub_data_providers_data_igdb_result_link_ref (value->data[0].v_pointer);
#line 3913 "IGDB.c"
	}
#line 288 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 3917 "IGDB.c"
}

GParamSpec*
game_hub_data_providers_data_igdb_result_param_spec_link (const gchar* name,
                                                          const gchar* nick,
                                                          const gchar* blurb,
                                                          GType object_type,
                                                          GParamFlags flags)
{
	GameHubDataProvidersDataIGDBResultParamSpecLink* spec;
#line 288 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK), NULL);
#line 288 "../src/data/providers/data/IGDB.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 288 "../src/data/providers/data/IGDB.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 288 "../src/data/providers/data/IGDB.vala"
	return G_PARAM_SPEC (spec);
#line 3936 "IGDB.c"
}

gpointer
game_hub_data_providers_data_igdb_result_value_get_link (const GValue* value)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK), NULL);
#line 288 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 3946 "IGDB.c"
}

void
game_hub_data_providers_data_igdb_result_value_set_link (GValue* value,
                                                         gpointer v_object)
{
	GameHubDataProvidersDataIGDBResultLink * old;
#line 288 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK));
#line 288 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 288 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 288 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK));
#line 288 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 288 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 288 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_link_ref (value->data[0].v_pointer);
#line 3968 "IGDB.c"
	} else {
#line 288 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 3972 "IGDB.c"
	}
#line 288 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 288 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_link_unref (old);
#line 3978 "IGDB.c"
	}
}

void
game_hub_data_providers_data_igdb_result_value_take_link (GValue* value,
                                                          gpointer v_object)
{
	GameHubDataProvidersDataIGDBResultLink * old;
#line 288 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK));
#line 288 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 288 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 288 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK));
#line 288 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 288 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 3999 "IGDB.c"
	} else {
#line 288 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 4003 "IGDB.c"
	}
#line 288 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 288 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_link_unref (old);
#line 4009 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_result_link_class_init (GameHubDataProvidersDataIGDBResultLinkClass * klass,
                                                          gpointer klass_data)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_result_link_parent_class = g_type_class_peek_parent (klass);
#line 288 "../src/data/providers/data/IGDB.vala"
	((GameHubDataProvidersDataIGDBResultLinkClass *) klass)->finalize = game_hub_data_providers_data_igdb_result_link_finalize;
#line 4021 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_link_instance_init (GameHubDataProvidersDataIGDBResultLink * self,
                                                             gpointer klass)
{
#line 288 "../src/data/providers/data/IGDB.vala"
	self->ref_count = 1;
#line 4030 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_link_finalize (GameHubDataProvidersDataIGDBResultLink * obj)
{
	GameHubDataProvidersDataIGDBResultLink * self;
#line 288 "../src/data/providers/data/IGDB.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_LINK, GameHubDataProvidersDataIGDBResultLink);
#line 288 "../src/data/providers/data/IGDB.vala"
	g_signal_handlers_destroy (self);
#line 290 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->name);
#line 291 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->url);
#line 4045 "IGDB.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_providers_data_igdb_result_link_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { game_hub_data_providers_data_igdb_result_value_link_init, game_hub_data_providers_data_igdb_result_value_link_free_value, game_hub_data_providers_data_igdb_result_value_link_copy_value, game_hub_data_providers_data_igdb_result_value_link_peek_pointer, "p", game_hub_data_providers_data_igdb_result_value_link_collect_value, "p", game_hub_data_providers_data_igdb_result_value_link_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataProvidersDataIGDBResultLinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_providers_data_igdb_result_link_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataProvidersDataIGDBResultLink), 0, (GInstanceInitFunc) game_hub_data_providers_data_igdb_result_link_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_hub_data_providers_data_igdb_result_link_type_id;
	game_hub_data_providers_data_igdb_result_link_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataProvidersDataIGDBResultLink", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return game_hub_data_providers_data_igdb_result_link_type_id;
}

GType
game_hub_data_providers_data_igdb_result_link_get_type (void)
{
	static volatile gsize game_hub_data_providers_data_igdb_result_link_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_providers_data_igdb_result_link_type_id__volatile)) {
		GType game_hub_data_providers_data_igdb_result_link_type_id;
		game_hub_data_providers_data_igdb_result_link_type_id = game_hub_data_providers_data_igdb_result_link_get_type_once ();
		g_once_init_leave (&game_hub_data_providers_data_igdb_result_link_type_id__volatile, game_hub_data_providers_data_igdb_result_link_type_id);
	}
	return game_hub_data_providers_data_igdb_result_link_type_id__volatile;
}

gpointer
game_hub_data_providers_data_igdb_result_link_ref (gpointer instance)
{
	GameHubDataProvidersDataIGDBResultLink * self;
	self = instance;
#line 288 "../src/data/providers/data/IGDB.vala"
	g_atomic_int_inc (&self->ref_count);
#line 288 "../src/data/providers/data/IGDB.vala"
	return instance;
#line 4080 "IGDB.c"
}

void
game_hub_data_providers_data_igdb_result_link_unref (gpointer instance)
{
	GameHubDataProvidersDataIGDBResultLink * self;
	self = instance;
#line 288 "../src/data/providers/data/IGDB.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 288 "../src/data/providers/data/IGDB.vala"
		GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_LINK_GET_CLASS (self)->finalize (self);
#line 288 "../src/data/providers/data/IGDB.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4094 "IGDB.c"
	}
}

GameHubDataProvidersDataIGDBResultWebsiteCategory
game_hub_data_providers_data_igdb_result_website_category_from_id (gint id)
{
	GameHubDataProvidersDataIGDBResultWebsiteCategory result = 0;
#line 319 "../src/data/providers/data/IGDB.vala"
	result = (GameHubDataProvidersDataIGDBResultWebsiteCategory) id;
#line 319 "../src/data/providers/data/IGDB.vala"
	return result;
#line 4106 "IGDB.c"
}

gint
game_hub_data_providers_data_igdb_result_website_category_id (GameHubDataProvidersDataIGDBResultWebsiteCategory self)
{
	gint result = 0;
#line 324 "../src/data/providers/data/IGDB.vala"
	result = (gint) self;
#line 324 "../src/data/providers/data/IGDB.vala"
	return result;
#line 4117 "IGDB.c"
}

gchar*
game_hub_data_providers_data_igdb_result_website_category_icon (GameHubDataProvidersDataIGDBResultWebsiteCategory self)
{
	gchar* _tmp17_;
	gchar* result = NULL;
#line 329 "../src/data/providers/data/IGDB.vala"
	switch (self) {
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIPEDIA:
#line 4129 "IGDB.c"
		{
			gchar* _tmp0_;
#line 331 "../src/data/providers/data/IGDB.vala"
			_tmp0_ = g_strdup ("related-link-wikipedia-symbolic");
#line 331 "../src/data/providers/data/IGDB.vala"
			result = _tmp0_;
#line 331 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4138 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_FACEBOOK:
#line 4142 "IGDB.c"
		{
			gchar* _tmp1_;
#line 332 "../src/data/providers/data/IGDB.vala"
			_tmp1_ = g_strdup ("related-link-facebook-symbolic");
#line 332 "../src/data/providers/data/IGDB.vala"
			result = _tmp1_;
#line 332 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4151 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITTER:
#line 4155 "IGDB.c"
		{
			gchar* _tmp2_;
#line 333 "../src/data/providers/data/IGDB.vala"
			_tmp2_ = g_strdup ("related-link-twitter-symbolic");
#line 333 "../src/data/providers/data/IGDB.vala"
			result = _tmp2_;
#line 333 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4164 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITCH:
#line 4168 "IGDB.c"
		{
			gchar* _tmp3_;
#line 334 "../src/data/providers/data/IGDB.vala"
			_tmp3_ = g_strdup ("related-link-twitch-symbolic");
#line 334 "../src/data/providers/data/IGDB.vala"
			result = _tmp3_;
#line 334 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4177 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_INSTAGRAM:
#line 4181 "IGDB.c"
		{
			gchar* _tmp4_;
#line 335 "../src/data/providers/data/IGDB.vala"
			_tmp4_ = g_strdup ("related-link-instagram-symbolic");
#line 335 "../src/data/providers/data/IGDB.vala"
			result = _tmp4_;
#line 335 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4190 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_YOUTUBE:
#line 4194 "IGDB.c"
		{
			gchar* _tmp5_;
#line 336 "../src/data/providers/data/IGDB.vala"
			_tmp5_ = g_strdup ("related-link-youtube-symbolic");
#line 336 "../src/data/providers/data/IGDB.vala"
			result = _tmp5_;
#line 336 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4203 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPHONE:
#line 4207 "IGDB.c"
		{
			gchar* _tmp6_;
#line 337 "../src/data/providers/data/IGDB.vala"
			_tmp6_ = g_strdup ("related-link-app-iphone-symbolic");
#line 337 "../src/data/providers/data/IGDB.vala"
			result = _tmp6_;
#line 337 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4216 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPAD:
#line 4220 "IGDB.c"
		{
			gchar* _tmp7_;
#line 338 "../src/data/providers/data/IGDB.vala"
			_tmp7_ = g_strdup ("related-link-app-ipad-symbolic");
#line 338 "../src/data/providers/data/IGDB.vala"
			result = _tmp7_;
#line 338 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4229 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_ANDROID:
#line 4233 "IGDB.c"
		{
			gchar* _tmp8_;
#line 339 "../src/data/providers/data/IGDB.vala"
			_tmp8_ = g_strdup ("related-link-app-android-symbolic");
#line 339 "../src/data/providers/data/IGDB.vala"
			result = _tmp8_;
#line 339 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4242 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_STEAM:
#line 4246 "IGDB.c"
		{
			gchar* _tmp9_;
#line 340 "../src/data/providers/data/IGDB.vala"
			_tmp9_ = g_strdup ("source-steam-symbolic");
#line 340 "../src/data/providers/data/IGDB.vala"
			result = _tmp9_;
#line 340 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4255 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_REDDIT:
#line 4259 "IGDB.c"
		{
			gchar* _tmp10_;
#line 341 "../src/data/providers/data/IGDB.vala"
			_tmp10_ = g_strdup ("related-link-reddit-symbolic");
#line 341 "../src/data/providers/data/IGDB.vala"
			result = _tmp10_;
#line 341 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4268 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_DISCORD:
#line 4272 "IGDB.c"
		{
			gchar* _tmp11_;
#line 342 "../src/data/providers/data/IGDB.vala"
			_tmp11_ = g_strdup ("related-link-discord-symbolic");
#line 342 "../src/data/providers/data/IGDB.vala"
			result = _tmp11_;
#line 342 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4281 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_GOOGLE_PLUS:
#line 4285 "IGDB.c"
		{
			gchar* _tmp12_;
#line 343 "../src/data/providers/data/IGDB.vala"
			_tmp12_ = g_strdup ("related-link-google-plus-symbolic");
#line 343 "../src/data/providers/data/IGDB.vala"
			result = _tmp12_;
#line 343 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4294 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TUMBLR:
#line 4298 "IGDB.c"
		{
			gchar* _tmp13_;
#line 344 "../src/data/providers/data/IGDB.vala"
			_tmp13_ = g_strdup ("related-link-tumblr-symbolic");
#line 344 "../src/data/providers/data/IGDB.vala"
			result = _tmp13_;
#line 344 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4307 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_LINKEDIN:
#line 4311 "IGDB.c"
		{
			gchar* _tmp14_;
#line 345 "../src/data/providers/data/IGDB.vala"
			_tmp14_ = g_strdup ("related-link-linkedin-symbolic");
#line 345 "../src/data/providers/data/IGDB.vala"
			result = _tmp14_;
#line 345 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4320 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_PINTEREST:
#line 4324 "IGDB.c"
		{
			gchar* _tmp15_;
#line 346 "../src/data/providers/data/IGDB.vala"
			_tmp15_ = g_strdup ("related-link-pinterest-symbolic");
#line 346 "../src/data/providers/data/IGDB.vala"
			result = _tmp15_;
#line 346 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4333 "IGDB.c"
		}
#line 329 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_SOUNDCLOUD:
#line 4337 "IGDB.c"
		{
			gchar* _tmp16_;
#line 347 "../src/data/providers/data/IGDB.vala"
			_tmp16_ = g_strdup ("related-link-soundcloud-symbolic");
#line 347 "../src/data/providers/data/IGDB.vala"
			result = _tmp16_;
#line 347 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4346 "IGDB.c"
		}
		default:
#line 329 "../src/data/providers/data/IGDB.vala"
		break;
#line 4351 "IGDB.c"
	}
#line 349 "../src/data/providers/data/IGDB.vala"
	_tmp17_ = g_strdup ("web-browser-symbolic");
#line 349 "../src/data/providers/data/IGDB.vala"
	result = _tmp17_;
#line 349 "../src/data/providers/data/IGDB.vala"
	return result;
#line 4359 "IGDB.c"
}

gchar*
game_hub_data_providers_data_igdb_result_website_category_description (GameHubDataProvidersDataIGDBResultWebsiteCategory self)
{
	gchar* result = NULL;
#line 354 "../src/data/providers/data/IGDB.vala"
	switch (self) {
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_OFFICIAL:
#line 4370 "IGDB.c"
		{
			gchar* _tmp0_;
#line 356 "../src/data/providers/data/IGDB.vala"
			_tmp0_ = g_strdup (C_ ("igdb_related_link", "Official website"));
#line 356 "../src/data/providers/data/IGDB.vala"
			result = _tmp0_;
#line 356 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4379 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIA:
#line 4383 "IGDB.c"
		{
			gchar* _tmp1_;
#line 357 "../src/data/providers/data/IGDB.vala"
			_tmp1_ = g_strdup ("Wikia");
#line 357 "../src/data/providers/data/IGDB.vala"
			result = _tmp1_;
#line 357 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4392 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIPEDIA:
#line 4396 "IGDB.c"
		{
			gchar* _tmp2_;
#line 358 "../src/data/providers/data/IGDB.vala"
			_tmp2_ = g_strdup ("Wikipedia");
#line 358 "../src/data/providers/data/IGDB.vala"
			result = _tmp2_;
#line 358 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4405 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_FACEBOOK:
#line 4409 "IGDB.c"
		{
			gchar* _tmp3_;
#line 359 "../src/data/providers/data/IGDB.vala"
			_tmp3_ = g_strdup ("Facebook");
#line 359 "../src/data/providers/data/IGDB.vala"
			result = _tmp3_;
#line 359 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4418 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITTER:
#line 4422 "IGDB.c"
		{
			gchar* _tmp4_;
#line 360 "../src/data/providers/data/IGDB.vala"
			_tmp4_ = g_strdup ("Twitter");
#line 360 "../src/data/providers/data/IGDB.vala"
			result = _tmp4_;
#line 360 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4431 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITCH:
#line 4435 "IGDB.c"
		{
			gchar* _tmp5_;
#line 361 "../src/data/providers/data/IGDB.vala"
			_tmp5_ = g_strdup ("Twitch");
#line 361 "../src/data/providers/data/IGDB.vala"
			result = _tmp5_;
#line 361 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4444 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_INSTAGRAM:
#line 4448 "IGDB.c"
		{
			gchar* _tmp6_;
#line 362 "../src/data/providers/data/IGDB.vala"
			_tmp6_ = g_strdup ("Instagram");
#line 362 "../src/data/providers/data/IGDB.vala"
			result = _tmp6_;
#line 362 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4457 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_YOUTUBE:
#line 4461 "IGDB.c"
		{
			gchar* _tmp7_;
#line 363 "../src/data/providers/data/IGDB.vala"
			_tmp7_ = g_strdup ("YouTube");
#line 363 "../src/data/providers/data/IGDB.vala"
			result = _tmp7_;
#line 363 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4470 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPHONE:
#line 4474 "IGDB.c"
		{
			gchar* _tmp8_;
#line 364 "../src/data/providers/data/IGDB.vala"
			_tmp8_ = g_strdup ("iPhone");
#line 364 "../src/data/providers/data/IGDB.vala"
			result = _tmp8_;
#line 364 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4483 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPAD:
#line 4487 "IGDB.c"
		{
			gchar* _tmp9_;
#line 365 "../src/data/providers/data/IGDB.vala"
			_tmp9_ = g_strdup ("iPad");
#line 365 "../src/data/providers/data/IGDB.vala"
			result = _tmp9_;
#line 365 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4496 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_ANDROID:
#line 4500 "IGDB.c"
		{
			gchar* _tmp10_;
#line 366 "../src/data/providers/data/IGDB.vala"
			_tmp10_ = g_strdup ("Android");
#line 366 "../src/data/providers/data/IGDB.vala"
			result = _tmp10_;
#line 366 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4509 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_STEAM:
#line 4513 "IGDB.c"
		{
			gchar* _tmp11_;
#line 367 "../src/data/providers/data/IGDB.vala"
			_tmp11_ = g_strdup ("Steam");
#line 367 "../src/data/providers/data/IGDB.vala"
			result = _tmp11_;
#line 367 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4522 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_REDDIT:
#line 4526 "IGDB.c"
		{
			gchar* _tmp12_;
#line 368 "../src/data/providers/data/IGDB.vala"
			_tmp12_ = g_strdup ("Reddit");
#line 368 "../src/data/providers/data/IGDB.vala"
			result = _tmp12_;
#line 368 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4535 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_DISCORD:
#line 4539 "IGDB.c"
		{
			gchar* _tmp13_;
#line 369 "../src/data/providers/data/IGDB.vala"
			_tmp13_ = g_strdup ("Discord");
#line 369 "../src/data/providers/data/IGDB.vala"
			result = _tmp13_;
#line 369 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4548 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_GOOGLE_PLUS:
#line 4552 "IGDB.c"
		{
			gchar* _tmp14_;
#line 370 "../src/data/providers/data/IGDB.vala"
			_tmp14_ = g_strdup ("Google+");
#line 370 "../src/data/providers/data/IGDB.vala"
			result = _tmp14_;
#line 370 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4561 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TUMBLR:
#line 4565 "IGDB.c"
		{
			gchar* _tmp15_;
#line 371 "../src/data/providers/data/IGDB.vala"
			_tmp15_ = g_strdup ("Tumblr");
#line 371 "../src/data/providers/data/IGDB.vala"
			result = _tmp15_;
#line 371 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4574 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_LINKEDIN:
#line 4578 "IGDB.c"
		{
			gchar* _tmp16_;
#line 372 "../src/data/providers/data/IGDB.vala"
			_tmp16_ = g_strdup ("LinkedIn");
#line 372 "../src/data/providers/data/IGDB.vala"
			result = _tmp16_;
#line 372 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4587 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_PINTEREST:
#line 4591 "IGDB.c"
		{
			gchar* _tmp17_;
#line 373 "../src/data/providers/data/IGDB.vala"
			_tmp17_ = g_strdup ("Pinterest");
#line 373 "../src/data/providers/data/IGDB.vala"
			result = _tmp17_;
#line 373 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4600 "IGDB.c"
		}
#line 354 "../src/data/providers/data/IGDB.vala"
		case GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_SOUNDCLOUD:
#line 4604 "IGDB.c"
		{
			gchar* _tmp18_;
#line 374 "../src/data/providers/data/IGDB.vala"
			_tmp18_ = g_strdup ("SoundCloud");
#line 374 "../src/data/providers/data/IGDB.vala"
			result = _tmp18_;
#line 374 "../src/data/providers/data/IGDB.vala"
			return result;
#line 4613 "IGDB.c"
		}
		default:
#line 354 "../src/data/providers/data/IGDB.vala"
		break;
#line 4618 "IGDB.c"
	}
#line 376 "../src/data/providers/data/IGDB.vala"
	result = NULL;
#line 376 "../src/data/providers/data/IGDB.vala"
	return result;
#line 4624 "IGDB.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_providers_data_igdb_result_website_category_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_UNKNOWN, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_UNKNOWN", "unknown"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_OFFICIAL, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_OFFICIAL", "official"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIA, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIA", "wikia"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIPEDIA, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_WIKIPEDIA", "wikipedia"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_FACEBOOK, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_FACEBOOK", "facebook"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITTER, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITTER", "twitter"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITCH, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TWITCH", "twitch"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_INSTAGRAM, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_INSTAGRAM", "instagram"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_YOUTUBE, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_YOUTUBE", "youtube"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPHONE, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPHONE", "iphone"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPAD, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_IPAD", "ipad"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_ANDROID, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_ANDROID", "android"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_STEAM, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_STEAM", "steam"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_REDDIT, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_REDDIT", "reddit"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_DISCORD, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_DISCORD", "discord"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_GOOGLE_PLUS, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_GOOGLE_PLUS", "google-plus"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TUMBLR, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_TUMBLR", "tumblr"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_LINKEDIN, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_LINKEDIN", "linkedin"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_PINTEREST, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_PINTEREST", "pinterest"}, {GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_SOUNDCLOUD, "GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_CATEGORY_SOUNDCLOUD", "soundcloud"}, {0, NULL, NULL}};
	GType game_hub_data_providers_data_igdb_result_website_category_type_id;
	game_hub_data_providers_data_igdb_result_website_category_type_id = g_enum_register_static ("GameHubDataProvidersDataIGDBResultWebsiteCategory", values);
	return game_hub_data_providers_data_igdb_result_website_category_type_id;
}

GType
game_hub_data_providers_data_igdb_result_website_category_get_type (void)
{
	static volatile gsize game_hub_data_providers_data_igdb_result_website_category_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_providers_data_igdb_result_website_category_type_id__volatile)) {
		GType game_hub_data_providers_data_igdb_result_website_category_type_id;
		game_hub_data_providers_data_igdb_result_website_category_type_id = game_hub_data_providers_data_igdb_result_website_category_get_type_once ();
		g_once_init_leave (&game_hub_data_providers_data_igdb_result_website_category_type_id__volatile, game_hub_data_providers_data_igdb_result_website_category_type_id);
	}
	return game_hub_data_providers_data_igdb_result_website_category_type_id__volatile;
}

GameHubDataProvidersDataIGDBResultWebsite*
game_hub_data_providers_data_igdb_result_website_construct (GType object_type,
                                                            JsonObject* obj)
{
	GameHubDataProvidersDataIGDBResultWebsite* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 305 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 305 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDBResultWebsite*) g_type_create_instance (object_type);
#line 307 "../src/data/providers/data/IGDB.vala"
	_tmp0_ = json_object_get_string_member (obj, "url");
#line 307 "../src/data/providers/data/IGDB.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 307 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->url);
#line 307 "../src/data/providers/data/IGDB.vala"
	self->url = _tmp1_;
#line 308 "../src/data/providers/data/IGDB.vala"
	self->category = game_hub_data_providers_data_igdb_result_website_category_from_id ((gint) json_object_get_int_member (obj, "category"));
#line 305 "../src/data/providers/data/IGDB.vala"
	return self;
#line 4671 "IGDB.c"
}

GameHubDataProvidersDataIGDBResultWebsite*
game_hub_data_providers_data_igdb_result_website_new (JsonObject* obj)
{
#line 305 "../src/data/providers/data/IGDB.vala"
	return game_hub_data_providers_data_igdb_result_website_construct (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE, obj);
#line 4679 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_value_website_init (GValue* value)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	value->data[0].v_pointer = NULL;
#line 4687 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_value_website_free_value (GValue* value)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	if (value->data[0].v_pointer) {
#line 300 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_website_unref (value->data[0].v_pointer);
#line 4697 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_result_value_website_copy_value (const GValue* src_value,
                                                                   GValue* dest_value)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	if (src_value->data[0].v_pointer) {
#line 300 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = game_hub_data_providers_data_igdb_result_website_ref (src_value->data[0].v_pointer);
#line 4709 "IGDB.c"
	} else {
#line 300 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4713 "IGDB.c"
	}
}

static gpointer
game_hub_data_providers_data_igdb_result_value_website_peek_pointer (const GValue* value)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 4722 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_result_value_website_collect_value (GValue* value,
                                                                      guint n_collect_values,
                                                                      GTypeCValue* collect_values,
                                                                      guint collect_flags)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	if (collect_values[0].v_pointer) {
#line 4733 "IGDB.c"
		GameHubDataProvidersDataIGDBResultWebsite * object;
		object = collect_values[0].v_pointer;
#line 300 "../src/data/providers/data/IGDB.vala"
		if (object->parent_instance.g_class == NULL) {
#line 300 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4740 "IGDB.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 300 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4744 "IGDB.c"
		}
#line 300 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = game_hub_data_providers_data_igdb_result_website_ref (object);
#line 4748 "IGDB.c"
	} else {
#line 300 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 4752 "IGDB.c"
	}
#line 300 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 4756 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_result_value_website_lcopy_value (const GValue* value,
                                                                    guint n_collect_values,
                                                                    GTypeCValue* collect_values,
                                                                    guint collect_flags)
{
	GameHubDataProvidersDataIGDBResultWebsite ** object_p;
	object_p = collect_values[0].v_pointer;
#line 300 "../src/data/providers/data/IGDB.vala"
	if (!object_p) {
#line 300 "../src/data/providers/data/IGDB.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4771 "IGDB.c"
	}
#line 300 "../src/data/providers/data/IGDB.vala"
	if (!value->data[0].v_pointer) {
#line 300 "../src/data/providers/data/IGDB.vala"
		*object_p = NULL;
#line 4777 "IGDB.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 300 "../src/data/providers/data/IGDB.vala"
		*object_p = value->data[0].v_pointer;
#line 4781 "IGDB.c"
	} else {
#line 300 "../src/data/providers/data/IGDB.vala"
		*object_p = game_hub_data_providers_data_igdb_result_website_ref (value->data[0].v_pointer);
#line 4785 "IGDB.c"
	}
#line 300 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 4789 "IGDB.c"
}

GParamSpec*
game_hub_data_providers_data_igdb_result_param_spec_website (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags)
{
	GameHubDataProvidersDataIGDBResultParamSpecWebsite* spec;
#line 300 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE), NULL);
#line 300 "../src/data/providers/data/IGDB.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 300 "../src/data/providers/data/IGDB.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 300 "../src/data/providers/data/IGDB.vala"
	return G_PARAM_SPEC (spec);
#line 4808 "IGDB.c"
}

gpointer
game_hub_data_providers_data_igdb_result_value_get_website (const GValue* value)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE), NULL);
#line 300 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 4818 "IGDB.c"
}

void
game_hub_data_providers_data_igdb_result_value_set_website (GValue* value,
                                                            gpointer v_object)
{
	GameHubDataProvidersDataIGDBResultWebsite * old;
#line 300 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE));
#line 300 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 300 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 300 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE));
#line 300 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 300 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 300 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_website_ref (value->data[0].v_pointer);
#line 4840 "IGDB.c"
	} else {
#line 300 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 4844 "IGDB.c"
	}
#line 300 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 300 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_website_unref (old);
#line 4850 "IGDB.c"
	}
}

void
game_hub_data_providers_data_igdb_result_value_take_website (GValue* value,
                                                             gpointer v_object)
{
	GameHubDataProvidersDataIGDBResultWebsite * old;
#line 300 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE));
#line 300 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 300 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 300 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE));
#line 300 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 300 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 4871 "IGDB.c"
	} else {
#line 300 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 4875 "IGDB.c"
	}
#line 300 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 300 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_website_unref (old);
#line 4881 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_result_website_class_init (GameHubDataProvidersDataIGDBResultWebsiteClass * klass,
                                                             gpointer klass_data)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_result_website_parent_class = g_type_class_peek_parent (klass);
#line 300 "../src/data/providers/data/IGDB.vala"
	((GameHubDataProvidersDataIGDBResultWebsiteClass *) klass)->finalize = game_hub_data_providers_data_igdb_result_website_finalize;
#line 4893 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_website_instance_init (GameHubDataProvidersDataIGDBResultWebsite * self,
                                                                gpointer klass)
{
#line 300 "../src/data/providers/data/IGDB.vala"
	self->ref_count = 1;
#line 4902 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_website_finalize (GameHubDataProvidersDataIGDBResultWebsite * obj)
{
	GameHubDataProvidersDataIGDBResultWebsite * self;
#line 300 "../src/data/providers/data/IGDB.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_TYPE_WEBSITE, GameHubDataProvidersDataIGDBResultWebsite);
#line 300 "../src/data/providers/data/IGDB.vala"
	g_signal_handlers_destroy (self);
#line 302 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->url);
#line 4915 "IGDB.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_providers_data_igdb_result_website_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { game_hub_data_providers_data_igdb_result_value_website_init, game_hub_data_providers_data_igdb_result_value_website_free_value, game_hub_data_providers_data_igdb_result_value_website_copy_value, game_hub_data_providers_data_igdb_result_value_website_peek_pointer, "p", game_hub_data_providers_data_igdb_result_value_website_collect_value, "p", game_hub_data_providers_data_igdb_result_value_website_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataProvidersDataIGDBResultWebsiteClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_providers_data_igdb_result_website_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataProvidersDataIGDBResultWebsite), 0, (GInstanceInitFunc) game_hub_data_providers_data_igdb_result_website_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_hub_data_providers_data_igdb_result_website_type_id;
	game_hub_data_providers_data_igdb_result_website_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataProvidersDataIGDBResultWebsite", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return game_hub_data_providers_data_igdb_result_website_type_id;
}

GType
game_hub_data_providers_data_igdb_result_website_get_type (void)
{
	static volatile gsize game_hub_data_providers_data_igdb_result_website_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_providers_data_igdb_result_website_type_id__volatile)) {
		GType game_hub_data_providers_data_igdb_result_website_type_id;
		game_hub_data_providers_data_igdb_result_website_type_id = game_hub_data_providers_data_igdb_result_website_get_type_once ();
		g_once_init_leave (&game_hub_data_providers_data_igdb_result_website_type_id__volatile, game_hub_data_providers_data_igdb_result_website_type_id);
	}
	return game_hub_data_providers_data_igdb_result_website_type_id__volatile;
}

gpointer
game_hub_data_providers_data_igdb_result_website_ref (gpointer instance)
{
	GameHubDataProvidersDataIGDBResultWebsite * self;
	self = instance;
#line 300 "../src/data/providers/data/IGDB.vala"
	g_atomic_int_inc (&self->ref_count);
#line 300 "../src/data/providers/data/IGDB.vala"
	return instance;
#line 4950 "IGDB.c"
}

void
game_hub_data_providers_data_igdb_result_website_unref (gpointer instance)
{
	GameHubDataProvidersDataIGDBResultWebsite * self;
	self = instance;
#line 300 "../src/data/providers/data/IGDB.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 300 "../src/data/providers/data/IGDB.vala"
		GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_WEBSITE_GET_CLASS (self)->finalize (self);
#line 300 "../src/data/providers/data/IGDB.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4964 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_value_result_init (GValue* value)
{
#line 174 "../src/data/providers/data/IGDB.vala"
	value->data[0].v_pointer = NULL;
#line 4973 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_value_result_free_value (GValue* value)
{
#line 174 "../src/data/providers/data/IGDB.vala"
	if (value->data[0].v_pointer) {
#line 174 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_unref (value->data[0].v_pointer);
#line 4983 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_value_result_copy_value (const GValue* src_value,
                                                           GValue* dest_value)
{
#line 174 "../src/data/providers/data/IGDB.vala"
	if (src_value->data[0].v_pointer) {
#line 174 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = game_hub_data_providers_data_igdb_result_ref (src_value->data[0].v_pointer);
#line 4995 "IGDB.c"
	} else {
#line 174 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4999 "IGDB.c"
	}
}

static gpointer
game_hub_data_providers_data_igdb_value_result_peek_pointer (const GValue* value)
{
#line 174 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 5008 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_value_result_collect_value (GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
#line 174 "../src/data/providers/data/IGDB.vala"
	if (collect_values[0].v_pointer) {
#line 5019 "IGDB.c"
		GameHubDataProvidersDataIGDBResult * object;
		object = collect_values[0].v_pointer;
#line 174 "../src/data/providers/data/IGDB.vala"
		if (object->parent_instance.g_class == NULL) {
#line 174 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5026 "IGDB.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 174 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5030 "IGDB.c"
		}
#line 174 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = game_hub_data_providers_data_igdb_result_ref (object);
#line 5034 "IGDB.c"
	} else {
#line 174 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 5038 "IGDB.c"
	}
#line 174 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 5042 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_value_result_lcopy_value (const GValue* value,
                                                            guint n_collect_values,
                                                            GTypeCValue* collect_values,
                                                            guint collect_flags)
{
	GameHubDataProvidersDataIGDBResult ** object_p;
	object_p = collect_values[0].v_pointer;
#line 174 "../src/data/providers/data/IGDB.vala"
	if (!object_p) {
#line 174 "../src/data/providers/data/IGDB.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5057 "IGDB.c"
	}
#line 174 "../src/data/providers/data/IGDB.vala"
	if (!value->data[0].v_pointer) {
#line 174 "../src/data/providers/data/IGDB.vala"
		*object_p = NULL;
#line 5063 "IGDB.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 174 "../src/data/providers/data/IGDB.vala"
		*object_p = value->data[0].v_pointer;
#line 5067 "IGDB.c"
	} else {
#line 174 "../src/data/providers/data/IGDB.vala"
		*object_p = game_hub_data_providers_data_igdb_result_ref (value->data[0].v_pointer);
#line 5071 "IGDB.c"
	}
#line 174 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 5075 "IGDB.c"
}

GParamSpec*
game_hub_data_providers_data_igdb_param_spec_result (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags)
{
	GameHubDataProvidersDataIGDBParamSpecResult* spec;
#line 174 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT), NULL);
#line 174 "../src/data/providers/data/IGDB.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 174 "../src/data/providers/data/IGDB.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 174 "../src/data/providers/data/IGDB.vala"
	return G_PARAM_SPEC (spec);
#line 5094 "IGDB.c"
}

gpointer
game_hub_data_providers_data_igdb_value_get_result (const GValue* value)
{
#line 174 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT), NULL);
#line 174 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 5104 "IGDB.c"
}

void
game_hub_data_providers_data_igdb_value_set_result (GValue* value,
                                                    gpointer v_object)
{
	GameHubDataProvidersDataIGDBResult * old;
#line 174 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT));
#line 174 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 174 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 174 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT));
#line 174 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 174 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 174 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_ref (value->data[0].v_pointer);
#line 5126 "IGDB.c"
	} else {
#line 174 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 5130 "IGDB.c"
	}
#line 174 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 174 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_unref (old);
#line 5136 "IGDB.c"
	}
}

void
game_hub_data_providers_data_igdb_value_take_result (GValue* value,
                                                     gpointer v_object)
{
	GameHubDataProvidersDataIGDBResult * old;
#line 174 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT));
#line 174 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 174 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 174 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT));
#line 174 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 174 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 5157 "IGDB.c"
	} else {
#line 174 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 5161 "IGDB.c"
	}
#line 174 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 174 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_result_unref (old);
#line 5167 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_result_class_init (GameHubDataProvidersDataIGDBResultClass * klass,
                                                     gpointer klass_data)
{
#line 174 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_result_parent_class = g_type_class_peek_parent (klass);
#line 174 "../src/data/providers/data/IGDB.vala"
	((GameHubDataProvidersDataIGDBResultClass *) klass)->finalize = game_hub_data_providers_data_igdb_result_finalize;
#line 5179 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_instance_init (GameHubDataProvidersDataIGDBResult * self,
                                                        gpointer klass)
{
#line 176 "../src/data/providers/data/IGDB.vala"
	self->id = NULL;
#line 177 "../src/data/providers/data/IGDB.vala"
	self->name = NULL;
#line 178 "../src/data/providers/data/IGDB.vala"
	self->url = NULL;
#line 179 "../src/data/providers/data/IGDB.vala"
	self->release_date = NULL;
#line 180 "../src/data/providers/data/IGDB.vala"
	self->websites = NULL;
#line 180 "../src/data/providers/data/IGDB.vala"
	self->websites_length1 = 0;
#line 182 "../src/data/providers/data/IGDB.vala"
	self->platforms = NULL;
#line 182 "../src/data/providers/data/IGDB.vala"
	self->platforms_length1 = 0;
#line 184 "../src/data/providers/data/IGDB.vala"
	self->summary = NULL;
#line 185 "../src/data/providers/data/IGDB.vala"
	self->storyline = NULL;
#line 187 "../src/data/providers/data/IGDB.vala"
	self->genres = NULL;
#line 187 "../src/data/providers/data/IGDB.vala"
	self->genres_length1 = 0;
#line 188 "../src/data/providers/data/IGDB.vala"
	self->keywords = NULL;
#line 188 "../src/data/providers/data/IGDB.vala"
	self->keywords_length1 = 0;
#line 190 "../src/data/providers/data/IGDB.vala"
	self->popularity = NULL;
#line 192 "../src/data/providers/data/IGDB.vala"
	self->aggregated_rating = NULL;
#line 193 "../src/data/providers/data/IGDB.vala"
	self->aggregated_rating_count = NULL;
#line 194 "../src/data/providers/data/IGDB.vala"
	self->igdb_rating = NULL;
#line 195 "../src/data/providers/data/IGDB.vala"
	self->igdb_rating_count = NULL;
#line 196 "../src/data/providers/data/IGDB.vala"
	self->total_rating = NULL;
#line 197 "../src/data/providers/data/IGDB.vala"
	self->total_rating_count = NULL;
#line 174 "../src/data/providers/data/IGDB.vala"
	self->ref_count = 1;
#line 5230 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_result_finalize (GameHubDataProvidersDataIGDBResult * obj)
{
	GameHubDataProvidersDataIGDBResult * self;
#line 174 "../src/data/providers/data/IGDB.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_RESULT, GameHubDataProvidersDataIGDBResult);
#line 174 "../src/data/providers/data/IGDB.vala"
	g_signal_handlers_destroy (self);
#line 176 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->id);
#line 177 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->name);
#line 178 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->url);
#line 179 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->release_date);
#line 180 "../src/data/providers/data/IGDB.vala"
	self->websites = (_vala_array_free (self->websites, self->websites_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_website_unref), NULL);
#line 182 "../src/data/providers/data/IGDB.vala"
	self->platforms = (_vala_array_free (self->platforms, self->platforms_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 184 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->summary);
#line 185 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->storyline);
#line 187 "../src/data/providers/data/IGDB.vala"
	self->genres = (_vala_array_free (self->genres, self->genres_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 188 "../src/data/providers/data/IGDB.vala"
	self->keywords = (_vala_array_free (self->keywords, self->keywords_length1, (GDestroyNotify) game_hub_data_providers_data_igdb_result_link_unref), NULL);
#line 190 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->popularity);
#line 192 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->aggregated_rating);
#line 193 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->aggregated_rating_count);
#line 194 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->igdb_rating);
#line 195 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->igdb_rating_count);
#line 196 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->total_rating);
#line 197 "../src/data/providers/data/IGDB.vala"
	_g_free0 (self->total_rating_count);
#line 5275 "IGDB.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_providers_data_igdb_result_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { game_hub_data_providers_data_igdb_value_result_init, game_hub_data_providers_data_igdb_value_result_free_value, game_hub_data_providers_data_igdb_value_result_copy_value, game_hub_data_providers_data_igdb_value_result_peek_pointer, "p", game_hub_data_providers_data_igdb_value_result_collect_value, "p", game_hub_data_providers_data_igdb_value_result_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataProvidersDataIGDBResultClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_providers_data_igdb_result_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataProvidersDataIGDBResult), 0, (GInstanceInitFunc) game_hub_data_providers_data_igdb_result_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_hub_data_providers_data_igdb_result_type_id;
	game_hub_data_providers_data_igdb_result_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataProvidersDataIGDBResult", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return game_hub_data_providers_data_igdb_result_type_id;
}

GType
game_hub_data_providers_data_igdb_result_get_type (void)
{
	static volatile gsize game_hub_data_providers_data_igdb_result_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_providers_data_igdb_result_type_id__volatile)) {
		GType game_hub_data_providers_data_igdb_result_type_id;
		game_hub_data_providers_data_igdb_result_type_id = game_hub_data_providers_data_igdb_result_get_type_once ();
		g_once_init_leave (&game_hub_data_providers_data_igdb_result_type_id__volatile, game_hub_data_providers_data_igdb_result_type_id);
	}
	return game_hub_data_providers_data_igdb_result_type_id__volatile;
}

gpointer
game_hub_data_providers_data_igdb_result_ref (gpointer instance)
{
	GameHubDataProvidersDataIGDBResult * self;
	self = instance;
#line 174 "../src/data/providers/data/IGDB.vala"
	g_atomic_int_inc (&self->ref_count);
#line 174 "../src/data/providers/data/IGDB.vala"
	return instance;
#line 5310 "IGDB.c"
}

void
game_hub_data_providers_data_igdb_result_unref (gpointer instance)
{
	GameHubDataProvidersDataIGDBResult * self;
	self = instance;
#line 174 "../src/data/providers/data/IGDB.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 174 "../src/data/providers/data/IGDB.vala"
		GAME_HUB_DATA_PROVIDERS_DATA_IGDB_RESULT_GET_CLASS (self)->finalize (self);
#line 174 "../src/data/providers/data/IGDB.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5324 "IGDB.c"
	}
}

static GameHubDataProvidersDataIGDBFields*
game_hub_data_providers_data_igdb_fields_construct (GType object_type)
{
	GameHubDataProvidersDataIGDBFields* self = NULL;
#line 382 "../src/data/providers/data/IGDB.vala"
	self = (GameHubDataProvidersDataIGDBFields*) g_type_create_instance (object_type);
#line 382 "../src/data/providers/data/IGDB.vala"
	return self;
#line 5336 "IGDB.c"
}

static GameHubDataProvidersDataIGDBFields*
game_hub_data_providers_data_igdb_fields_new (void)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	return game_hub_data_providers_data_igdb_fields_construct (GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS);
#line 5344 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_value_fields_init (GValue* value)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	value->data[0].v_pointer = NULL;
#line 5352 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_value_fields_free_value (GValue* value)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	if (value->data[0].v_pointer) {
#line 382 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_fields_unref (value->data[0].v_pointer);
#line 5362 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_value_fields_copy_value (const GValue* src_value,
                                                           GValue* dest_value)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	if (src_value->data[0].v_pointer) {
#line 382 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = game_hub_data_providers_data_igdb_fields_ref (src_value->data[0].v_pointer);
#line 5374 "IGDB.c"
	} else {
#line 382 "../src/data/providers/data/IGDB.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5378 "IGDB.c"
	}
}

static gpointer
game_hub_data_providers_data_igdb_value_fields_peek_pointer (const GValue* value)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 5387 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_value_fields_collect_value (GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	if (collect_values[0].v_pointer) {
#line 5398 "IGDB.c"
		GameHubDataProvidersDataIGDBFields * object;
		object = collect_values[0].v_pointer;
#line 382 "../src/data/providers/data/IGDB.vala"
		if (object->parent_instance.g_class == NULL) {
#line 382 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5405 "IGDB.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 382 "../src/data/providers/data/IGDB.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5409 "IGDB.c"
		}
#line 382 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = game_hub_data_providers_data_igdb_fields_ref (object);
#line 5413 "IGDB.c"
	} else {
#line 382 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 5417 "IGDB.c"
	}
#line 382 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 5421 "IGDB.c"
}

static gchar*
game_hub_data_providers_data_igdb_value_fields_lcopy_value (const GValue* value,
                                                            guint n_collect_values,
                                                            GTypeCValue* collect_values,
                                                            guint collect_flags)
{
	GameHubDataProvidersDataIGDBFields ** object_p;
	object_p = collect_values[0].v_pointer;
#line 382 "../src/data/providers/data/IGDB.vala"
	if (!object_p) {
#line 382 "../src/data/providers/data/IGDB.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5436 "IGDB.c"
	}
#line 382 "../src/data/providers/data/IGDB.vala"
	if (!value->data[0].v_pointer) {
#line 382 "../src/data/providers/data/IGDB.vala"
		*object_p = NULL;
#line 5442 "IGDB.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 382 "../src/data/providers/data/IGDB.vala"
		*object_p = value->data[0].v_pointer;
#line 5446 "IGDB.c"
	} else {
#line 382 "../src/data/providers/data/IGDB.vala"
		*object_p = game_hub_data_providers_data_igdb_fields_ref (value->data[0].v_pointer);
#line 5450 "IGDB.c"
	}
#line 382 "../src/data/providers/data/IGDB.vala"
	return NULL;
#line 5454 "IGDB.c"
}

static GParamSpec*
game_hub_data_providers_data_igdb_param_spec_fields (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags)
{
	GameHubDataProvidersDataIGDBParamSpecFields* spec;
#line 382 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS), NULL);
#line 382 "../src/data/providers/data/IGDB.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 382 "../src/data/providers/data/IGDB.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 382 "../src/data/providers/data/IGDB.vala"
	return G_PARAM_SPEC (spec);
#line 5473 "IGDB.c"
}

static gpointer
game_hub_data_providers_data_igdb_value_get_fields (const GValue* value)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS), NULL);
#line 382 "../src/data/providers/data/IGDB.vala"
	return value->data[0].v_pointer;
#line 5483 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_value_set_fields (GValue* value,
                                                    gpointer v_object)
{
	GameHubDataProvidersDataIGDBFields * old;
#line 382 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS));
#line 382 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 382 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 382 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS));
#line 382 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 382 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 382 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_fields_ref (value->data[0].v_pointer);
#line 5505 "IGDB.c"
	} else {
#line 382 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 5509 "IGDB.c"
	}
#line 382 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 382 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_fields_unref (old);
#line 5515 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_value_take_fields (GValue* value,
                                                     gpointer v_object)
{
	GameHubDataProvidersDataIGDBFields * old;
#line 382 "../src/data/providers/data/IGDB.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS));
#line 382 "../src/data/providers/data/IGDB.vala"
	old = value->data[0].v_pointer;
#line 382 "../src/data/providers/data/IGDB.vala"
	if (v_object) {
#line 382 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS));
#line 382 "../src/data/providers/data/IGDB.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 382 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = v_object;
#line 5536 "IGDB.c"
	} else {
#line 382 "../src/data/providers/data/IGDB.vala"
		value->data[0].v_pointer = NULL;
#line 5540 "IGDB.c"
	}
#line 382 "../src/data/providers/data/IGDB.vala"
	if (old) {
#line 382 "../src/data/providers/data/IGDB.vala"
		game_hub_data_providers_data_igdb_fields_unref (old);
#line 5546 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_fields_class_init (GameHubDataProvidersDataIGDBFieldsClass * klass,
                                                     gpointer klass_data)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_fields_parent_class = g_type_class_peek_parent (klass);
#line 382 "../src/data/providers/data/IGDB.vala"
	((GameHubDataProvidersDataIGDBFieldsClass *) klass)->finalize = game_hub_data_providers_data_igdb_fields_finalize;
#line 5558 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_fields_instance_init (GameHubDataProvidersDataIGDBFields * self,
                                                        gpointer klass)
{
#line 382 "../src/data/providers/data/IGDB.vala"
	self->ref_count = 1;
#line 5567 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_fields_finalize (GameHubDataProvidersDataIGDBFields * obj)
{
	GameHubDataProvidersDataIGDBFields * self;
#line 382 "../src/data/providers/data/IGDB.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_PROVIDERS_DATA_IGDB_TYPE_FIELDS, GameHubDataProvidersDataIGDBFields);
#line 382 "../src/data/providers/data/IGDB.vala"
	g_signal_handlers_destroy (self);
#line 5578 "IGDB.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_providers_data_igdb_fields_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { game_hub_data_providers_data_igdb_value_fields_init, game_hub_data_providers_data_igdb_value_fields_free_value, game_hub_data_providers_data_igdb_value_fields_copy_value, game_hub_data_providers_data_igdb_value_fields_peek_pointer, "p", game_hub_data_providers_data_igdb_value_fields_collect_value, "p", game_hub_data_providers_data_igdb_value_fields_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataProvidersDataIGDBFieldsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_providers_data_igdb_fields_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataProvidersDataIGDBFields), 0, (GInstanceInitFunc) game_hub_data_providers_data_igdb_fields_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_hub_data_providers_data_igdb_fields_type_id;
	game_hub_data_providers_data_igdb_fields_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataProvidersDataIGDBFields", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return game_hub_data_providers_data_igdb_fields_type_id;
}

static GType
game_hub_data_providers_data_igdb_fields_get_type (void)
{
	static volatile gsize game_hub_data_providers_data_igdb_fields_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_providers_data_igdb_fields_type_id__volatile)) {
		GType game_hub_data_providers_data_igdb_fields_type_id;
		game_hub_data_providers_data_igdb_fields_type_id = game_hub_data_providers_data_igdb_fields_get_type_once ();
		g_once_init_leave (&game_hub_data_providers_data_igdb_fields_type_id__volatile, game_hub_data_providers_data_igdb_fields_type_id);
	}
	return game_hub_data_providers_data_igdb_fields_type_id__volatile;
}

static gpointer
game_hub_data_providers_data_igdb_fields_ref (gpointer instance)
{
	GameHubDataProvidersDataIGDBFields * self;
	self = instance;
#line 382 "../src/data/providers/data/IGDB.vala"
	g_atomic_int_inc (&self->ref_count);
#line 382 "../src/data/providers/data/IGDB.vala"
	return instance;
#line 5613 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_fields_unref (gpointer instance)
{
	GameHubDataProvidersDataIGDBFields * self;
	self = instance;
#line 382 "../src/data/providers/data/IGDB.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 382 "../src/data/providers/data/IGDB.vala"
		GAME_HUB_DATA_PROVIDERS_DATA_IGDB_FIELDS_GET_CLASS (self)->finalize (self);
#line 382 "../src/data/providers/data/IGDB.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5627 "IGDB.c"
	}
}

static void
game_hub_data_providers_data_igdb_class_init (GameHubDataProvidersDataIGDBClass * klass,
                                              gpointer klass_data)
{
#line 24 "../src/data/providers/data/IGDB.vala"
	game_hub_data_providers_data_igdb_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/data/providers/data/IGDB.vala"
	((GameHubDataProvidersProviderClass *) klass)->finalize = game_hub_data_providers_data_igdb_finalize;
#line 24 "../src/data/providers/data/IGDB.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataProvidersDataIGDB_private_offset);
#line 24 "../src/data/providers/data/IGDB.vala"
	((GameHubDataProvidersDataProviderClass *) klass)->data = (void (*) (GameHubDataProvidersDataProvider*, GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_providers_data_igdb_real_data;
#line 24 "../src/data/providers/data/IGDB.vala"
	((GameHubDataProvidersDataProviderClass *) klass)->data_finish = (gpointer (*) (GameHubDataProvidersDataProvider*, GAsyncResult*)) game_hub_data_providers_data_igdb_data_finish;
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (klass)->get_id = game_hub_data_providers_data_igdb_real_get_id;
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (klass)->get_name = game_hub_data_providers_data_igdb_real_get_name;
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (klass)->get_url = game_hub_data_providers_data_igdb_real_get_url;
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (klass)->get_icon = game_hub_data_providers_data_igdb_real_get_icon;
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (klass)->get_enabled = game_hub_data_providers_data_igdb_real_get_enabled;
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (klass)->set_enabled = game_hub_data_providers_data_igdb_real_set_enabled;
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (klass)->get_settings_widget = game_hub_data_providers_data_igdb_real_get_settings_widget;
#line 5659 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_instance_init (GameHubDataProvidersDataIGDB * self,
                                                 gpointer klass)
{
#line 24 "../src/data/providers/data/IGDB.vala"
	self->priv = game_hub_data_providers_data_igdb_get_instance_private (self);
#line 5668 "IGDB.c"
}

static void
game_hub_data_providers_data_igdb_finalize (GameHubDataProvidersProvider * obj)
{
	GameHubDataProvidersDataIGDB * self;
#line 24 "../src/data/providers/data/IGDB.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_PROVIDERS_DATA_TYPE_IGDB, GameHubDataProvidersDataIGDB);
#line 24 "../src/data/providers/data/IGDB.vala"
	GAME_HUB_DATA_PROVIDERS_PROVIDER_CLASS (game_hub_data_providers_data_igdb_parent_class)->finalize (obj);
#line 5679 "IGDB.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_providers_data_igdb_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataProvidersDataIGDBClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_providers_data_igdb_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataProvidersDataIGDB), 0, (GInstanceInitFunc) game_hub_data_providers_data_igdb_instance_init, NULL };
	GType game_hub_data_providers_data_igdb_type_id;
	game_hub_data_providers_data_igdb_type_id = g_type_register_static (GAME_HUB_DATA_PROVIDERS_TYPE_DATA_PROVIDER, "GameHubDataProvidersDataIGDB", &g_define_type_info, 0);
	GameHubDataProvidersDataIGDB_private_offset = g_type_add_instance_private (game_hub_data_providers_data_igdb_type_id, sizeof (GameHubDataProvidersDataIGDBPrivate));
	return game_hub_data_providers_data_igdb_type_id;
}

GType
game_hub_data_providers_data_igdb_get_type (void)
{
	static volatile gsize game_hub_data_providers_data_igdb_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_providers_data_igdb_type_id__volatile)) {
		GType game_hub_data_providers_data_igdb_type_id;
		game_hub_data_providers_data_igdb_type_id = game_hub_data_providers_data_igdb_get_type_once ();
		g_once_init_leave (&game_hub_data_providers_data_igdb_type_id__volatile, game_hub_data_providers_data_igdb_type_id);
	}
	return game_hub_data_providers_data_igdb_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

