/* GOGGame.c generated by valac 0.54.8, the Vala compiler
 * generated from GOGGame.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <sqlite3.h>
#include <locale.h>
#include <libsoup/soup.h>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <gobject/gvaluecollector.h>
#include <glib/gi18n-lib.h>

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_FILEMAP_NAME ".bonusmap.json"
#define GAME_HUB_DATA_PLATFORM_CURRENT GAME_HUB_DATA_PLATFORM_LINUX
#define GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR "_gamehub"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;
typedef struct _GameHubDataRunnablePrivate GameHubDataRunnablePrivate;
typedef enum  {
	GAME_HUB_DATA_PLATFORM_LINUX,
	GAME_HUB_DATA_PLATFORM_WINDOWS,
	GAME_HUB_DATA_PLATFORM_MACOS,
	GAME_HUB_DATA_PLATFORM_EMULATED
} GameHubDataPlatform;

#define GAME_HUB_DATA_TYPE_PLATFORM (game_hub_data_platform_get_type ())
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD
} GameHubDataRunnableInstallerInstallMode;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALL_MODE (game_hub_data_runnable_installer_install_mode_get_type ())

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;
typedef struct _GameHubDataGamePrivate GameHubDataGamePrivate;

#define GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT (game_hub_data_game_achievement_get_type ())
#define GAME_HUB_DATA_GAME_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievement))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))

typedef struct _GameHubDataGameAchievement GameHubDataGameAchievement;
typedef struct _GameHubDataGameAchievementClass GameHubDataGameAchievementClass;

#define GAME_HUB_DATA_GAME_TYPE_STATUS (game_hub_data_game_status_get_type ())
#define GAME_HUB_DATA_GAME_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatus))
#define GAME_HUB_DATA_GAME_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))
#define GAME_HUB_DATA_GAME_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))

typedef struct _GameHubDataGameStatus GameHubDataGameStatus;
typedef struct _GameHubDataGameStatusClass GameHubDataGameStatusClass;

#define GAME_HUB_DATA_GAME_TYPE_OVERLAY (game_hub_data_game_overlay_get_type ())
#define GAME_HUB_DATA_GAME_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay))
#define GAME_HUB_DATA_GAME_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))
#define GAME_HUB_DATA_GAME_IS_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_IS_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))

typedef struct _GameHubDataGameOverlay GameHubDataGameOverlay;
typedef struct _GameHubDataGameOverlayClass GameHubDataGameOverlayClass;

#define GAME_HUB_DATA_TYPE_TWEAKABLE_GAME (game_hub_data_tweakable_game_get_type ())
#define GAME_HUB_DATA_TWEAKABLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_TWEAKABLE_GAME, GameHubDataTweakableGame))
#define GAME_HUB_DATA_IS_TWEAKABLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_TWEAKABLE_GAME))
#define GAME_HUB_DATA_TWEAKABLE_GAME_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GAME_HUB_DATA_TYPE_TWEAKABLE_GAME, GameHubDataTweakableGameIface))

typedef struct _GameHubDataTweakableGame GameHubDataTweakableGame;
typedef struct _GameHubDataTweakableGameIface GameHubDataTweakableGameIface;

#define GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME (game_hub_data_sources_gog_gog_game_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGameClass))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGameClass))

typedef struct _GameHubDataSourcesGOGGOGGame GameHubDataSourcesGOGGOGGame;
typedef struct _GameHubDataSourcesGOGGOGGameClass GameHubDataSourcesGOGGOGGameClass;
typedef struct _GameHubDataSourcesGOGGOGGamePrivate GameHubDataSourcesGOGGOGGamePrivate;

#define GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER (game_hub_data_runnable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))

typedef struct _GameHubDataRunnableInstaller GameHubDataRunnableInstaller;
typedef struct _GameHubDataRunnableInstallerClass GameHubDataRunnableInstallerClass;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT (game_hub_data_sources_gog_gog_game_bonus_content_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT, GameHubDataSourcesGOGGOGGameBonusContent))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT, GameHubDataSourcesGOGGOGGameBonusContentClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_BONUS_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_BONUS_CONTENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT, GameHubDataSourcesGOGGOGGameBonusContentClass))

typedef struct _GameHubDataSourcesGOGGOGGameBonusContent GameHubDataSourcesGOGGOGGameBonusContent;
typedef struct _GameHubDataSourcesGOGGOGGameBonusContentClass GameHubDataSourcesGOGGOGGameBonusContentClass;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC (game_hub_data_sources_gog_gog_game_dlc_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLCClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLCClass))

typedef struct _GameHubDataSourcesGOGGOGGameDLC GameHubDataSourcesGOGGOGGameDLC;
typedef struct _GameHubDataSourcesGOGGOGGameDLCClass GameHubDataSourcesGOGGOGGameDLCClass;
enum  {
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_0_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TWEAKS_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLERS_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_DIR_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_HAS_UPDATES_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DEFAULT_INSTALL_DIR_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAME_HUB_DATA_TYPE_GAME_SOURCE (game_hub_data_game_source_get_type ())
#define GAME_HUB_DATA_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSource))
#define GAME_HUB_DATA_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))
#define GAME_HUB_DATA_IS_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_IS_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_GAME_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))

typedef struct _GameHubDataGameSource GameHubDataGameSource;
typedef struct _GameHubDataGameSourceClass GameHubDataGameSourceClass;

#define GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG (game_hub_data_sources_gog_gog_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOGClass))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOGClass))

typedef struct _GameHubDataSourcesGOGGOG GameHubDataSourcesGOGGOG;
typedef struct _GameHubDataSourcesGOGGOGClass GameHubDataSourcesGOGGOGClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG (game_hub_data_db_tables_tags_tag_get_type ())
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTag))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))

typedef struct _GameHubDataDBTablesTagsTag GameHubDataDBTablesTagsTag;
typedef struct _GameHubDataDBTablesTagsTagClass GameHubDataDBTablesTagsTagClass;
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

#define GAME_HUB_DATA_DB_TABLE_TYPE_FIELD (game_hub_data_db_table_field_get_type ())
#define GAME_HUB_DATA_DB_TABLE_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableField))
#define GAME_HUB_DATA_DB_TABLE_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_IS_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD))
#define GAME_HUB_DATA_DB_TABLE_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLE_TYPE_FIELD, GameHubDataDBTableFieldClass))

typedef struct _GameHubDataDBTableField GameHubDataDBTableField;
typedef struct _GameHubDataDBTableFieldClass GameHubDataDBTableFieldClass;
typedef struct _GameHubDataGameSourcePrivate GameHubDataGameSourcePrivate;
typedef void (*GameHubUtilsFutureResult2) (gconstpointer t, gconstpointer t2, gpointer user_data);
typedef void (*GameHubUtilsFuture) (gpointer user_data);
typedef struct _GameHubDataSourcesGOGGOGPrivate GameHubDataSourcesGOGGOGPrivate;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER (game_hub_data_runnable_downloadable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, GameHubDataRunnableDownloadableInstaller))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, GameHubDataRunnableDownloadableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_DOWNLOADABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_DOWNLOADABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, GameHubDataRunnableDownloadableInstallerClass))

typedef struct _GameHubDataRunnableDownloadableInstaller GameHubDataRunnableDownloadableInstaller;
typedef struct _GameHubDataRunnableDownloadableInstallerClass GameHubDataRunnableDownloadableInstallerClass;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER (game_hub_data_sources_gog_gog_game_installer_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER, GameHubDataSourcesGOGGOGGameInstaller))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER, GameHubDataSourcesGOGGOGGameInstallerClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER, GameHubDataSourcesGOGGOGGameInstallerClass))

typedef struct _GameHubDataSourcesGOGGOGGameInstaller GameHubDataSourcesGOGGOGGameInstaller;
typedef struct _GameHubDataSourcesGOGGOGGameInstallerClass GameHubDataSourcesGOGGOGGameInstallerClass;
#define _game_hub_data_runnable_installer_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_installer_unref (var), NULL)))
#define _game_hub_data_sources_gog_gog_game_bonus_content_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_sources_gog_gog_game_bonus_content_unref (var), NULL)))
typedef struct _GameHubDataSourcesGogGogGameUpdateGameInfoData GameHubDataSourcesGogGogGameUpdateGameInfoData;

#define GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG (game_hub_ui_dialogs_install_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialog))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_IS_INSTALL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG))
#define GAME_HUB_UI_DIALOGS_INSTALL_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_TYPE_INSTALL_DIALOG, GameHubUIDialogsInstallDialogClass))

typedef struct _GameHubUIDialogsInstallDialog GameHubUIDialogsInstallDialog;
typedef struct _GameHubUIDialogsInstallDialogClass GameHubUIDialogsInstallDialogClass;
typedef struct _GameHubDataSourcesGogGogGameInstallData GameHubDataSourcesGogGogGameInstallData;

#define GAME_HUB_UTILS_TYPE_RUN_TASK (game_hub_utils_run_task_get_type ())
#define GAME_HUB_UTILS_RUN_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_TYPE_RUN_TASK, GameHubUtilsRunTask))
#define GAME_HUB_UTILS_RUN_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_TYPE_RUN_TASK, GameHubUtilsRunTaskClass))
#define GAME_HUB_UTILS_IS_RUN_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_TYPE_RUN_TASK))
#define GAME_HUB_UTILS_IS_RUN_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_TYPE_RUN_TASK))
#define GAME_HUB_UTILS_RUN_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_TYPE_RUN_TASK, GameHubUtilsRunTaskClass))

typedef struct _GameHubUtilsRunTask GameHubUtilsRunTask;
typedef struct _GameHubUtilsRunTaskClass GameHubUtilsRunTaskClass;

#define GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT (game_hub_utils_run_task_result_get_type ())
#define GAME_HUB_UTILS_RUN_TASK_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT, GameHubUtilsRunTaskResult))
#define GAME_HUB_UTILS_RUN_TASK_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT, GameHubUtilsRunTaskResultClass))
#define GAME_HUB_UTILS_RUN_TASK_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT))
#define GAME_HUB_UTILS_RUN_TASK_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT))
#define GAME_HUB_UTILS_RUN_TASK_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT, GameHubUtilsRunTaskResultClass))

typedef struct _GameHubUtilsRunTaskResult GameHubUtilsRunTaskResult;
typedef struct _GameHubUtilsRunTaskResultClass GameHubUtilsRunTaskResultClass;
#define _game_hub_utils_run_task_result_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_utils_run_task_result_unref (var), NULL)))
#define _game_hub_utils_run_task_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_utils_run_task_unref (var), NULL)))
typedef struct _GameHubDataSourcesGogGogGameUninstallData GameHubDataSourcesGogGogGameUninstallData;
typedef struct _GameHubDataGameStatusPrivate GameHubDataGameStatusPrivate;
typedef enum  {
	GAME_HUB_DATA_GAME_STATE_UNINSTALLED,
	GAME_HUB_DATA_GAME_STATE_INSTALLED,
	GAME_HUB_DATA_GAME_STATE_DOWNLOADING,
	GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY,
	GAME_HUB_DATA_GAME_STATE_INSTALLING
} GameHubDataGameState;

#define GAME_HUB_DATA_GAME_TYPE_STATE (game_hub_data_game_state_get_type ())

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD (game_hub_utils_downloader_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownload))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))

typedef struct _GameHubUtilsDownloaderDownload GameHubUtilsDownloaderDownload;
typedef struct _GameHubUtilsDownloaderDownloadClass GameHubUtilsDownloaderDownloadClass;

#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS (game_hub_utils_downloader_download_status_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS, GameHubUtilsDownloaderDownloadStatus))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS, GameHubUtilsDownloaderDownloadStatusClass))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS, GameHubUtilsDownloaderDownloadStatusClass))

typedef struct _GameHubUtilsDownloaderDownloadStatus GameHubUtilsDownloaderDownloadStatus;
typedef struct _GameHubUtilsDownloaderDownloadStatusClass GameHubUtilsDownloaderDownloadStatusClass;
typedef struct _GameHubUtilsDownloaderDownloadStatusPrivate GameHubUtilsDownloaderDownloadStatusPrivate;
typedef enum  {
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_QUEUED,
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_STARTING,
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_STARTED,
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_DOWNLOADING,
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_FINISHED,
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_PAUSED,
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_CANCELLED,
	GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_FAILED
} GameHubUtilsDownloaderDownloadState;

#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATE (game_hub_utils_downloader_download_state_get_type ())
#define _game_hub_data_game_status_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_status_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION (game_hub_data_runnable_runnable_action_get_type ())
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableAction))
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableActionClass))
#define GAME_HUB_DATA_RUNNABLE_IS_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_RUNNABLE_IS_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableActionClass))

typedef struct _GameHubDataRunnableRunnableAction GameHubDataRunnableRunnableAction;
typedef struct _GameHubDataRunnableRunnableActionClass GameHubDataRunnableRunnableActionClass;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_RUNNABLE_ACTION (game_hub_data_sources_gog_gog_game_runnable_action_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_RUNNABLE_ACTION, GameHubDataSourcesGOGGOGGameRunnableAction))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_RUNNABLE_ACTION, GameHubDataSourcesGOGGOGGameRunnableActionClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_RUNNABLE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_RUNNABLE_ACTION, GameHubDataSourcesGOGGOGGameRunnableActionClass))

typedef struct _GameHubDataSourcesGOGGOGGameRunnableAction GameHubDataSourcesGOGGOGGameRunnableAction;
typedef struct _GameHubDataSourcesGOGGOGGameRunnableActionClass GameHubDataSourcesGOGGOGGameRunnableActionClass;
#define _game_hub_data_runnable_runnable_action_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_runnable_action_unref (var), NULL)))
typedef struct _GameHubDataSourcesGOGGOGGameDLCPrivate GameHubDataSourcesGOGGOGGameDLCPrivate;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_ACHIEVEMENT (game_hub_data_sources_gog_gog_game_achievement_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_ACHIEVEMENT, GameHubDataSourcesGOGGOGGameAchievement))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_ACHIEVEMENT, GameHubDataSourcesGOGGOGGameAchievementClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_ACHIEVEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_ACHIEVEMENT, GameHubDataSourcesGOGGOGGameAchievementClass))

typedef struct _GameHubDataSourcesGOGGOGGameAchievement GameHubDataSourcesGOGGOGGameAchievement;
typedef struct _GameHubDataSourcesGOGGOGGameAchievementClass GameHubDataSourcesGOGGOGGameAchievementClass;
#define _game_hub_data_game_achievement_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_achievement_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _GameHubDataSourcesGogGogGameLoadAchievementsData GameHubDataSourcesGogGogGameLoadAchievementsData;
typedef struct _GameHubDataGameAchievementPrivate GameHubDataGameAchievementPrivate;
typedef struct _GameHubDataSourcesGOGGOGGameAchievementPrivate GameHubDataSourcesGOGGOGGameAchievementPrivate;
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
typedef struct _GameHubDataRunnableInstallerPrivate GameHubDataRunnableInstallerPrivate;

#define GAME_HUB_DATA_TYPE_COMPAT_TOOL (game_hub_data_compat_tool_get_type ())
#define GAME_HUB_DATA_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatTool))
#define GAME_HUB_DATA_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))
#define GAME_HUB_DATA_IS_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_IS_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_COMPAT_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))

typedef struct _GameHubDataCompatTool GameHubDataCompatTool;
typedef struct _GameHubDataCompatToolClass GameHubDataCompatToolClass;
typedef struct _GameHubDataRunnableDownloadableInstallerPrivate GameHubDataRunnableDownloadableInstallerPrivate;
typedef struct _GameHubDataSourcesGOGGOGGameInstallerPrivate GameHubDataSourcesGOGGOGGameInstallerPrivate;
typedef struct _Block16Data Block16Data;
typedef struct _Block17Data Block17Data;
#define _xmlFreeDoc0(var) ((var == NULL) ? NULL : (var = (xmlFreeDoc (var), NULL)))

#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART (game_hub_data_runnable_downloadable_installer_part_get_type ())
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPart))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPartClass))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_IS_PART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_IS_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPartClass))

typedef struct _GameHubDataRunnableDownloadableInstallerPart GameHubDataRunnableDownloadableInstallerPart;
typedef struct _GameHubDataRunnableDownloadableInstallerPartClass GameHubDataRunnableDownloadableInstallerPartClass;
typedef struct _GameHubDataSourcesGogGogGameInstallerFetchPartsData GameHubDataSourcesGogGogGameInstallerFetchPartsData;
typedef struct _GameHubDataRunnableRunnableActionPrivate GameHubDataRunnableRunnableActionPrivate;
typedef struct _GameHubDataSourcesGOGGOGGameRunnableActionPrivate GameHubDataSourcesGOGGOGGameRunnableActionPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define GAME_HUB_DATA_COMPAT_TYPE_WINE (game_hub_data_compat_wine_get_type ())
#define GAME_HUB_DATA_COMPAT_WINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_COMPAT_TYPE_WINE, GameHubDataCompatWine))
#define GAME_HUB_DATA_COMPAT_WINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_COMPAT_TYPE_WINE, GameHubDataCompatWineClass))
#define GAME_HUB_DATA_COMPAT_IS_WINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_COMPAT_TYPE_WINE))
#define GAME_HUB_DATA_COMPAT_IS_WINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_COMPAT_TYPE_WINE))
#define GAME_HUB_DATA_COMPAT_WINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_COMPAT_TYPE_WINE, GameHubDataCompatWineClass))

typedef struct _GameHubDataCompatWine GameHubDataCompatWine;
typedef struct _GameHubDataCompatWineClass GameHubDataCompatWineClass;
typedef struct _GameHubDataSourcesGOGGOGGameBonusContentPrivate GameHubDataSourcesGOGGOGGameBonusContentPrivate;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS (game_hub_data_sources_gog_gog_game_bonus_content_status_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS, GameHubDataSourcesGOGGOGGameBonusContentStatus))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS, GameHubDataSourcesGOGGOGGameBonusContentStatusClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS, GameHubDataSourcesGOGGOGGameBonusContentStatusClass))

typedef struct _GameHubDataSourcesGOGGOGGameBonusContentStatus GameHubDataSourcesGOGGOGGameBonusContentStatus;
typedef struct _GameHubDataSourcesGOGGOGGameBonusContentStatusClass GameHubDataSourcesGOGGOGGameBonusContentStatusClass;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO (game_hub_utils_downloader_download_info_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfo))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfoClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfoClass))

typedef struct _GameHubUtilsDownloaderDownloadInfo GameHubUtilsDownloaderDownloadInfo;
typedef struct _GameHubUtilsDownloaderDownloadInfoClass GameHubUtilsDownloaderDownloadInfoClass;
typedef enum  {
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_NOT_DOWNLOADED,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADING,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADED
} GameHubDataSourcesGOGGOGGameBonusContentState;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATE (game_hub_data_sources_gog_gog_game_bonus_content_state_get_type ())
#define _game_hub_data_sources_gog_gog_game_bonus_content_status_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_sources_gog_gog_game_bonus_content_status_unref (var), NULL)))
typedef struct _Block18Data Block18Data;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER (game_hub_utils_downloader_download_manager_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER, GameHubUtilsDownloaderDownloadManager))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER, GameHubUtilsDownloaderDownloadManagerClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER, GameHubUtilsDownloaderDownloadManagerClass))

typedef struct _GameHubUtilsDownloaderDownloadManager GameHubUtilsDownloaderDownloadManager;
typedef struct _GameHubUtilsDownloaderDownloadManagerClass GameHubUtilsDownloaderDownloadManagerClass;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD (game_hub_utils_downloader_file_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_FILE_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD, GameHubUtilsDownloaderFileDownload))
#define GAME_HUB_UTILS_DOWNLOADER_FILE_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD, GameHubUtilsDownloaderFileDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_FILE_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_FILE_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_FILE_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD, GameHubUtilsDownloaderFileDownloadClass))

typedef struct _GameHubUtilsDownloaderFileDownload GameHubUtilsDownloaderFileDownload;
typedef struct _GameHubUtilsDownloaderFileDownloadClass GameHubUtilsDownloaderFileDownloadClass;
typedef struct _GameHubUtilsDownloaderDownloadPrivate GameHubUtilsDownloaderDownloadPrivate;
typedef struct _GameHubUtilsDownloaderFileDownloadPrivate GameHubUtilsDownloaderFileDownloadPrivate;
typedef struct _GameHubDataSourcesGogGogGameBonusContentDownloadData GameHubDataSourcesGogGogGameBonusContentDownloadData;
typedef struct _GameHubDataSourcesGOGGOGGameBonusContentStatusPrivate GameHubDataSourcesGOGGOGGameBonusContentStatusPrivate;
#define _game_hub_utils_downloader_download_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_utils_downloader_download_unref (var), NULL)))
typedef struct _GameHubDataSourcesGOGGOGGameBonusContentParamSpecStatus GameHubDataSourcesGOGGOGGameBonusContentParamSpecStatus;
typedef struct _GameHubDataSourcesGOGGOGGameParamSpecBonusContent GameHubDataSourcesGOGGOGGameParamSpecBonusContent;
enum  {
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS_CHANGE_SIGNAL,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_NUM_SIGNALS
};
static guint game_hub_data_sources_gog_gog_game_bonus_content_signals[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_NUM_SIGNALS] = {0};
enum  {
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_0_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_DEFAULT_INSTALL_DIR_PROPERTY,
	GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_sources_gog_gog_game_dlc_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_NUM_PROPERTIES];
typedef struct _GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData;
typedef struct _GameHubDataGameOverlayPrivate GameHubDataGameOverlayPrivate;
typedef struct _GameHubDataSourcesGogGogGameDlcInstallData GameHubDataSourcesGogGogGameDlcInstallData;

struct _GameHubDataRunnable {
	GObject parent_instance;
	GameHubDataRunnablePrivate * priv;
};

struct _GameHubDataRunnableClass {
	GObjectClass parent_class;
	gboolean (*is_supported) (GameHubDataRunnable* self, GameHubDataPlatform* platform, gboolean with_compat);
	void (*install) (GameHubDataRunnable* self, GameHubDataRunnableInstallerInstallMode install_mode, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run) (GameHubDataRunnable* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	gboolean (*can_be_launched) (GameHubDataRunnable* self, gboolean is_launch_attempt);
	void (*run_with_compat) (GameHubDataRunnable* self, gboolean is_opened_from_menu, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_with_compat_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	GtkFileChooser* (*setup_executable_chooser) (GameHubDataRunnable* self);
	void (*choose_executable) (GameHubDataRunnable* self, gboolean update);
	void (*set_chosen_executable) (GameHubDataRunnable* self, GFile* file, gboolean update);
	void (*save) (GameHubDataRunnable* self);
	void (*update_status) (GameHubDataRunnable* self);
	void (*import) (GameHubDataRunnable* self, gboolean update);
	GFile* (*get_executable) (GameHubDataRunnable* self);
	void (*set_executable) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_work_dir) (GameHubDataRunnable* self);
	void (*set_work_dir) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_default_install_dir) (GameHubDataRunnable* self);
};

struct _GameHubDataGame {
	GameHubDataRunnable parent_instance;
	GameHubDataGamePrivate * priv;
	GameHubDataGameStatus* _status;
	GeeArrayList* overlays;
	gchar* executable_path;
	gchar* work_dir_path;
};

struct _GameHubDataGameClass {
	GameHubDataRunnableClass parent_class;
	void (*uninstall) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*uninstall_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*update_game_info) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*update_game_info_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*load_achievements) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeArrayList* (*load_achievements_finish) (GameHubDataGame* self, GAsyncResult* _res_);
};

struct _GameHubDataTweakableGameIface {
	GTypeInterface parent_iface;
	gchar** (*get_tweaks) (GameHubDataTweakableGame* self, gint* result_length1);
	void (*set_tweaks) (GameHubDataTweakableGame* self, gchar** value, gint value_length1);
};

struct _GameHubDataSourcesGOGGOGGame {
	GameHubDataGame parent_instance;
	GameHubDataSourcesGOGGOGGamePrivate * priv;
};

struct _GameHubDataSourcesGOGGOGGameClass {
	GameHubDataGameClass parent_class;
};

struct _GameHubDataSourcesGOGGOGGamePrivate {
	gchar** _tweaks;
	gint _tweaks_length1;
	gint __tweaks_size_;
	GeeArrayList* _installers;
	GeeArrayList* _bonus_content;
	GeeArrayList* _dlc;
	GFile* _bonus_content_dir;
	gboolean _has_updates;
	gboolean game_info_updating;
	gboolean game_info_updated;
	gboolean loading_achievements;
};

struct _GameHubDataGameSource {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataGameSourcePrivate * priv;
};

struct _GameHubDataGameSourceClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataGameSource *self);
	gboolean (*is_installed) (GameHubDataGameSource* self, gboolean refresh);
	void (*install) (GameHubDataGameSource* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*install_finish) (GameHubDataGameSource* self, GAsyncResult* _res_);
	void (*authenticate) (GameHubDataGameSource* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*authenticate_finish) (GameHubDataGameSource* self, GAsyncResult* _res_);
	gboolean (*is_authenticated) (GameHubDataGameSource* self);
	gboolean (*can_authenticate_automatically) (GameHubDataGameSource* self);
	void (*load_games) (GameHubDataGameSource* self, GameHubUtilsFutureResult2 game_loaded, gpointer game_loaded_target, GameHubUtilsFuture cache_loaded, gpointer cache_loaded_target, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeArrayList* (*load_games_finish) (GameHubDataGameSource* self, GAsyncResult* _res_);
	const gchar* (*get_id) (GameHubDataGameSource* self);
	const gchar* (*get_name) (GameHubDataGameSource* self);
	gchar* (*get_name_from) (GameHubDataGameSource* self);
	const gchar* (*get_icon) (GameHubDataGameSource* self);
	gchar* (*get_auth_description) (GameHubDataGameSource* self);
	gboolean (*get_enabled) (GameHubDataGameSource* self);
	void (*set_enabled) (GameHubDataGameSource* self, gboolean value);
	GeeArrayList* (*get_games) (GameHubDataGameSource* self);
};

struct _GameHubDataSourcesGOGGOG {
	GameHubDataGameSource parent_instance;
	GameHubDataSourcesGOGGOGPrivate * priv;
	gchar* user_token;
};

struct _GameHubDataSourcesGOGGOGClass {
	GameHubDataGameSourceClass parent_class;
};

struct _GameHubDataSourcesGogGogGameUpdateGameInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGame* self;
	gboolean _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* lang;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* url;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	guint status;
	gchar* json;
	const gchar* _tmp28_;
	GameHubDataGameSource* _tmp29_;
	GameHubDataGameSource* _tmp30_;
	const gchar* _tmp31_;
	guint _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	const gchar* _tmp40_;
	GameHubDataGameSource* _tmp41_;
	GameHubDataGameSource* _tmp42_;
	JsonNode* root;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	JsonNode* _tmp45_;
	JsonObject* images;
	JsonNode* _tmp46_;
	gchar* _tmp47_;
	gchar** _tmp48_;
	gchar** _tmp49_;
	gint _tmp49__length1;
	JsonObject* _tmp50_;
	JsonObject* _tmp51_;
	JsonObject* desc;
	JsonNode* _tmp52_;
	gchar* _tmp53_;
	gchar** _tmp54_;
	gchar** _tmp55_;
	gint _tmp55__length1;
	JsonObject* _tmp56_;
	JsonObject* _tmp57_;
	JsonObject* links;
	JsonNode* _tmp58_;
	gchar* _tmp59_;
	gchar** _tmp60_;
	gchar** _tmp61_;
	gint _tmp61__length1;
	JsonObject* _tmp62_;
	JsonObject* _tmp63_;
	gboolean _tmp64_;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	const gchar* _tmp67_;
	const gchar* _tmp68_;
	JsonObject* i;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	JsonNode* _tmp71_;
	JsonNode* _tmp72_;
	JsonObject* _tmp73_;
	JsonObject* _tmp74_;
	JsonObject* _tmp75_;
	JsonObject* _tmp76_;
	const gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar* _tmp81_;
	gboolean _tmp82_;
	gboolean _tmp83_;
	const gchar* _tmp84_;
	const gchar* _tmp85_;
	const gchar* _tmp86_;
	const gchar* _tmp87_;
	gboolean _tmp88_;
	JsonObject* _tmp89_;
	JsonObject* _tmp90_;
	JsonObject* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	const gchar* _tmp95_;
	const gchar* _tmp96_;
	gchar* _tmp97_;
	gchar* _tmp98_;
	const gchar* _tmp99_;
	const gchar* _tmp100_;
	gboolean _tmp101_;
	gboolean _tmp102_;
	gboolean _tmp103_;
	JsonNode* _tmp104_;
	JsonNode* _tmp105_;
	JsonNode* _tmp106_;
	JsonObject* _tmp107_;
	JsonNode* _tmp108_;
	JsonObject* _tmp109_;
	JsonObject* _tmp110_;
	JsonObject* _tmp111_;
	const gchar* _tmp112_;
	gchar* cool;
	JsonObject* _tmp113_;
	const gchar* _tmp114_;
	gchar* _tmp115_;
	gboolean _tmp116_;
	const gchar* _tmp117_;
	const gchar* _tmp118_;
	gint _tmp119_;
	gint _tmp120_;
	const gchar* _tmp121_;
	const gchar* _tmp122_;
	gchar* _tmp123_;
	gchar* _tmp124_;
	gchar** cool_parts;
	const gchar* _tmp125_;
	gchar** _tmp126_;
	gchar** _tmp127_;
	gint cool_parts_length1;
	gint _cool_parts_size_;
	gchar** _tmp128_;
	gint _tmp128__length1;
	gchar** part_collection;
	gint part_collection_length1;
	gint _part_collection_size_;
	gint part_it;
	gchar* _tmp129_;
	gchar* part;
	const gchar* _tmp130_;
	gchar* _tmp131_;
	const gchar* _tmp132_;
	gint _tmp133_;
	gint _tmp134_;
	const gchar* _tmp135_;
	const gchar* _tmp136_;
	const gchar* _tmp137_;
	gchar* _tmp138_;
	gchar* _tmp139_;
	gchar* _tmp140_;
	gchar* _tmp141_;
	gchar* _tmp142_;
	gchar* _tmp143_;
	const gchar* _tmp144_;
	const gchar* _tmp145_;
	gchar* _tmp146_;
	gchar* _tmp147_;
	JsonObject* _tmp148_;
	JsonObject* _tmp149_;
	const gchar* _tmp150_;
	JsonObject* downloads;
	JsonNode* _tmp151_;
	gchar* _tmp152_;
	gchar** _tmp153_;
	gchar** _tmp154_;
	gint _tmp154__length1;
	JsonObject* _tmp155_;
	JsonObject* _tmp156_;
	JsonArray* _tmp157_;
	gboolean _tmp158_;
	JsonObject* _tmp159_;
	JsonObject* _tmp160_;
	JsonObject* _tmp161_;
	JsonArray* _tmp162_;
	JsonArray* installers_json;
	JsonArray* _tmp163_;
	gboolean _tmp164_;
	JsonArray* _tmp165_;
	GeeArrayList* _tmp166_;
	gint _tmp167_;
	gint _tmp168_;
	JsonArray* _tmp169_;
	GList* _tmp170_;
	GList* installer_json_collection;
	GList* installer_json_it;
	JsonNode* installer_json;
	GameHubDataSourcesGOGGOGGameInstaller* installer;
	JsonNode* _tmp171_;
	JsonObject* _tmp172_;
	GameHubDataSourcesGOGGOGGameInstaller* _tmp173_;
	GeeArrayList* _tmp174_;
	GameHubDataSourcesGOGGOGGameInstaller* _tmp175_;
	GeeArrayList* _tmp176_;
	gint _tmp177_;
	gint _tmp178_;
	JsonArray* _tmp179_;
	gboolean _tmp180_;
	JsonObject* _tmp181_;
	JsonObject* _tmp182_;
	JsonObject* _tmp183_;
	JsonArray* _tmp184_;
	JsonArray* bonuses_json;
	JsonArray* _tmp185_;
	gboolean _tmp186_;
	JsonArray* _tmp187_;
	GeeArrayList* _tmp188_;
	gint _tmp189_;
	gint _tmp190_;
	JsonObject* bonus_map;
	gboolean _tmp191_;
	GFile* _tmp192_;
	GFile* _tmp193_;
	GFile* map_file;
	GFile* _tmp194_;
	GFile* _tmp195_;
	gboolean _tmp196_;
	GFile* _tmp197_;
	GFile* _tmp198_;
	JsonNode* map_root_node;
	GFile* _tmp199_;
	gchar* _tmp200_;
	gchar* _tmp201_;
	JsonNode* _tmp202_;
	JsonNode* _tmp203_;
	JsonObject* _tmp204_;
	gboolean _tmp205_;
	JsonNode* _tmp206_;
	JsonNode* _tmp207_;
	JsonNode* _tmp208_;
	JsonObject* _tmp209_;
	JsonObject* _tmp210_;
	JsonArray* _tmp211_;
	GList* _tmp212_;
	GList* bonus_json_collection;
	GList* bonus_json_it;
	JsonNode* bonus_json;
	GeeArrayList* _tmp213_;
	JsonNode* _tmp214_;
	JsonObject* _tmp215_;
	JsonObject* _tmp216_;
	GameHubDataSourcesGOGGOGGameBonusContent* _tmp217_;
	GameHubDataSourcesGOGGOGGameBonusContent* _tmp218_;
	JsonArray* _tmp219_;
	gboolean _tmp220_;
	gboolean _tmp221_;
	JsonNode* _tmp222_;
	JsonNode* _tmp223_;
	JsonNode* _tmp224_;
	JsonObject* _tmp225_;
	JsonNode* _tmp226_;
	JsonObject* _tmp227_;
	JsonArray* _tmp228_;
	JsonArray* dlcs_json;
	JsonArray* _tmp229_;
	gboolean _tmp230_;
	JsonArray* _tmp231_;
	GeeArrayList* _tmp232_;
	gint _tmp233_;
	gint _tmp234_;
	JsonArray* _tmp235_;
	GList* _tmp236_;
	GList* dlc_json_collection;
	GList* dlc_json_it;
	JsonNode* dlc_json;
	GameHubDataSourcesGOGGOGGameDLC* d;
	JsonNode* _tmp237_;
	GameHubDataSourcesGOGGOGGameDLC* _tmp238_;
	GeeArrayList* _tmp239_;
	GameHubDataSourcesGOGGOGGameDLC* _tmp240_;
	GameHubDataSourcesGOGGOGGameDLC* _tmp241_;
	const gchar* _tmp242_;
	const gchar* _tmp243_;
	JsonNode* _tmp244_;
	JsonArray* _tmp245_;
	gboolean _tmp246_;
	gboolean _tmp247_;
	JsonNode* _tmp248_;
	JsonNode* _tmp249_;
	JsonNode* _tmp250_;
	JsonObject* _tmp251_;
	JsonNode* _tmp252_;
	JsonObject* _tmp253_;
	JsonArray* _tmp254_;
	JsonArray* tags_json;
	JsonArray* _tmp255_;
	JsonArray* _tmp256_;
	JsonArray* _tmp257_;
	GList* _tmp258_;
	GList* tag_json_collection;
	GList* tag_json_it;
	JsonNode* tag_json;
	gchar* tid;
	GameHubDataGameSource* _tmp259_;
	GameHubDataGameSource* _tmp260_;
	const gchar* _tmp261_;
	const gchar* _tmp262_;
	gchar* _tmp263_;
	gchar* _tmp264_;
	JsonNode* _tmp265_;
	const gchar* _tmp266_;
	gchar* _tmp267_;
	gchar* _tmp268_;
	GeeArrayList* _t_list;
	GeeArrayList* _tmp269_;
	gint _t_size;
	GeeArrayList* _tmp270_;
	gint _tmp271_;
	gint _tmp272_;
	gint _t_index;
	gint _tmp273_;
	gint _tmp274_;
	GameHubDataDBTablesTagsTag* t;
	GeeArrayList* _tmp275_;
	gpointer _tmp276_;
	const gchar* _tmp277_;
	GameHubDataDBTablesTagsTag* _tmp278_;
	const gchar* _tmp279_;
	const gchar* _tmp280_;
	GeeArrayList* _tmp281_;
	GeeArrayList* _tmp282_;
	GameHubDataDBTablesTagsTag* _tmp283_;
	GeeArrayList* _tmp284_;
	GeeArrayList* _tmp285_;
	GameHubDataDBTablesTagsTag* _tmp286_;
};

struct _GameHubDataSourcesGogGogGameInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGame* self;
	GameHubDataRunnableInstallerInstallMode install_mode;
	gboolean _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GeeArrayList* _tmp5_;
	GameHubUIDialogsInstallDialog* _tmp6_;
	GameHubUIDialogsInstallDialog* _tmp7_;
};

struct _GameHubDataSourcesGogGogGameUninstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGame* self;
	gboolean _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* uninstaller;
	GFileInfo* finfo;
	GFileEnumerator* enumerator;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFileEnumerator* _tmp7_;
	GFileInfo* _tmp8_;
	GFileEnumerator* _tmp9_;
	GFileInfo* _tmp10_;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp12_;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	GFileInfo* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	GFile* _tmp19_;
	GFile* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar** _tmp30_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	GameHubUtilsRunTask* _tmp32_;
	GameHubUtilsRunTask* _tmp33_;
	GameHubUtilsRunTask* _tmp34_;
	GameHubUtilsRunTask* _tmp35_;
	GameHubUtilsRunTaskResult* _tmp36_;
	GameHubUtilsRunTaskResult* _tmp37_;
	GFile* _tmp38_;
	GFile* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gboolean _tmp42_;
	gboolean _tmp43_;
	GFile* _tmp44_;
	GFile* _tmp45_;
	GFile* _tmp46_;
	GFile* _tmp47_;
	gboolean _tmp48_;
	GFile* _tmp49_;
	GFile* _tmp50_;
	GFile* _tmp51_;
	gboolean _tmp52_;
	GFile* _tmp53_;
	GFile* _tmp54_;
	GFile* _tmp55_;
	GError* _inner_error0_;
};

struct _GameHubDataGameStatus {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataGameStatusPrivate * priv;
	GameHubDataGameState state;
	GameHubDataGame* game;
	GameHubUtilsDownloaderDownload* download;
};

struct _GameHubDataGameStatusClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataGameStatus *self);
};

struct _GameHubUtilsDownloaderDownloadStatus {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubUtilsDownloaderDownloadStatusPrivate * priv;
	GameHubUtilsDownloaderDownloadState state;
};

struct _GameHubUtilsDownloaderDownloadStatusClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubUtilsDownloaderDownloadStatus *self);
	gdouble (*get_progress) (GameHubUtilsDownloaderDownloadStatus* self);
	gchar* (*get_progress_string) (GameHubUtilsDownloaderDownloadStatus* self);
};

struct _GameHubDataSourcesGOGGOGGameDLC {
	GameHubDataSourcesGOGGOGGame parent_instance;
	GameHubDataSourcesGOGGOGGameDLCPrivate * priv;
	GameHubDataSourcesGOGGOGGame* game;
};

struct _GameHubDataSourcesGOGGOGGameDLCClass {
	GameHubDataSourcesGOGGOGGameClass parent_class;
};

struct _GameHubDataSourcesGogGogGameLoadAchievementsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGame* self;
	GeeArrayList* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GameHubDataGameSource* _tmp5_;
	GameHubDataGameSource* _tmp6_;
	GameHubDataGameSource* _tmp7_;
	GameHubDataGameSource* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	JsonNode* root;
	JsonObject* root_obj;
	gchar* url;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GameHubDataGameSource* _tmp16_;
	GameHubDataGameSource* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	guint status;
	const gchar* _tmp21_;
	GameHubDataGameSource* _tmp22_;
	GameHubDataGameSource* _tmp23_;
	const gchar* _tmp24_;
	guint _tmp25_;
	JsonNode* _tmp26_;
	JsonObject* _tmp27_;
	gboolean _tmp28_;
	JsonNode* _tmp29_;
	JsonNode* _tmp30_;
	JsonNode* _tmp31_;
	JsonObject* _tmp32_;
	JsonObject* _tmp33_;
	GameHubDataGameSource* _tmp34_;
	GameHubDataGameSource* _tmp35_;
	gboolean _tmp36_;
	JsonObject* _tmp37_;
	JsonObject* _tmp38_;
	JsonArray* achievements_array;
	JsonObject* _tmp39_;
	JsonArray* _tmp40_;
	JsonArray* _tmp41_;
	GeeArrayList* _achievements;
	GeeArrayList* _tmp42_;
	JsonArray* _tmp43_;
	GList* _tmp44_;
	GList* a_node_collection;
	GList* a_node_it;
	JsonNode* a_node;
	JsonObject* _tmp45_;
	gboolean _tmp46_;
	JsonNode* _tmp47_;
	JsonNode* _tmp48_;
	JsonNode* _tmp49_;
	JsonObject* _tmp50_;
	JsonObject* a_obj;
	JsonObject* _tmp51_;
	gboolean _tmp52_;
	JsonObject* _tmp53_;
	JsonObject* _tmp54_;
	gchar* a_id;
	JsonObject* _tmp55_;
	const gchar* _tmp56_;
	gchar* _tmp57_;
	const gchar* _tmp58_;
	JsonObject* _tmp59_;
	JsonObject* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	gchar* a_name;
	gchar* _tmp63_;
	const gchar* _tmp64_;
	JsonObject* _tmp65_;
	JsonObject* _tmp66_;
	const gchar* _tmp67_;
	gchar* a_desc;
	gchar* _tmp68_;
	const gchar* _tmp69_;
	JsonObject* _tmp70_;
	JsonObject* _tmp71_;
	const gchar* _tmp72_;
	gchar* a_image_unlocked;
	gchar* _tmp73_;
	const gchar* _tmp74_;
	JsonObject* _tmp75_;
	JsonObject* _tmp76_;
	const gchar* _tmp77_;
	gchar* a_image_locked;
	gchar* _tmp78_;
	gchar* a_unlock_date;
	JsonObject* _tmp79_;
	JsonNode* date;
	JsonObject* _tmp80_;
	JsonNode* _tmp81_;
	JsonNode* _tmp82_;
	JsonNode* _tmp83_;
	JsonNode* _tmp84_;
	const gchar* _tmp85_;
	gchar* _tmp86_;
	gboolean a_unlocked;
	const gchar* _tmp87_;
	gfloat _tmp88_;
	JsonObject* _tmp89_;
	JsonObject* _tmp90_;
	gfloat a_global_percentage;
	GeeArrayList* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	const gchar* _tmp95_;
	const gchar* _tmp96_;
	const gchar* _tmp97_;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp98_;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp99_;
	GeeArrayList* _tmp100_;
	GeeArrayList* _tmp101_;
	GeeArrayList* _tmp102_;
	GeeArrayList* _tmp103_;
	GeeArrayList* _tmp104_;
};

struct _GameHubDataGameAchievement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataGameAchievementPrivate * priv;
};

struct _GameHubDataGameAchievementClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataGameAchievement *self);
};

struct _GameHubDataSourcesGOGGOGGameAchievement {
	GameHubDataGameAchievement parent_instance;
	GameHubDataSourcesGOGGOGGameAchievementPrivate * priv;
};

struct _GameHubDataSourcesGOGGOGGameAchievementClass {
	GameHubDataGameAchievementClass parent_class;
};

struct _GameHubDataRunnableInstaller {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableInstallerPrivate * priv;
};

struct _GameHubDataRunnableInstallerClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableInstaller *self);
	void (*install) (GameHubDataRunnableInstaller* self, GameHubDataRunnable* runnable, GameHubDataCompatTool* tool, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnableInstaller* self, GAsyncResult* _res_);
	gchar* (*get_name) (GameHubDataRunnableInstaller* self);
};

struct _GameHubDataRunnableDownloadableInstaller {
	GameHubDataRunnableInstaller parent_instance;
	GameHubDataRunnableDownloadableInstallerPrivate * priv;
};

struct _GameHubDataRunnableDownloadableInstallerClass {
	GameHubDataRunnableInstallerClass parent_class;
	void (*fetch_parts) (GameHubDataRunnableDownloadableInstaller* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*fetch_parts_finish) (GameHubDataRunnableDownloadableInstaller* self, GAsyncResult* _res_);
};

struct _GameHubDataSourcesGOGGOGGameInstaller {
	GameHubDataRunnableDownloadableInstaller parent_instance;
	GameHubDataSourcesGOGGOGGameInstallerPrivate * priv;
	gchar* lang;
	gchar* lang_full;
};

struct _GameHubDataSourcesGOGGOGGameInstallerClass {
	GameHubDataRunnableDownloadableInstallerClass parent_class;
};

struct _GameHubDataSourcesGOGGOGGameInstallerPrivate {
	GameHubDataSourcesGOGGOGGame* game;
	JsonObject* json;
	gboolean fetched;
	GFile* installers_dir;
};

struct _Block16Data {
	int _ref_count_;
	GameHubDataSourcesGOGGOGGameInstaller* self;
	gint loading_count;
	gpointer _async_data_;
};

struct _Block17Data {
	int _ref_count_;
	Block16Data * _data16_;
	gchar* id;
	gint64 size;
	gchar* downlink_url;
};

struct _GameHubDataSourcesGogGogGameInstallerFetchPartsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGameInstaller* self;
	Block16Data* _data16_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* _tmp3_;
	JsonObject* _tmp4_;
	JsonObject* _tmp5_;
	JsonNode* _tmp6_;
	JsonObject* _tmp7_;
	JsonArray* _tmp8_;
	GList* _tmp9_;
	GList* file_node_collection;
	GList* file_node_it;
	JsonNode* file_node;
	JsonObject* _tmp10_;
	gboolean _tmp11_;
	JsonNode* _tmp12_;
	JsonNode* _tmp13_;
	JsonNode* _tmp14_;
	JsonObject* _tmp15_;
	JsonObject* file;
	JsonObject* _tmp16_;
	JsonObject* _tmp17_;
	Block17Data* _data17_;
	JsonObject* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	JsonObject* _tmp21_;
	JsonObject* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
};

struct _GameHubDataRunnableRunnableAction {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableRunnableActionPrivate * priv;
};

struct _GameHubDataRunnableRunnableActionClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableRunnableAction *self);
};

struct _GameHubDataSourcesGOGGOGGameRunnableAction {
	GameHubDataRunnableRunnableAction parent_instance;
	GameHubDataSourcesGOGGOGGameRunnableActionPrivate * priv;
};

struct _GameHubDataSourcesGOGGOGGameRunnableActionClass {
	GameHubDataRunnableRunnableActionClass parent_class;
};

struct _GameHubDataSourcesGOGGOGGameBonusContent {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataSourcesGOGGOGGameBonusContentPrivate * priv;
	GameHubDataSourcesGOGGOGGame* game;
	gchar* id;
	gchar* name;
	gchar* type;
	gint64 count;
	gchar* file;
	gint64 size;
	gchar* filename;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _status;
	GameHubUtilsDownloaderDownloadInfo* dl_info;
	GFile* downloaded_file;
};

struct _GameHubDataSourcesGOGGOGGameBonusContentClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataSourcesGOGGOGGameBonusContent *self);
};

struct _Block18Data {
	int _ref_count_;
	GameHubDataSourcesGOGGOGGameBonusContent* self;
	GFile* remote;
	gpointer _async_data_;
};

struct _GameHubUtilsDownloaderDownload {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubUtilsDownloaderDownloadPrivate * priv;
	gchar* id;
	GameHubUtilsDownloaderDownloadStatus* _status;
};

struct _GameHubUtilsDownloaderDownloadClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubUtilsDownloaderDownload *self);
	void (*cancel) (GameHubUtilsDownloaderDownload* self);
};

struct _GameHubUtilsDownloaderFileDownload {
	GameHubUtilsDownloaderDownload parent_instance;
	GameHubUtilsDownloaderFileDownloadPrivate * priv;
	GFile* remote;
	GFile* local;
	GFile* local_tmp;
};

struct _GameHubUtilsDownloaderFileDownloadClass {
	GameHubUtilsDownloaderDownloadClass parent_class;
};

struct _GameHubDataSourcesGogGogGameBonusContentDownloadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGameBonusContent* self;
	GFile* result;
	Block18Data* _data18_;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	JsonNode* root_node;
	guint status;
	const gchar* _tmp3_;
	GameHubDataSourcesGOGGOGGame* _tmp4_;
	GameHubDataGameSource* _tmp5_;
	GameHubDataGameSource* _tmp6_;
	const gchar* _tmp7_;
	guint _tmp8_;
	JsonNode* _tmp9_;
	GameHubDataSourcesGOGGOGGame* _tmp10_;
	GameHubDataGameSource* _tmp11_;
	GameHubDataGameSource* _tmp12_;
	gboolean _tmp13_;
	JsonNode* _tmp14_;
	JsonNode* _tmp15_;
	JsonObject* root;
	JsonNode* _tmp16_;
	JsonObject* _tmp17_;
	JsonObject* _tmp18_;
	gboolean _tmp19_;
	JsonObject* _tmp20_;
	JsonObject* _tmp21_;
	gchar* url;
	JsonObject* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* checksum_url;
	JsonObject* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	GFile* _tmp29_;
	gboolean _tmp30_;
	const gchar* _tmp31_;
	GameHubDataSourcesGOGGOGGame* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gboolean _tmp40_;
	const gchar* _tmp41_;
	gchar* remote_path_encoded;
	const gchar* _tmp42_;
	gchar** _tmp43_;
	gchar** _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	const gchar* _tmp46_;
	gchar** _tmp47_;
	gchar** _tmp48_;
	gchar** _tmp49_;
	gint _tmp49__length1;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* remote_path;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	GFile* _tmp56_;
	GFile* _tmp57_;
	gchar* _tmp58_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	GFile* _tmp63_;
	GFile* _tmp64_;
	GameHubDataSourcesGOGGOGGame* _tmp65_;
	GFile* _tmp66_;
	GFile* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	GFile* _tmp70_;
	GFile* _tmp71_;
	GFile* local;
	GameHubDataSourcesGOGGOGGame* _tmp72_;
	GFile* _tmp73_;
	GFile* _tmp74_;
	const gchar* _tmp75_;
	GFile* _tmp76_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp77_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp78_;
	gulong ds_id;
	GameHubUtilsDownloaderDownloadManager* _tmp79_;
	GameHubUtilsDownloaderDownloadManager* _tmp80_;
	gulong _tmp81_;
	gulong _tmp82_;
	GDateTime* start_date;
	GDateTime* _tmp83_;
	GFile* _tmp84_;
	GFile* _tmp85_;
	GFile* _tmp86_;
	GameHubUtilsDownloaderDownloadInfo* _tmp87_;
	GFile* _tmp88_;
	GFile* _tmp89_;
	GameHubUtilsDownloaderDownloadManager* _tmp90_;
	GameHubUtilsDownloaderDownloadManager* _tmp91_;
	GameHubDataSourcesGOGGOGGameBonusContentState _tmp92_;
	gboolean _tmp93_;
	GFile* _tmp94_;
	GFile* _tmp95_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp96_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp97_;
	GTimeSpan elapsed;
	GDateTime* _tmp98_;
	GDateTime* _tmp99_;
	GDateTime* _tmp100_;
	GTimeSpan _tmp101_;
	GFile* _tmp102_;
	GFile* _tmp103_;
	GError* _inner_error0_;
};

struct _GameHubDataSourcesGOGGOGGameBonusContentStatus {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataSourcesGOGGOGGameBonusContentStatusPrivate * priv;
	GameHubDataSourcesGOGGOGGameBonusContentState state;
	GameHubUtilsDownloaderDownload* download;
};

struct _GameHubDataSourcesGOGGOGGameBonusContentStatusClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataSourcesGOGGOGGameBonusContentStatus *self);
};

struct _GameHubDataSourcesGOGGOGGameBonusContentParamSpecStatus {
	GParamSpec parent_instance;
};

struct _GameHubDataSourcesGOGGOGGameParamSpecBonusContent {
	GParamSpec parent_instance;
};

struct _GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGameDLC* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
};

struct _GameHubDataGameOverlay {
	GObject parent_instance;
	GameHubDataGameOverlayPrivate * priv;
	GFile* directory;
};

struct _GameHubDataGameOverlayClass {
	GObjectClass parent_class;
};

struct _GameHubDataSourcesGogGogGameDlcInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataSourcesGOGGOGGameDLC* self;
	GameHubDataRunnableInstallerInstallMode install_mode;
	gboolean _tmp0_;
	GameHubDataSourcesGOGGOGGame* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GameHubDataSourcesGOGGOGGame* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GameHubDataSourcesGOGGOGGame* _tmp7_;
	GameHubDataSourcesGOGGOGGame* _tmp8_;
	GameHubDataGameOverlay* overlay;
	GameHubDataSourcesGOGGOGGame* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GameHubDataGameOverlay* _tmp18_;
	GameHubDataGameOverlay* _tmp19_;
	GameHubDataSourcesGOGGOGGame* _tmp20_;
	GameHubDataGameOverlay* _tmp21_;
	GFile* _tmp22_;
	GameHubDataSourcesGOGGOGGame* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	GFile* _tmp28_;
	GFile* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	GameHubDataSourcesGOGGOGGame* _tmp32_;
	GameHubDataSourcesGOGGOGGame* _tmp33_;
	GeeArrayList* _tmp34_;
	GameHubDataGameOverlay* _tmp35_;
	GameHubDataSourcesGOGGOGGame* _tmp36_;
	GameHubDataSourcesGOGGOGGame* _tmp37_;
};

static gint GameHubDataSourcesGOGGOGGame_private_offset;
static gpointer game_hub_data_sources_gog_gog_game_parent_class = NULL;
VALA_EXTERN GeeArrayList* game_hub_data_db_tables_tags_TAGS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_ID;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_NAME;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_INFO;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_INFO_DETAILED;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_ICON;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_IMAGE;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_INSTALL_PATH;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_EXECUTABLE;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_WORK_DIR;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_COMPAT_TOOL;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_COMPAT_TOOL_SETTINGS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_ARGUMENTS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_LAST_LAUNCH;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_PLAYTIME_SOURCE;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_PLAYTIME_TRACKED;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_IMAGE_VERTICAL;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_PLATFORMS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_TAGS;
VALA_EXTERN GameHubDataDBTableField* game_hub_data_db_tables_games_TWEAKS;
VALA_EXTERN GameHubDataDBTablesTagsTag* game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
VALA_EXTERN GameHubDataDBTablesTagsTag* game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
static gpointer game_hub_data_sources_gog_gog_game_achievement_parent_class = NULL;
static gint GameHubDataSourcesGOGGOGGameInstaller_private_offset;
static gpointer game_hub_data_sources_gog_gog_game_installer_parent_class = NULL;
static gpointer game_hub_data_sources_gog_gog_game_runnable_action_parent_class = NULL;
static gpointer game_hub_data_sources_gog_gog_game_bonus_content_parent_class = NULL;
static gpointer game_hub_data_sources_gog_gog_game_bonus_content_status_parent_class = NULL;
static gpointer game_hub_data_sources_gog_gog_game_dlc_parent_class = NULL;
static GameHubDataTweakableGameIface * game_hub_data_sources_gog_gog_game_game_hub_data_tweakable_game_parent_iface = NULL;

VALA_EXTERN GType game_hub_data_runnable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnable, g_object_unref)
VALA_EXTERN GType game_hub_data_platform_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType game_hub_data_runnable_installer_install_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType game_hub_data_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGame, g_object_unref)
VALA_EXTERN gpointer game_hub_data_game_achievement_ref (gpointer instance);
VALA_EXTERN void game_hub_data_game_achievement_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_game_param_spec_achievement (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags);
VALA_EXTERN void game_hub_data_game_value_set_achievement (GValue* value,
                                               gpointer v_object);
VALA_EXTERN void game_hub_data_game_value_take_achievement (GValue* value,
                                                gpointer v_object);
VALA_EXTERN gpointer game_hub_data_game_value_get_achievement (const GValue* value);
VALA_EXTERN GType game_hub_data_game_achievement_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameAchievement, game_hub_data_game_achievement_unref)
VALA_EXTERN gpointer game_hub_data_game_status_ref (gpointer instance);
VALA_EXTERN void game_hub_data_game_status_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_game_param_spec_status (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void game_hub_data_game_value_set_status (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void game_hub_data_game_value_take_status (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer game_hub_data_game_value_get_status (const GValue* value);
VALA_EXTERN GType game_hub_data_game_status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameStatus, game_hub_data_game_status_unref)
VALA_EXTERN GType game_hub_data_game_overlay_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameOverlay, g_object_unref)
VALA_EXTERN GType game_hub_data_tweakable_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataTweakableGame, g_object_unref)
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGame, g_object_unref)
VALA_EXTERN gpointer game_hub_data_runnable_installer_ref (gpointer instance);
VALA_EXTERN void game_hub_data_runnable_installer_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_runnable_param_spec_installer (const gchar* name,
                                                         const gchar* nick,
                                                         const gchar* blurb,
                                                         GType object_type,
                                                         GParamFlags flags);
VALA_EXTERN void game_hub_data_runnable_value_set_installer (GValue* value,
                                                 gpointer v_object);
VALA_EXTERN void game_hub_data_runnable_value_take_installer (GValue* value,
                                                  gpointer v_object);
VALA_EXTERN gpointer game_hub_data_runnable_value_get_installer (const GValue* value);
VALA_EXTERN GType game_hub_data_runnable_installer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableInstaller, game_hub_data_runnable_installer_unref)
VALA_EXTERN gpointer game_hub_data_sources_gog_gog_game_bonus_content_ref (gpointer instance);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_bonus_content_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_sources_gog_gog_game_param_spec_bonus_content (const gchar* name,
                                                                         const gchar* nick,
                                                                         const gchar* blurb,
                                                                         GType object_type,
                                                                         GParamFlags flags);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_value_set_bonus_content (GValue* value,
                                                                 gpointer v_object);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_value_take_bonus_content (GValue* value,
                                                                  gpointer v_object);
VALA_EXTERN gpointer game_hub_data_sources_gog_gog_game_value_get_bonus_content (const GValue* value);
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_bonus_content_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGameBonusContent, game_hub_data_sources_gog_gog_game_bonus_content_unref)
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_dlc_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGameDLC, g_object_unref)
VALA_EXTERN void game_hub_data_game_update_game_info (GameHubDataGame* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_update_game_info_finish (GameHubDataGame* self,
                                                 GAsyncResult* _res_);
VALA_EXTERN void game_hub_data_runnable_install (GameHubDataRunnable* self,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
VALA_EXTERN void game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                            GAsyncResult* _res_);
VALA_EXTERN void game_hub_data_game_uninstall (GameHubDataGame* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_uninstall_finish (GameHubDataGame* self,
                                          GAsyncResult* _res_);
VALA_EXTERN void game_hub_data_runnable_update_status (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_data_game_load_achievements (GameHubDataGame* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN GeeArrayList* game_hub_data_game_load_achievements_finish (GameHubDataGame* self,
                                                           GAsyncResult* _res_);
VALA_EXTERN GFile* game_hub_data_runnable_get_default_install_dir (GameHubDataRunnable* self);
VALA_EXTERN GameHubDataSourcesGOGGOGGame* game_hub_data_sources_gog_gog_game_new_default (void);
VALA_EXTERN GameHubDataSourcesGOGGOGGame* game_hub_data_sources_gog_gog_game_construct_default (GType object_type);
VALA_EXTERN GameHubDataGame* game_hub_data_game_construct (GType object_type);
VALA_EXTERN gpointer game_hub_data_game_source_ref (gpointer instance);
VALA_EXTERN void game_hub_data_game_source_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_param_spec_game_source (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void game_hub_data_value_set_game_source (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void game_hub_data_value_take_game_source (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer game_hub_data_value_get_game_source (const GValue* value);
VALA_EXTERN GType game_hub_data_game_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameSource, game_hub_data_game_source_unref)
VALA_EXTERN GType game_hub_data_sources_gog_gog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOG, game_hub_data_game_source_unref)
VALA_EXTERN GameHubDataSourcesGOGGOGGame* game_hub_data_sources_gog_gog_game_new (GameHubDataSourcesGOGGOG* src,
                                                                      JsonNode* json_node);
VALA_EXTERN GameHubDataSourcesGOGGOGGame* game_hub_data_sources_gog_gog_game_construct (GType object_type,
                                                                            GameHubDataSourcesGOGGOG* src,
                                                                            JsonNode* json_node);
VALA_EXTERN void game_hub_data_game_set_source (GameHubDataGame* self,
                                    GameHubDataGameSource* value);
VALA_EXTERN void game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                                    const gchar* value);
VALA_EXTERN void game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                      const gchar* value);
VALA_EXTERN void game_hub_data_game_set_icon (GameHubDataGame* self,
                                  const gchar* value);
VALA_EXTERN void game_hub_data_game_set_image (GameHubDataGame* self,
                                   const gchar* value);
VALA_EXTERN void game_hub_data_game_set_info (GameHubDataGame* self,
                                  const gchar* value);
VALA_EXTERN GeeArrayList* game_hub_data_runnable_get_platforms (GameHubDataRunnable* self);
VALA_EXTERN GameHubDataGameSource* game_hub_data_game_get_source (GameHubDataGame* self);
VALA_EXTERN const gchar* game_hub_data_game_source_get_id (GameHubDataGameSource* self);
VALA_EXTERN GType game_hub_data_db_tables_tags_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTablesTagsTag, g_object_unref)
VALA_EXTERN const gchar* game_hub_data_db_tables_tags_tag_get_id (GameHubDataDBTablesTagsTag* self);
VALA_EXTERN GeeArrayList* game_hub_data_game_get_tags (GameHubDataGame* self);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_set_has_updates (GameHubDataSourcesGOGGOGGame* self,
                                                         gboolean value);
VALA_EXTERN void game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                             GFile* value);
VALA_EXTERN void game_hub_data_game_mount_overlays (GameHubDataGame* self,
                                        GFile* persist,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_mount_overlays_finish (GameHubDataGame* self,
                                               GAsyncResult* _res_);
VALA_EXTERN GameHubDataSourcesGOGGOGGame* game_hub_data_sources_gog_gog_game_new_from_db (GameHubDataSourcesGOGGOG* src,
                                                                              sqlite3_stmt* s);
VALA_EXTERN GameHubDataSourcesGOGGOGGame* game_hub_data_sources_gog_gog_game_construct_from_db (GType object_type,
                                                                                    GameHubDataSourcesGOGGOG* src,
                                                                                    sqlite3_stmt* s);
VALA_EXTERN gpointer game_hub_data_db_table_field_ref (gpointer instance);
VALA_EXTERN void game_hub_data_db_table_field_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_db_table_param_spec_field (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
VALA_EXTERN void game_hub_data_db_table_value_set_field (GValue* value,
                                             gpointer v_object);
VALA_EXTERN void game_hub_data_db_table_value_take_field (GValue* value,
                                              gpointer v_object);
VALA_EXTERN gpointer game_hub_data_db_table_value_get_field (const GValue* value);
VALA_EXTERN GType game_hub_data_db_table_field_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTableField, game_hub_data_db_table_field_unref)
VALA_EXTERN gchar* game_hub_data_db_table_field_get (GameHubDataDBTableField* self,
                                         sqlite3_stmt* s);
VALA_EXTERN void game_hub_data_game_set_info_detailed (GameHubDataGame* self,
                                           const gchar* value);
VALA_EXTERN GFile* game_hub_utils_fs_utils_file (const gchar* path,
                                     const gchar* file,
                                     GeeHashMap* variables);
VALA_EXTERN void game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                             const gchar* value);
VALA_EXTERN void game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                      const gchar* value);
VALA_EXTERN void game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                           const gchar* value);
VALA_EXTERN gint64 game_hub_data_db_table_field_get_int64 (GameHubDataDBTableField* self,
                                               sqlite3_stmt* s);
VALA_EXTERN void game_hub_data_game_set_last_launch (GameHubDataGame* self,
                                         gint64 value);
VALA_EXTERN void game_hub_data_game_set_playtime_source (GameHubDataGame* self,
                                             gint64 value);
VALA_EXTERN void game_hub_data_game_set_playtime_tracked (GameHubDataGame* self,
                                              gint64 value);
VALA_EXTERN void game_hub_data_game_set_image_vertical (GameHubDataGame* self,
                                            const gchar* value);
VALA_EXTERN gchar* game_hub_data_platform_id (GameHubDataPlatform self);
VALA_EXTERN void game_hub_data_tweakable_game_set_tweaks (GameHubDataTweakableGame* self,
                                              gchar** value,
                                              gint value_length1);
static void game_hub_data_sources_gog_gog_game_real_update_game_info_data_free (gpointer _data);
static void game_hub_data_sources_gog_gog_game_real_update_game_info (GameHubDataGame* base,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static gboolean game_hub_data_sources_gog_gog_game_real_update_game_info_co (GameHubDataSourcesGogGogGameUpdateGameInfoData* _data_);
static void game_hub_data_sources_gog_gog_game_update_game_info_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
VALA_EXTERN const gchar* game_hub_data_game_get_info_detailed (GameHubDataGame* self);
VALA_EXTERN const gchar* game_hub_data_runnable_get_id (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_utils_parser_load_remote_file_async (const gchar* url,
                                                   const gchar* method,
                                                   const gchar* auth,
                                                   GeeHashMap* headers,
                                                   GeeHashMap* data,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN gchar* game_hub_utils_parser_load_remote_file_finish (GAsyncResult* _res_,
                                                      guint* status);
VALA_EXTERN void game_hub_data_sources_gog_gog_refresh_token (GameHubDataSourcesGOGGOG* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN gboolean game_hub_data_sources_gog_gog_refresh_token_finish (GameHubDataSourcesGOGGOG* self,
                                                             GAsyncResult* _res_);
VALA_EXTERN JsonNode* game_hub_utils_parser_parse_json (const gchar* json);
VALA_EXTERN JsonObject* game_hub_utils_parser_json_object (JsonNode* root,
                                               gchar** keys,
                                               gint keys_length1);
VALA_EXTERN const gchar* game_hub_data_game_get_image (GameHubDataGame* self);
VALA_EXTERN const gchar* game_hub_data_game_get_info (GameHubDataGame* self);
static void _vala_JsonNode_free (JsonNode* self);
VALA_EXTERN const gchar* game_hub_data_game_get_icon (GameHubDataGame* self);
VALA_EXTERN void game_hub_data_game_set_is_installable (GameHubDataGame* self,
                                            gboolean value);
VALA_EXTERN void game_hub_data_game_set_description (GameHubDataGame* self,
                                         const gchar* value);
VALA_EXTERN const gchar* game_hub_data_game_get_description (GameHubDataGame* self);
VALA_EXTERN void game_hub_data_game_set_store_page (GameHubDataGame* self,
                                        const gchar* value);
VALA_EXTERN GeeArrayList* game_hub_data_sources_gog_gog_game_get_installers (GameHubDataSourcesGOGGOGGame* self);
VALA_EXTERN GType game_hub_data_runnable_downloadable_installer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableDownloadableInstaller, game_hub_data_runnable_installer_unref)
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_installer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGameInstaller, game_hub_data_runnable_installer_unref)
VALA_EXTERN GameHubDataSourcesGOGGOGGameInstaller* game_hub_data_sources_gog_gog_game_installer_new (GameHubDataSourcesGOGGOGGame* game,
                                                                                         JsonObject* json);
VALA_EXTERN GameHubDataSourcesGOGGOGGameInstaller* game_hub_data_sources_gog_gog_game_installer_construct (GType object_type,
                                                                                               GameHubDataSourcesGOGGOGGame* game,
                                                                                               JsonObject* json);
VALA_EXTERN GeeArrayList* game_hub_data_sources_gog_gog_game_get_bonus_content (GameHubDataSourcesGOGGOGGame* self);
VALA_EXTERN GFile* game_hub_data_sources_gog_gog_game_get_bonus_content_dir (GameHubDataSourcesGOGGOGGame* self);
VALA_EXTERN JsonNode* game_hub_utils_parser_parse_json_file (const gchar* path,
                                                 const gchar* file);
VALA_EXTERN GameHubDataSourcesGOGGOGGameBonusContent* game_hub_data_sources_gog_gog_game_bonus_content_new (GameHubDataSourcesGOGGOGGame* game,
                                                                                                JsonObject* json,
                                                                                                JsonObject* bonus_map);
VALA_EXTERN GameHubDataSourcesGOGGOGGameBonusContent* game_hub_data_sources_gog_gog_game_bonus_content_construct (GType object_type,
                                                                                                      GameHubDataSourcesGOGGOGGame* game,
                                                                                                      JsonObject* json,
                                                                                                      JsonObject* bonus_map);
VALA_EXTERN GeeArrayList* game_hub_data_sources_gog_gog_game_get_dlc (GameHubDataSourcesGOGGOGGame* self);
VALA_EXTERN GameHubDataSourcesGOGGOGGameDLC* game_hub_data_sources_gog_gog_game_dlc_new (GameHubDataSourcesGOGGOGGame* game,
                                                                             JsonNode* json_node);
VALA_EXTERN GameHubDataSourcesGOGGOGGameDLC* game_hub_data_sources_gog_gog_game_dlc_construct (GType object_type,
                                                                                   GameHubDataSourcesGOGGOGGame* game,
                                                                                   JsonNode* json_node);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_dlc_update_downloads_info (GameHubDataSourcesGOGGOGGameDLC* self,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_finish (GameHubDataSourcesGOGGOGGameDLC* self,
                                                                          GAsyncResult* _res_);
VALA_EXTERN void game_hub_data_runnable_save (GameHubDataRunnable* self);
static void game_hub_data_sources_gog_gog_game_real_install_data_free (gpointer _data);
static void game_hub_data_sources_gog_gog_game_real_install (GameHubDataRunnable* base,
                                                      GameHubDataRunnableInstallerInstallMode install_mode,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static gboolean game_hub_data_sources_gog_gog_game_real_install_co (GameHubDataSourcesGogGogGameInstallData* _data_);
static void game_hub_data_sources_gog_gog_game_install_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static gboolean _game_hub_data_sources_gog_gog_game_real_install_co_gsource_func (gpointer self);
VALA_EXTERN GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_new (GameHubDataRunnable* runnable,
                                                                       GeeArrayList* installers,
                                                                       GameHubDataRunnableInstallerInstallMode install_mode,
                                                                       GSourceFunc callback,
                                                                       gpointer callback_target,
                                                                       GDestroyNotify callback_target_destroy_notify);
VALA_EXTERN GameHubUIDialogsInstallDialog* game_hub_ui_dialogs_install_dialog_construct (GType object_type,
                                                                             GameHubDataRunnable* runnable,
                                                                             GeeArrayList* installers,
                                                                             GameHubDataRunnableInstallerInstallMode install_mode,
                                                                             GSourceFunc callback,
                                                                             gpointer callback_target,
                                                                             GDestroyNotify callback_target_destroy_notify);
VALA_EXTERN GType game_hub_ui_dialogs_install_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIDialogsInstallDialog, g_object_unref)
static void game_hub_data_sources_gog_gog_game_real_uninstall_data_free (gpointer _data);
static void game_hub_data_sources_gog_gog_game_real_uninstall (GameHubDataGame* base,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static gboolean game_hub_data_sources_gog_gog_game_real_uninstall_co (GameHubDataSourcesGogGogGameUninstallData* _data_);
VALA_EXTERN GFile* game_hub_data_runnable_get_install_dir (GameHubDataRunnable* self);
static void game_hub_data_sources_gog_gog_game_uninstall_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_umount_overlays (GameHubDataGame* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_umount_overlays_finish (GameHubDataGame* self,
                                                GAsyncResult* _res_);
VALA_EXTERN gchar* game_hub_utils_fs_utils_expand (const gchar* path,
                                       const gchar* file,
                                       GeeHashMap* variables);
VALA_EXTERN gpointer game_hub_utils_run_task_ref (gpointer instance);
VALA_EXTERN void game_hub_utils_run_task_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_utils_param_spec_run_task (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void game_hub_utils_value_set_run_task (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void game_hub_utils_value_take_run_task (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer game_hub_utils_value_get_run_task (const GValue* value);
VALA_EXTERN GType game_hub_utils_run_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsRunTask, game_hub_utils_run_task_unref)
VALA_EXTERN GameHubUtilsRunTask* game_hub_utils_run (gchar** cmd,
                                         gint cmd_length1);
VALA_EXTERN GameHubUtilsRunTask* game_hub_utils_run_task_override_runtime (GameHubUtilsRunTask* self,
                                                               gboolean override_runtime);
VALA_EXTERN void game_hub_utils_run_task_run_sync_thread (GameHubUtilsRunTask* self,
                                              gboolean capture_output,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN gpointer game_hub_utils_run_task_result_ref (gpointer instance);
VALA_EXTERN void game_hub_utils_run_task_result_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_utils_run_task_param_spec_result (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags);
VALA_EXTERN void game_hub_utils_run_task_value_set_result (GValue* value,
                                               gpointer v_object);
VALA_EXTERN void game_hub_utils_run_task_value_take_result (GValue* value,
                                                gpointer v_object);
VALA_EXTERN gpointer game_hub_utils_run_task_value_get_result (const GValue* value);
VALA_EXTERN GType game_hub_utils_run_task_result_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsRunTaskResult, game_hub_utils_run_task_result_unref)
VALA_EXTERN GameHubUtilsRunTaskResult* game_hub_utils_run_task_run_sync_thread_finish (GameHubUtilsRunTask* self,
                                                                           GAsyncResult* _res_);
VALA_EXTERN void game_hub_utils_fs_utils_rm (const gchar* path,
                                 const gchar* file,
                                 const gchar* flags,
                                 GeeHashMap* variables);
VALA_EXTERN GFile* game_hub_data_runnable_get_executable (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                            GFile* value);
static void game_hub_data_sources_gog_gog_game_real_update_status (GameHubDataRunnable* base);
VALA_EXTERN GameHubDataGameStatus* game_hub_data_game_get_status (GameHubDataGame* self);
VALA_EXTERN GType game_hub_data_game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer game_hub_utils_downloader_download_ref (gpointer instance);
VALA_EXTERN void game_hub_utils_downloader_download_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_utils_downloader_param_spec_download (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags);
VALA_EXTERN void game_hub_utils_downloader_value_set_download (GValue* value,
                                                   gpointer v_object);
VALA_EXTERN void game_hub_utils_downloader_value_take_download (GValue* value,
                                                    gpointer v_object);
VALA_EXTERN gpointer game_hub_utils_downloader_value_get_download (const GValue* value);
VALA_EXTERN GType game_hub_utils_downloader_download_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownload, game_hub_utils_downloader_download_unref)
VALA_EXTERN gpointer game_hub_utils_downloader_download_status_ref (gpointer instance);
VALA_EXTERN void game_hub_utils_downloader_download_status_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_utils_downloader_download_param_spec_status (const gchar* name,
                                                                  const gchar* nick,
                                                                  const gchar* blurb,
                                                                  GType object_type,
                                                                  GParamFlags flags);
VALA_EXTERN void game_hub_utils_downloader_download_value_set_status (GValue* value,
                                                          gpointer v_object);
VALA_EXTERN void game_hub_utils_downloader_download_value_take_status (GValue* value,
                                                           gpointer v_object);
VALA_EXTERN gpointer game_hub_utils_downloader_download_value_get_status (const GValue* value);
VALA_EXTERN GType game_hub_utils_downloader_download_status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownloadStatus, game_hub_utils_downloader_download_status_unref)
VALA_EXTERN GameHubUtilsDownloaderDownloadStatus* game_hub_utils_downloader_download_get_status (GameHubUtilsDownloaderDownload* self);
VALA_EXTERN GType game_hub_utils_downloader_download_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GFile* game_hub_data_game_get_file (GameHubDataGame* self,
                                    const gchar* p,
                                    gboolean from_all_overlays);
VALA_EXTERN GameHubDataGameStatus* game_hub_data_game_status_new (GameHubDataGameState state,
                                                      GameHubDataGame* game,
                                                      GameHubUtilsDownloaderDownload* download);
VALA_EXTERN GameHubDataGameStatus* game_hub_data_game_status_construct (GType object_type,
                                                            GameHubDataGameState state,
                                                            GameHubDataGame* game,
                                                            GameHubUtilsDownloaderDownload* download);
VALA_EXTERN void game_hub_data_game_set_status (GameHubDataGame* self,
                                    GameHubDataGameStatus* value);
VALA_EXTERN void game_hub_data_game_remove_tag (GameHubDataGame* self,
                                    GameHubDataDBTablesTagsTag* tag);
VALA_EXTERN void game_hub_data_game_add_tag (GameHubDataGame* self,
                                 GameHubDataDBTablesTagsTag* tag);
VALA_EXTERN void game_hub_data_game_set_version (GameHubDataGame* self,
                                     const gchar* value);
VALA_EXTERN void game_hub_data_game_update_version (GameHubDataGame* self);
VALA_EXTERN gpointer game_hub_data_runnable_runnable_action_ref (gpointer instance);
VALA_EXTERN void game_hub_data_runnable_runnable_action_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_runnable_param_spec_runnable_action (const gchar* name,
                                                               const gchar* nick,
                                                               const gchar* blurb,
                                                               GType object_type,
                                                               GParamFlags flags);
VALA_EXTERN void game_hub_data_runnable_value_set_runnable_action (GValue* value,
                                                       gpointer v_object);
VALA_EXTERN void game_hub_data_runnable_value_take_runnable_action (GValue* value,
                                                        gpointer v_object);
VALA_EXTERN gpointer game_hub_data_runnable_value_get_runnable_action (const GValue* value);
VALA_EXTERN GType game_hub_data_runnable_runnable_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableRunnableAction, game_hub_data_runnable_runnable_action_unref)
VALA_EXTERN GeeArrayList* game_hub_data_runnable_get_actions (GameHubDataRunnable* self);
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_runnable_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGameRunnableAction, game_hub_data_runnable_runnable_action_unref)
VALA_EXTERN GameHubDataSourcesGOGGOGGameRunnableAction* game_hub_data_sources_gog_gog_game_runnable_action_new (GameHubDataSourcesGOGGOGGame* game,
                                                                                                    JsonObject* json);
VALA_EXTERN GameHubDataSourcesGOGGOGGameRunnableAction* game_hub_data_sources_gog_gog_game_runnable_action_construct (GType object_type,
                                                                                                          GameHubDataSourcesGOGGOGGame* game,
                                                                                                          JsonObject* json);
VALA_EXTERN gboolean game_hub_data_runnable_runnable_action_get_is_hidden (GameHubDataRunnableRunnableAction* self);
VALA_EXTERN const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
VALA_EXTERN gchar* game_hub_utils_fs_utils_paths_collection_gog_expand_installers (const gchar* game,
                                                                       const gchar* dlc,
                                                                       GameHubDataPlatform* platform);
VALA_EXTERN void game_hub_data_game_set_installers_dir (GameHubDataGame* self,
                                            GFile* value);
VALA_EXTERN gchar* game_hub_utils_fs_utils_paths_collection_gog_expand_bonus (const gchar* game,
                                                                  const gchar* dlc);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_set_bonus_content_dir (GameHubDataSourcesGOGGOGGame* self,
                                                               GFile* value);
static void game_hub_data_sources_gog_gog_game_real_load_achievements_data_free (gpointer _data);
static void game_hub_data_sources_gog_gog_game_real_load_achievements (GameHubDataGame* base,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_);
static gboolean game_hub_data_sources_gog_gog_game_real_load_achievements_co (GameHubDataSourcesGogGogGameLoadAchievementsData* _data_);
VALA_EXTERN GeeArrayList* game_hub_data_game_get_achievements (GameHubDataGame* self);
VALA_EXTERN const gchar* game_hub_data_sources_gog_gog_get_user_id (GameHubDataSourcesGOGGOG* self);
VALA_EXTERN void game_hub_utils_parser_parse_remote_json_file_async (const gchar* url,
                                                         const gchar* method,
                                                         const gchar* auth,
                                                         GeeHashMap* headers,
                                                         GeeHashMap* data,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
VALA_EXTERN JsonNode* game_hub_utils_parser_parse_remote_json_file_finish (GAsyncResult* _res_,
                                                               guint* status);
static void game_hub_data_sources_gog_gog_game_load_achievements_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
VALA_EXTERN GameHubDataSourcesGOGGOGGameAchievement* game_hub_data_sources_gog_gog_game_achievement_new (const gchar* id,
                                                                                             const gchar* name,
                                                                                             const gchar* desc,
                                                                                             const gchar* image_locked,
                                                                                             const gchar* image_unlocked,
                                                                                             gboolean unlocked,
                                                                                             const gchar* unlock_date,
                                                                                             gfloat global_percentage);
VALA_EXTERN GameHubDataSourcesGOGGOGGameAchievement* game_hub_data_sources_gog_gog_game_achievement_construct (GType object_type,
                                                                                                   const gchar* id,
                                                                                                   const gchar* name,
                                                                                                   const gchar* desc,
                                                                                                   const gchar* image_locked,
                                                                                                   const gchar* image_unlocked,
                                                                                                   gboolean unlocked,
                                                                                                   const gchar* unlock_date,
                                                                                                   gfloat global_percentage);
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_achievement_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGameAchievement, game_hub_data_game_achievement_unref)
static gint __lambda126_ (GameHubDataSourcesGOGGOGGame* self,
                   GameHubDataGameAchievement* first,
                   GameHubDataGameAchievement* second);
VALA_EXTERN GDateTime* game_hub_data_game_achievement_get_unlock_date (GameHubDataGameAchievement* self);
VALA_EXTERN gfloat game_hub_data_game_achievement_get_global_percentage (GameHubDataGameAchievement* self);
static gint ___lambda126__gcompare_data_func (gconstpointer a,
                                       gconstpointer b,
                                       gpointer self);
VALA_EXTERN void game_hub_data_game_set_achievements (GameHubDataGame* self,
                                          GeeArrayList* value);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_set_installers (GameHubDataSourcesGOGGOGGame* self,
                                                        GeeArrayList* value);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_set_bonus_content (GameHubDataSourcesGOGGOGGame* self,
                                                           GeeArrayList* value);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_set_dlc (GameHubDataSourcesGOGGOGGame* self,
                                                 GeeArrayList* value);
VALA_EXTERN gboolean game_hub_data_sources_gog_gog_game_get_has_updates (GameHubDataSourcesGOGGOGGame* self);
VALA_EXTERN gchar* game_hub_utils_fs_utils_paths_gog_get_Games (void);
VALA_EXTERN const gchar* game_hub_data_runnable_get_escaped_name (GameHubDataRunnable* self);
VALA_EXTERN GameHubDataGameAchievement* game_hub_data_game_achievement_construct (GType object_type);
VALA_EXTERN void game_hub_data_game_achievement_set_id (GameHubDataGameAchievement* self,
                                            const gchar* value);
VALA_EXTERN void game_hub_data_game_achievement_set_name (GameHubDataGameAchievement* self,
                                              const gchar* value);
VALA_EXTERN void game_hub_data_game_achievement_set_description (GameHubDataGameAchievement* self,
                                                     const gchar* value);
VALA_EXTERN void game_hub_data_game_achievement_set_image_locked (GameHubDataGameAchievement* self,
                                                      const gchar* value);
VALA_EXTERN void game_hub_data_game_achievement_set_image_unlocked (GameHubDataGameAchievement* self,
                                                        const gchar* value);
VALA_EXTERN void game_hub_data_game_achievement_set_unlocked (GameHubDataGameAchievement* self,
                                                  gboolean value);
VALA_EXTERN void game_hub_data_game_achievement_set_global_percentage (GameHubDataGameAchievement* self,
                                                           gfloat value);
VALA_EXTERN void game_hub_data_game_achievement_set_unlock_date (GameHubDataGameAchievement* self,
                                                     GDateTime* value);
VALA_EXTERN gchar* game_hub_utils_get_relative_datetime (GDateTime* date_time);
VALA_EXTERN void game_hub_data_game_achievement_set_unlock_time (GameHubDataGameAchievement* self,
                                                     const gchar* value);
static GType game_hub_data_sources_gog_gog_game_achievement_get_type_once (void);
VALA_EXTERN GType game_hub_data_compat_tool_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataCompatTool, g_object_unref)
VALA_EXTERN void game_hub_data_runnable_downloadable_installer_fetch_parts (GameHubDataRunnableDownloadableInstaller* self,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_);
VALA_EXTERN void game_hub_data_runnable_downloadable_installer_fetch_parts_finish (GameHubDataRunnableDownloadableInstaller* self,
                                                                       GAsyncResult* _res_);
VALA_EXTERN gchar* game_hub_data_runnable_installer_get_name (GameHubDataRunnableInstaller* self);
VALA_EXTERN GameHubDataRunnableDownloadableInstaller* game_hub_data_runnable_downloadable_installer_construct (GType object_type);
VALA_EXTERN void game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                              const gchar* value);
VALA_EXTERN void game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                                    GameHubDataPlatform value);
VALA_EXTERN GameHubDataPlatform game_hub_data_runnable_installer_get_platform (GameHubDataRunnableInstaller* self);
VALA_EXTERN GFile* game_hub_data_game_get_installers_dir (GameHubDataGame* self);
VALA_EXTERN void game_hub_data_runnable_installer_set_full_size (GameHubDataRunnableInstaller* self,
                                                     gint64 value);
VALA_EXTERN void game_hub_data_runnable_installer_set_version (GameHubDataRunnableInstaller* self,
                                                   const gchar* value);
static void game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_data_free (gpointer _data);
static void game_hub_data_sources_gog_gog_game_installer_real_fetch_parts (GameHubDataRunnableDownloadableInstaller* base,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static gboolean game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_co (GameHubDataSourcesGogGogGameInstallerFetchPartsData* _data_);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
VALA_EXTERN void game_hub_utils_thread (const gchar* name,
                            GameHubUtilsFuture worker,
                            gpointer worker_target,
                            GDestroyNotify worker_target_destroy_notify,
                            gboolean log);
static void _____lambda90_ (Block17Data* _data17_);
VALA_EXTERN JsonNode* game_hub_utils_parser_parse_remote_json_file (const gchar* url,
                                                        const gchar* method,
                                                        const gchar* auth,
                                                        GeeHashMap* headers,
                                                        GeeHashMap* data,
                                                        guint* status);
VALA_EXTERN xmlDoc* game_hub_utils_parser_parse_remote_xml_file (const gchar* url,
                                                     const gchar* method,
                                                     const gchar* auth,
                                                     GeeHashMap* headers,
                                                     GeeHashMap* data);
VALA_EXTERN const gchar* game_hub_data_runnable_installer_get_id (GameHubDataRunnableInstaller* self);
VALA_EXTERN GType game_hub_data_runnable_downloadable_installer_part_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableDownloadableInstallerPart, g_object_unref)
VALA_EXTERN GeeArrayList* game_hub_data_runnable_downloadable_installer_get_parts (GameHubDataRunnableDownloadableInstaller* self);
VALA_EXTERN GameHubDataRunnableDownloadableInstallerPart* game_hub_data_runnable_downloadable_installer_part_new (const gchar* id,
                                                                                                      const gchar* url,
                                                                                                      gint64 size,
                                                                                                      GFile* remote,
                                                                                                      GFile* local,
                                                                                                      const gchar* checksum,
                                                                                                      GChecksumType checksum_type);
VALA_EXTERN GameHubDataRunnableDownloadableInstallerPart* game_hub_data_runnable_downloadable_installer_part_construct (GType object_type,
                                                                                                            const gchar* id,
                                                                                                            const gchar* url,
                                                                                                            gint64 size,
                                                                                                            GFile* remote,
                                                                                                            GFile* local,
                                                                                                            const gchar* checksum,
                                                                                                            GChecksumType checksum_type);
static gboolean _game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_co_gsource_func (gpointer self);
static void ______lambda90__game_hub_utils_future (gpointer self);
VALA_EXTERN const gchar* game_hub_data_runnable_installer_get_version (GameHubDataRunnableInstaller* self);
static void game_hub_data_sources_gog_gog_game_installer_finalize (GameHubDataRunnableInstaller * obj);
static GType game_hub_data_sources_gog_gog_game_installer_get_type_once (void);
VALA_EXTERN GameHubDataRunnableRunnableAction* game_hub_data_runnable_runnable_action_construct (GType object_type);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_runnable (GameHubDataRunnableRunnableAction* self,
                                                          GameHubDataRunnable* value);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_is_primary (GameHubDataRunnableRunnableAction* self,
                                                            gboolean value);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_is_hidden (GameHubDataRunnableRunnableAction* self,
                                                           gboolean value);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_name (GameHubDataRunnableRunnableAction* self,
                                                      const gchar* value);
static GFile* game_hub_data_sources_gog_gog_game_runnable_action_find_file (GameHubDataSourcesGOGGOGGameRunnableAction* self,
                                                                     const gchar* path);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_file (GameHubDataRunnableRunnableAction* self,
                                                      GFile* value);
VALA_EXTERN GFile* game_hub_data_runnable_runnable_action_get_file (GameHubDataRunnableRunnableAction* self);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_workdir (GameHubDataRunnableRunnableAction* self,
                                                         GFile* value);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_args (GameHubDataRunnableRunnableAction* self,
                                                      const gchar* value);
VALA_EXTERN GType game_hub_data_compat_wine_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataCompatWine, g_object_unref)
static GType* _g_type_dup (GType* self);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                              GType** value,
                                                              gint value_length1);
VALA_EXTERN void game_hub_data_runnable_runnable_action_set_uri (GameHubDataRunnableRunnableAction* self,
                                                     const gchar* value);
VALA_EXTERN GameHubDataRunnable* game_hub_data_runnable_runnable_action_get_runnable (GameHubDataRunnableRunnableAction* self);
VALA_EXTERN gboolean game_hub_data_game_get_overlays_enabled (GameHubDataGame* self);
VALA_EXTERN GFile* game_hub_utils_fs_utils_find_case_insensitive (GFile* root,
                                                      const gchar* path,
                                                      gchar** parts,
                                                      gint parts_length1);
static GType game_hub_data_sources_gog_gog_game_runnable_action_get_type_once (void);
VALA_EXTERN gpointer game_hub_data_sources_gog_gog_game_bonus_content_status_ref (gpointer instance);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_bonus_content_status_unref (gpointer instance);
VALA_EXTERN GParamSpec* game_hub_data_sources_gog_gog_game_bonus_content_param_spec_status (const gchar* name,
                                                                                const gchar* nick,
                                                                                const gchar* blurb,
                                                                                GType object_type,
                                                                                GParamFlags flags);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_bonus_content_value_set_status (GValue* value,
                                                                        gpointer v_object);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_bonus_content_value_take_status (GValue* value,
                                                                         gpointer v_object);
VALA_EXTERN gpointer game_hub_data_sources_gog_gog_game_bonus_content_value_get_status (const GValue* value);
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_bonus_content_status_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGameBonusContentStatus, game_hub_data_sources_gog_gog_game_bonus_content_status_unref)
VALA_EXTERN GType game_hub_utils_downloader_download_info_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownloadInfo, g_object_unref)
VALA_EXTERN GType game_hub_data_sources_gog_gog_game_bonus_content_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameHubDataSourcesGOGGOGGameBonusContentStatus* game_hub_data_sources_gog_gog_game_bonus_content_status_new (GameHubDataSourcesGOGGOGGameBonusContentState state,
                                                                                                             GameHubUtilsDownloaderDownload* download);
VALA_EXTERN GameHubDataSourcesGOGGOGGameBonusContentStatus* game_hub_data_sources_gog_gog_game_bonus_content_status_construct (GType object_type,
                                                                                                                   GameHubDataSourcesGOGGOGGameBonusContentState state,
                                                                                                                   GameHubUtilsDownloaderDownload* download);
VALA_EXTERN gchar* game_hub_data_sources_gog_gog_game_bonus_content_get_text (GameHubDataSourcesGOGGOGGameBonusContent* self);
VALA_EXTERN const gchar* game_hub_data_sources_gog_gog_game_bonus_content_get_icon (GameHubDataSourcesGOGGOGGameBonusContent* self);
VALA_EXTERN GameHubUtilsDownloaderDownloadInfo* game_hub_utils_downloader_download_info_new (const gchar* name,
                                                                                 const gchar* description,
                                                                                 const gchar* icon,
                                                                                 const gchar* icon_name,
                                                                                 const gchar* type_icon,
                                                                                 const gchar* type_icon_name);
VALA_EXTERN GameHubUtilsDownloaderDownloadInfo* game_hub_utils_downloader_download_info_construct (GType object_type,
                                                                                       const gchar* name,
                                                                                       const gchar* description,
                                                                                       const gchar* icon,
                                                                                       const gchar* icon_name,
                                                                                       const gchar* type_icon,
                                                                                       const gchar* type_icon_name);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_bonus_content_set_status (GameHubDataSourcesGOGGOGGameBonusContent* self,
                                                                  GameHubDataSourcesGOGGOGGameBonusContentStatus* value);
static void game_hub_data_sources_gog_gog_game_bonus_content_download_data_free (gpointer _data);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_bonus_content_download (GameHubDataSourcesGOGGOGGameBonusContent* self,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_);
VALA_EXTERN GFile* game_hub_data_sources_gog_gog_game_bonus_content_download_finish (GameHubDataSourcesGOGGOGGameBonusContent* self,
                                                                         GAsyncResult* _res_);
static gboolean game_hub_data_sources_gog_gog_game_bonus_content_download_co (GameHubDataSourcesGogGogGameBonusContentDownloadData* _data_);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void game_hub_data_sources_gog_gog_game_bonus_content_download_ready (GObject* source_object,
                                                                      GAsyncResult* _res_,
                                                                      gpointer _user_data_);
VALA_EXTERN GFile* game_hub_utils_fs_utils_mkdir (const gchar* path,
                                      const gchar* file,
                                      GeeHashMap* variables);
VALA_EXTERN GType game_hub_utils_downloader_download_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownloadManager, g_object_unref)
VALA_EXTERN GameHubUtilsDownloaderDownloadManager* game_hub_utils_downloader_download_manager (void);
VALA_EXTERN GType game_hub_utils_downloader_file_download_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderFileDownload, game_hub_utils_downloader_download_unref)
static void __lambda123_ (Block18Data* _data18_,
                   GameHubUtilsDownloaderFileDownload* dl);
static void __lambda124_ (GameHubDataSourcesGOGGOGGameBonusContent* self,
                   GameHubUtilsDownloaderDownloadStatus* s);
VALA_EXTERN GameHubDataSourcesGOGGOGGameBonusContentStatus* game_hub_data_sources_gog_gog_game_bonus_content_get_status (GameHubDataSourcesGOGGOGGameBonusContent* self);
static void ___lambda124__game_hub_utils_downloader_download_status_change (GameHubUtilsDownloaderDownload* _sender,
                                                                     GameHubUtilsDownloaderDownloadStatus* status,
                                                                     gpointer self);
static void ___lambda123__game_hub_utils_downloader_download_manager_file_download_started (GameHubUtilsDownloaderDownloadManager* _sender,
                                                                                     GameHubUtilsDownloaderFileDownload* download,
                                                                                     gpointer self);
VALA_EXTERN void game_hub_utils_downloader_download_file (GFile* remote,
                                              GFile* local,
                                              GameHubUtilsDownloaderDownloadInfo* info,
                                              gboolean preserve_filename,
                                              gboolean queue,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN GFile* game_hub_utils_downloader_download_file_finish (GAsyncResult* _res_,
                                                       GError** error);
static void game_hub_data_sources_gog_gog_game_bonus_content_save_filename (GameHubDataSourcesGOGGOGGameBonusContent* self);
VALA_EXTERN void game_hub_data_sources_gog_gog_game_bonus_content_open (GameHubDataSourcesGOGGOGGameBonusContent* self);
static gboolean ___lambda125_ (GameHubDataSourcesGOGGOGGameBonusContent* self);
VALA_EXTERN void game_hub_utils_open_uri (const gchar* uri);
static gboolean ____lambda125__gsource_func (gpointer self);
static void g_cclosure_user_marshal_VOID__GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS (GClosure * closure,
                                                                                            GValue * return_value,
                                                                                            guint n_param_values,
                                                                                            const GValue * param_values,
                                                                                            gpointer invocation_hint,
                                                                                            gpointer marshal_data);
static void game_hub_data_sources_gog_gog_game_bonus_content_status_finalize (GameHubDataSourcesGOGGOGGameBonusContentStatus * obj);
static GType game_hub_data_sources_gog_gog_game_bonus_content_status_get_type_once (void);
static void game_hub_data_sources_gog_gog_game_bonus_content_finalize (GameHubDataSourcesGOGGOGGameBonusContent * obj);
static GType game_hub_data_sources_gog_gog_game_bonus_content_get_type_once (void);
VALA_EXTERN GFile* game_hub_data_runnable_get_work_dir (GameHubDataRunnable* self);
VALA_EXTERN void game_hub_data_runnable_set_work_dir (GameHubDataRunnable* self,
                                          GFile* value);
VALA_EXTERN void game_hub_data_runnable_set_platforms (GameHubDataRunnable* self,
                                           GeeArrayList* value);
static void game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_data_free (gpointer _data);
static gboolean game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_co (GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData* _data_);
static void game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_ready (GObject* source_object,
                                                                         GAsyncResult* _res_,
                                                                         gpointer _user_data_);
static void game_hub_data_sources_gog_gog_game_dlc_real_update_status (GameHubDataRunnable* base);
static void game_hub_data_sources_gog_gog_game_dlc_real_install_data_free (gpointer _data);
static void game_hub_data_sources_gog_gog_game_dlc_real_install (GameHubDataRunnable* base,
                                                          GameHubDataRunnableInstallerInstallMode install_mode,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static gboolean game_hub_data_sources_gog_gog_game_dlc_real_install_co (GameHubDataSourcesGogGogGameDlcInstallData* _data_);
static void game_hub_data_sources_gog_gog_game_dlc_install_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
VALA_EXTERN void game_hub_data_game_enable_overlays (GameHubDataGame* self);
VALA_EXTERN GameHubDataGameOverlay* game_hub_data_game_overlay_new (GameHubDataGame* game,
                                                        const gchar* id,
                                                        const gchar* name,
                                                        gboolean enabled);
VALA_EXTERN GameHubDataGameOverlay* game_hub_data_game_overlay_construct (GType object_type,
                                                              GameHubDataGame* game,
                                                              const gchar* id,
                                                              const gchar* name,
                                                              gboolean enabled);
VALA_EXTERN void game_hub_data_game_save_overlays (GameHubDataGame* self);
static void game_hub_data_sources_gog_gog_game_dlc_finalize (GObject * obj);
static GType game_hub_data_sources_gog_gog_game_dlc_get_type_once (void);
static void _vala_game_hub_data_sources_gog_gog_game_dlc_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
VALA_EXTERN gchar** game_hub_data_tweakable_game_get_tweaks (GameHubDataTweakableGame* self,
                                                 gint* result_length1);
static void game_hub_data_sources_gog_gog_game_finalize (GObject * obj);
static GType game_hub_data_sources_gog_gog_game_get_type_once (void);
static void _vala_game_hub_data_sources_gog_gog_game_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_game_hub_data_sources_gog_gog_game_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

VALA_EXTERN const GameHubDataPlatform GAME_HUB_DATA_PLATFORM_PLATFORMS[4];

static inline gpointer
game_hub_data_sources_gog_gog_game_get_instance_private (GameHubDataSourcesGOGGOGGame* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataSourcesGOGGOGGame_private_offset);
}

GameHubDataSourcesGOGGOGGame*
game_hub_data_sources_gog_gog_game_construct_default (GType object_type)
{
	GameHubDataSourcesGOGGOGGame * self = NULL;
#line 48 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) game_hub_data_game_construct (object_type);
#line 48 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 2427 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGame*
game_hub_data_sources_gog_gog_game_new_default (void)
{
#line 48 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_construct_default (GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME);
#line 2435 "GOGGame.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 54 "../src/data/sources/gog/GOGGame.vala"
	return self ? json_object_ref (self) : NULL;
#line 2443 "GOGGame.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 72 "../src/data/sources/gog/GOGGame.vala"
	return self ? json_array_ref (self) : NULL;
#line 2451 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGame*
game_hub_data_sources_gog_gog_game_construct (GType object_type,
                                              GameHubDataSourcesGOGGOG* src,
                                              JsonNode* json_node)
{
	GameHubDataSourcesGOGGOGGame * self = NULL;
	JsonObject* json_obj = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonObject* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	JsonObject* _tmp5_;
	const gchar* _tmp6_;
	JsonObject* _tmp7_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	JsonObject* _tmp16_ = NULL;
	gboolean _tmp17_ = FALSE;
	JsonObject* _tmp18_;
	JsonObject* worksOn = NULL;
	JsonObject* _tmp22_;
	gboolean _tmp23_ = FALSE;
	JsonObject* _tmp24_;
	gboolean _tmp28_ = FALSE;
	JsonObject* _tmp29_;
	gboolean _tmp33_ = FALSE;
	JsonObject* _tmp34_;
	JsonArray* _tmp38_ = NULL;
	JsonObject* _tmp39_;
	JsonArray* tags_json = NULL;
	JsonArray* _tmp42_;
	JsonArray* _tmp43_;
	gboolean _tmp74_ = FALSE;
	JsonObject* _tmp75_;
	gchar* _tmp77_;
	gchar* _tmp78_;
#line 50 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 50 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (json_node != NULL, NULL);
#line 50 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) game_hub_data_game_construct (object_type);
#line 52 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_source ((GameHubDataGame*) self, (GameHubDataGameSource*) src);
#line 54 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = json_node_get_object (json_node);
#line 54 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _json_object_ref0 (_tmp0_);
#line 54 "../src/data/sources/gog/GOGGame.vala"
	json_obj = _tmp1_;
#line 56 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = json_obj;
#line 56 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = g_strdup_printf ("%" G_GINT64_FORMAT, json_object_get_int_member (_tmp2_, "id"));
#line 56 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = _tmp3_;
#line 56 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp4_);
#line 56 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp4_);
#line 57 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = json_obj;
#line 57 "../src/data/sources/gog/GOGGame.vala"
	_tmp6_ = json_object_get_string_member (_tmp5_, "title");
#line 57 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, _tmp6_);
#line 58 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_icon ((GameHubDataGame*) self, "");
#line 60 "../src/data/sources/gog/GOGGame.vala"
	_tmp7_ = json_obj;
#line 60 "../src/data/sources/gog/GOGGame.vala"
	if (json_object_has_member (_tmp7_, "image")) {
#line 2527 "GOGGame.c"
		JsonObject* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_tmp8_ = json_obj;
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_tmp9_ = json_object_get_string_member (_tmp8_, "image");
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_tmp10_ = g_strconcat ("https:", _tmp9_, NULL);
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_tmp11_ = _tmp10_;
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_tmp12_ = g_strconcat (_tmp11_, "_392.jpg", NULL);
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_tmp13_ = _tmp12_;
#line 62 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_set_image ((GameHubDataGame*) self, _tmp13_);
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp13_);
#line 62 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp11_);
#line 2552 "GOGGame.c"
	}
#line 65 "../src/data/sources/gog/GOGGame.vala"
	_tmp14_ = json_to_string (json_node, FALSE);
#line 65 "../src/data/sources/gog/GOGGame.vala"
	_tmp15_ = _tmp14_;
#line 65 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_info ((GameHubDataGame*) self, _tmp15_);
#line 65 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp15_);
#line 67 "../src/data/sources/gog/GOGGame.vala"
	_tmp18_ = json_obj;
#line 67 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp18_ != NULL) {
#line 2566 "GOGGame.c"
		JsonObject* _tmp19_;
#line 67 "../src/data/sources/gog/GOGGame.vala"
		_tmp19_ = json_obj;
#line 67 "../src/data/sources/gog/GOGGame.vala"
		_tmp17_ = json_object_has_member (_tmp19_, "worksOn");
#line 2572 "GOGGame.c"
	} else {
#line 67 "../src/data/sources/gog/GOGGame.vala"
		_tmp17_ = FALSE;
#line 2576 "GOGGame.c"
	}
#line 67 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp17_) {
#line 2580 "GOGGame.c"
		JsonObject* _tmp20_;
		JsonObject* _tmp21_;
#line 67 "../src/data/sources/gog/GOGGame.vala"
		_tmp20_ = json_obj;
#line 67 "../src/data/sources/gog/GOGGame.vala"
		_tmp21_ = json_object_get_object_member (_tmp20_, "worksOn");
#line 67 "../src/data/sources/gog/GOGGame.vala"
		_tmp16_ = _tmp21_;
#line 2589 "GOGGame.c"
	} else {
#line 67 "../src/data/sources/gog/GOGGame.vala"
		_tmp16_ = NULL;
#line 2593 "GOGGame.c"
	}
#line 67 "../src/data/sources/gog/GOGGame.vala"
	_tmp22_ = _json_object_ref0 (_tmp16_);
#line 67 "../src/data/sources/gog/GOGGame.vala"
	worksOn = _tmp22_;
#line 68 "../src/data/sources/gog/GOGGame.vala"
	_tmp24_ = worksOn;
#line 68 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp24_ != NULL) {
#line 2603 "GOGGame.c"
		JsonObject* _tmp25_;
#line 68 "../src/data/sources/gog/GOGGame.vala"
		_tmp25_ = worksOn;
#line 68 "../src/data/sources/gog/GOGGame.vala"
		_tmp23_ = json_object_get_boolean_member (_tmp25_, "Linux");
#line 2609 "GOGGame.c"
	} else {
#line 68 "../src/data/sources/gog/GOGGame.vala"
		_tmp23_ = FALSE;
#line 2613 "GOGGame.c"
	}
#line 68 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp23_) {
#line 2617 "GOGGame.c"
		GeeArrayList* _tmp26_;
		GeeArrayList* _tmp27_;
#line 68 "../src/data/sources/gog/GOGGame.vala"
		_tmp26_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 68 "../src/data/sources/gog/GOGGame.vala"
		_tmp27_ = _tmp26_;
#line 68 "../src/data/sources/gog/GOGGame.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, (gpointer) ((gintptr) GAME_HUB_DATA_PLATFORM_LINUX));
#line 2626 "GOGGame.c"
	}
#line 69 "../src/data/sources/gog/GOGGame.vala"
	_tmp29_ = worksOn;
#line 69 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp29_ != NULL) {
#line 2632 "GOGGame.c"
		JsonObject* _tmp30_;
#line 69 "../src/data/sources/gog/GOGGame.vala"
		_tmp30_ = worksOn;
#line 69 "../src/data/sources/gog/GOGGame.vala"
		_tmp28_ = json_object_get_boolean_member (_tmp30_, "Windows");
#line 2638 "GOGGame.c"
	} else {
#line 69 "../src/data/sources/gog/GOGGame.vala"
		_tmp28_ = FALSE;
#line 2642 "GOGGame.c"
	}
#line 69 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp28_) {
#line 2646 "GOGGame.c"
		GeeArrayList* _tmp31_;
		GeeArrayList* _tmp32_;
#line 69 "../src/data/sources/gog/GOGGame.vala"
		_tmp31_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 69 "../src/data/sources/gog/GOGGame.vala"
		_tmp32_ = _tmp31_;
#line 69 "../src/data/sources/gog/GOGGame.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, (gpointer) ((gintptr) GAME_HUB_DATA_PLATFORM_WINDOWS));
#line 2655 "GOGGame.c"
	}
#line 70 "../src/data/sources/gog/GOGGame.vala"
	_tmp34_ = worksOn;
#line 70 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp34_ != NULL) {
#line 2661 "GOGGame.c"
		JsonObject* _tmp35_;
#line 70 "../src/data/sources/gog/GOGGame.vala"
		_tmp35_ = worksOn;
#line 70 "../src/data/sources/gog/GOGGame.vala"
		_tmp33_ = json_object_get_boolean_member (_tmp35_, "Mac");
#line 2667 "GOGGame.c"
	} else {
#line 70 "../src/data/sources/gog/GOGGame.vala"
		_tmp33_ = FALSE;
#line 2671 "GOGGame.c"
	}
#line 70 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp33_) {
#line 2675 "GOGGame.c"
		GeeArrayList* _tmp36_;
		GeeArrayList* _tmp37_;
#line 70 "../src/data/sources/gog/GOGGame.vala"
		_tmp36_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 70 "../src/data/sources/gog/GOGGame.vala"
		_tmp37_ = _tmp36_;
#line 70 "../src/data/sources/gog/GOGGame.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp37_, (gpointer) ((gintptr) GAME_HUB_DATA_PLATFORM_MACOS));
#line 2684 "GOGGame.c"
	}
#line 72 "../src/data/sources/gog/GOGGame.vala"
	_tmp39_ = json_obj;
#line 72 "../src/data/sources/gog/GOGGame.vala"
	if (!json_object_has_member (_tmp39_, "tags")) {
#line 72 "../src/data/sources/gog/GOGGame.vala"
		_tmp38_ = NULL;
#line 2692 "GOGGame.c"
	} else {
		JsonObject* _tmp40_;
		JsonArray* _tmp41_;
#line 72 "../src/data/sources/gog/GOGGame.vala"
		_tmp40_ = json_obj;
#line 72 "../src/data/sources/gog/GOGGame.vala"
		_tmp41_ = json_object_get_array_member (_tmp40_, "tags");
#line 72 "../src/data/sources/gog/GOGGame.vala"
		_tmp38_ = _tmp41_;
#line 2702 "GOGGame.c"
	}
#line 72 "../src/data/sources/gog/GOGGame.vala"
	_tmp42_ = _json_array_ref0 (_tmp38_);
#line 72 "../src/data/sources/gog/GOGGame.vala"
	tags_json = _tmp42_;
#line 73 "../src/data/sources/gog/GOGGame.vala"
	_tmp43_ = tags_json;
#line 73 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp43_ != NULL) {
#line 2712 "GOGGame.c"
		JsonArray* _tmp44_;
		GList* _tmp45_;
#line 75 "../src/data/sources/gog/GOGGame.vala"
		_tmp44_ = tags_json;
#line 75 "../src/data/sources/gog/GOGGame.vala"
		_tmp45_ = json_array_get_elements (_tmp44_);
#line 2719 "GOGGame.c"
		{
			GList* tag_json_collection = NULL;
			GList* tag_json_it = NULL;
#line 75 "../src/data/sources/gog/GOGGame.vala"
			tag_json_collection = _tmp45_;
#line 75 "../src/data/sources/gog/GOGGame.vala"
			for (tag_json_it = tag_json_collection; tag_json_it != NULL; tag_json_it = tag_json_it->next) {
#line 2727 "GOGGame.c"
				JsonNode* tag_json = NULL;
#line 75 "../src/data/sources/gog/GOGGame.vala"
				tag_json = (JsonNode*) tag_json_it->data;
#line 2731 "GOGGame.c"
				{
					gchar* tid = NULL;
					GameHubDataGameSource* _tmp46_;
					GameHubDataGameSource* _tmp47_;
					const gchar* _tmp48_;
					const gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
					JsonNode* _tmp52_;
					const gchar* _tmp53_;
					gchar* _tmp54_;
					gchar* _tmp55_;
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp46_ = game_hub_data_game_get_source ((GameHubDataGame*) self);
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp47_ = _tmp46_;
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp48_ = game_hub_data_game_source_get_id (_tmp47_);
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp49_ = _tmp48_;
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp50_ = g_strconcat (_tmp49_, ":", NULL);
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp51_ = _tmp50_;
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp52_ = tag_json;
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp53_ = json_node_get_string (_tmp52_);
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp54_ = g_strconcat (_tmp51_, _tmp53_, NULL);
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_tmp55_ = _tmp54_;
#line 77 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_tmp51_);
#line 77 "../src/data/sources/gog/GOGGame.vala"
					tid = _tmp55_;
#line 2768 "GOGGame.c"
					{
						GeeArrayList* _t_list = NULL;
						GeeArrayList* _tmp56_;
						gint _t_size = 0;
						GeeArrayList* _tmp57_;
						gint _tmp58_;
						gint _tmp59_;
						gint _t_index = 0;
#line 78 "../src/data/sources/gog/GOGGame.vala"
						_tmp56_ = game_hub_data_db_tables_tags_TAGS;
#line 78 "../src/data/sources/gog/GOGGame.vala"
						_t_list = _tmp56_;
#line 78 "../src/data/sources/gog/GOGGame.vala"
						_tmp57_ = _t_list;
#line 78 "../src/data/sources/gog/GOGGame.vala"
						_tmp58_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp57_);
#line 78 "../src/data/sources/gog/GOGGame.vala"
						_tmp59_ = _tmp58_;
#line 78 "../src/data/sources/gog/GOGGame.vala"
						_t_size = _tmp59_;
#line 78 "../src/data/sources/gog/GOGGame.vala"
						_t_index = -1;
#line 78 "../src/data/sources/gog/GOGGame.vala"
						while (TRUE) {
#line 2793 "GOGGame.c"
							gint _tmp60_;
							gint _tmp61_;
							GameHubDataDBTablesTagsTag* t = NULL;
							GeeArrayList* _tmp62_;
							gpointer _tmp63_;
							const gchar* _tmp64_;
							GameHubDataDBTablesTagsTag* _tmp65_;
							const gchar* _tmp66_;
							const gchar* _tmp67_;
#line 78 "../src/data/sources/gog/GOGGame.vala"
							_t_index = _t_index + 1;
#line 78 "../src/data/sources/gog/GOGGame.vala"
							_tmp60_ = _t_index;
#line 78 "../src/data/sources/gog/GOGGame.vala"
							_tmp61_ = _t_size;
#line 78 "../src/data/sources/gog/GOGGame.vala"
							if (!(_tmp60_ < _tmp61_)) {
#line 78 "../src/data/sources/gog/GOGGame.vala"
								break;
#line 2813 "GOGGame.c"
							}
#line 78 "../src/data/sources/gog/GOGGame.vala"
							_tmp62_ = _t_list;
#line 78 "../src/data/sources/gog/GOGGame.vala"
							_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) _tmp62_, _t_index);
#line 78 "../src/data/sources/gog/GOGGame.vala"
							t = (GameHubDataDBTablesTagsTag*) _tmp63_;
#line 80 "../src/data/sources/gog/GOGGame.vala"
							_tmp64_ = tid;
#line 80 "../src/data/sources/gog/GOGGame.vala"
							_tmp65_ = t;
#line 80 "../src/data/sources/gog/GOGGame.vala"
							_tmp66_ = game_hub_data_db_tables_tags_tag_get_id (_tmp65_);
#line 80 "../src/data/sources/gog/GOGGame.vala"
							_tmp67_ = _tmp66_;
#line 80 "../src/data/sources/gog/GOGGame.vala"
							if (g_strcmp0 (_tmp64_, _tmp67_) == 0) {
#line 2831 "GOGGame.c"
								GeeArrayList* _tmp68_;
								GeeArrayList* _tmp69_;
								GameHubDataDBTablesTagsTag* _tmp70_;
#line 82 "../src/data/sources/gog/GOGGame.vala"
								_tmp68_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 82 "../src/data/sources/gog/GOGGame.vala"
								_tmp69_ = _tmp68_;
#line 82 "../src/data/sources/gog/GOGGame.vala"
								_tmp70_ = t;
#line 82 "../src/data/sources/gog/GOGGame.vala"
								if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp69_, _tmp70_)) {
#line 2843 "GOGGame.c"
									GeeArrayList* _tmp71_;
									GeeArrayList* _tmp72_;
									GameHubDataDBTablesTagsTag* _tmp73_;
#line 82 "../src/data/sources/gog/GOGGame.vala"
									_tmp71_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 82 "../src/data/sources/gog/GOGGame.vala"
									_tmp72_ = _tmp71_;
#line 82 "../src/data/sources/gog/GOGGame.vala"
									_tmp73_ = t;
#line 82 "../src/data/sources/gog/GOGGame.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp72_, _tmp73_);
#line 2855 "GOGGame.c"
								}
#line 83 "../src/data/sources/gog/GOGGame.vala"
								_g_object_unref0 (t);
#line 83 "../src/data/sources/gog/GOGGame.vala"
								break;
#line 2861 "GOGGame.c"
							}
#line 78 "../src/data/sources/gog/GOGGame.vala"
							_g_object_unref0 (t);
#line 2865 "GOGGame.c"
						}
					}
#line 75 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (tid);
#line 2870 "GOGGame.c"
				}
			}
#line 75 "../src/data/sources/gog/GOGGame.vala"
			(tag_json_collection == NULL) ? NULL : (tag_json_collection = (g_list_free (tag_json_collection), NULL));
#line 2875 "GOGGame.c"
		}
	}
#line 89 "../src/data/sources/gog/GOGGame.vala"
	_tmp75_ = json_obj;
#line 89 "../src/data/sources/gog/GOGGame.vala"
	if (json_object_has_member (_tmp75_, "updates")) {
#line 2882 "GOGGame.c"
		JsonObject* _tmp76_;
#line 89 "../src/data/sources/gog/GOGGame.vala"
		_tmp76_ = json_obj;
#line 89 "../src/data/sources/gog/GOGGame.vala"
		_tmp74_ = json_object_get_int_member (_tmp76_, "updates") > ((gint64) 0);
#line 2888 "GOGGame.c"
	} else {
#line 89 "../src/data/sources/gog/GOGGame.vala"
		_tmp74_ = FALSE;
#line 2892 "GOGGame.c"
	}
#line 89 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_set_has_updates (self, _tmp74_);
#line 91 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, NULL);
#line 92 "../src/data/sources/gog/GOGGame.vala"
	_tmp77_ = g_strdup ("$game_dir/start.sh");
#line 92 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (((GameHubDataGame*) self)->executable_path);
#line 92 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGame*) self)->executable_path = _tmp77_;
#line 93 "../src/data/sources/gog/GOGGame.vala"
	_tmp78_ = g_strdup ("$game_dir");
#line 93 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (((GameHubDataGame*) self)->work_dir_path);
#line 93 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGame*) self)->work_dir_path = _tmp78_;
#line 95 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) self, NULL, NULL, NULL);
#line 96 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 50 "../src/data/sources/gog/GOGGame.vala"
	_json_array_unref0 (tags_json);
#line 50 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (worksOn);
#line 50 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (json_obj);
#line 50 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 2922 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGame*
game_hub_data_sources_gog_gog_game_new (GameHubDataSourcesGOGGOG* src,
                                        JsonNode* json_node)
{
#line 50 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_construct (GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, src, json_node);
#line 2931 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGame*
game_hub_data_sources_gog_gog_game_construct_from_db (GType object_type,
                                                      GameHubDataSourcesGOGGOG* src,
                                                      sqlite3_stmt* s)
{
	GameHubDataSourcesGOGGOGGame * self = NULL;
	GameHubDataDBTableField* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GameHubDataDBTableField* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GameHubDataDBTableField* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GameHubDataDBTableField* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GameHubDataDBTableField* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GameHubDataDBTableField* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GFile* _tmp18_ = NULL;
	GameHubDataDBTableField* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gboolean _tmp22_;
	GameHubDataDBTableField* _tmp27_;
	gchar* _tmp28_;
	GameHubDataDBTableField* _tmp29_;
	gchar* _tmp30_;
	GameHubDataDBTableField* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GameHubDataDBTableField* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GameHubDataDBTableField* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	GameHubDataDBTableField* _tmp40_;
	GameHubDataDBTableField* _tmp41_;
	GameHubDataDBTableField* _tmp42_;
	GameHubDataDBTableField* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GeeArrayList* _tmp46_;
	GeeArrayList* _tmp47_;
	gchar** pls = NULL;
	GameHubDataDBTableField* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar** _tmp51_;
	gchar** _tmp52_;
	gchar** _tmp53_;
	gint _tmp53__length1;
	gint pls_length1;
	gint _pls_size_;
	gchar** _tmp54_;
	gint _tmp54__length1;
	GeeArrayList* _tmp62_;
	GeeArrayList* _tmp63_;
	gchar* _tmp64_ = NULL;
	GameHubDataDBTableField* _tmp65_;
	gchar* _tmp66_;
	gchar** tag_ids = NULL;
	gchar** _tmp68_;
	gchar** _tmp69_;
	gint tag_ids_length1;
	gint _tag_ids_size_;
	gchar** _tmp70_;
	gint _tmp70__length1;
	gchar* tweaks_string = NULL;
	GameHubDataDBTableField* _tmp90_;
	gchar* _tmp91_;
	const gchar* _tmp92_;
#line 99 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) game_hub_data_game_construct (object_type);
#line 101 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_source ((GameHubDataGame*) self, (GameHubDataGameSource*) src);
#line 102 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = game_hub_data_db_tables_games_ID;
#line 102 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = game_hub_data_db_table_field_get (_tmp0_, s);
#line 102 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = _tmp1_;
#line 102 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_id ((GameHubDataRunnable*) self, _tmp2_);
#line 102 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp2_);
#line 103 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = game_hub_data_db_tables_games_NAME;
#line 103 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = game_hub_data_db_table_field_get (_tmp3_, s);
#line 103 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = _tmp4_;
#line 103 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_name ((GameHubDataRunnable*) self, _tmp5_);
#line 103 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp5_);
#line 104 "../src/data/sources/gog/GOGGame.vala"
	_tmp6_ = game_hub_data_db_tables_games_INFO;
#line 104 "../src/data/sources/gog/GOGGame.vala"
	_tmp7_ = game_hub_data_db_table_field_get (_tmp6_, s);
#line 104 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = _tmp7_;
#line 104 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_info ((GameHubDataGame*) self, _tmp8_);
#line 104 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp8_);
#line 105 "../src/data/sources/gog/GOGGame.vala"
	_tmp9_ = game_hub_data_db_tables_games_INFO_DETAILED;
#line 105 "../src/data/sources/gog/GOGGame.vala"
	_tmp10_ = game_hub_data_db_table_field_get (_tmp9_, s);
#line 105 "../src/data/sources/gog/GOGGame.vala"
	_tmp11_ = _tmp10_;
#line 105 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_info_detailed ((GameHubDataGame*) self, _tmp11_);
#line 105 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp11_);
#line 106 "../src/data/sources/gog/GOGGame.vala"
	_tmp12_ = game_hub_data_db_tables_games_ICON;
#line 106 "../src/data/sources/gog/GOGGame.vala"
	_tmp13_ = game_hub_data_db_table_field_get (_tmp12_, s);
#line 106 "../src/data/sources/gog/GOGGame.vala"
	_tmp14_ = _tmp13_;
#line 106 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_icon ((GameHubDataGame*) self, _tmp14_);
#line 106 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp14_);
#line 107 "../src/data/sources/gog/GOGGame.vala"
	_tmp15_ = game_hub_data_db_tables_games_IMAGE;
#line 107 "../src/data/sources/gog/GOGGame.vala"
	_tmp16_ = game_hub_data_db_table_field_get (_tmp15_, s);
#line 107 "../src/data/sources/gog/GOGGame.vala"
	_tmp17_ = _tmp16_;
#line 107 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_image ((GameHubDataGame*) self, _tmp17_);
#line 107 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp17_);
#line 108 "../src/data/sources/gog/GOGGame.vala"
	_tmp19_ = game_hub_data_db_tables_games_INSTALL_PATH;
#line 108 "../src/data/sources/gog/GOGGame.vala"
	_tmp20_ = game_hub_data_db_table_field_get (_tmp19_, s);
#line 108 "../src/data/sources/gog/GOGGame.vala"
	_tmp21_ = _tmp20_;
#line 108 "../src/data/sources/gog/GOGGame.vala"
	_tmp22_ = _tmp21_ != NULL;
#line 108 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp21_);
#line 108 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp22_) {
#line 3092 "GOGGame.c"
		GameHubDataDBTableField* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GFile* _tmp26_;
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_tmp23_ = game_hub_data_db_tables_games_INSTALL_PATH;
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_tmp24_ = game_hub_data_db_table_field_get (_tmp23_, s);
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_tmp25_ = _tmp24_;
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_tmp26_ = game_hub_utils_fs_utils_file (_tmp25_, NULL, NULL);
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp18_);
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_tmp18_ = _tmp26_;
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp25_);
#line 3111 "GOGGame.c"
	} else {
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp18_);
#line 108 "../src/data/sources/gog/GOGGame.vala"
		_tmp18_ = NULL;
#line 3117 "GOGGame.c"
	}
#line 108 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, _tmp18_);
#line 109 "../src/data/sources/gog/GOGGame.vala"
	_tmp27_ = game_hub_data_db_tables_games_EXECUTABLE;
#line 109 "../src/data/sources/gog/GOGGame.vala"
	_tmp28_ = game_hub_data_db_table_field_get (_tmp27_, s);
#line 109 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (((GameHubDataGame*) self)->executable_path);
#line 109 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGame*) self)->executable_path = _tmp28_;
#line 110 "../src/data/sources/gog/GOGGame.vala"
	_tmp29_ = game_hub_data_db_tables_games_WORK_DIR;
#line 110 "../src/data/sources/gog/GOGGame.vala"
	_tmp30_ = game_hub_data_db_table_field_get (_tmp29_, s);
#line 110 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (((GameHubDataGame*) self)->work_dir_path);
#line 110 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGame*) self)->work_dir_path = _tmp30_;
#line 111 "../src/data/sources/gog/GOGGame.vala"
	_tmp31_ = game_hub_data_db_tables_games_COMPAT_TOOL;
#line 111 "../src/data/sources/gog/GOGGame.vala"
	_tmp32_ = game_hub_data_db_table_field_get (_tmp31_, s);
#line 111 "../src/data/sources/gog/GOGGame.vala"
	_tmp33_ = _tmp32_;
#line 111 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_compat_tool ((GameHubDataRunnable*) self, _tmp33_);
#line 111 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp33_);
#line 112 "../src/data/sources/gog/GOGGame.vala"
	_tmp34_ = game_hub_data_db_tables_games_COMPAT_TOOL_SETTINGS;
#line 112 "../src/data/sources/gog/GOGGame.vala"
	_tmp35_ = game_hub_data_db_table_field_get (_tmp34_, s);
#line 112 "../src/data/sources/gog/GOGGame.vala"
	_tmp36_ = _tmp35_;
#line 112 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_compat_tool_settings ((GameHubDataRunnable*) self, _tmp36_);
#line 112 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp36_);
#line 113 "../src/data/sources/gog/GOGGame.vala"
	_tmp37_ = game_hub_data_db_tables_games_ARGUMENTS;
#line 113 "../src/data/sources/gog/GOGGame.vala"
	_tmp38_ = game_hub_data_db_table_field_get (_tmp37_, s);
#line 113 "../src/data/sources/gog/GOGGame.vala"
	_tmp39_ = _tmp38_;
#line 113 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_arguments ((GameHubDataRunnable*) self, _tmp39_);
#line 113 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp39_);
#line 114 "../src/data/sources/gog/GOGGame.vala"
	_tmp40_ = game_hub_data_db_tables_games_LAST_LAUNCH;
#line 114 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_last_launch ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp40_, s));
#line 115 "../src/data/sources/gog/GOGGame.vala"
	_tmp41_ = game_hub_data_db_tables_games_PLAYTIME_SOURCE;
#line 115 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_playtime_source ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp41_, s));
#line 116 "../src/data/sources/gog/GOGGame.vala"
	_tmp42_ = game_hub_data_db_tables_games_PLAYTIME_TRACKED;
#line 116 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_playtime_tracked ((GameHubDataGame*) self, game_hub_data_db_table_field_get_int64 (_tmp42_, s));
#line 117 "../src/data/sources/gog/GOGGame.vala"
	_tmp43_ = game_hub_data_db_tables_games_IMAGE_VERTICAL;
#line 117 "../src/data/sources/gog/GOGGame.vala"
	_tmp44_ = game_hub_data_db_table_field_get (_tmp43_, s);
#line 117 "../src/data/sources/gog/GOGGame.vala"
	_tmp45_ = _tmp44_;
#line 117 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_image_vertical ((GameHubDataGame*) self, _tmp45_);
#line 117 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp45_);
#line 119 "../src/data/sources/gog/GOGGame.vala"
	_tmp46_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 119 "../src/data/sources/gog/GOGGame.vala"
	_tmp47_ = _tmp46_;
#line 119 "../src/data/sources/gog/GOGGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp47_);
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_tmp48_ = game_hub_data_db_tables_games_PLATFORMS;
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_tmp49_ = game_hub_data_db_table_field_get (_tmp48_, s);
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_tmp50_ = _tmp49_;
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_tmp52_ = _tmp51_ = g_strsplit (_tmp50_, ",", 0);
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_tmp53_ = _tmp52_;
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_tmp53__length1 = _vala_array_length (_tmp51_);
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp50_);
#line 120 "../src/data/sources/gog/GOGGame.vala"
	pls = _tmp53_;
#line 120 "../src/data/sources/gog/GOGGame.vala"
	pls_length1 = _tmp53__length1;
#line 120 "../src/data/sources/gog/GOGGame.vala"
	_pls_size_ = pls_length1;
#line 121 "../src/data/sources/gog/GOGGame.vala"
	_tmp54_ = pls;
#line 121 "../src/data/sources/gog/GOGGame.vala"
	_tmp54__length1 = pls_length1;
#line 3219 "GOGGame.c"
	{
		gchar** pl_collection = NULL;
		gint pl_collection_length1 = 0;
		gint _pl_collection_size_ = 0;
		gint pl_it = 0;
#line 121 "../src/data/sources/gog/GOGGame.vala"
		pl_collection = _tmp54_;
#line 121 "../src/data/sources/gog/GOGGame.vala"
		pl_collection_length1 = _tmp54__length1;
#line 121 "../src/data/sources/gog/GOGGame.vala"
		for (pl_it = 0; pl_it < pl_collection_length1; pl_it = pl_it + 1) {
#line 3231 "GOGGame.c"
			gchar* _tmp55_;
			gchar* pl = NULL;
#line 121 "../src/data/sources/gog/GOGGame.vala"
			_tmp55_ = g_strdup (pl_collection[pl_it]);
#line 121 "../src/data/sources/gog/GOGGame.vala"
			pl = _tmp55_;
#line 3238 "GOGGame.c"
			{
				{
					GameHubDataPlatform* p_collection = NULL;
					gint p_collection_length1 = 0;
					gint _p_collection_size_ = 0;
					gint p_it = 0;
#line 123 "../src/data/sources/gog/GOGGame.vala"
					p_collection = GAME_HUB_DATA_PLATFORM_PLATFORMS;
#line 123 "../src/data/sources/gog/GOGGame.vala"
					p_collection_length1 = G_N_ELEMENTS (GAME_HUB_DATA_PLATFORM_PLATFORMS);
#line 123 "../src/data/sources/gog/GOGGame.vala"
					for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 3251 "GOGGame.c"
						GameHubDataPlatform p = 0;
#line 123 "../src/data/sources/gog/GOGGame.vala"
						p = p_collection[p_it];
#line 3255 "GOGGame.c"
						{
							const gchar* _tmp56_;
							gchar* _tmp57_;
							gchar* _tmp58_;
							gboolean _tmp59_;
#line 125 "../src/data/sources/gog/GOGGame.vala"
							_tmp56_ = pl;
#line 125 "../src/data/sources/gog/GOGGame.vala"
							_tmp57_ = game_hub_data_platform_id (p);
#line 125 "../src/data/sources/gog/GOGGame.vala"
							_tmp58_ = _tmp57_;
#line 125 "../src/data/sources/gog/GOGGame.vala"
							_tmp59_ = g_strcmp0 (_tmp56_, _tmp58_) == 0;
#line 125 "../src/data/sources/gog/GOGGame.vala"
							_g_free0 (_tmp58_);
#line 125 "../src/data/sources/gog/GOGGame.vala"
							if (_tmp59_) {
#line 3273 "GOGGame.c"
								GeeArrayList* _tmp60_;
								GeeArrayList* _tmp61_;
#line 127 "../src/data/sources/gog/GOGGame.vala"
								_tmp60_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) self);
#line 127 "../src/data/sources/gog/GOGGame.vala"
								_tmp61_ = _tmp60_;
#line 127 "../src/data/sources/gog/GOGGame.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, (gpointer) ((gintptr) p));
#line 128 "../src/data/sources/gog/GOGGame.vala"
								break;
#line 3284 "GOGGame.c"
							}
						}
					}
				}
#line 121 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (pl);
#line 3291 "GOGGame.c"
			}
		}
	}
#line 133 "../src/data/sources/gog/GOGGame.vala"
	_tmp62_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 133 "../src/data/sources/gog/GOGGame.vala"
	_tmp63_ = _tmp62_;
#line 133 "../src/data/sources/gog/GOGGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp63_);
#line 134 "../src/data/sources/gog/GOGGame.vala"
	_tmp65_ = game_hub_data_db_tables_games_TAGS;
#line 134 "../src/data/sources/gog/GOGGame.vala"
	_tmp66_ = game_hub_data_db_table_field_get (_tmp65_, s);
#line 134 "../src/data/sources/gog/GOGGame.vala"
	_tmp64_ = _tmp66_;
#line 134 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp64_ == NULL) {
#line 3309 "GOGGame.c"
		gchar* _tmp67_;
#line 134 "../src/data/sources/gog/GOGGame.vala"
		_tmp67_ = g_strdup ("");
#line 134 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp64_);
#line 134 "../src/data/sources/gog/GOGGame.vala"
		_tmp64_ = _tmp67_;
#line 3317 "GOGGame.c"
	}
#line 134 "../src/data/sources/gog/GOGGame.vala"
	_tmp69_ = _tmp68_ = g_strsplit (_tmp64_, ",", 0);
#line 134 "../src/data/sources/gog/GOGGame.vala"
	tag_ids = _tmp69_;
#line 134 "../src/data/sources/gog/GOGGame.vala"
	tag_ids_length1 = _vala_array_length (_tmp68_);
#line 134 "../src/data/sources/gog/GOGGame.vala"
	_tag_ids_size_ = tag_ids_length1;
#line 135 "../src/data/sources/gog/GOGGame.vala"
	_tmp70_ = tag_ids;
#line 135 "../src/data/sources/gog/GOGGame.vala"
	_tmp70__length1 = tag_ids_length1;
#line 3331 "GOGGame.c"
	{
		gchar** tid_collection = NULL;
		gint tid_collection_length1 = 0;
		gint _tid_collection_size_ = 0;
		gint tid_it = 0;
#line 135 "../src/data/sources/gog/GOGGame.vala"
		tid_collection = _tmp70_;
#line 135 "../src/data/sources/gog/GOGGame.vala"
		tid_collection_length1 = _tmp70__length1;
#line 135 "../src/data/sources/gog/GOGGame.vala"
		for (tid_it = 0; tid_it < tid_collection_length1; tid_it = tid_it + 1) {
#line 3343 "GOGGame.c"
			gchar* _tmp71_;
			gchar* tid = NULL;
#line 135 "../src/data/sources/gog/GOGGame.vala"
			_tmp71_ = g_strdup (tid_collection[tid_it]);
#line 135 "../src/data/sources/gog/GOGGame.vala"
			tid = _tmp71_;
#line 3350 "GOGGame.c"
			{
				{
					GeeArrayList* _t_list = NULL;
					GeeArrayList* _tmp72_;
					gint _t_size = 0;
					GeeArrayList* _tmp73_;
					gint _tmp74_;
					gint _tmp75_;
					gint _t_index = 0;
#line 137 "../src/data/sources/gog/GOGGame.vala"
					_tmp72_ = game_hub_data_db_tables_tags_TAGS;
#line 137 "../src/data/sources/gog/GOGGame.vala"
					_t_list = _tmp72_;
#line 137 "../src/data/sources/gog/GOGGame.vala"
					_tmp73_ = _t_list;
#line 137 "../src/data/sources/gog/GOGGame.vala"
					_tmp74_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp73_);
#line 137 "../src/data/sources/gog/GOGGame.vala"
					_tmp75_ = _tmp74_;
#line 137 "../src/data/sources/gog/GOGGame.vala"
					_t_size = _tmp75_;
#line 137 "../src/data/sources/gog/GOGGame.vala"
					_t_index = -1;
#line 137 "../src/data/sources/gog/GOGGame.vala"
					while (TRUE) {
#line 3376 "GOGGame.c"
						gint _tmp76_;
						gint _tmp77_;
						GameHubDataDBTablesTagsTag* t = NULL;
						GeeArrayList* _tmp78_;
						gpointer _tmp79_;
						const gchar* _tmp80_;
						GameHubDataDBTablesTagsTag* _tmp81_;
						const gchar* _tmp82_;
						const gchar* _tmp83_;
#line 137 "../src/data/sources/gog/GOGGame.vala"
						_t_index = _t_index + 1;
#line 137 "../src/data/sources/gog/GOGGame.vala"
						_tmp76_ = _t_index;
#line 137 "../src/data/sources/gog/GOGGame.vala"
						_tmp77_ = _t_size;
#line 137 "../src/data/sources/gog/GOGGame.vala"
						if (!(_tmp76_ < _tmp77_)) {
#line 137 "../src/data/sources/gog/GOGGame.vala"
							break;
#line 3396 "GOGGame.c"
						}
#line 137 "../src/data/sources/gog/GOGGame.vala"
						_tmp78_ = _t_list;
#line 137 "../src/data/sources/gog/GOGGame.vala"
						_tmp79_ = gee_abstract_list_get ((GeeAbstractList*) _tmp78_, _t_index);
#line 137 "../src/data/sources/gog/GOGGame.vala"
						t = (GameHubDataDBTablesTagsTag*) _tmp79_;
#line 139 "../src/data/sources/gog/GOGGame.vala"
						_tmp80_ = tid;
#line 139 "../src/data/sources/gog/GOGGame.vala"
						_tmp81_ = t;
#line 139 "../src/data/sources/gog/GOGGame.vala"
						_tmp82_ = game_hub_data_db_tables_tags_tag_get_id (_tmp81_);
#line 139 "../src/data/sources/gog/GOGGame.vala"
						_tmp83_ = _tmp82_;
#line 139 "../src/data/sources/gog/GOGGame.vala"
						if (g_strcmp0 (_tmp80_, _tmp83_) == 0) {
#line 3414 "GOGGame.c"
							GeeArrayList* _tmp84_;
							GeeArrayList* _tmp85_;
							GameHubDataDBTablesTagsTag* _tmp86_;
#line 141 "../src/data/sources/gog/GOGGame.vala"
							_tmp84_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 141 "../src/data/sources/gog/GOGGame.vala"
							_tmp85_ = _tmp84_;
#line 141 "../src/data/sources/gog/GOGGame.vala"
							_tmp86_ = t;
#line 141 "../src/data/sources/gog/GOGGame.vala"
							if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp85_, _tmp86_)) {
#line 3426 "GOGGame.c"
								GeeArrayList* _tmp87_;
								GeeArrayList* _tmp88_;
								GameHubDataDBTablesTagsTag* _tmp89_;
#line 141 "../src/data/sources/gog/GOGGame.vala"
								_tmp87_ = game_hub_data_game_get_tags ((GameHubDataGame*) self);
#line 141 "../src/data/sources/gog/GOGGame.vala"
								_tmp88_ = _tmp87_;
#line 141 "../src/data/sources/gog/GOGGame.vala"
								_tmp89_ = t;
#line 141 "../src/data/sources/gog/GOGGame.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp88_, _tmp89_);
#line 3438 "GOGGame.c"
							}
#line 142 "../src/data/sources/gog/GOGGame.vala"
							_g_object_unref0 (t);
#line 142 "../src/data/sources/gog/GOGGame.vala"
							break;
#line 3444 "GOGGame.c"
						}
#line 137 "../src/data/sources/gog/GOGGame.vala"
						_g_object_unref0 (t);
#line 3448 "GOGGame.c"
					}
				}
#line 135 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (tid);
#line 3453 "GOGGame.c"
			}
		}
	}
#line 147 "../src/data/sources/gog/GOGGame.vala"
	_tmp90_ = game_hub_data_db_tables_games_TWEAKS;
#line 147 "../src/data/sources/gog/GOGGame.vala"
	_tmp91_ = game_hub_data_db_table_field_get (_tmp90_, s);
#line 147 "../src/data/sources/gog/GOGGame.vala"
	tweaks_string = _tmp91_;
#line 148 "../src/data/sources/gog/GOGGame.vala"
	_tmp92_ = tweaks_string;
#line 148 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp92_ != NULL) {
#line 3467 "GOGGame.c"
		const gchar* _tmp93_;
		gchar** _tmp94_;
		gchar** _tmp95_;
		gchar** _tmp96_;
		gint _tmp96__length1;
#line 150 "../src/data/sources/gog/GOGGame.vala"
		_tmp93_ = tweaks_string;
#line 150 "../src/data/sources/gog/GOGGame.vala"
		_tmp95_ = _tmp94_ = g_strsplit (_tmp93_, ",", 0);
#line 150 "../src/data/sources/gog/GOGGame.vala"
		_tmp96_ = _tmp95_;
#line 150 "../src/data/sources/gog/GOGGame.vala"
		_tmp96__length1 = _vala_array_length (_tmp94_);
#line 150 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_tweakable_game_set_tweaks ((GameHubDataTweakableGame*) self, _tmp96_, _vala_array_length (_tmp94_));
#line 150 "../src/data/sources/gog/GOGGame.vala"
		_tmp96_ = (_vala_array_free (_tmp96_, _tmp96__length1, (GDestroyNotify) g_free), NULL);
#line 3485 "GOGGame.c"
	}
#line 153 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) self, NULL, NULL, NULL);
#line 154 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (tweaks_string);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	tag_ids = (_vala_array_free (tag_ids, tag_ids_length1, (GDestroyNotify) g_free), NULL);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp64_);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	pls = (_vala_array_free (pls, pls_length1, (GDestroyNotify) g_free), NULL);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_tmp18_);
#line 99 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 3503 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGame*
game_hub_data_sources_gog_gog_game_new_from_db (GameHubDataSourcesGOGGOG* src,
                                                sqlite3_stmt* s)
{
#line 99 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_construct_from_db (GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, src, s);
#line 3512 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_update_game_info_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameUpdateGameInfoData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameUpdateGameInfoData, _data_);
#line 3524 "GOGGame.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 25 "../src/data/sources/gog/GOGGame.vala"
	return self ? g_object_ref (self) : NULL;
#line 3532 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_update_game_info (GameHubDataGame* base,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	GameHubDataSourcesGOGGOGGame * self;
	GameHubDataSourcesGogGogGameUpdateGameInfoData* _data_;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameUpdateGameInfoData);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_real_update_game_info_data_free);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_update_game_info_co (_data_);
#line 3557 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_update_game_info_finish (GameHubDataGame* base,
                                                            GAsyncResult* _res_)
{
	GameHubDataSourcesGogGogGameUpdateGameInfoData* _data_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3567 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_update_game_info_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameUpdateGameInfoData* _data_;
#line 162 "../src/data/sources/gog/GOGGame.vala"
	_data_ = _user_data_;
#line 162 "../src/data/sources/gog/GOGGame.vala"
	_data_->_source_object_ = source_object;
#line 162 "../src/data/sources/gog/GOGGame.vala"
	_data_->_res_ = _res_;
#line 162 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_update_game_info_co (_data_);
#line 3584 "GOGGame.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 3607 "GOGGame.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 3616 "GOGGame.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 3635 "GOGGame.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3639 "GOGGame.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 3645 "GOGGame.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 3655 "GOGGame.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 3663 "GOGGame.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 3667 "GOGGame.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 3673 "GOGGame.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 3683 "GOGGame.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1570 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1571 "glib-2.0.vapi"
	result = self;
#line 1571 "glib-2.0.vapi"
	return result;
#line 3696 "GOGGame.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 196 "../src/data/sources/gog/GOGGame.vala"
	g_boxed_free (json_node_get_type (), self);
#line 3704 "GOGGame.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 3725 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_real_update_game_info_co (GameHubDataSourcesGogGogGameUpdateGameInfoData* _data_)
{
#line 157 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 157 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 3735 "GOGGame.c"
		goto _state_0;
#line 157 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 3739 "GOGGame.c"
		goto _state_1;
#line 157 "../src/data/sources/gog/GOGGame.vala"
		case 2:
#line 3743 "GOGGame.c"
		goto _state_2;
#line 157 "../src/data/sources/gog/GOGGame.vala"
		case 3:
#line 3747 "GOGGame.c"
		goto _state_3;
#line 157 "../src/data/sources/gog/GOGGame.vala"
		case 4:
#line 3751 "GOGGame.c"
		goto _state_4;
		default:
#line 157 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 3756 "GOGGame.c"
	}
	_state_0:
#line 159 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->self->priv->game_info_updating) {
#line 159 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 159 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 159 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 159 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3769 "GOGGame.c"
			}
		}
#line 159 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 159 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 3776 "GOGGame.c"
	}
#line 160 "../src/data/sources/gog/GOGGame.vala"
	_data_->self->priv->game_info_updating = TRUE;
#line 162 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 1;
#line 162 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) _data_->self, NULL, game_hub_data_sources_gog_gog_game_update_game_info_ready, _data_);
#line 162 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 3786 "GOGGame.c"
	_state_1:
#line 162 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 163 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 165 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp1_ = game_hub_data_game_get_info_detailed ((GameHubDataGame*) _data_->self);
#line 165 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 165 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp2_ == NULL) {
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = TRUE;
#line 3800 "GOGGame.c"
	} else {
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp3_ = game_hub_data_game_get_info_detailed ((GameHubDataGame*) _data_->self);
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp5_ = strlen (_data_->_tmp4_);
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = _data_->_tmp6_ == 0;
#line 3812 "GOGGame.c"
	}
#line 165 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp0_) {
#line 167 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp7_ = setlocale (LC_ALL, NULL);
#line 167 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp8_ = g_utf8_strdown (_data_->_tmp7_, (gssize) -1);
#line 167 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 167 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp10_ = string_substring (_data_->_tmp9_, (glong) 0, (glong) 2);
#line 167 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 167 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->_tmp9_);
#line 167 "../src/data/sources/gog/GOGGame.vala"
		_data_->lang = _data_->_tmp11_;
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp14_ = _data_->lang;
#line 168 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp14_ != NULL) {
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp15_ = _data_->lang;
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp16_ = strlen (_data_->_tmp15_);
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp13_ = _data_->_tmp17_ > 0;
#line 3842 "GOGGame.c"
		} else {
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp13_ = FALSE;
#line 3846 "GOGGame.c"
		}
#line 168 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp13_) {
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp18_ = _data_->lang;
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp19_ = g_strconcat ("&locale=", _data_->_tmp18_, NULL);
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->_tmp12_);
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp12_ = _data_->_tmp19_;
#line 3858 "GOGGame.c"
		} else {
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp20_ = g_strdup ("");
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->_tmp12_);
#line 168 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp12_ = _data_->_tmp20_;
#line 3866 "GOGGame.c"
		}
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp21_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) _data_->self);
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp22_ = _data_->_tmp21_;
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp23_ = string_to_string (_data_->_tmp22_);
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp24_ = g_strconcat ("https://api.gog.com/products/", _data_->_tmp23_, "?expand=downloads,description,expanded_dlcs", NULL);
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp26_ = g_strconcat (_data_->_tmp25_, _data_->_tmp12_, NULL);
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp27_ = _data_->_tmp26_;
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->_tmp25_);
#line 168 "../src/data/sources/gog/GOGGame.vala"
		_data_->url = _data_->_tmp27_;
#line 170 "../src/data/sources/gog/GOGGame.vala"
		while (TRUE) {
#line 172 "../src/data/sources/gog/GOGGame.vala"
			_data_->status = (guint) 0;
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp28_ = _data_->url;
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp29_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp30_ = _data_->_tmp29_;
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp31_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp30_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG)->user_token;
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp32_ = 0U;
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->_state_ = 2;
#line 173 "../src/data/sources/gog/GOGGame.vala"
			game_hub_utils_parser_load_remote_file_async (_data_->_tmp28_, "GET", _data_->_tmp31_, NULL, NULL, game_hub_data_sources_gog_gog_game_update_game_info_ready, _data_);
#line 173 "../src/data/sources/gog/GOGGame.vala"
			return FALSE;
#line 3906 "GOGGame.c"
			_state_2:
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp33_ = game_hub_utils_parser_load_remote_file_finish (_data_->_res_, &_data_->_tmp32_);
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->status = _data_->_tmp32_;
#line 173 "../src/data/sources/gog/GOGGame.vala"
			_data_->json = _data_->_tmp33_;
#line 175 "../src/data/sources/gog/GOGGame.vala"
			if (_data_->status == ((guint) SOUP_STATUS_OK)) {
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp36_ = _data_->json;
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp35_ = _data_->_tmp36_ != NULL;
#line 3920 "GOGGame.c"
			} else {
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp35_ = FALSE;
#line 3924 "GOGGame.c"
			}
#line 175 "../src/data/sources/gog/GOGGame.vala"
			if (_data_->_tmp35_) {
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp37_ = _data_->json;
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp38_ = strlen (_data_->_tmp37_);
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp39_ = _data_->_tmp38_;
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp34_ = _data_->_tmp39_ > 0;
#line 3936 "GOGGame.c"
			} else {
#line 175 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp34_ = FALSE;
#line 3940 "GOGGame.c"
			}
#line 175 "../src/data/sources/gog/GOGGame.vala"
			if (_data_->_tmp34_) {
#line 177 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp40_ = _data_->json;
#line 177 "../src/data/sources/gog/GOGGame.vala"
				game_hub_data_game_set_info_detailed ((GameHubDataGame*) _data_->self, _data_->_tmp40_);
#line 178 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->json);
#line 178 "../src/data/sources/gog/GOGGame.vala"
				break;
#line 3952 "GOGGame.c"
			} else {
#line 180 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->status == ((guint) SOUP_STATUS_UNAUTHORIZED)) {
#line 182 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp41_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 182 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp42_ = _data_->_tmp41_;
#line 182 "../src/data/sources/gog/GOGGame.vala"
					_data_->_state_ = 3;
#line 182 "../src/data/sources/gog/GOGGame.vala"
					game_hub_data_sources_gog_gog_refresh_token (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp42_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG), game_hub_data_sources_gog_gog_game_update_game_info_ready, _data_);
#line 182 "../src/data/sources/gog/GOGGame.vala"
					return FALSE;
#line 3966 "GOGGame.c"
					_state_3:
#line 182 "../src/data/sources/gog/GOGGame.vala"
					game_hub_data_sources_gog_gog_refresh_token_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp42_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG), _data_->_res_);
#line 3970 "GOGGame.c"
				} else {
#line 184 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_data_->json);
#line 184 "../src/data/sources/gog/GOGGame.vala"
					break;
#line 3976 "GOGGame.c"
				}
			}
#line 170 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->json);
#line 3981 "GOGGame.c"
		}
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->url);
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->_tmp12_);
#line 165 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->lang);
#line 3989 "GOGGame.c"
	}
#line 188 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp43_ = game_hub_data_game_get_info_detailed ((GameHubDataGame*) _data_->self);
#line 188 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 188 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp45_ = game_hub_utils_parser_parse_json (_data_->_tmp44_);
#line 188 "../src/data/sources/gog/GOGGame.vala"
	_data_->root = _data_->_tmp45_;
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp46_ = _data_->root;
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp47_ = g_strdup ("images");
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp48_ = g_new0 (gchar*, 1 + 1);
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp48_[0] = _data_->_tmp47_;
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp49_ = _data_->_tmp48_;
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp49__length1 = 1;
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp50_ = game_hub_utils_parser_json_object (_data_->_tmp46_, _data_->_tmp49_, (gint) 1);
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp51_ = _data_->_tmp50_;
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp49_ = (_vala_array_free (_data_->_tmp49_, _data_->_tmp49__length1, (GDestroyNotify) g_free), NULL);
#line 190 "../src/data/sources/gog/GOGGame.vala"
	_data_->images = _data_->_tmp51_;
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp52_ = _data_->root;
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp53_ = g_strdup ("description");
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp54_ = g_new0 (gchar*, 1 + 1);
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp54_[0] = _data_->_tmp53_;
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp55_ = _data_->_tmp54_;
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp55__length1 = 1;
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp56_ = game_hub_utils_parser_json_object (_data_->_tmp52_, _data_->_tmp55_, (gint) 1);
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp57_ = _data_->_tmp56_;
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp55_ = (_vala_array_free (_data_->_tmp55_, _data_->_tmp55__length1, (GDestroyNotify) g_free), NULL);
#line 191 "../src/data/sources/gog/GOGGame.vala"
	_data_->desc = _data_->_tmp57_;
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp58_ = _data_->root;
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp59_ = g_strdup ("links");
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp60_ = g_new0 (gchar*, 1 + 1);
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp60_[0] = _data_->_tmp59_;
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp61_ = _data_->_tmp60_;
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp61__length1 = 1;
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp62_ = game_hub_utils_parser_json_object (_data_->_tmp58_, _data_->_tmp61_, (gint) 1);
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp63_ = _data_->_tmp62_;
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp61_ = (_vala_array_free (_data_->_tmp61_, _data_->_tmp61__length1, (GDestroyNotify) g_free), NULL);
#line 192 "../src/data/sources/gog/GOGGame.vala"
	_data_->links = _data_->_tmp63_;
#line 194 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp65_ = game_hub_data_game_get_image ((GameHubDataGame*) _data_->self);
#line 194 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp66_ = _data_->_tmp65_;
#line 194 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp66_ == NULL) {
#line 194 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp64_ = TRUE;
#line 4067 "GOGGame.c"
	} else {
#line 194 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp67_ = game_hub_data_game_get_image ((GameHubDataGame*) _data_->self);
#line 194 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp68_ = _data_->_tmp67_;
#line 194 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp64_ = g_strcmp0 (_data_->_tmp68_, "") == 0;
#line 4075 "GOGGame.c"
	}
#line 194 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp64_) {
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp69_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp70_ = _data_->_tmp69_;
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp71_ = game_hub_utils_parser_parse_json (_data_->_tmp70_);
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp72_ = _data_->_tmp71_;
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp73_ = json_node_get_object (_data_->_tmp72_);
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp74_ = _json_object_ref0 (_data_->_tmp73_);
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp75_ = _data_->_tmp74_;
#line 196 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (_data_->_tmp72_);
#line 196 "../src/data/sources/gog/GOGGame.vala"
		_data_->i = _data_->_tmp75_;
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp76_ = _data_->i;
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp77_ = json_object_get_string_member (_data_->_tmp76_, "image");
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp78_ = g_strconcat ("https:", _data_->_tmp77_, NULL);
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp79_ = _data_->_tmp78_;
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp80_ = g_strconcat (_data_->_tmp79_, "_392.jpg", NULL);
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp81_ = _data_->_tmp80_;
#line 197 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_set_image ((GameHubDataGame*) _data_->self, _data_->_tmp81_);
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->_tmp81_);
#line 197 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->_tmp79_);
#line 194 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (_data_->i);
#line 4117 "GOGGame.c"
	}
#line 200 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp84_ = game_hub_data_game_get_icon ((GameHubDataGame*) _data_->self);
#line 200 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp85_ = _data_->_tmp84_;
#line 200 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp85_ == NULL) {
#line 200 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp83_ = TRUE;
#line 4127 "GOGGame.c"
	} else {
#line 200 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp86_ = game_hub_data_game_get_icon ((GameHubDataGame*) _data_->self);
#line 200 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp87_ = _data_->_tmp86_;
#line 200 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp83_ = g_strcmp0 (_data_->_tmp87_, "") == 0;
#line 4135 "GOGGame.c"
	}
#line 200 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp83_) {
#line 200 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp89_ = _data_->images;
#line 200 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp89_ != NULL) {
#line 200 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp90_ = _data_->images;
#line 200 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp88_ = json_object_has_member (_data_->_tmp90_, "icon");
#line 4147 "GOGGame.c"
		} else {
#line 200 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp88_ = FALSE;
#line 4151 "GOGGame.c"
		}
#line 200 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp82_ = _data_->_tmp88_;
#line 4155 "GOGGame.c"
	} else {
#line 200 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp82_ = FALSE;
#line 4159 "GOGGame.c"
	}
#line 200 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp82_) {
#line 202 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp91_ = _data_->images;
#line 202 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp92_ = json_object_get_string_member (_data_->_tmp91_, "icon");
#line 202 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_set_icon ((GameHubDataGame*) _data_->self, _data_->_tmp92_);
#line 203 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp93_ = game_hub_data_game_get_icon ((GameHubDataGame*) _data_->self);
#line 203 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp94_ = _data_->_tmp93_;
#line 203 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp94_ != NULL) {
#line 203 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp95_ = game_hub_data_game_get_icon ((GameHubDataGame*) _data_->self);
#line 203 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp96_ = _data_->_tmp95_;
#line 203 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp97_ = g_strconcat ("https:", _data_->_tmp96_, NULL);
#line 203 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp98_ = _data_->_tmp97_;
#line 203 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_game_set_icon ((GameHubDataGame*) _data_->self, _data_->_tmp98_);
#line 203 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->_tmp98_);
#line 4187 "GOGGame.c"
		} else {
#line 204 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp99_ = game_hub_data_game_get_image ((GameHubDataGame*) _data_->self);
#line 204 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp100_ = _data_->_tmp99_;
#line 204 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_game_set_icon ((GameHubDataGame*) _data_->self, _data_->_tmp100_);
#line 4195 "GOGGame.c"
		}
	}
#line 207 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp104_ = _data_->root;
#line 207 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp104_ != NULL) {
#line 207 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp105_ = _data_->root;
#line 207 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp103_ = json_node_get_node_type (_data_->_tmp105_) == JSON_NODE_OBJECT;
#line 4206 "GOGGame.c"
	} else {
#line 207 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp103_ = FALSE;
#line 4210 "GOGGame.c"
	}
#line 207 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp103_) {
#line 208 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp106_ = _data_->root;
#line 208 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp107_ = json_node_get_object (_data_->_tmp106_);
#line 208 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp102_ = json_object_has_member (_data_->_tmp107_, "is_installable");
#line 4220 "GOGGame.c"
	} else {
#line 207 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp102_ = FALSE;
#line 4224 "GOGGame.c"
	}
#line 207 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp102_) {
#line 208 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp108_ = _data_->root;
#line 208 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp109_ = json_node_get_object (_data_->_tmp108_);
#line 208 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp101_ = json_object_get_boolean_member (_data_->_tmp109_, "is_installable");
#line 4234 "GOGGame.c"
	} else {
#line 207 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp101_ = FALSE;
#line 4238 "GOGGame.c"
	}
#line 207 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_is_installable ((GameHubDataGame*) _data_->self, _data_->_tmp101_);
#line 210 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp110_ = _data_->desc;
#line 210 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp110_ != NULL) {
#line 212 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp111_ = _data_->desc;
#line 212 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp112_ = json_object_get_string_member (_data_->_tmp111_, "full");
#line 212 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_set_description ((GameHubDataGame*) _data_->self, _data_->_tmp112_);
#line 213 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp113_ = _data_->desc;
#line 213 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp114_ = json_object_get_string_member (_data_->_tmp113_, "whats_cool_about_it");
#line 213 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp115_ = g_strdup (_data_->_tmp114_);
#line 213 "../src/data/sources/gog/GOGGame.vala"
		_data_->cool = _data_->_tmp115_;
#line 214 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp117_ = _data_->cool;
#line 214 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp117_ != NULL) {
#line 214 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp118_ = _data_->cool;
#line 214 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp119_ = strlen (_data_->_tmp118_);
#line 214 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp120_ = _data_->_tmp119_;
#line 214 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp116_ = _data_->_tmp120_ > 0;
#line 4272 "GOGGame.c"
		} else {
#line 214 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp116_ = FALSE;
#line 4276 "GOGGame.c"
		}
#line 214 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp116_) {
#line 216 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp121_ = game_hub_data_game_get_description ((GameHubDataGame*) _data_->self);
#line 216 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp122_ = _data_->_tmp121_;
#line 216 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp123_ = g_strconcat (_data_->_tmp122_, "<ul>", NULL);
#line 216 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp124_ = _data_->_tmp123_;
#line 216 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_game_set_description ((GameHubDataGame*) _data_->self, _data_->_tmp124_);
#line 216 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->_tmp124_);
#line 217 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp125_ = _data_->cool;
#line 217 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp127_ = _data_->_tmp126_ = g_strsplit (_data_->_tmp125_, "\n", 0);
#line 217 "../src/data/sources/gog/GOGGame.vala"
			_data_->cool_parts = _data_->_tmp127_;
#line 217 "../src/data/sources/gog/GOGGame.vala"
			_data_->cool_parts_length1 = _vala_array_length (_data_->_tmp126_);
#line 217 "../src/data/sources/gog/GOGGame.vala"
			_data_->_cool_parts_size_ = _data_->cool_parts_length1;
#line 218 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp128_ = _data_->cool_parts;
#line 218 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp128__length1 = _data_->cool_parts_length1;
#line 4306 "GOGGame.c"
			{
#line 218 "../src/data/sources/gog/GOGGame.vala"
				_data_->part_collection_length1 = 0;
#line 218 "../src/data/sources/gog/GOGGame.vala"
				_data_->_part_collection_size_ = 0;
#line 218 "../src/data/sources/gog/GOGGame.vala"
				_data_->part_collection = _data_->_tmp128_;
#line 218 "../src/data/sources/gog/GOGGame.vala"
				_data_->part_collection_length1 = _data_->_tmp128__length1;
#line 218 "../src/data/sources/gog/GOGGame.vala"
				for (_data_->part_it = 0; _data_->part_it < _data_->part_collection_length1; _data_->part_it = _data_->part_it + 1) {
#line 218 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp129_ = g_strdup (_data_->part_collection[_data_->part_it]);
#line 218 "../src/data/sources/gog/GOGGame.vala"
					_data_->part = _data_->_tmp129_;
#line 4322 "GOGGame.c"
					{
#line 220 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp130_ = _data_->part;
#line 220 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp131_ = string_strip (_data_->_tmp130_);
#line 220 "../src/data/sources/gog/GOGGame.vala"
						_g_free0 (_data_->part);
#line 220 "../src/data/sources/gog/GOGGame.vala"
						_data_->part = _data_->_tmp131_;
#line 221 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp132_ = _data_->part;
#line 221 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp133_ = strlen (_data_->_tmp132_);
#line 221 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp134_ = _data_->_tmp133_;
#line 221 "../src/data/sources/gog/GOGGame.vala"
						if (_data_->_tmp134_ > 0) {
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp135_ = game_hub_data_game_get_description ((GameHubDataGame*) _data_->self);
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp136_ = _data_->_tmp135_;
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp137_ = _data_->part;
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp138_ = g_strconcat ("<li>", _data_->_tmp137_, NULL);
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp139_ = _data_->_tmp138_;
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp140_ = g_strconcat (_data_->_tmp139_, "</li>", NULL);
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp141_ = _data_->_tmp140_;
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp142_ = g_strconcat (_data_->_tmp136_, _data_->_tmp141_, NULL);
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp143_ = _data_->_tmp142_;
#line 223 "../src/data/sources/gog/GOGGame.vala"
							game_hub_data_game_set_description ((GameHubDataGame*) _data_->self, _data_->_tmp143_);
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_g_free0 (_data_->_tmp143_);
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_g_free0 (_data_->_tmp141_);
#line 223 "../src/data/sources/gog/GOGGame.vala"
							_g_free0 (_data_->_tmp139_);
#line 4366 "GOGGame.c"
						}
#line 218 "../src/data/sources/gog/GOGGame.vala"
						_g_free0 (_data_->part);
#line 4370 "GOGGame.c"
					}
				}
			}
#line 226 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp144_ = game_hub_data_game_get_description ((GameHubDataGame*) _data_->self);
#line 226 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp145_ = _data_->_tmp144_;
#line 226 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp146_ = g_strconcat (_data_->_tmp145_, "</ul>", NULL);
#line 226 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp147_ = _data_->_tmp146_;
#line 226 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_game_set_description ((GameHubDataGame*) _data_->self, _data_->_tmp147_);
#line 226 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->_tmp147_);
#line 214 "../src/data/sources/gog/GOGGame.vala"
			_data_->cool_parts = (_vala_array_free (_data_->cool_parts, _data_->cool_parts_length1, (GDestroyNotify) g_free), NULL);
#line 4388 "GOGGame.c"
		}
#line 210 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->cool);
#line 4392 "GOGGame.c"
	}
#line 230 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp148_ = _data_->links;
#line 230 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp148_ != NULL) {
#line 232 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp149_ = _data_->links;
#line 232 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp150_ = json_object_get_string_member (_data_->_tmp149_, "product_card");
#line 232 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_set_store_page ((GameHubDataGame*) _data_->self, _data_->_tmp150_);
#line 4404 "GOGGame.c"
	}
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp151_ = _data_->root;
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp152_ = g_strdup ("downloads");
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp153_ = g_new0 (gchar*, 1 + 1);
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp153_[0] = _data_->_tmp152_;
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp154_ = _data_->_tmp153_;
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp154__length1 = 1;
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp155_ = game_hub_utils_parser_json_object (_data_->_tmp151_, _data_->_tmp154_, (gint) 1);
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp156_ = _data_->_tmp155_;
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp154_ = (_vala_array_free (_data_->_tmp154_, _data_->_tmp154__length1, (GDestroyNotify) g_free), NULL);
#line 235 "../src/data/sources/gog/GOGGame.vala"
	_data_->downloads = _data_->_tmp156_;
#line 237 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp159_ = _data_->downloads;
#line 237 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp159_ == NULL) {
#line 237 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp158_ = TRUE;
#line 4432 "GOGGame.c"
	} else {
#line 237 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp160_ = _data_->downloads;
#line 237 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp158_ = !json_object_has_member (_data_->_tmp160_, "installers");
#line 4438 "GOGGame.c"
	}
#line 237 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp158_) {
#line 237 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp157_ = NULL;
#line 4444 "GOGGame.c"
	} else {
#line 237 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp161_ = _data_->downloads;
#line 237 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp162_ = json_object_get_array_member (_data_->_tmp161_, "installers");
#line 237 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp157_ = _data_->_tmp162_;
#line 4452 "GOGGame.c"
	}
#line 237 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp163_ = _json_array_ref0 (_data_->_tmp157_);
#line 237 "../src/data/sources/gog/GOGGame.vala"
	_data_->installers_json = _data_->_tmp163_;
#line 238 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp165_ = _data_->installers_json;
#line 238 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp165_ != NULL) {
#line 238 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp166_ = _data_->self->priv->_installers;
#line 238 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp167_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp166_);
#line 238 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp168_ = _data_->_tmp167_;
#line 238 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp164_ = _data_->_tmp168_ == 0;
#line 4470 "GOGGame.c"
	} else {
#line 238 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp164_ = FALSE;
#line 4474 "GOGGame.c"
	}
#line 238 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp164_) {
#line 240 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp169_ = _data_->installers_json;
#line 240 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp170_ = json_array_get_elements (_data_->_tmp169_);
#line 4482 "GOGGame.c"
		{
#line 240 "../src/data/sources/gog/GOGGame.vala"
			_data_->installer_json_collection = _data_->_tmp170_;
#line 240 "../src/data/sources/gog/GOGGame.vala"
			for (_data_->installer_json_it = _data_->installer_json_collection; _data_->installer_json_it != NULL; _data_->installer_json_it = _data_->installer_json_it->next) {
#line 240 "../src/data/sources/gog/GOGGame.vala"
				_data_->installer_json = (JsonNode*) _data_->installer_json_it->data;
#line 4490 "GOGGame.c"
				{
#line 242 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp171_ = _data_->installer_json;
#line 242 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp172_ = json_node_get_object (_data_->_tmp171_);
#line 242 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp173_ = game_hub_data_sources_gog_gog_game_installer_new (_data_->self, _data_->_tmp172_);
#line 242 "../src/data/sources/gog/GOGGame.vala"
					_data_->installer = _data_->_tmp173_;
#line 243 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp174_ = _data_->self->priv->_installers;
#line 243 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp175_ = _data_->installer;
#line 243 "../src/data/sources/gog/GOGGame.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp174_, (GameHubDataRunnableInstaller*) _data_->_tmp175_);
#line 240 "../src/data/sources/gog/GOGGame.vala"
					_game_hub_data_runnable_installer_unref0 (_data_->installer);
#line 4508 "GOGGame.c"
				}
			}
#line 240 "../src/data/sources/gog/GOGGame.vala"
			(_data_->installer_json_collection == NULL) ? NULL : (_data_->installer_json_collection = (g_list_free (_data_->installer_json_collection), NULL));
#line 4513 "GOGGame.c"
		}
	}
#line 247 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp176_ = _data_->self->priv->_installers;
#line 247 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp177_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp176_);
#line 247 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp178_ = _data_->_tmp177_;
#line 247 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp178_ == 0) {
#line 249 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_set_is_installable ((GameHubDataGame*) _data_->self, FALSE);
#line 4526 "GOGGame.c"
	}
#line 252 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp181_ = _data_->downloads;
#line 252 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp181_ == NULL) {
#line 252 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp180_ = TRUE;
#line 4534 "GOGGame.c"
	} else {
#line 252 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp182_ = _data_->downloads;
#line 252 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp180_ = !json_object_has_member (_data_->_tmp182_, "bonus_content");
#line 4540 "GOGGame.c"
	}
#line 252 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp180_) {
#line 252 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp179_ = NULL;
#line 4546 "GOGGame.c"
	} else {
#line 252 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp183_ = _data_->downloads;
#line 252 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp184_ = json_object_get_array_member (_data_->_tmp183_, "bonus_content");
#line 252 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp179_ = _data_->_tmp184_;
#line 4554 "GOGGame.c"
	}
#line 252 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp185_ = _json_array_ref0 (_data_->_tmp179_);
#line 252 "../src/data/sources/gog/GOGGame.vala"
	_data_->bonuses_json = _data_->_tmp185_;
#line 253 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp187_ = _data_->bonuses_json;
#line 253 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp187_ != NULL) {
#line 253 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp188_ = _data_->self->priv->_bonus_content;
#line 253 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp189_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp188_);
#line 253 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp190_ = _data_->_tmp189_;
#line 253 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp186_ = _data_->_tmp190_ == 0;
#line 4572 "GOGGame.c"
	} else {
#line 253 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp186_ = FALSE;
#line 4576 "GOGGame.c"
	}
#line 253 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp186_) {
#line 255 "../src/data/sources/gog/GOGGame.vala"
		_data_->bonus_map = NULL;
#line 257 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp192_ = _data_->self->priv->_bonus_content_dir;
#line 257 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp192_ != NULL) {
#line 257 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp193_ = _data_->self->priv->_bonus_content_dir;
#line 257 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp191_ = g_file_query_exists (_data_->_tmp193_, NULL);
#line 4590 "GOGGame.c"
		} else {
#line 257 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp191_ = FALSE;
#line 4594 "GOGGame.c"
		}
#line 257 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp191_) {
#line 259 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp194_ = _data_->self->priv->_bonus_content_dir;
#line 259 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp195_ = g_file_get_child (_data_->_tmp194_, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_FILEMAP_NAME);
#line 259 "../src/data/sources/gog/GOGGame.vala"
			_data_->map_file = _data_->_tmp195_;
#line 260 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp197_ = _data_->map_file;
#line 260 "../src/data/sources/gog/GOGGame.vala"
			if (_data_->_tmp197_ != NULL) {
#line 260 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp198_ = _data_->map_file;
#line 260 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp196_ = g_file_query_exists (_data_->_tmp198_, NULL);
#line 4612 "GOGGame.c"
			} else {
#line 260 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp196_ = FALSE;
#line 4616 "GOGGame.c"
			}
#line 260 "../src/data/sources/gog/GOGGame.vala"
			if (_data_->_tmp196_) {
#line 262 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp199_ = _data_->map_file;
#line 262 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp200_ = g_file_get_path (_data_->_tmp199_);
#line 262 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp201_ = _data_->_tmp200_;
#line 262 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp202_ = game_hub_utils_parser_parse_json_file (_data_->_tmp201_, "");
#line 262 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp203_ = _data_->_tmp202_;
#line 262 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->_tmp201_);
#line 262 "../src/data/sources/gog/GOGGame.vala"
				_data_->map_root_node = _data_->_tmp203_;
#line 263 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp206_ = _data_->map_root_node;
#line 263 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp206_ != NULL) {
#line 263 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp207_ = _data_->map_root_node;
#line 263 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp205_ = json_node_get_node_type (_data_->_tmp207_) == JSON_NODE_OBJECT;
#line 4642 "GOGGame.c"
				} else {
#line 263 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp205_ = FALSE;
#line 4646 "GOGGame.c"
				}
#line 263 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp205_) {
#line 263 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp208_ = _data_->map_root_node;
#line 263 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp209_ = json_node_get_object (_data_->_tmp208_);
#line 263 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp204_ = _data_->_tmp209_;
#line 4656 "GOGGame.c"
				} else {
#line 263 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp204_ = NULL;
#line 4660 "GOGGame.c"
				}
#line 263 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp210_ = _json_object_ref0 (_data_->_tmp204_);
#line 263 "../src/data/sources/gog/GOGGame.vala"
				_json_object_unref0 (_data_->bonus_map);
#line 263 "../src/data/sources/gog/GOGGame.vala"
				_data_->bonus_map = _data_->_tmp210_;
#line 260 "../src/data/sources/gog/GOGGame.vala"
				__vala_JsonNode_free0 (_data_->map_root_node);
#line 4670 "GOGGame.c"
			}
#line 257 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (_data_->map_file);
#line 4674 "GOGGame.c"
		}
#line 267 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp211_ = _data_->bonuses_json;
#line 267 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp212_ = json_array_get_elements (_data_->_tmp211_);
#line 4680 "GOGGame.c"
		{
#line 267 "../src/data/sources/gog/GOGGame.vala"
			_data_->bonus_json_collection = _data_->_tmp212_;
#line 267 "../src/data/sources/gog/GOGGame.vala"
			for (_data_->bonus_json_it = _data_->bonus_json_collection; _data_->bonus_json_it != NULL; _data_->bonus_json_it = _data_->bonus_json_it->next) {
#line 267 "../src/data/sources/gog/GOGGame.vala"
				_data_->bonus_json = (JsonNode*) _data_->bonus_json_it->data;
#line 4688 "GOGGame.c"
				{
#line 269 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp213_ = _data_->self->priv->_bonus_content;
#line 269 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp214_ = _data_->bonus_json;
#line 269 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp215_ = json_node_get_object (_data_->_tmp214_);
#line 269 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp216_ = _data_->bonus_map;
#line 269 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp217_ = game_hub_data_sources_gog_gog_game_bonus_content_new (_data_->self, _data_->_tmp215_, _data_->_tmp216_);
#line 269 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp218_ = _data_->_tmp217_;
#line 269 "../src/data/sources/gog/GOGGame.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp213_, _data_->_tmp218_);
#line 269 "../src/data/sources/gog/GOGGame.vala"
					_game_hub_data_sources_gog_gog_game_bonus_content_unref0 (_data_->_tmp218_);
#line 4706 "GOGGame.c"
				}
			}
#line 267 "../src/data/sources/gog/GOGGame.vala"
			(_data_->bonus_json_collection == NULL) ? NULL : (_data_->bonus_json_collection = (g_list_free (_data_->bonus_json_collection), NULL));
#line 4711 "GOGGame.c"
		}
#line 253 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (_data_->bonus_map);
#line 4715 "GOGGame.c"
	}
#line 273 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp222_ = _data_->root;
#line 273 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp222_ == NULL) {
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp221_ = TRUE;
#line 4723 "GOGGame.c"
	} else {
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp223_ = _data_->root;
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp221_ = json_node_get_node_type (_data_->_tmp223_) != JSON_NODE_OBJECT;
#line 4729 "GOGGame.c"
	}
#line 273 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp221_) {
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp220_ = TRUE;
#line 4735 "GOGGame.c"
	} else {
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp224_ = _data_->root;
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp225_ = json_node_get_object (_data_->_tmp224_);
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp220_ = !json_object_has_member (_data_->_tmp225_, "expanded_dlcs");
#line 4743 "GOGGame.c"
	}
#line 273 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp220_) {
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp219_ = NULL;
#line 4749 "GOGGame.c"
	} else {
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp226_ = _data_->root;
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp227_ = json_node_get_object (_data_->_tmp226_);
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp228_ = json_object_get_array_member (_data_->_tmp227_, "expanded_dlcs");
#line 273 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp219_ = _data_->_tmp228_;
#line 4759 "GOGGame.c"
	}
#line 273 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp229_ = _json_array_ref0 (_data_->_tmp219_);
#line 273 "../src/data/sources/gog/GOGGame.vala"
	_data_->dlcs_json = _data_->_tmp229_;
#line 274 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp231_ = _data_->dlcs_json;
#line 274 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp231_ != NULL) {
#line 274 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp232_ = _data_->self->priv->_dlc;
#line 274 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp233_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp232_);
#line 274 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp234_ = _data_->_tmp233_;
#line 274 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp230_ = _data_->_tmp234_ == 0;
#line 4777 "GOGGame.c"
	} else {
#line 274 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp230_ = FALSE;
#line 4781 "GOGGame.c"
	}
#line 274 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp230_) {
#line 276 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp235_ = _data_->dlcs_json;
#line 276 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp236_ = json_array_get_elements (_data_->_tmp235_);
#line 4789 "GOGGame.c"
		{
#line 276 "../src/data/sources/gog/GOGGame.vala"
			_data_->dlc_json_collection = _data_->_tmp236_;
#line 276 "../src/data/sources/gog/GOGGame.vala"
			for (_data_->dlc_json_it = _data_->dlc_json_collection; _data_->dlc_json_it != NULL; _data_->dlc_json_it = _data_->dlc_json_it->next) {
#line 276 "../src/data/sources/gog/GOGGame.vala"
				_data_->dlc_json = (JsonNode*) _data_->dlc_json_it->data;
#line 4797 "GOGGame.c"
				{
#line 278 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp237_ = _data_->dlc_json;
#line 278 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp238_ = game_hub_data_sources_gog_gog_game_dlc_new (_data_->self, _data_->_tmp237_);
#line 278 "../src/data/sources/gog/GOGGame.vala"
					_data_->d = _data_->_tmp238_;
#line 279 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp239_ = _data_->self->priv->_dlc;
#line 279 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp240_ = _data_->d;
#line 279 "../src/data/sources/gog/GOGGame.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp239_, _data_->_tmp240_);
#line 280 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp241_ = _data_->d;
#line 280 "../src/data/sources/gog/GOGGame.vala"
					_data_->_state_ = 4;
#line 280 "../src/data/sources/gog/GOGGame.vala"
					game_hub_data_sources_gog_gog_game_dlc_update_downloads_info (_data_->_tmp241_, game_hub_data_sources_gog_gog_game_update_game_info_ready, _data_);
#line 280 "../src/data/sources/gog/GOGGame.vala"
					return FALSE;
#line 4819 "GOGGame.c"
					_state_4:
#line 280 "../src/data/sources/gog/GOGGame.vala"
					game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_finish (_data_->_tmp241_, _data_->_res_);
#line 276 "../src/data/sources/gog/GOGGame.vala"
					_g_object_unref0 (_data_->d);
#line 4825 "GOGGame.c"
				}
			}
#line 276 "../src/data/sources/gog/GOGGame.vala"
			(_data_->dlc_json_collection == NULL) ? NULL : (_data_->dlc_json_collection = (g_list_free (_data_->dlc_json_collection), NULL));
#line 4830 "GOGGame.c"
		}
	}
#line 284 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp242_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 284 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp243_ = _data_->_tmp242_;
#line 284 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp244_ = game_hub_utils_parser_parse_json (_data_->_tmp243_);
#line 284 "../src/data/sources/gog/GOGGame.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 284 "../src/data/sources/gog/GOGGame.vala"
	_data_->root = _data_->_tmp244_;
#line 286 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp248_ = _data_->root;
#line 286 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp248_ == NULL) {
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp247_ = TRUE;
#line 4849 "GOGGame.c"
	} else {
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp249_ = _data_->root;
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp247_ = json_node_get_node_type (_data_->_tmp249_) != JSON_NODE_OBJECT;
#line 4855 "GOGGame.c"
	}
#line 286 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp247_) {
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp246_ = TRUE;
#line 4861 "GOGGame.c"
	} else {
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp250_ = _data_->root;
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp251_ = json_node_get_object (_data_->_tmp250_);
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp246_ = !json_object_has_member (_data_->_tmp251_, "tags");
#line 4869 "GOGGame.c"
	}
#line 286 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp246_) {
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp245_ = NULL;
#line 4875 "GOGGame.c"
	} else {
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp252_ = _data_->root;
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp253_ = json_node_get_object (_data_->_tmp252_);
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp254_ = json_object_get_array_member (_data_->_tmp253_, "tags");
#line 286 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp245_ = _data_->_tmp254_;
#line 4885 "GOGGame.c"
	}
#line 286 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp255_ = _json_array_ref0 (_data_->_tmp245_);
#line 286 "../src/data/sources/gog/GOGGame.vala"
	_data_->tags_json = _data_->_tmp255_;
#line 288 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp256_ = _data_->tags_json;
#line 288 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp256_ != NULL) {
#line 290 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp257_ = _data_->tags_json;
#line 290 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp258_ = json_array_get_elements (_data_->_tmp257_);
#line 4899 "GOGGame.c"
		{
#line 290 "../src/data/sources/gog/GOGGame.vala"
			_data_->tag_json_collection = _data_->_tmp258_;
#line 290 "../src/data/sources/gog/GOGGame.vala"
			for (_data_->tag_json_it = _data_->tag_json_collection; _data_->tag_json_it != NULL; _data_->tag_json_it = _data_->tag_json_it->next) {
#line 290 "../src/data/sources/gog/GOGGame.vala"
				_data_->tag_json = (JsonNode*) _data_->tag_json_it->data;
#line 4907 "GOGGame.c"
				{
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp259_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp260_ = _data_->_tmp259_;
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp261_ = game_hub_data_game_source_get_id (_data_->_tmp260_);
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp262_ = _data_->_tmp261_;
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp263_ = g_strconcat (_data_->_tmp262_, ":", NULL);
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp264_ = _data_->_tmp263_;
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp265_ = _data_->tag_json;
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp266_ = json_node_get_string (_data_->_tmp265_);
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp267_ = g_strconcat (_data_->_tmp264_, _data_->_tmp266_, NULL);
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp268_ = _data_->_tmp267_;
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_data_->_tmp264_);
#line 292 "../src/data/sources/gog/GOGGame.vala"
					_data_->tid = _data_->_tmp268_;
#line 4933 "GOGGame.c"
					{
#line 293 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp269_ = game_hub_data_db_tables_tags_TAGS;
#line 293 "../src/data/sources/gog/GOGGame.vala"
						_data_->_t_list = _data_->_tmp269_;
#line 293 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp270_ = _data_->_t_list;
#line 293 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp271_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp270_);
#line 293 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp272_ = _data_->_tmp271_;
#line 293 "../src/data/sources/gog/GOGGame.vala"
						_data_->_t_size = _data_->_tmp272_;
#line 293 "../src/data/sources/gog/GOGGame.vala"
						_data_->_t_index = -1;
#line 293 "../src/data/sources/gog/GOGGame.vala"
						while (TRUE) {
#line 293 "../src/data/sources/gog/GOGGame.vala"
							_data_->_t_index = _data_->_t_index + 1;
#line 293 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp273_ = _data_->_t_index;
#line 293 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp274_ = _data_->_t_size;
#line 293 "../src/data/sources/gog/GOGGame.vala"
							if (!(_data_->_tmp273_ < _data_->_tmp274_)) {
#line 293 "../src/data/sources/gog/GOGGame.vala"
								break;
#line 4961 "GOGGame.c"
							}
#line 293 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp275_ = _data_->_t_list;
#line 293 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp276_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp275_, _data_->_t_index);
#line 293 "../src/data/sources/gog/GOGGame.vala"
							_data_->t = (GameHubDataDBTablesTagsTag*) _data_->_tmp276_;
#line 295 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp277_ = _data_->tid;
#line 295 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp278_ = _data_->t;
#line 295 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp279_ = game_hub_data_db_tables_tags_tag_get_id (_data_->_tmp278_);
#line 295 "../src/data/sources/gog/GOGGame.vala"
							_data_->_tmp280_ = _data_->_tmp279_;
#line 295 "../src/data/sources/gog/GOGGame.vala"
							if (g_strcmp0 (_data_->_tmp277_, _data_->_tmp280_) == 0) {
#line 297 "../src/data/sources/gog/GOGGame.vala"
								_data_->_tmp281_ = game_hub_data_game_get_tags ((GameHubDataGame*) _data_->self);
#line 297 "../src/data/sources/gog/GOGGame.vala"
								_data_->_tmp282_ = _data_->_tmp281_;
#line 297 "../src/data/sources/gog/GOGGame.vala"
								_data_->_tmp283_ = _data_->t;
#line 297 "../src/data/sources/gog/GOGGame.vala"
								if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp282_, _data_->_tmp283_)) {
#line 297 "../src/data/sources/gog/GOGGame.vala"
									_data_->_tmp284_ = game_hub_data_game_get_tags ((GameHubDataGame*) _data_->self);
#line 297 "../src/data/sources/gog/GOGGame.vala"
									_data_->_tmp285_ = _data_->_tmp284_;
#line 297 "../src/data/sources/gog/GOGGame.vala"
									_data_->_tmp286_ = _data_->t;
#line 297 "../src/data/sources/gog/GOGGame.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp285_, _data_->_tmp286_);
#line 4995 "GOGGame.c"
								}
#line 298 "../src/data/sources/gog/GOGGame.vala"
								_g_object_unref0 (_data_->t);
#line 298 "../src/data/sources/gog/GOGGame.vala"
								break;
#line 5001 "GOGGame.c"
							}
#line 293 "../src/data/sources/gog/GOGGame.vala"
							_g_object_unref0 (_data_->t);
#line 5005 "GOGGame.c"
						}
					}
#line 290 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_data_->tid);
#line 5010 "GOGGame.c"
				}
			}
#line 290 "../src/data/sources/gog/GOGGame.vala"
			(_data_->tag_json_collection == NULL) ? NULL : (_data_->tag_json_collection = (g_list_free (_data_->tag_json_collection), NULL));
#line 5015 "GOGGame.c"
		}
	}
#line 304 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_save ((GameHubDataRunnable*) _data_->self);
#line 306 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 308 "../src/data/sources/gog/GOGGame.vala"
	_data_->self->priv->game_info_updated = TRUE;
#line 309 "../src/data/sources/gog/GOGGame.vala"
	_data_->self->priv->game_info_updating = FALSE;
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_array_unref0 (_data_->tags_json);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_array_unref0 (_data_->dlcs_json);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_array_unref0 (_data_->bonuses_json);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_array_unref0 (_data_->installers_json);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (_data_->downloads);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (_data_->links);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (_data_->desc);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (_data_->images);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 157 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 157 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5052 "GOGGame.c"
		}
	}
#line 157 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 157 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 5059 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_install_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameInstallData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameInstallData, _data_);
#line 5071 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_install (GameHubDataRunnable* base,
                                                 GameHubDataRunnableInstallerInstallMode install_mode,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	GameHubDataSourcesGOGGOGGame * self;
	GameHubDataSourcesGogGogGameInstallData* _data_;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameInstallData);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_real_install_data_free);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->install_mode = install_mode;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_install_co (_data_);
#line 5099 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_install_finish (GameHubDataRunnable* base,
                                                   GAsyncResult* _res_)
{
	GameHubDataSourcesGogGogGameInstallData* _data_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5109 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_install_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameInstallData* _data_;
#line 314 "../src/data/sources/gog/GOGGame.vala"
	_data_ = _user_data_;
#line 314 "../src/data/sources/gog/GOGGame.vala"
	_data_->_source_object_ = source_object;
#line 314 "../src/data/sources/gog/GOGGame.vala"
	_data_->_res_ = _res_;
#line 314 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_install_co (_data_);
#line 5126 "GOGGame.c"
}

static gboolean
_game_hub_data_sources_gog_gog_game_real_install_co_gsource_func (gpointer self)
{
	gboolean result;
	result = game_hub_data_sources_gog_gog_game_real_install_co (self);
#line 316 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 5136 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_real_install_co (GameHubDataSourcesGogGogGameInstallData* _data_)
{
#line 312 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 312 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 5146 "GOGGame.c"
		goto _state_0;
#line 312 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 5150 "GOGGame.c"
		goto _state_1;
#line 312 "../src/data/sources/gog/GOGGame.vala"
		case 2:
#line 5154 "GOGGame.c"
		goto _state_2;
		default:
#line 312 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 5159 "GOGGame.c"
	}
	_state_0:
#line 314 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 1;
#line 314 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_update_game_info ((GameHubDataGame*) _data_->self, game_hub_data_sources_gog_gog_game_install_ready, _data_);
#line 314 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 5168 "GOGGame.c"
	_state_1:
#line 314 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_update_game_info_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 315 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp1_ = _data_->self->priv->_installers;
#line 315 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp1_ == NULL) {
#line 315 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = TRUE;
#line 5178 "GOGGame.c"
	} else {
#line 315 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp2_ = _data_->self->priv->_installers;
#line 315 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
#line 315 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 315 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = _data_->_tmp4_ < 1;
#line 5188 "GOGGame.c"
	}
#line 315 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp0_) {
#line 315 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 315 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 315 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 315 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5200 "GOGGame.c"
			}
		}
#line 315 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 315 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 5207 "GOGGame.c"
	}
#line 316 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp5_ = _data_->self->priv->_installers;
#line 316 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp6_ = game_hub_ui_dialogs_install_dialog_new ((GameHubDataRunnable*) _data_->self, _data_->_tmp5_, _data_->install_mode, _game_hub_data_sources_gog_gog_game_real_install_co_gsource_func, _data_, NULL);
#line 316 "../src/data/sources/gog/GOGGame.vala"
	g_object_ref_sink (_data_->_tmp6_);
#line 316 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 316 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp7_);
#line 317 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 2;
#line 317 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 5223 "GOGGame.c"
	_state_2:
	;
#line 312 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 312 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 312 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 312 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5234 "GOGGame.c"
		}
	}
#line 312 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 312 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 5241 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_uninstall_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameUninstallData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameUninstallData, _data_);
#line 5253 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_uninstall (GameHubDataGame* base,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	GameHubDataSourcesGOGGOGGame * self;
	GameHubDataSourcesGogGogGameUninstallData* _data_;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameUninstallData);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_real_uninstall_data_free);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_uninstall_co (_data_);
#line 5278 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_uninstall_finish (GameHubDataGame* base,
                                                     GAsyncResult* _res_)
{
	GameHubDataSourcesGogGogGameUninstallData* _data_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5288 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_uninstall_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameUninstallData* _data_;
#line 328 "../src/data/sources/gog/GOGGame.vala"
	_data_ = _user_data_;
#line 328 "../src/data/sources/gog/GOGGame.vala"
	_data_->_source_object_ = source_object;
#line 328 "../src/data/sources/gog/GOGGame.vala"
	_data_->_res_ = _res_;
#line 328 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_uninstall_co (_data_);
#line 5305 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_real_uninstall_co (GameHubDataSourcesGogGogGameUninstallData* _data_)
{
#line 320 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 320 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 5315 "GOGGame.c"
		goto _state_0;
#line 320 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 5319 "GOGGame.c"
		goto _state_1;
#line 320 "../src/data/sources/gog/GOGGame.vala"
		case 2:
#line 5323 "GOGGame.c"
		goto _state_2;
#line 320 "../src/data/sources/gog/GOGGame.vala"
		case 3:
#line 5327 "GOGGame.c"
		goto _state_3;
		default:
#line 320 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 5332 "GOGGame.c"
	}
	_state_0:
#line 322 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp1_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 322 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 322 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp2_ != NULL) {
#line 322 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp3_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 322 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 322 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = g_file_query_exists (_data_->_tmp4_, NULL);
#line 5347 "GOGGame.c"
	} else {
#line 322 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = FALSE;
#line 5351 "GOGGame.c"
	}
#line 322 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp0_) {
#line 324 "../src/data/sources/gog/GOGGame.vala"
		_data_->uninstaller = NULL;
#line 5357 "GOGGame.c"
		{
#line 327 "../src/data/sources/gog/GOGGame.vala"
			_data_->finfo = NULL;
#line 328 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp5_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 328 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 328 "../src/data/sources/gog/GOGGame.vala"
			_data_->_state_ = 1;
#line 328 "../src/data/sources/gog/GOGGame.vala"
			g_file_enumerate_children_async (_data_->_tmp6_, "standard::*", G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, game_hub_data_sources_gog_gog_game_uninstall_ready, _data_);
#line 328 "../src/data/sources/gog/GOGGame.vala"
			return FALSE;
#line 5371 "GOGGame.c"
			_state_1:
#line 328 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp7_ = g_file_enumerate_children_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 328 "../src/data/sources/gog/GOGGame.vala"
			_data_->enumerator = _data_->_tmp7_;
#line 328 "../src/data/sources/gog/GOGGame.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 328 "../src/data/sources/gog/GOGGame.vala"
				_g_object_unref0 (_data_->finfo);
#line 5381 "GOGGame.c"
				goto __catch0_g_error;
			}
#line 329 "../src/data/sources/gog/GOGGame.vala"
			while (TRUE) {
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp9_ = _data_->enumerator;
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp10_ = g_file_enumerator_next_file (_data_->_tmp9_, NULL, &_data_->_inner_error0_);
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp8_ = _data_->_tmp10_;
#line 329 "../src/data/sources/gog/GOGGame.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 329 "../src/data/sources/gog/GOGGame.vala"
					_g_object_unref0 (_data_->enumerator);
#line 329 "../src/data/sources/gog/GOGGame.vala"
					_g_object_unref0 (_data_->finfo);
#line 5398 "GOGGame.c"
					goto __catch0_g_error;
				}
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp11_ = _data_->_tmp8_;
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp8_ = NULL;
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_g_object_unref0 (_data_->finfo);
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_data_->finfo = _data_->_tmp11_;
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp12_ = _data_->finfo;
#line 329 "../src/data/sources/gog/GOGGame.vala"
				if (!(_data_->_tmp12_ != NULL)) {
#line 329 "../src/data/sources/gog/GOGGame.vala"
					_g_object_unref0 (_data_->_tmp8_);
#line 329 "../src/data/sources/gog/GOGGame.vala"
					break;
#line 5417 "GOGGame.c"
				}
#line 331 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp13_ = _data_->finfo;
#line 331 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp14_ = g_file_info_get_name (_data_->_tmp13_);
#line 331 "../src/data/sources/gog/GOGGame.vala"
				if (g_str_has_prefix (_data_->_tmp14_, "uninstall-")) {
#line 333 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp15_ = _data_->finfo;
#line 333 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp16_ = g_file_info_get_name (_data_->_tmp15_);
#line 333 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp17_ = g_strdup (_data_->_tmp16_);
#line 333 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_data_->uninstaller);
#line 333 "../src/data/sources/gog/GOGGame.vala"
					_data_->uninstaller = _data_->_tmp17_;
#line 334 "../src/data/sources/gog/GOGGame.vala"
					_g_object_unref0 (_data_->_tmp8_);
#line 334 "../src/data/sources/gog/GOGGame.vala"
					break;
#line 5439 "GOGGame.c"
				}
#line 329 "../src/data/sources/gog/GOGGame.vala"
				_g_object_unref0 (_data_->_tmp8_);
#line 5443 "GOGGame.c"
			}
#line 325 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (_data_->enumerator);
#line 325 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (_data_->finfo);
#line 5449 "GOGGame.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 325 "../src/data/sources/gog/GOGGame.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 5456 "GOGGame.c"
		}
		__finally0:
#line 325 "../src/data/sources/gog/GOGGame.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 325 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->uninstaller);
#line 325 "../src/data/sources/gog/GOGGame.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 325 "../src/data/sources/gog/GOGGame.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 325 "../src/data/sources/gog/GOGGame.vala"
			g_object_unref (_data_->_async_result);
#line 325 "../src/data/sources/gog/GOGGame.vala"
			return FALSE;
#line 5471 "GOGGame.c"
		}
#line 340 "../src/data/sources/gog/GOGGame.vala"
		_data_->_state_ = 2;
#line 340 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_umount_overlays ((GameHubDataGame*) _data_->self, game_hub_data_sources_gog_gog_game_uninstall_ready, _data_);
#line 340 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 5479 "GOGGame.c"
		_state_2:
#line 340 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_umount_overlays_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 342 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp18_ = _data_->uninstaller;
#line 342 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp18_ != NULL) {
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp19_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp20_ = _data_->_tmp19_;
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp21_ = g_file_get_path (_data_->_tmp20_);
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp22_ = _data_->_tmp21_;
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp23_ = _data_->uninstaller;
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp24_ = game_hub_utils_fs_utils_expand (_data_->_tmp22_, _data_->_tmp23_, NULL);
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->uninstaller);
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_data_->uninstaller = _data_->_tmp24_;
#line 344 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->_tmp22_);
#line 345 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp25_ = _data_->uninstaller;
#line 345 "../src/data/sources/gog/GOGGame.vala"
			g_debug ("GOGGame.vala:345: [GOGGame] Running uninstaller '%s'...", _data_->_tmp25_);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp26_ = _data_->uninstaller;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp27_ = g_strdup (_data_->_tmp26_);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp28_ = g_strdup ("--noprompt");
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp29_ = g_strdup ("--force");
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp30_ = g_new0 (gchar*, 3 + 1);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp30_[0] = _data_->_tmp27_;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp30_[1] = _data_->_tmp28_;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp30_[2] = _data_->_tmp29_;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp31_ = _data_->_tmp30_;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp31__length1 = 3;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp32_ = game_hub_utils_run (_data_->_tmp31_, (gint) 3);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp33_ = _data_->_tmp32_;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp34_ = game_hub_utils_run_task_override_runtime (_data_->_tmp33_, TRUE);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp35_ = _data_->_tmp34_;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_state_ = 3;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			game_hub_utils_run_task_run_sync_thread (_data_->_tmp35_, FALSE, game_hub_data_sources_gog_gog_game_uninstall_ready, _data_);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			return FALSE;
#line 5543 "GOGGame.c"
			_state_3:
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp36_ = game_hub_utils_run_task_run_sync_thread_finish (_data_->_tmp35_, _data_->_res_);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp37_ = _data_->_tmp36_;
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_game_hub_utils_run_task_result_unref0 (_data_->_tmp37_);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_game_hub_utils_run_task_unref0 (_data_->_tmp35_);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_game_hub_utils_run_task_unref0 (_data_->_tmp33_);
#line 346 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp31_ = (_vala_array_free (_data_->_tmp31_, _data_->_tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 5557 "GOGGame.c"
		} else {
#line 350 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp38_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 350 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp39_ = _data_->_tmp38_;
#line 350 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp40_ = g_file_get_path (_data_->_tmp39_);
#line 350 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 350 "../src/data/sources/gog/GOGGame.vala"
			game_hub_utils_fs_utils_rm (_data_->_tmp41_, "", "-rf", NULL);
#line 350 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->_tmp41_);
#line 5571 "GOGGame.c"
		}
#line 352 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 322 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->uninstaller);
#line 5577 "GOGGame.c"
	}
#line 354 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp44_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 354 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp45_ = _data_->_tmp44_;
#line 354 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp45_ == NULL) {
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp43_ = TRUE;
#line 5587 "GOGGame.c"
	} else {
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp46_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp47_ = _data_->_tmp46_;
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp43_ = !g_file_query_exists (_data_->_tmp47_, NULL);
#line 5595 "GOGGame.c"
	}
#line 354 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp43_) {
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp49_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp51_ = _data_->_tmp50_;
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp52_ = _data_->_tmp51_ == NULL;
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_data_->_tmp51_);
#line 354 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp52_) {
#line 354 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp48_ = TRUE;
#line 5613 "GOGGame.c"
		} else {
#line 354 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp53_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 354 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp54_ = _data_->_tmp53_;
#line 354 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp55_ = _data_->_tmp54_;
#line 354 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp48_ = !g_file_query_exists (_data_->_tmp55_, NULL);
#line 354 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (_data_->_tmp55_);
#line 5625 "GOGGame.c"
		}
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp42_ = _data_->_tmp48_;
#line 5629 "GOGGame.c"
	} else {
#line 354 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp42_ = FALSE;
#line 5633 "GOGGame.c"
	}
#line 354 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp42_) {
#line 356 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) _data_->self, NULL);
#line 357 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_runnable_set_executable ((GameHubDataRunnable*) _data_->self, NULL);
#line 358 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_runnable_save ((GameHubDataRunnable*) _data_->self);
#line 359 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 5645 "GOGGame.c"
	}
#line 320 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 320 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 320 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 320 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5655 "GOGGame.c"
		}
	}
#line 320 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 320 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 5662 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_update_status (GameHubDataRunnable* base)
{
	GameHubDataSourcesGOGGOGGame * self;
	gboolean _tmp0_ = FALSE;
	GameHubDataGameStatus* _tmp1_;
	GameHubDataGameStatus* _tmp2_;
	GameHubDataGameState state = 0;
	GFile* gameinfo = NULL;
	GFile* _tmp8_;
	GFile* goggame = NULL;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* gh_marker = NULL;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	GeeArrayList* files = NULL;
	GeeArrayList* _tmp23_;
	GeeArrayList* _tmp24_;
	GFile* _tmp25_;
	GeeArrayList* _tmp26_;
	GFile* _tmp27_;
	GameHubDataGameStatus* _tmp45_;
	GameHubDataGameStatus* _tmp46_;
	gboolean _tmp51_ = FALSE;
	GFile* _tmp52_;
	GeeArrayList* _tmp66_;
	GeeArrayList* _tmp67_;
	gboolean _tmp68_ = FALSE;
	GFile* _tmp69_;
	gchar* g = NULL;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	gchar* _tmp104_;
	gchar* d = NULL;
	const gchar* _tmp112_;
	const gchar* _tmp113_;
	gchar* _tmp114_;
	gchar* _tmp115_;
	GFile* _tmp116_;
	GFile* _tmp117_;
	const gchar* _tmp118_;
	const gchar* _tmp119_;
	gchar* _tmp120_;
	gchar* _tmp121_;
	GFile* _tmp122_;
	GFile* _tmp123_;
	GError* _inner_error0_ = NULL;
#line 363 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 365 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = game_hub_data_game_get_status ((GameHubDataGame*) self);
#line 365 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = _tmp1_;
#line 365 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp2_->state == GAME_HUB_DATA_GAME_STATE_DOWNLOADING) {
#line 5731 "GOGGame.c"
		GameHubDataGameStatus* _tmp3_;
		GameHubDataGameStatus* _tmp4_;
		GameHubUtilsDownloaderDownload* _tmp5_;
		GameHubUtilsDownloaderDownloadStatus* _tmp6_;
		GameHubUtilsDownloaderDownloadStatus* _tmp7_;
#line 365 "../src/data/sources/gog/GOGGame.vala"
		_tmp3_ = game_hub_data_game_get_status ((GameHubDataGame*) self);
#line 365 "../src/data/sources/gog/GOGGame.vala"
		_tmp4_ = _tmp3_;
#line 365 "../src/data/sources/gog/GOGGame.vala"
		_tmp5_ = _tmp4_->download;
#line 365 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = game_hub_utils_downloader_download_get_status (_tmp5_);
#line 365 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = _tmp6_;
#line 365 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _tmp7_->state != GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATE_CANCELLED;
#line 5749 "GOGGame.c"
	} else {
#line 365 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = FALSE;
#line 5753 "GOGGame.c"
	}
#line 365 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp0_) {
#line 365 "../src/data/sources/gog/GOGGame.vala"
		return;
#line 5759 "GOGGame.c"
	}
#line 367 "../src/data/sources/gog/GOGGame.vala"
	state = GAME_HUB_DATA_GAME_STATE_UNINSTALLED;
#line 369 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = game_hub_data_game_get_file ((GameHubDataGame*) self, "gameinfo", FALSE);
#line 369 "../src/data/sources/gog/GOGGame.vala"
	gameinfo = _tmp8_;
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_tmp9_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) self);
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_tmp10_ = _tmp9_;
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_tmp11_ = string_to_string (_tmp10_);
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_tmp12_ = g_strconcat ("goggame-", _tmp11_, ".info", NULL);
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_tmp13_ = _tmp12_;
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_tmp14_ = game_hub_data_game_get_file ((GameHubDataGame*) self, _tmp13_, TRUE);
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_tmp15_ = _tmp14_;
#line 370 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp13_);
#line 370 "../src/data/sources/gog/GOGGame.vala"
	goggame = _tmp15_;
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_tmp16_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) self);
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_tmp17_ = _tmp16_;
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_tmp18_ = string_to_string (_tmp17_);
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_tmp19_ = g_strconcat (".gamehub_", _tmp18_, NULL);
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_tmp20_ = _tmp19_;
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_tmp21_ = game_hub_data_game_get_file ((GameHubDataGame*) self, _tmp20_, TRUE);
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_tmp22_ = _tmp21_;
#line 371 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp20_);
#line 371 "../src/data/sources/gog/GOGGame.vala"
	gh_marker = _tmp22_;
#line 373 "../src/data/sources/gog/GOGGame.vala"
	_tmp23_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 373 "../src/data/sources/gog/GOGGame.vala"
	files = _tmp23_;
#line 375 "../src/data/sources/gog/GOGGame.vala"
	_tmp24_ = files;
#line 375 "../src/data/sources/gog/GOGGame.vala"
	_tmp25_ = goggame;
#line 375 "../src/data/sources/gog/GOGGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp25_);
#line 376 "../src/data/sources/gog/GOGGame.vala"
	_tmp26_ = files;
#line 376 "../src/data/sources/gog/GOGGame.vala"
	_tmp27_ = gh_marker;
#line 376 "../src/data/sources/gog/GOGGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 378 "../src/data/sources/gog/GOGGame.vala"
	if (!GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (self)) {
#line 5821 "GOGGame.c"
		GeeArrayList* _tmp28_;
		GFile* _tmp29_;
		GFile* _tmp30_;
		GFile* _tmp31_;
		GeeArrayList* _tmp32_;
		GFile* _tmp33_;
#line 380 "../src/data/sources/gog/GOGGame.vala"
		_tmp28_ = files;
#line 380 "../src/data/sources/gog/GOGGame.vala"
		_tmp29_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) self);
#line 380 "../src/data/sources/gog/GOGGame.vala"
		_tmp30_ = _tmp29_;
#line 380 "../src/data/sources/gog/GOGGame.vala"
		_tmp31_ = _tmp30_;
#line 380 "../src/data/sources/gog/GOGGame.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp31_);
#line 380 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp31_);
#line 381 "../src/data/sources/gog/GOGGame.vala"
		_tmp32_ = files;
#line 381 "../src/data/sources/gog/GOGGame.vala"
		_tmp33_ = gameinfo;
#line 381 "../src/data/sources/gog/GOGGame.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 5846 "GOGGame.c"
	}
	{
		GeeArrayList* _file_list = NULL;
		GeeArrayList* _tmp34_;
		gint _file_size = 0;
		GeeArrayList* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		gint _file_index = 0;
#line 384 "../src/data/sources/gog/GOGGame.vala"
		_tmp34_ = files;
#line 384 "../src/data/sources/gog/GOGGame.vala"
		_file_list = _tmp34_;
#line 384 "../src/data/sources/gog/GOGGame.vala"
		_tmp35_ = _file_list;
#line 384 "../src/data/sources/gog/GOGGame.vala"
		_tmp36_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp35_);
#line 384 "../src/data/sources/gog/GOGGame.vala"
		_tmp37_ = _tmp36_;
#line 384 "../src/data/sources/gog/GOGGame.vala"
		_file_size = _tmp37_;
#line 384 "../src/data/sources/gog/GOGGame.vala"
		_file_index = -1;
#line 384 "../src/data/sources/gog/GOGGame.vala"
		while (TRUE) {
#line 5872 "GOGGame.c"
			gint _tmp38_;
			gint _tmp39_;
			GFile* file = NULL;
			GeeArrayList* _tmp40_;
			gpointer _tmp41_;
			gboolean _tmp42_ = FALSE;
			GFile* _tmp43_;
#line 384 "../src/data/sources/gog/GOGGame.vala"
			_file_index = _file_index + 1;
#line 384 "../src/data/sources/gog/GOGGame.vala"
			_tmp38_ = _file_index;
#line 384 "../src/data/sources/gog/GOGGame.vala"
			_tmp39_ = _file_size;
#line 384 "../src/data/sources/gog/GOGGame.vala"
			if (!(_tmp38_ < _tmp39_)) {
#line 384 "../src/data/sources/gog/GOGGame.vala"
				break;
#line 5890 "GOGGame.c"
			}
#line 384 "../src/data/sources/gog/GOGGame.vala"
			_tmp40_ = _file_list;
#line 384 "../src/data/sources/gog/GOGGame.vala"
			_tmp41_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, _file_index);
#line 384 "../src/data/sources/gog/GOGGame.vala"
			file = (GFile*) _tmp41_;
#line 386 "../src/data/sources/gog/GOGGame.vala"
			_tmp43_ = file;
#line 386 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp43_ != NULL) {
#line 5902 "GOGGame.c"
				GFile* _tmp44_;
#line 386 "../src/data/sources/gog/GOGGame.vala"
				_tmp44_ = file;
#line 386 "../src/data/sources/gog/GOGGame.vala"
				_tmp42_ = g_file_query_exists (_tmp44_, NULL);
#line 5908 "GOGGame.c"
			} else {
#line 386 "../src/data/sources/gog/GOGGame.vala"
				_tmp42_ = FALSE;
#line 5912 "GOGGame.c"
			}
#line 386 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp42_) {
#line 388 "../src/data/sources/gog/GOGGame.vala"
				state = GAME_HUB_DATA_GAME_STATE_INSTALLED;
#line 389 "../src/data/sources/gog/GOGGame.vala"
				_g_object_unref0 (file);
#line 389 "../src/data/sources/gog/GOGGame.vala"
				break;
#line 5922 "GOGGame.c"
			}
#line 384 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (file);
#line 5926 "GOGGame.c"
		}
	}
#line 393 "../src/data/sources/gog/GOGGame.vala"
	_tmp45_ = game_hub_data_game_status_new (state, (GameHubDataGame*) self, NULL);
#line 393 "../src/data/sources/gog/GOGGame.vala"
	_tmp46_ = _tmp45_;
#line 393 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_status ((GameHubDataGame*) self, _tmp46_);
#line 393 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_game_status_unref0 (_tmp46_);
#line 394 "../src/data/sources/gog/GOGGame.vala"
	if (state == GAME_HUB_DATA_GAME_STATE_INSTALLED) {
#line 5939 "GOGGame.c"
		GameHubDataDBTablesTagsTag* _tmp47_;
		GameHubDataDBTablesTagsTag* _tmp48_;
#line 396 "../src/data/sources/gog/GOGGame.vala"
		_tmp47_ = game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
#line 396 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_remove_tag ((GameHubDataGame*) self, _tmp47_);
#line 397 "../src/data/sources/gog/GOGGame.vala"
		_tmp48_ = game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
#line 397 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_add_tag ((GameHubDataGame*) self, _tmp48_);
#line 5950 "GOGGame.c"
	} else {
		GameHubDataDBTablesTagsTag* _tmp49_;
		GameHubDataDBTablesTagsTag* _tmp50_;
#line 401 "../src/data/sources/gog/GOGGame.vala"
		_tmp49_ = game_hub_data_db_tables_tags_BUILTIN_UNINSTALLED;
#line 401 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_add_tag ((GameHubDataGame*) self, _tmp49_);
#line 402 "../src/data/sources/gog/GOGGame.vala"
		_tmp50_ = game_hub_data_db_tables_tags_BUILTIN_INSTALLED;
#line 402 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_remove_tag ((GameHubDataGame*) self, _tmp50_);
#line 5962 "GOGGame.c"
	}
#line 405 "../src/data/sources/gog/GOGGame.vala"
	_tmp52_ = gameinfo;
#line 405 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp52_ != NULL) {
#line 5968 "GOGGame.c"
		GFile* _tmp53_;
#line 405 "../src/data/sources/gog/GOGGame.vala"
		_tmp53_ = gameinfo;
#line 405 "../src/data/sources/gog/GOGGame.vala"
		_tmp51_ = g_file_query_exists (_tmp53_, NULL);
#line 5974 "GOGGame.c"
	} else {
#line 405 "../src/data/sources/gog/GOGGame.vala"
		_tmp51_ = FALSE;
#line 5978 "GOGGame.c"
	}
#line 405 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp51_) {
#line 5982 "GOGGame.c"
		{
			gchar* info = NULL;
			GFile* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_ = NULL;
			gchar** lines = NULL;
			const gchar* _tmp58_;
			gchar** _tmp59_;
			gchar** _tmp60_;
			gint lines_length1;
			gint _lines_size_;
			gchar** _tmp61_;
			gint _tmp61__length1;
#line 410 "../src/data/sources/gog/GOGGame.vala"
			_tmp54_ = gameinfo;
#line 410 "../src/data/sources/gog/GOGGame.vala"
			_tmp55_ = g_file_get_path (_tmp54_);
#line 410 "../src/data/sources/gog/GOGGame.vala"
			_tmp56_ = _tmp55_;
#line 410 "../src/data/sources/gog/GOGGame.vala"
			g_file_get_contents (_tmp56_, &_tmp57_, NULL, &_inner_error0_);
#line 410 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (info);
#line 410 "../src/data/sources/gog/GOGGame.vala"
			info = _tmp57_;
#line 410 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_tmp56_);
#line 410 "../src/data/sources/gog/GOGGame.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (info);
#line 6015 "GOGGame.c"
				goto __catch0_g_error;
			}
#line 411 "../src/data/sources/gog/GOGGame.vala"
			_tmp58_ = info;
#line 411 "../src/data/sources/gog/GOGGame.vala"
			_tmp60_ = _tmp59_ = g_strsplit (_tmp58_, "\n", 0);
#line 411 "../src/data/sources/gog/GOGGame.vala"
			lines = _tmp60_;
#line 411 "../src/data/sources/gog/GOGGame.vala"
			lines_length1 = _vala_array_length (_tmp59_);
#line 411 "../src/data/sources/gog/GOGGame.vala"
			_lines_size_ = lines_length1;
#line 412 "../src/data/sources/gog/GOGGame.vala"
			_tmp61_ = lines;
#line 412 "../src/data/sources/gog/GOGGame.vala"
			_tmp61__length1 = lines_length1;
#line 412 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp61__length1 >= 2) {
#line 6034 "GOGGame.c"
				gchar** _tmp62_;
				gint _tmp62__length1;
				const gchar* _tmp63_;
#line 414 "../src/data/sources/gog/GOGGame.vala"
				_tmp62_ = lines;
#line 414 "../src/data/sources/gog/GOGGame.vala"
				_tmp62__length1 = lines_length1;
#line 414 "../src/data/sources/gog/GOGGame.vala"
				_tmp63_ = _tmp62_[1];
#line 414 "../src/data/sources/gog/GOGGame.vala"
				game_hub_data_game_set_version ((GameHubDataGame*) self, _tmp63_);
#line 6046 "GOGGame.c"
			}
#line 407 "../src/data/sources/gog/GOGGame.vala"
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (info);
#line 6052 "GOGGame.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp64_;
			const gchar* _tmp65_;
#line 407 "../src/data/sources/gog/GOGGame.vala"
			e = _inner_error0_;
#line 407 "../src/data/sources/gog/GOGGame.vala"
			_inner_error0_ = NULL;
#line 419 "../src/data/sources/gog/GOGGame.vala"
			_tmp64_ = e;
#line 419 "../src/data/sources/gog/GOGGame.vala"
			_tmp65_ = _tmp64_->message;
#line 419 "../src/data/sources/gog/GOGGame.vala"
			g_warning ("GOGGame.vala:419: [GOGGame.update_status] Error while reading gameinfo" \
": %s", _tmp65_);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			_g_error_free0 (e);
#line 6072 "GOGGame.c"
		}
		__finally0:
#line 407 "../src/data/sources/gog/GOGGame.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 407 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (files);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (gh_marker);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (goggame);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (gameinfo);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			g_clear_error (&_inner_error0_);
#line 407 "../src/data/sources/gog/GOGGame.vala"
			return;
#line 6091 "GOGGame.c"
		}
	} else {
#line 424 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_update_version ((GameHubDataGame*) self);
#line 6096 "GOGGame.c"
	}
#line 427 "../src/data/sources/gog/GOGGame.vala"
	_tmp66_ = game_hub_data_runnable_get_actions ((GameHubDataRunnable*) self);
#line 427 "../src/data/sources/gog/GOGGame.vala"
	_tmp67_ = _tmp66_;
#line 427 "../src/data/sources/gog/GOGGame.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp67_);
#line 428 "../src/data/sources/gog/GOGGame.vala"
	_tmp69_ = goggame;
#line 428 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp69_ != NULL) {
#line 6108 "GOGGame.c"
		GFile* _tmp70_;
#line 428 "../src/data/sources/gog/GOGGame.vala"
		_tmp70_ = goggame;
#line 428 "../src/data/sources/gog/GOGGame.vala"
		_tmp68_ = g_file_query_exists (_tmp70_, NULL);
#line 6114 "GOGGame.c"
	} else {
#line 428 "../src/data/sources/gog/GOGGame.vala"
		_tmp68_ = FALSE;
#line 6118 "GOGGame.c"
	}
#line 428 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp68_) {
#line 6122 "GOGGame.c"
		JsonNode* goggame_node = NULL;
		GFile* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		JsonNode* _tmp74_;
		JsonNode* _tmp75_;
		gboolean _tmp76_ = FALSE;
		JsonNode* _tmp77_;
#line 430 "../src/data/sources/gog/GOGGame.vala"
		_tmp71_ = goggame;
#line 430 "../src/data/sources/gog/GOGGame.vala"
		_tmp72_ = g_file_get_path (_tmp71_);
#line 430 "../src/data/sources/gog/GOGGame.vala"
		_tmp73_ = _tmp72_;
#line 430 "../src/data/sources/gog/GOGGame.vala"
		_tmp74_ = game_hub_utils_parser_parse_json_file (_tmp73_, "");
#line 430 "../src/data/sources/gog/GOGGame.vala"
		_tmp75_ = _tmp74_;
#line 430 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp73_);
#line 430 "../src/data/sources/gog/GOGGame.vala"
		goggame_node = _tmp75_;
#line 431 "../src/data/sources/gog/GOGGame.vala"
		_tmp77_ = goggame_node;
#line 431 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp77_ != NULL) {
#line 6149 "GOGGame.c"
			JsonNode* _tmp78_;
#line 431 "../src/data/sources/gog/GOGGame.vala"
			_tmp78_ = goggame_node;
#line 431 "../src/data/sources/gog/GOGGame.vala"
			_tmp76_ = json_node_get_node_type (_tmp78_) == JSON_NODE_OBJECT;
#line 6155 "GOGGame.c"
		} else {
#line 431 "../src/data/sources/gog/GOGGame.vala"
			_tmp76_ = FALSE;
#line 6159 "GOGGame.c"
		}
#line 431 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp76_) {
#line 6163 "GOGGame.c"
			JsonObject* goggame_obj = NULL;
			JsonNode* _tmp79_;
			JsonObject* _tmp80_;
			JsonObject* _tmp81_;
			JsonArray* _tmp82_ = NULL;
			JsonObject* _tmp83_;
			JsonArray* tasks = NULL;
			JsonArray* _tmp86_;
			JsonArray* _tmp87_;
#line 433 "../src/data/sources/gog/GOGGame.vala"
			_tmp79_ = goggame_node;
#line 433 "../src/data/sources/gog/GOGGame.vala"
			_tmp80_ = json_node_get_object (_tmp79_);
#line 433 "../src/data/sources/gog/GOGGame.vala"
			_tmp81_ = _json_object_ref0 (_tmp80_);
#line 433 "../src/data/sources/gog/GOGGame.vala"
			goggame_obj = _tmp81_;
#line 434 "../src/data/sources/gog/GOGGame.vala"
			_tmp83_ = goggame_obj;
#line 434 "../src/data/sources/gog/GOGGame.vala"
			if (json_object_has_member (_tmp83_, "playTasks")) {
#line 6185 "GOGGame.c"
				JsonObject* _tmp84_;
				JsonArray* _tmp85_;
#line 434 "../src/data/sources/gog/GOGGame.vala"
				_tmp84_ = goggame_obj;
#line 434 "../src/data/sources/gog/GOGGame.vala"
				_tmp85_ = json_object_get_array_member (_tmp84_, "playTasks");
#line 434 "../src/data/sources/gog/GOGGame.vala"
				_tmp82_ = _tmp85_;
#line 6194 "GOGGame.c"
			} else {
#line 434 "../src/data/sources/gog/GOGGame.vala"
				_tmp82_ = NULL;
#line 6198 "GOGGame.c"
			}
#line 434 "../src/data/sources/gog/GOGGame.vala"
			_tmp86_ = _json_array_ref0 (_tmp82_);
#line 434 "../src/data/sources/gog/GOGGame.vala"
			tasks = _tmp86_;
#line 435 "../src/data/sources/gog/GOGGame.vala"
			_tmp87_ = tasks;
#line 435 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp87_ != NULL) {
#line 6208 "GOGGame.c"
				JsonArray* _tmp88_;
				GList* _tmp89_;
#line 437 "../src/data/sources/gog/GOGGame.vala"
				_tmp88_ = tasks;
#line 437 "../src/data/sources/gog/GOGGame.vala"
				_tmp89_ = json_array_get_elements (_tmp88_);
#line 6215 "GOGGame.c"
				{
					GList* task_node_collection = NULL;
					GList* task_node_it = NULL;
#line 437 "../src/data/sources/gog/GOGGame.vala"
					task_node_collection = _tmp89_;
#line 437 "../src/data/sources/gog/GOGGame.vala"
					for (task_node_it = task_node_collection; task_node_it != NULL; task_node_it = task_node_it->next) {
#line 6223 "GOGGame.c"
						JsonNode* task_node = NULL;
#line 437 "../src/data/sources/gog/GOGGame.vala"
						task_node = (JsonNode*) task_node_it->data;
#line 6227 "GOGGame.c"
						{
							gboolean _tmp90_ = FALSE;
							JsonNode* _tmp91_;
							GameHubDataSourcesGOGGOGGameRunnableAction* action = NULL;
							JsonNode* _tmp93_;
							JsonObject* _tmp94_;
							GameHubDataSourcesGOGGOGGameRunnableAction* _tmp95_;
							GameHubDataSourcesGOGGOGGameRunnableAction* _tmp96_;
							gboolean _tmp97_;
							gboolean _tmp98_;
#line 439 "../src/data/sources/gog/GOGGame.vala"
							_tmp91_ = task_node;
#line 439 "../src/data/sources/gog/GOGGame.vala"
							if (_tmp91_ == NULL) {
#line 439 "../src/data/sources/gog/GOGGame.vala"
								_tmp90_ = TRUE;
#line 6244 "GOGGame.c"
							} else {
								JsonNode* _tmp92_;
#line 439 "../src/data/sources/gog/GOGGame.vala"
								_tmp92_ = task_node;
#line 439 "../src/data/sources/gog/GOGGame.vala"
								_tmp90_ = json_node_get_node_type (_tmp92_) != JSON_NODE_OBJECT;
#line 6251 "GOGGame.c"
							}
#line 439 "../src/data/sources/gog/GOGGame.vala"
							if (_tmp90_) {
#line 439 "../src/data/sources/gog/GOGGame.vala"
								continue;
#line 6257 "GOGGame.c"
							}
#line 440 "../src/data/sources/gog/GOGGame.vala"
							_tmp93_ = task_node;
#line 440 "../src/data/sources/gog/GOGGame.vala"
							_tmp94_ = json_node_get_object (_tmp93_);
#line 440 "../src/data/sources/gog/GOGGame.vala"
							_tmp95_ = game_hub_data_sources_gog_gog_game_runnable_action_new (self, _tmp94_);
#line 440 "../src/data/sources/gog/GOGGame.vala"
							action = _tmp95_;
#line 441 "../src/data/sources/gog/GOGGame.vala"
							_tmp96_ = action;
#line 441 "../src/data/sources/gog/GOGGame.vala"
							_tmp97_ = game_hub_data_runnable_runnable_action_get_is_hidden ((GameHubDataRunnableRunnableAction*) _tmp96_);
#line 441 "../src/data/sources/gog/GOGGame.vala"
							_tmp98_ = _tmp97_;
#line 441 "../src/data/sources/gog/GOGGame.vala"
							if (!_tmp98_) {
#line 6275 "GOGGame.c"
								GeeArrayList* _tmp99_;
								GeeArrayList* _tmp100_;
								GameHubDataSourcesGOGGOGGameRunnableAction* _tmp101_;
#line 443 "../src/data/sources/gog/GOGGame.vala"
								_tmp99_ = game_hub_data_runnable_get_actions ((GameHubDataRunnable*) self);
#line 443 "../src/data/sources/gog/GOGGame.vala"
								_tmp100_ = _tmp99_;
#line 443 "../src/data/sources/gog/GOGGame.vala"
								_tmp101_ = action;
#line 443 "../src/data/sources/gog/GOGGame.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp100_, (GameHubDataRunnableRunnableAction*) _tmp101_);
#line 6287 "GOGGame.c"
							}
#line 437 "../src/data/sources/gog/GOGGame.vala"
							_game_hub_data_runnable_runnable_action_unref0 (action);
#line 6291 "GOGGame.c"
						}
					}
#line 437 "../src/data/sources/gog/GOGGame.vala"
					(task_node_collection == NULL) ? NULL : (task_node_collection = (g_list_free (task_node_collection), NULL));
#line 6296 "GOGGame.c"
				}
			}
#line 431 "../src/data/sources/gog/GOGGame.vala"
			_json_array_unref0 (tasks);
#line 431 "../src/data/sources/gog/GOGGame.vala"
			_json_object_unref0 (goggame_obj);
#line 6303 "GOGGame.c"
		}
#line 428 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (goggame_node);
#line 6307 "GOGGame.c"
	}
#line 450 "../src/data/sources/gog/GOGGame.vala"
	_tmp102_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) self);
#line 450 "../src/data/sources/gog/GOGGame.vala"
	_tmp103_ = _tmp102_;
#line 450 "../src/data/sources/gog/GOGGame.vala"
	_tmp104_ = g_strdup (_tmp103_);
#line 450 "../src/data/sources/gog/GOGGame.vala"
	g = _tmp104_;
#line 451 "../src/data/sources/gog/GOGGame.vala"
	d = NULL;
#line 452 "../src/data/sources/gog/GOGGame.vala"
	if (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (self)) {
#line 6321 "GOGGame.c"
		GameHubDataSourcesGOGGOGGame* _tmp105_;
		const gchar* _tmp106_;
		const gchar* _tmp107_;
		gchar* _tmp108_;
		const gchar* _tmp109_;
		const gchar* _tmp110_;
		gchar* _tmp111_;
#line 454 "../src/data/sources/gog/GOGGame.vala"
		_tmp105_ = (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (self) ? ((GameHubDataSourcesGOGGOGGameDLC*) self) : NULL)->game;
#line 454 "../src/data/sources/gog/GOGGame.vala"
		_tmp106_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) _tmp105_);
#line 454 "../src/data/sources/gog/GOGGame.vala"
		_tmp107_ = _tmp106_;
#line 454 "../src/data/sources/gog/GOGGame.vala"
		_tmp108_ = g_strdup (_tmp107_);
#line 454 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (g);
#line 454 "../src/data/sources/gog/GOGGame.vala"
		g = _tmp108_;
#line 455 "../src/data/sources/gog/GOGGame.vala"
		_tmp109_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) self);
#line 455 "../src/data/sources/gog/GOGGame.vala"
		_tmp110_ = _tmp109_;
#line 455 "../src/data/sources/gog/GOGGame.vala"
		_tmp111_ = g_strdup (_tmp110_);
#line 455 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (d);
#line 455 "../src/data/sources/gog/GOGGame.vala"
		d = _tmp111_;
#line 6351 "GOGGame.c"
	}
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_tmp112_ = g;
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_tmp113_ = d;
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_tmp114_ = game_hub_utils_fs_utils_paths_collection_gog_expand_installers (_tmp112_, _tmp113_, NULL);
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_tmp115_ = _tmp114_;
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_tmp116_ = game_hub_utils_fs_utils_file (_tmp115_, NULL, NULL);
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_tmp117_ = _tmp116_;
#line 457 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_installers_dir ((GameHubDataGame*) self, _tmp117_);
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_tmp117_);
#line 457 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp115_);
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_tmp118_ = g;
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_tmp119_ = d;
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_tmp120_ = game_hub_utils_fs_utils_paths_collection_gog_expand_bonus (_tmp118_, _tmp119_);
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_tmp121_ = _tmp120_;
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_tmp122_ = game_hub_utils_fs_utils_file (_tmp121_, NULL, NULL);
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_tmp123_ = _tmp122_;
#line 458 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_set_bonus_content_dir (self, _tmp123_);
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_tmp123_);
#line 458 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp121_);
#line 363 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (d);
#line 363 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (g);
#line 363 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (files);
#line 363 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (gh_marker);
#line 363 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (goggame);
#line 363 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (gameinfo);
#line 6401 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_load_achievements_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameLoadAchievementsData* _data_;
	_data_ = _data;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->result);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameLoadAchievementsData, _data_);
#line 6415 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_load_achievements (GameHubDataGame* base,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_)
{
	GameHubDataSourcesGOGGOGGame * self;
	GameHubDataSourcesGogGogGameLoadAchievementsData* _data_;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameLoadAchievementsData);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_real_load_achievements_data_free);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_load_achievements_co (_data_);
#line 6440 "GOGGame.c"
}

static GeeArrayList*
game_hub_data_sources_gog_gog_game_load_achievements_finish (GameHubDataGame* base,
                                                             GAsyncResult* _res_)
{
	GeeArrayList* result;
	GameHubDataSourcesGogGogGameLoadAchievementsData* _data_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	result = _data_->result;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	_data_->result = NULL;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 6457 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_load_achievements_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameLoadAchievementsData* _data_;
#line 479 "../src/data/sources/gog/GOGGame.vala"
	_data_ = _user_data_;
#line 479 "../src/data/sources/gog/GOGGame.vala"
	_data_->_source_object_ = source_object;
#line 479 "../src/data/sources/gog/GOGGame.vala"
	_data_->_res_ = _res_;
#line 479 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_real_load_achievements_co (_data_);
#line 6474 "GOGGame.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 515 "../src/data/sources/gog/GOGGame.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 6482 "GOGGame.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 515 "../src/data/sources/gog/GOGGame.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 6490 "GOGGame.c"
}

static gpointer
_game_hub_data_game_achievement_ref0 (gpointer self)
{
#line 530 "../src/data/sources/gog/GOGGame.vala"
	return self ? game_hub_data_game_achievement_ref (self) : NULL;
#line 6498 "GOGGame.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 535 "../src/data/sources/gog/GOGGame.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 6506 "GOGGame.c"
}

static gint
__lambda126_ (GameHubDataSourcesGOGGOGGame* self,
              GameHubDataGameAchievement* first,
              GameHubDataGameAchievement* second)
{
	GameHubDataSourcesGOGGOGGameAchievement* a1 = NULL;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp0_;
	GameHubDataSourcesGOGGOGGameAchievement* a2 = NULL;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp24_;
	gfloat _tmp25_;
	gfloat _tmp26_;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp27_;
	gfloat _tmp28_;
	gfloat _tmp29_;
	GameHubDataSourcesGOGGOGGameAchievement* _tmp30_;
	gfloat _tmp31_;
	gfloat _tmp32_;
	gint result = 0;
#line 529 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (first != NULL, 0);
#line 529 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (second != NULL, 0);
#line 530 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _game_hub_data_game_achievement_ref0 (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_ACHIEVEMENT (first) ? ((GameHubDataSourcesGOGGOGGameAchievement*) first) : NULL);
#line 530 "../src/data/sources/gog/GOGGame.vala"
	a1 = _tmp0_;
#line 531 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _game_hub_data_game_achievement_ref0 (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_ACHIEVEMENT (second) ? ((GameHubDataSourcesGOGGOGGameAchievement*) second) : NULL);
#line 531 "../src/data/sources/gog/GOGGame.vala"
	a2 = _tmp1_;
#line 533 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = a1;
#line 533 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = game_hub_data_game_achievement_get_unlock_date ((GameHubDataGameAchievement*) _tmp3_);
#line 533 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = _tmp4_;
#line 533 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp5_ != NULL) {
#line 533 "../src/data/sources/gog/GOGGame.vala"
		_tmp2_ = TRUE;
#line 6557 "GOGGame.c"
	} else {
		GameHubDataSourcesGOGGOGGameAchievement* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
#line 533 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = a2;
#line 533 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = game_hub_data_game_achievement_get_unlock_date ((GameHubDataGameAchievement*) _tmp6_);
#line 533 "../src/data/sources/gog/GOGGame.vala"
		_tmp8_ = _tmp7_;
#line 533 "../src/data/sources/gog/GOGGame.vala"
		_tmp2_ = _tmp8_ != NULL;
#line 6570 "GOGGame.c"
	}
#line 533 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp2_) {
#line 6574 "GOGGame.c"
		GDateTime* _tmp9_ = NULL;
		GameHubDataSourcesGOGGOGGameAchievement* _tmp10_;
		GDateTime* _tmp11_;
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
		GDateTime* _tmp15_ = NULL;
		GameHubDataSourcesGOGGOGGameAchievement* _tmp16_;
		GDateTime* _tmp17_;
		GDateTime* _tmp18_;
		GDateTime* _tmp19_;
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp10_ = a2;
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp11_ = game_hub_data_game_achievement_get_unlock_date ((GameHubDataGameAchievement*) _tmp10_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp12_ = _tmp11_;
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp13_ = _g_date_time_ref0 (_tmp12_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp9_ = _tmp13_;
#line 535 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp9_ == NULL) {
#line 6597 "GOGGame.c"
			GDateTime* _tmp14_;
#line 535 "../src/data/sources/gog/GOGGame.vala"
			_tmp14_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 535 "../src/data/sources/gog/GOGGame.vala"
			_g_date_time_unref0 (_tmp9_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
			_tmp9_ = _tmp14_;
#line 6605 "GOGGame.c"
		}
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp16_ = a1;
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp17_ = game_hub_data_game_achievement_get_unlock_date ((GameHubDataGameAchievement*) _tmp16_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp18_ = _tmp17_;
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp19_ = _g_date_time_ref0 (_tmp18_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_tmp15_ = _tmp19_;
#line 535 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp15_ == NULL) {
#line 6619 "GOGGame.c"
			GDateTime* _tmp20_;
#line 535 "../src/data/sources/gog/GOGGame.vala"
			_tmp20_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 535 "../src/data/sources/gog/GOGGame.vala"
			_g_date_time_unref0 (_tmp15_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
			_tmp15_ = _tmp20_;
#line 6627 "GOGGame.c"
		}
#line 535 "../src/data/sources/gog/GOGGame.vala"
		result = g_date_time_compare (_tmp9_, _tmp15_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_g_date_time_unref0 (_tmp15_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_g_date_time_unref0 (_tmp9_);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_game_achievement_unref0 (a2);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_game_achievement_unref0 (a1);
#line 535 "../src/data/sources/gog/GOGGame.vala"
		return result;
#line 6641 "GOGGame.c"
	}
#line 538 "../src/data/sources/gog/GOGGame.vala"
	_tmp21_ = a1;
#line 538 "../src/data/sources/gog/GOGGame.vala"
	_tmp22_ = game_hub_data_game_achievement_get_global_percentage ((GameHubDataGameAchievement*) _tmp21_);
#line 538 "../src/data/sources/gog/GOGGame.vala"
	_tmp23_ = _tmp22_;
#line 538 "../src/data/sources/gog/GOGGame.vala"
	_tmp24_ = a2;
#line 538 "../src/data/sources/gog/GOGGame.vala"
	_tmp25_ = game_hub_data_game_achievement_get_global_percentage ((GameHubDataGameAchievement*) _tmp24_);
#line 538 "../src/data/sources/gog/GOGGame.vala"
	_tmp26_ = _tmp25_;
#line 538 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp23_ < _tmp26_) {
#line 538 "../src/data/sources/gog/GOGGame.vala"
		result = 1;
#line 538 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_game_achievement_unref0 (a2);
#line 538 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_game_achievement_unref0 (a1);
#line 538 "../src/data/sources/gog/GOGGame.vala"
		return result;
#line 6665 "GOGGame.c"
	}
#line 539 "../src/data/sources/gog/GOGGame.vala"
	_tmp27_ = a1;
#line 539 "../src/data/sources/gog/GOGGame.vala"
	_tmp28_ = game_hub_data_game_achievement_get_global_percentage ((GameHubDataGameAchievement*) _tmp27_);
#line 539 "../src/data/sources/gog/GOGGame.vala"
	_tmp29_ = _tmp28_;
#line 539 "../src/data/sources/gog/GOGGame.vala"
	_tmp30_ = a2;
#line 539 "../src/data/sources/gog/GOGGame.vala"
	_tmp31_ = game_hub_data_game_achievement_get_global_percentage ((GameHubDataGameAchievement*) _tmp30_);
#line 539 "../src/data/sources/gog/GOGGame.vala"
	_tmp32_ = _tmp31_;
#line 539 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp29_ > _tmp32_) {
#line 539 "../src/data/sources/gog/GOGGame.vala"
		result = -1;
#line 539 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_game_achievement_unref0 (a2);
#line 539 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_game_achievement_unref0 (a1);
#line 539 "../src/data/sources/gog/GOGGame.vala"
		return result;
#line 6689 "GOGGame.c"
	}
#line 540 "../src/data/sources/gog/GOGGame.vala"
	result = 0;
#line 540 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_game_achievement_unref0 (a2);
#line 540 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_game_achievement_unref0 (a1);
#line 540 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 6699 "GOGGame.c"
}

static gint
___lambda126__gcompare_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gint result;
	result = __lambda126_ ((GameHubDataSourcesGOGGOGGame*) self, (GameHubDataGameAchievement*) a, (GameHubDataGameAchievement*) b);
#line 529 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 6711 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_real_load_achievements_co (GameHubDataSourcesGogGogGameLoadAchievementsData* _data_)
{
#line 462 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 462 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 6721 "GOGGame.c"
		goto _state_0;
#line 462 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 6725 "GOGGame.c"
		goto _state_1;
#line 462 "../src/data/sources/gog/GOGGame.vala"
		case 2:
#line 6729 "GOGGame.c"
		goto _state_2;
		default:
#line 462 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 6734 "GOGGame.c"
	}
	_state_0:
#line 464 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp3_ = game_hub_data_game_get_achievements ((GameHubDataGame*) _data_->self);
#line 464 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 464 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp4_ != NULL) {
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp2_ = TRUE;
#line 6745 "GOGGame.c"
	} else {
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp2_ = _data_->self->priv->loading_achievements;
#line 6749 "GOGGame.c"
	}
#line 464 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp2_) {
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp1_ = TRUE;
#line 6755 "GOGGame.c"
	} else {
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp5_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp1_ = _data_->_tmp6_ == NULL;
#line 6763 "GOGGame.c"
	}
#line 464 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp1_) {
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = TRUE;
#line 6769 "GOGGame.c"
	} else {
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp7_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp9_ = game_hub_data_sources_gog_gog_get_user_id (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG));
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 464 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = _data_->_tmp10_ == NULL;
#line 6781 "GOGGame.c"
	}
#line 464 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp0_) {
#line 466 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp11_ = game_hub_data_game_get_achievements ((GameHubDataGame*) _data_->self);
#line 466 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 466 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp13_ = _g_object_ref0 (_data_->_tmp12_);
#line 466 "../src/data/sources/gog/GOGGame.vala"
		_data_->result = _data_->_tmp13_;
#line 466 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 466 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 466 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 466 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6801 "GOGGame.c"
			}
		}
#line 466 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 466 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 6808 "GOGGame.c"
	}
#line 469 "../src/data/sources/gog/GOGGame.vala"
	_data_->self->priv->loading_achievements = TRUE;
#line 471 "../src/data/sources/gog/GOGGame.vala"
	_data_->root = NULL;
#line 472 "../src/data/sources/gog/GOGGame.vala"
	_data_->root_obj = NULL;
#line 474 "../src/data/sources/gog/GOGGame.vala"
	while (TRUE) {
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp14_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) _data_->self);
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp16_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp18_ = game_hub_data_sources_gog_gog_get_user_id (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp17_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG));
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp20_ = g_strdup_printf ("https://gameplay.gog.com/clients/%s/users/%s/achievements", _data_->_tmp15_, _data_->_tmp19_);
#line 476 "../src/data/sources/gog/GOGGame.vala"
		_data_->url = _data_->_tmp20_;
#line 477 "../src/data/sources/gog/GOGGame.vala"
		_data_->status = (guint) 0;
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp21_ = _data_->url;
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp22_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp24_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp23_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG)->user_token;
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp25_ = 0U;
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->_state_ = 1;
#line 479 "../src/data/sources/gog/GOGGame.vala"
		game_hub_utils_parser_parse_remote_json_file_async (_data_->_tmp21_, "GET", _data_->_tmp24_, NULL, NULL, game_hub_data_sources_gog_gog_game_load_achievements_ready, _data_);
#line 479 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 6852 "GOGGame.c"
		_state_1:
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp26_ = game_hub_utils_parser_parse_remote_json_file_finish (_data_->_res_, &_data_->_tmp25_);
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->status = _data_->_tmp25_;
#line 479 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 479 "../src/data/sources/gog/GOGGame.vala"
		_data_->root = _data_->_tmp26_;
#line 480 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp29_ = _data_->root;
#line 480 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp29_ != NULL) {
#line 480 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp30_ = _data_->root;
#line 480 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp28_ = json_node_get_node_type (_data_->_tmp30_) == JSON_NODE_OBJECT;
#line 6870 "GOGGame.c"
		} else {
#line 480 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp28_ = FALSE;
#line 6874 "GOGGame.c"
		}
#line 480 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_tmp28_) {
#line 480 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp31_ = _data_->root;
#line 480 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp32_ = json_node_get_object (_data_->_tmp31_);
#line 480 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp27_ = _data_->_tmp32_;
#line 6884 "GOGGame.c"
		} else {
#line 480 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp27_ = NULL;
#line 6888 "GOGGame.c"
		}
#line 480 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp33_ = _json_object_ref0 (_data_->_tmp27_);
#line 480 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (_data_->root_obj);
#line 480 "../src/data/sources/gog/GOGGame.vala"
		_data_->root_obj = _data_->_tmp33_;
#line 482 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->status == ((guint) SOUP_STATUS_UNAUTHORIZED)) {
#line 484 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp34_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->self);
#line 484 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp35_ = _data_->_tmp34_;
#line 484 "../src/data/sources/gog/GOGGame.vala"
			_data_->_state_ = 2;
#line 484 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_sources_gog_gog_refresh_token (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp35_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG), game_hub_data_sources_gog_gog_game_load_achievements_ready, _data_);
#line 484 "../src/data/sources/gog/GOGGame.vala"
			return FALSE;
#line 6908 "GOGGame.c"
			_state_2:
#line 484 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_sources_gog_gog_refresh_token_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp35_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG), _data_->_res_);
#line 6912 "GOGGame.c"
		} else {
#line 486 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_data_->url);
#line 486 "../src/data/sources/gog/GOGGame.vala"
			break;
#line 6918 "GOGGame.c"
		}
#line 474 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->url);
#line 6922 "GOGGame.c"
	}
#line 489 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp37_ = _data_->root_obj;
#line 489 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp37_ == NULL) {
#line 489 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp36_ = TRUE;
#line 6930 "GOGGame.c"
	} else {
#line 489 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp38_ = _data_->root_obj;
#line 489 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp36_ = !json_object_has_member (_data_->_tmp38_, "items");
#line 6936 "GOGGame.c"
	}
#line 489 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp36_) {
#line 491 "../src/data/sources/gog/GOGGame.vala"
		_data_->self->priv->loading_achievements = FALSE;
#line 492 "../src/data/sources/gog/GOGGame.vala"
		_data_->result = NULL;
#line 492 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (_data_->root_obj);
#line 492 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 492 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 492 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 492 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 492 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6956 "GOGGame.c"
			}
		}
#line 492 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 492 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 6963 "GOGGame.c"
	}
#line 495 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp39_ = _data_->root_obj;
#line 495 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp40_ = json_object_get_array_member (_data_->_tmp39_, "items");
#line 495 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp41_ = _json_array_ref0 (_data_->_tmp40_);
#line 495 "../src/data/sources/gog/GOGGame.vala"
	_data_->achievements_array = _data_->_tmp41_;
#line 497 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp42_ = gee_array_list_new (GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, (GBoxedCopyFunc) game_hub_data_game_achievement_ref, (GDestroyNotify) game_hub_data_game_achievement_unref, NULL, NULL, NULL);
#line 497 "../src/data/sources/gog/GOGGame.vala"
	_data_->_achievements = _data_->_tmp42_;
#line 499 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp43_ = _data_->achievements_array;
#line 499 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp44_ = json_array_get_elements (_data_->_tmp43_);
#line 6981 "GOGGame.c"
	{
#line 499 "../src/data/sources/gog/GOGGame.vala"
		_data_->a_node_collection = _data_->_tmp44_;
#line 499 "../src/data/sources/gog/GOGGame.vala"
		for (_data_->a_node_it = _data_->a_node_collection; _data_->a_node_it != NULL; _data_->a_node_it = _data_->a_node_it->next) {
#line 499 "../src/data/sources/gog/GOGGame.vala"
			_data_->a_node = (JsonNode*) _data_->a_node_it->data;
#line 6989 "GOGGame.c"
			{
#line 501 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp47_ = _data_->a_node;
#line 501 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp47_ != NULL) {
#line 501 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp48_ = _data_->a_node;
#line 501 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp46_ = json_node_get_node_type (_data_->_tmp48_) == JSON_NODE_OBJECT;
#line 6999 "GOGGame.c"
				} else {
#line 501 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp46_ = FALSE;
#line 7003 "GOGGame.c"
				}
#line 501 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp46_) {
#line 502 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp49_ = _data_->a_node;
#line 502 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp50_ = json_node_get_object (_data_->_tmp49_);
#line 502 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp45_ = _data_->_tmp50_;
#line 7013 "GOGGame.c"
				} else {
#line 502 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp45_ = NULL;
#line 7017 "GOGGame.c"
				}
#line 501 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp51_ = _json_object_ref0 (_data_->_tmp45_);
#line 501 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_obj = _data_->_tmp51_;
#line 504 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp53_ = _data_->a_obj;
#line 504 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp53_ == NULL) {
#line 504 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp52_ = TRUE;
#line 7029 "GOGGame.c"
				} else {
#line 504 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp54_ = _data_->a_obj;
#line 504 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp52_ = !json_object_has_member (_data_->_tmp54_, "achievement_key");
#line 7035 "GOGGame.c"
				}
#line 504 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp52_) {
#line 504 "../src/data/sources/gog/GOGGame.vala"
					_json_object_unref0 (_data_->a_obj);
#line 504 "../src/data/sources/gog/GOGGame.vala"
					continue;
#line 7043 "GOGGame.c"
				}
#line 506 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp55_ = _data_->a_obj;
#line 506 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp56_ = json_object_get_string_member (_data_->_tmp55_, "achievement_key");
#line 506 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp57_ = g_strdup (_data_->_tmp56_);
#line 506 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_id = _data_->_tmp57_;
#line 507 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp59_ = _data_->a_obj;
#line 507 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (_data_->_tmp59_, "name")) {
#line 507 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp60_ = _data_->a_obj;
#line 507 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp61_ = json_object_get_string_member (_data_->_tmp60_, "name");
#line 507 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp58_ = _data_->_tmp61_;
#line 7063 "GOGGame.c"
				} else {
#line 507 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp62_ = _data_->a_id;
#line 507 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp58_ = _data_->_tmp62_;
#line 7069 "GOGGame.c"
				}
#line 507 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp63_ = g_strdup (_data_->_tmp58_);
#line 507 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_name = _data_->_tmp63_;
#line 508 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp65_ = _data_->a_obj;
#line 508 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (_data_->_tmp65_, "description")) {
#line 508 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp66_ = _data_->a_obj;
#line 508 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp67_ = json_object_get_string_member (_data_->_tmp66_, "description");
#line 508 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp64_ = _data_->_tmp67_;
#line 7085 "GOGGame.c"
				} else {
#line 508 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp64_ = "";
#line 7089 "GOGGame.c"
				}
#line 508 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp68_ = g_strdup (_data_->_tmp64_);
#line 508 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_desc = _data_->_tmp68_;
#line 509 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp70_ = _data_->a_obj;
#line 509 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (_data_->_tmp70_, "image_url_unlocked")) {
#line 509 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp71_ = _data_->a_obj;
#line 509 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp72_ = json_object_get_string_member (_data_->_tmp71_, "image_url_unlocked");
#line 509 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp69_ = _data_->_tmp72_;
#line 7105 "GOGGame.c"
				} else {
#line 509 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp69_ = NULL;
#line 7109 "GOGGame.c"
				}
#line 509 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp73_ = g_strdup (_data_->_tmp69_);
#line 509 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_image_unlocked = _data_->_tmp73_;
#line 510 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp75_ = _data_->a_obj;
#line 510 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (_data_->_tmp75_, "image_url_locked")) {
#line 510 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp76_ = _data_->a_obj;
#line 510 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp77_ = json_object_get_string_member (_data_->_tmp76_, "image_url_locked");
#line 510 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp74_ = _data_->_tmp77_;
#line 7125 "GOGGame.c"
				} else {
#line 510 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp74_ = NULL;
#line 7129 "GOGGame.c"
				}
#line 510 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp78_ = g_strdup (_data_->_tmp74_);
#line 510 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_image_locked = _data_->_tmp78_;
#line 511 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_unlock_date = NULL;
#line 513 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp79_ = _data_->a_obj;
#line 513 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (_data_->_tmp79_, "date_unlocked")) {
#line 515 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp80_ = _data_->a_obj;
#line 515 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp81_ = json_object_get_member (_data_->_tmp80_, "date_unlocked");
#line 515 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp82_ = __vala_JsonNode_copy0 (_data_->_tmp81_);
#line 515 "../src/data/sources/gog/GOGGame.vala"
					_data_->date = _data_->_tmp82_;
#line 516 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp83_ = _data_->date;
#line 516 "../src/data/sources/gog/GOGGame.vala"
					if (json_node_get_node_type (_data_->_tmp83_) == JSON_NODE_VALUE) {
#line 518 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp84_ = _data_->date;
#line 518 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp85_ = json_node_get_string (_data_->_tmp84_);
#line 518 "../src/data/sources/gog/GOGGame.vala"
						_data_->_tmp86_ = g_strdup (_data_->_tmp85_);
#line 518 "../src/data/sources/gog/GOGGame.vala"
						_g_free0 (_data_->a_unlock_date);
#line 518 "../src/data/sources/gog/GOGGame.vala"
						_data_->a_unlock_date = _data_->_tmp86_;
#line 7163 "GOGGame.c"
					}
#line 513 "../src/data/sources/gog/GOGGame.vala"
					__vala_JsonNode_free0 (_data_->date);
#line 7167 "GOGGame.c"
				}
#line 522 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp87_ = _data_->a_unlock_date;
#line 522 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_unlocked = _data_->_tmp87_ != NULL;
#line 523 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp89_ = _data_->a_obj;
#line 523 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (_data_->_tmp89_, "rarity")) {
#line 523 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp90_ = _data_->a_obj;
#line 523 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp88_ = (gfloat) json_object_get_double_member (_data_->_tmp90_, "rarity");
#line 7181 "GOGGame.c"
				} else {
#line 523 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp88_ = (gfloat) 0;
#line 7185 "GOGGame.c"
				}
#line 523 "../src/data/sources/gog/GOGGame.vala"
				_data_->a_global_percentage = _data_->_tmp88_;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp91_ = _data_->_achievements;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp92_ = _data_->a_id;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp93_ = _data_->a_name;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp94_ = _data_->a_desc;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp95_ = _data_->a_image_locked;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp96_ = _data_->a_image_unlocked;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp97_ = _data_->a_unlock_date;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp98_ = game_hub_data_sources_gog_gog_game_achievement_new (_data_->_tmp92_, _data_->_tmp93_, _data_->_tmp94_, _data_->_tmp95_, _data_->_tmp96_, _data_->a_unlocked, _data_->_tmp97_, _data_->a_global_percentage);
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp99_ = _data_->_tmp98_;
#line 525 "../src/data/sources/gog/GOGGame.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp91_, (GameHubDataGameAchievement*) _data_->_tmp99_);
#line 525 "../src/data/sources/gog/GOGGame.vala"
				_game_hub_data_game_achievement_unref0 (_data_->_tmp99_);
#line 499 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->a_unlock_date);
#line 499 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->a_image_locked);
#line 499 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->a_image_unlocked);
#line 499 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->a_desc);
#line 499 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->a_name);
#line 499 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_data_->a_id);
#line 499 "../src/data/sources/gog/GOGGame.vala"
				_json_object_unref0 (_data_->a_obj);
#line 7225 "GOGGame.c"
			}
		}
#line 499 "../src/data/sources/gog/GOGGame.vala"
		(_data_->a_node_collection == NULL) ? NULL : (_data_->a_node_collection = (g_list_free (_data_->a_node_collection), NULL));
#line 7230 "GOGGame.c"
	}
#line 529 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp100_ = _data_->_achievements;
#line 529 "../src/data/sources/gog/GOGGame.vala"
	gee_list_sort ((GeeList*) _data_->_tmp100_, ___lambda126__gcompare_data_func, g_object_ref (_data_->self), g_object_unref);
#line 543 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp101_ = _data_->_achievements;
#line 543 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_achievements ((GameHubDataGame*) _data_->self, _data_->_tmp101_);
#line 544 "../src/data/sources/gog/GOGGame.vala"
	_data_->self->priv->loading_achievements = FALSE;
#line 545 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp102_ = game_hub_data_game_get_achievements ((GameHubDataGame*) _data_->self);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp103_ = _data_->_tmp102_;
#line 545 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp104_ = _g_object_ref0 (_data_->_tmp103_);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	_data_->result = _data_->_tmp104_;
#line 545 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_achievements);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	_json_array_unref0 (_data_->achievements_array);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (_data_->root_obj);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 545 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 545 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7266 "GOGGame.c"
		}
	}
#line 545 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 545 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 7273 "GOGGame.c"
}

static gchar**
game_hub_data_sources_gog_gog_game_real_get_tweaks (GameHubDataTweakableGame* base,
                                                    gint* result_length1)
{
	gchar** result;
	GameHubDataSourcesGOGGOGGame* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->priv->_tweaks;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	_tmp0__length1 = self->priv->_tweaks_length1;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _tmp0_;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	_tmp1__length1 = _tmp0__length1;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	if (result_length1) {
#line 27 "../src/data/sources/gog/GOGGame.vala"
		*result_length1 = _tmp1__length1;
#line 7300 "GOGGame.c"
	}
#line 27 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp1_;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 7306 "GOGGame.c"
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
#line 27 "../src/data/sources/gog/GOGGame.vala"
	if (length >= 0) {
#line 7315 "GOGGame.c"
		gchar** result;
		gssize i;
#line 27 "../src/data/sources/gog/GOGGame.vala"
		result = g_new0 (gchar*, length + 1);
#line 27 "../src/data/sources/gog/GOGGame.vala"
		for (i = 0; i < length; i++) {
#line 7322 "GOGGame.c"
			gchar* _tmp0_;
#line 27 "../src/data/sources/gog/GOGGame.vala"
			_tmp0_ = g_strdup (self[i]);
#line 27 "../src/data/sources/gog/GOGGame.vala"
			result[i] = _tmp0_;
#line 7328 "GOGGame.c"
		}
#line 27 "../src/data/sources/gog/GOGGame.vala"
		return result;
#line 7332 "GOGGame.c"
	}
#line 27 "../src/data/sources/gog/GOGGame.vala"
	return NULL;
#line 7336 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_real_set_tweaks (GameHubDataTweakableGame* base,
                                                    gchar** value,
                                                    gint value_length1)
{
	GameHubDataSourcesGOGGOGGame* self;
	gchar** old_value;
	gint old_value_length;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	old_value = game_hub_data_sources_gog_gog_game_real_get_tweaks (base, &old_value_length);
#line 27 "../src/data/sources/gog/GOGGame.vala"
	if (old_value != value) {
#line 7353 "GOGGame.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 27 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup5 (value, value_length1) : value;
#line 27 "../src/data/sources/gog/GOGGame.vala"
		_tmp0__length1 = value_length1;
#line 27 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_tweaks = (_vala_array_free (self->priv->_tweaks, self->priv->_tweaks_length1, (GDestroyNotify) g_free), NULL);
#line 27 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_tweaks = _tmp0_;
#line 27 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_tweaks_length1 = _tmp0__length1;
#line 27 "../src/data/sources/gog/GOGGame.vala"
		self->priv->__tweaks_size_ = self->priv->_tweaks_length1;
#line 27 "../src/data/sources/gog/GOGGame.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TWEAKS_PROPERTY]);
#line 7370 "GOGGame.c"
	}
}

GeeArrayList*
game_hub_data_sources_gog_gog_game_get_installers (GameHubDataSourcesGOGGOGGame* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 29 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->priv->_installers;
#line 29 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp0_;
#line 29 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 7387 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_set_installers (GameHubDataSourcesGOGGOGGame* self,
                                                   GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 29 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/data/sources/gog/GOGGame.vala"
	old_value = game_hub_data_sources_gog_gog_game_get_installers (self);
#line 29 "../src/data/sources/gog/GOGGame.vala"
	if (old_value != value) {
#line 7401 "GOGGame.c"
		GeeArrayList* _tmp0_;
#line 29 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (self->priv->_installers);
#line 29 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_installers = _tmp0_;
#line 29 "../src/data/sources/gog/GOGGame.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLERS_PROPERTY]);
#line 7411 "GOGGame.c"
	}
}

GeeArrayList*
game_hub_data_sources_gog_gog_game_get_bonus_content (GameHubDataSourcesGOGGOGGame* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 30 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->priv->_bonus_content;
#line 30 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp0_;
#line 30 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 7428 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_set_bonus_content (GameHubDataSourcesGOGGOGGame* self,
                                                      GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 30 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/data/sources/gog/GOGGame.vala"
	old_value = game_hub_data_sources_gog_gog_game_get_bonus_content (self);
#line 30 "../src/data/sources/gog/GOGGame.vala"
	if (old_value != value) {
#line 7442 "GOGGame.c"
		GeeArrayList* _tmp0_;
#line 30 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (self->priv->_bonus_content);
#line 30 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_bonus_content = _tmp0_;
#line 30 "../src/data/sources/gog/GOGGame.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_PROPERTY]);
#line 7452 "GOGGame.c"
	}
}

GeeArrayList*
game_hub_data_sources_gog_gog_game_get_dlc (GameHubDataSourcesGOGGOGGame* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 31 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->priv->_dlc;
#line 31 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp0_;
#line 31 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 7469 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_set_dlc (GameHubDataSourcesGOGGOGGame* self,
                                            GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 31 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/data/sources/gog/GOGGame.vala"
	old_value = game_hub_data_sources_gog_gog_game_get_dlc (self);
#line 31 "../src/data/sources/gog/GOGGame.vala"
	if (old_value != value) {
#line 7483 "GOGGame.c"
		GeeArrayList* _tmp0_;
#line 31 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (self->priv->_dlc);
#line 31 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_dlc = _tmp0_;
#line 31 "../src/data/sources/gog/GOGGame.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_PROPERTY]);
#line 7493 "GOGGame.c"
	}
}

GFile*
game_hub_data_sources_gog_gog_game_get_bonus_content_dir (GameHubDataSourcesGOGGOGGame* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 33 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->priv->_bonus_content_dir;
#line 33 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp0_;
#line 33 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 7510 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_set_bonus_content_dir (GameHubDataSourcesGOGGOGGame* self,
                                                          GFile* value)
{
	GFile* old_value;
#line 33 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/data/sources/gog/GOGGame.vala"
	old_value = game_hub_data_sources_gog_gog_game_get_bonus_content_dir (self);
#line 33 "../src/data/sources/gog/GOGGame.vala"
	if (old_value != value) {
#line 7524 "GOGGame.c"
		GFile* _tmp0_;
#line 33 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (self->priv->_bonus_content_dir);
#line 33 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_bonus_content_dir = _tmp0_;
#line 33 "../src/data/sources/gog/GOGGame.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_DIR_PROPERTY]);
#line 7534 "GOGGame.c"
	}
}

gboolean
game_hub_data_sources_gog_gog_game_get_has_updates (GameHubDataSourcesGOGGOGGame* self)
{
	gboolean result;
#line 35 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../src/data/sources/gog/GOGGame.vala"
	result = self->priv->_has_updates;
#line 35 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 7548 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_set_has_updates (GameHubDataSourcesGOGGOGGame* self,
                                                    gboolean value)
{
	gboolean old_value;
#line 35 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/data/sources/gog/GOGGame.vala"
	old_value = game_hub_data_sources_gog_gog_game_get_has_updates (self);
#line 35 "../src/data/sources/gog/GOGGame.vala"
	if (old_value != value) {
#line 35 "../src/data/sources/gog/GOGGame.vala"
		self->priv->_has_updates = value;
#line 35 "../src/data/sources/gog/GOGGame.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_HAS_UPDATES_PROPERTY]);
#line 7566 "GOGGame.c"
	}
}

static GFile*
game_hub_data_sources_gog_gog_game_real_get_default_install_dir (GameHubDataRunnable* base)
{
	GFile* result;
	GameHubDataSourcesGOGGOGGame* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
#line 39 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGame*) base;
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = game_hub_utils_fs_utils_paths_gog_get_Games ();
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _tmp0_;
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = _tmp1_;
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = game_hub_data_runnable_get_escaped_name ((GameHubDataRunnable*) self);
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = _tmp3_;
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = game_hub_utils_fs_utils_file (_tmp2_, _tmp4_, NULL);
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_tmp6_ = _tmp5_;
#line 41 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp2_);
#line 41 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp6_;
#line 41 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 7604 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameAchievement*
game_hub_data_sources_gog_gog_game_achievement_construct (GType object_type,
                                                          const gchar* id,
                                                          const gchar* name,
                                                          const gchar* desc,
                                                          const gchar* image_locked,
                                                          const gchar* image_unlocked,
                                                          gboolean unlocked,
                                                          const gchar* unlock_date,
                                                          gfloat global_percentage)
{
	GameHubDataSourcesGOGGOGGameAchievement* self = NULL;
#line 550 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 550 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 550 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (desc != NULL, NULL);
#line 550 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameAchievement*) game_hub_data_game_achievement_construct (object_type);
#line 553 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_achievement_set_id ((GameHubDataGameAchievement*) self, id);
#line 554 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_achievement_set_name ((GameHubDataGameAchievement*) self, name);
#line 555 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_achievement_set_description ((GameHubDataGameAchievement*) self, desc);
#line 556 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_achievement_set_image_locked ((GameHubDataGameAchievement*) self, image_locked);
#line 557 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_achievement_set_image_unlocked ((GameHubDataGameAchievement*) self, image_unlocked);
#line 558 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_achievement_set_unlocked ((GameHubDataGameAchievement*) self, unlocked);
#line 559 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_achievement_set_global_percentage ((GameHubDataGameAchievement*) self, global_percentage);
#line 562 "../src/data/sources/gog/GOGGame.vala"
	if (unlock_date != NULL) {
#line 7643 "GOGGame.c"
		GTimeZone* _tmp0_;
		GTimeZone* _tmp1_;
		GDateTime* _tmp2_;
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 564 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = g_time_zone_new_utc ();
#line 564 "../src/data/sources/gog/GOGGame.vala"
		_tmp1_ = _tmp0_;
#line 564 "../src/data/sources/gog/GOGGame.vala"
		_tmp2_ = g_date_time_new_from_iso8601 (unlock_date, _tmp1_);
#line 564 "../src/data/sources/gog/GOGGame.vala"
		_tmp3_ = _tmp2_;
#line 564 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_achievement_set_unlock_date ((GameHubDataGameAchievement*) self, _tmp3_);
#line 564 "../src/data/sources/gog/GOGGame.vala"
		_g_date_time_unref0 (_tmp3_);
#line 564 "../src/data/sources/gog/GOGGame.vala"
		_g_time_zone_unref0 (_tmp1_);
#line 565 "../src/data/sources/gog/GOGGame.vala"
		_tmp4_ = game_hub_data_game_achievement_get_unlock_date ((GameHubDataGameAchievement*) self);
#line 565 "../src/data/sources/gog/GOGGame.vala"
		_tmp5_ = _tmp4_;
#line 565 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = game_hub_utils_get_relative_datetime (_tmp5_);
#line 565 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = _tmp6_;
#line 565 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_game_achievement_set_unlock_time ((GameHubDataGameAchievement*) self, _tmp7_);
#line 565 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp7_);
#line 7678 "GOGGame.c"
	}
#line 550 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 7682 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameAchievement*
game_hub_data_sources_gog_gog_game_achievement_new (const gchar* id,
                                                    const gchar* name,
                                                    const gchar* desc,
                                                    const gchar* image_locked,
                                                    const gchar* image_unlocked,
                                                    gboolean unlocked,
                                                    const gchar* unlock_date,
                                                    gfloat global_percentage)
{
#line 550 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_achievement_construct (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_ACHIEVEMENT, id, name, desc, image_locked, image_unlocked, unlocked, unlock_date, global_percentage);
#line 7697 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_achievement_class_init (GameHubDataSourcesGOGGOGGameAchievementClass * klass,
                                                           gpointer klass_data)
{
#line 548 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_achievement_parent_class = g_type_class_peek_parent (klass);
#line 7706 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_achievement_instance_init (GameHubDataSourcesGOGGOGGameAchievement * self,
                                                              gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_achievement_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesGOGGOGGameAchievementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_gog_gog_game_achievement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesGOGGOGGameAchievement), 0, (GInstanceInitFunc) game_hub_data_sources_gog_gog_game_achievement_instance_init, NULL };
	GType game_hub_data_sources_gog_gog_game_achievement_type_id;
	game_hub_data_sources_gog_gog_game_achievement_type_id = g_type_register_static (GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, "GameHubDataSourcesGOGGOGGameAchievement", &g_define_type_info, 0);
	return game_hub_data_sources_gog_gog_game_achievement_type_id;
}

GType
game_hub_data_sources_gog_gog_game_achievement_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_achievement_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_achievement_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_achievement_type_id;
		game_hub_data_sources_gog_gog_game_achievement_type_id = game_hub_data_sources_gog_gog_game_achievement_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_achievement_type_id__volatile, game_hub_data_sources_gog_gog_game_achievement_type_id);
	}
	return game_hub_data_sources_gog_gog_game_achievement_type_id__volatile;
}

static inline gpointer
game_hub_data_sources_gog_gog_game_installer_get_instance_private (GameHubDataSourcesGOGGOGGameInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataSourcesGOGGOGGameInstaller_private_offset);
}

GameHubDataSourcesGOGGOGGameInstaller*
game_hub_data_sources_gog_gog_game_installer_construct (GType object_type,
                                                        GameHubDataSourcesGOGGOGGame* game,
                                                        JsonObject* json)
{
	GameHubDataSourcesGOGGOGGameInstaller* self = NULL;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
	JsonObject* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* os = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* g = NULL;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* d = NULL;
	GFile* _tmp23_ = NULL;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	GameHubDataPlatform _tmp26_;
	GameHubDataPlatform _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	GFile* _tmp35_;
	const gchar* _tmp36_;
#line 583 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 583 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (json != NULL, NULL);
#line 583 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameInstaller*) game_hub_data_runnable_downloadable_installer_construct (object_type);
#line 585 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 585 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->game);
#line 585 "../src/data/sources/gog/GOGGame.vala"
	self->priv->game = _tmp0_;
#line 586 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _json_object_ref0 (json);
#line 586 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (self->priv->json);
#line 586 "../src/data/sources/gog/GOGGame.vala"
	self->priv->json = _tmp1_;
#line 588 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = json_object_get_string_member (json, "id");
#line 588 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_installer_set_id ((GameHubDataRunnableInstaller*) self, _tmp2_);
#line 589 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = json_object_get_string_member (json, "language");
#line 589 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 589 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->lang);
#line 589 "../src/data/sources/gog/GOGGame.vala"
	self->lang = _tmp4_;
#line 590 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = json_object_get_string_member (json, "language_full");
#line 590 "../src/data/sources/gog/GOGGame.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 590 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->lang_full);
#line 590 "../src/data/sources/gog/GOGGame.vala"
	self->lang_full = _tmp6_;
#line 592 "../src/data/sources/gog/GOGGame.vala"
	_tmp7_ = json_object_get_string_member (json, "os");
#line 592 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 592 "../src/data/sources/gog/GOGGame.vala"
	os = _tmp8_;
#line 593 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_installer_set_platform ((GameHubDataRunnableInstaller*) self, GAME_HUB_DATA_PLATFORM_CURRENT);
#line 7820 "GOGGame.c"
	{
		GameHubDataPlatform* p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 594 "../src/data/sources/gog/GOGGame.vala"
		p_collection = GAME_HUB_DATA_PLATFORM_PLATFORMS;
#line 594 "../src/data/sources/gog/GOGGame.vala"
		p_collection_length1 = G_N_ELEMENTS (GAME_HUB_DATA_PLATFORM_PLATFORMS);
#line 594 "../src/data/sources/gog/GOGGame.vala"
		for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 7832 "GOGGame.c"
			GameHubDataPlatform p = 0;
#line 594 "../src/data/sources/gog/GOGGame.vala"
			p = p_collection[p_it];
#line 7836 "GOGGame.c"
			{
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gboolean _tmp12_;
#line 596 "../src/data/sources/gog/GOGGame.vala"
				_tmp9_ = os;
#line 596 "../src/data/sources/gog/GOGGame.vala"
				_tmp10_ = game_hub_data_platform_id (p);
#line 596 "../src/data/sources/gog/GOGGame.vala"
				_tmp11_ = _tmp10_;
#line 596 "../src/data/sources/gog/GOGGame.vala"
				_tmp12_ = g_strcmp0 (_tmp9_, _tmp11_) == 0;
#line 596 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp11_);
#line 596 "../src/data/sources/gog/GOGGame.vala"
				if (_tmp12_) {
#line 598 "../src/data/sources/gog/GOGGame.vala"
					game_hub_data_runnable_installer_set_platform ((GameHubDataRunnableInstaller*) self, p);
#line 599 "../src/data/sources/gog/GOGGame.vala"
					break;
#line 7858 "GOGGame.c"
				}
			}
		}
	}
#line 603 "../src/data/sources/gog/GOGGame.vala"
	_tmp13_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 603 "../src/data/sources/gog/GOGGame.vala"
	_tmp14_ = _tmp13_;
#line 603 "../src/data/sources/gog/GOGGame.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 603 "../src/data/sources/gog/GOGGame.vala"
	g = _tmp15_;
#line 604 "../src/data/sources/gog/GOGGame.vala"
	d = NULL;
#line 605 "../src/data/sources/gog/GOGGame.vala"
	if (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (game)) {
#line 7875 "GOGGame.c"
		GameHubDataSourcesGOGGOGGame* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 607 "../src/data/sources/gog/GOGGame.vala"
		_tmp16_ = (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (game) ? ((GameHubDataSourcesGOGGOGGameDLC*) game) : NULL)->game;
#line 607 "../src/data/sources/gog/GOGGame.vala"
		_tmp17_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) _tmp16_);
#line 607 "../src/data/sources/gog/GOGGame.vala"
		_tmp18_ = _tmp17_;
#line 607 "../src/data/sources/gog/GOGGame.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 607 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (g);
#line 607 "../src/data/sources/gog/GOGGame.vala"
		g = _tmp19_;
#line 608 "../src/data/sources/gog/GOGGame.vala"
		_tmp20_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 608 "../src/data/sources/gog/GOGGame.vala"
		_tmp21_ = _tmp20_;
#line 608 "../src/data/sources/gog/GOGGame.vala"
		_tmp22_ = g_strdup (_tmp21_);
#line 608 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (d);
#line 608 "../src/data/sources/gog/GOGGame.vala"
		d = _tmp22_;
#line 7905 "GOGGame.c"
	}
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp24_ = g;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp25_ = d;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp26_ = game_hub_data_runnable_installer_get_platform ((GameHubDataRunnableInstaller*) self);
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp27_ = _tmp26_;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp28_ = game_hub_utils_fs_utils_paths_collection_gog_expand_installers (_tmp24_, _tmp25_, &_tmp27_);
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp29_ = _tmp28_;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp30_ = game_hub_utils_fs_utils_file (_tmp29_, NULL, NULL);
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp31_ = _tmp30_;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp29_);
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp23_ = _tmp31_;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp23_ == NULL) {
#line 7929 "GOGGame.c"
		GFile* _tmp32_;
		GFile* _tmp33_;
		GFile* _tmp34_;
#line 610 "../src/data/sources/gog/GOGGame.vala"
		_tmp32_ = game_hub_data_game_get_installers_dir ((GameHubDataGame*) game);
#line 610 "../src/data/sources/gog/GOGGame.vala"
		_tmp33_ = _tmp32_;
#line 610 "../src/data/sources/gog/GOGGame.vala"
		_tmp34_ = _g_object_ref0 (_tmp33_);
#line 610 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp23_);
#line 610 "../src/data/sources/gog/GOGGame.vala"
		_tmp23_ = _tmp34_;
#line 7943 "GOGGame.c"
	}
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp35_ = _tmp23_;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_tmp23_ = NULL;
#line 610 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->installers_dir);
#line 610 "../src/data/sources/gog/GOGGame.vala"
	self->priv->installers_dir = _tmp35_;
#line 612 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_installer_set_full_size ((GameHubDataRunnableInstaller*) self, json_object_get_int_member (json, "total_size"));
#line 613 "../src/data/sources/gog/GOGGame.vala"
	_tmp36_ = json_object_get_string_member (json, "version");
#line 613 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_installer_set_version ((GameHubDataRunnableInstaller*) self, _tmp36_);
#line 583 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_tmp23_);
#line 583 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (d);
#line 583 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (g);
#line 583 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (os);
#line 583 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 7969 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameInstaller*
game_hub_data_sources_gog_gog_game_installer_new (GameHubDataSourcesGOGGOGGame* game,
                                                  JsonObject* json)
{
#line 583 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_installer_construct (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER, game, json);
#line 7978 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameInstallerFetchPartsData* _data_;
	_data_ = _data;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_runnable_installer_unref0 (_data_->self);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameInstallerFetchPartsData, _data_);
#line 7990 "GOGGame.c"
}

static gpointer
_game_hub_data_runnable_installer_ref0 (gpointer self)
{
#line 571 "../src/data/sources/gog/GOGGame.vala"
	return self ? game_hub_data_runnable_installer_ref (self) : NULL;
#line 7998 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_installer_real_fetch_parts (GameHubDataRunnableDownloadableInstaller* base,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	GameHubDataSourcesGOGGOGGameInstaller * self;
	GameHubDataSourcesGogGogGameInstallerFetchPartsData* _data_;
	GameHubDataSourcesGOGGOGGameInstaller* _tmp0_;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameInstaller*) base;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameInstallerFetchPartsData);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_data_free);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (self);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_co (_data_);
#line 8023 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_installer_fetch_parts_finish (GameHubDataRunnableDownloadableInstaller* base,
                                                                 GAsyncResult* _res_)
{
	GameHubDataSourcesGogGogGameInstallerFetchPartsData* _data_;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8033 "GOGGame.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 616 "../src/data/sources/gog/GOGGame.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 616 "../src/data/sources/gog/GOGGame.vala"
	return _data16_;
#line 8043 "GOGGame.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 616 "../src/data/sources/gog/GOGGame.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 8053 "GOGGame.c"
		GameHubDataSourcesGOGGOGGameInstaller* self;
#line 616 "../src/data/sources/gog/GOGGame.vala"
		self = _data16_->self;
#line 616 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_runnable_installer_unref0 (self);
#line 616 "../src/data/sources/gog/GOGGame.vala"
		g_slice_free (Block16Data, _data16_);
#line 8061 "GOGGame.c"
	}
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 625 "../src/data/sources/gog/GOGGame.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 625 "../src/data/sources/gog/GOGGame.vala"
	return _data17_;
#line 8072 "GOGGame.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 625 "../src/data/sources/gog/GOGGame.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 8082 "GOGGame.c"
		GameHubDataSourcesGOGGOGGameInstaller* self;
#line 625 "../src/data/sources/gog/GOGGame.vala"
		self = _data17_->_data16_->self;
#line 625 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data17_->downlink_url);
#line 625 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data17_->id);
#line 625 "../src/data/sources/gog/GOGGame.vala"
		block16_data_unref (_data17_->_data16_);
#line 625 "../src/data/sources/gog/GOGGame.vala"
		_data17_->_data16_ = NULL;
#line 625 "../src/data/sources/gog/GOGGame.vala"
		g_slice_free (Block17Data, _data17_);
#line 8096 "GOGGame.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 8116 "GOGGame.c"
}

static gboolean
_game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_co_gsource_func (gpointer self)
{
	gboolean result;
	result = game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_co (self);
#line 678 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 8126 "GOGGame.c"
}

static void
_____lambda90_ (Block17Data* _data17_)
{
	Block16Data* _data16_;
	GameHubDataSourcesGOGGOGGameInstaller* self;
	gint _tmp0_;
	JsonNode* root_node = NULL;
	const gchar* _tmp1_;
	GameHubDataSourcesGOGGOGGame* _tmp2_;
	GameHubDataGameSource* _tmp3_;
	GameHubDataGameSource* _tmp4_;
	const gchar* _tmp5_;
	JsonNode* _tmp6_;
	gboolean _tmp7_ = FALSE;
	JsonNode* _tmp8_;
	gint _tmp88_;
#line 631 "../src/data/sources/gog/GOGGame.vala"
	_data16_ = _data17_->_data16_;
#line 631 "../src/data/sources/gog/GOGGame.vala"
	self = _data16_->self;
#line 632 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _data16_->loading_count;
#line 632 "../src/data/sources/gog/GOGGame.vala"
	_data16_->loading_count = _tmp0_ + 1;
#line 634 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _data17_->downlink_url;
#line 634 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = self->priv->game;
#line 634 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = game_hub_data_game_get_source ((GameHubDataGame*) _tmp2_);
#line 634 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = _tmp3_;
#line 634 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG)->user_token;
#line 634 "../src/data/sources/gog/GOGGame.vala"
	_tmp6_ = game_hub_utils_parser_parse_remote_json_file (_tmp1_, "GET", _tmp5_, NULL, NULL, NULL);
#line 634 "../src/data/sources/gog/GOGGame.vala"
	root_node = _tmp6_;
#line 635 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = root_node;
#line 635 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp8_ != NULL) {
#line 8171 "GOGGame.c"
		JsonNode* _tmp9_;
#line 635 "../src/data/sources/gog/GOGGame.vala"
		_tmp9_ = root_node;
#line 635 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = json_node_get_node_type (_tmp9_) == JSON_NODE_OBJECT;
#line 8177 "GOGGame.c"
	} else {
#line 635 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = FALSE;
#line 8181 "GOGGame.c"
	}
#line 635 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp7_) {
#line 8185 "GOGGame.c"
		JsonObject* root = NULL;
		JsonNode* _tmp10_;
		JsonObject* _tmp11_;
		JsonObject* _tmp12_;
		gboolean _tmp13_ = FALSE;
		JsonObject* _tmp14_;
#line 637 "../src/data/sources/gog/GOGGame.vala"
		_tmp10_ = root_node;
#line 637 "../src/data/sources/gog/GOGGame.vala"
		_tmp11_ = json_node_get_object (_tmp10_);
#line 637 "../src/data/sources/gog/GOGGame.vala"
		_tmp12_ = _json_object_ref0 (_tmp11_);
#line 637 "../src/data/sources/gog/GOGGame.vala"
		root = _tmp12_;
#line 638 "../src/data/sources/gog/GOGGame.vala"
		_tmp14_ = root;
#line 638 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp14_ != NULL) {
#line 8204 "GOGGame.c"
			JsonObject* _tmp15_;
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_tmp15_ = root;
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_tmp13_ = json_object_has_member (_tmp15_, "downlink");
#line 8210 "GOGGame.c"
		} else {
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_tmp13_ = FALSE;
#line 8214 "GOGGame.c"
		}
#line 638 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp13_) {
#line 8218 "GOGGame.c"
			gchar* url = NULL;
			JsonObject* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* checksum_url = NULL;
			JsonObject* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			GFile* remote = NULL;
			const gchar* _tmp22_;
			GFile* _tmp23_;
			gchar* local_filename = NULL;
			gchar* hash = NULL;
			GChecksumType hash_type = 0;
			xmlDoc* checksum_root = NULL;
			const gchar* _tmp24_;
			GameHubDataSourcesGOGGOGGame* _tmp25_;
			GameHubDataGameSource* _tmp26_;
			GameHubDataGameSource* _tmp27_;
			const gchar* _tmp28_;
			xmlDoc* _tmp29_;
			xmlDoc* _tmp30_;
			gboolean _tmp39_ = FALSE;
			const gchar* _tmp40_;
			gchar* _tmp59_ = NULL;
			const gchar* _tmp60_;
			gchar* _tmp61_;
			GFile* local = NULL;
			GFile* _tmp77_;
			GFile* _tmp78_;
			GeeArrayList* _tmp79_;
			GeeArrayList* _tmp80_;
			const gchar* _tmp81_;
			const gchar* _tmp82_;
			GFile* _tmp83_;
			GFile* _tmp84_;
			const gchar* _tmp85_;
			GameHubDataRunnableDownloadableInstallerPart* _tmp86_;
			GameHubDataRunnableDownloadableInstallerPart* _tmp87_;
#line 640 "../src/data/sources/gog/GOGGame.vala"
			_tmp16_ = root;
#line 640 "../src/data/sources/gog/GOGGame.vala"
			_tmp17_ = json_object_get_string_member (_tmp16_, "downlink");
#line 640 "../src/data/sources/gog/GOGGame.vala"
			_tmp18_ = g_strdup (_tmp17_);
#line 640 "../src/data/sources/gog/GOGGame.vala"
			url = _tmp18_;
#line 641 "../src/data/sources/gog/GOGGame.vala"
			_tmp19_ = root;
#line 641 "../src/data/sources/gog/GOGGame.vala"
			_tmp20_ = json_object_get_string_member (_tmp19_, "checksum");
#line 641 "../src/data/sources/gog/GOGGame.vala"
			_tmp21_ = g_strdup (_tmp20_);
#line 641 "../src/data/sources/gog/GOGGame.vala"
			checksum_url = _tmp21_;
#line 642 "../src/data/sources/gog/GOGGame.vala"
			_tmp22_ = url;
#line 642 "../src/data/sources/gog/GOGGame.vala"
			_tmp23_ = g_file_new_for_uri (_tmp22_);
#line 642 "../src/data/sources/gog/GOGGame.vala"
			remote = _tmp23_;
#line 644 "../src/data/sources/gog/GOGGame.vala"
			local_filename = NULL;
#line 646 "../src/data/sources/gog/GOGGame.vala"
			hash = NULL;
#line 647 "../src/data/sources/gog/GOGGame.vala"
			hash_type = G_CHECKSUM_MD5;
#line 649 "../src/data/sources/gog/GOGGame.vala"
			_tmp24_ = checksum_url;
#line 649 "../src/data/sources/gog/GOGGame.vala"
			_tmp25_ = self->priv->game;
#line 649 "../src/data/sources/gog/GOGGame.vala"
			_tmp26_ = game_hub_data_game_get_source ((GameHubDataGame*) _tmp25_);
#line 649 "../src/data/sources/gog/GOGGame.vala"
			_tmp27_ = _tmp26_;
#line 649 "../src/data/sources/gog/GOGGame.vala"
			_tmp28_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG)->user_token;
#line 649 "../src/data/sources/gog/GOGGame.vala"
			_tmp29_ = game_hub_utils_parser_parse_remote_xml_file (_tmp24_, "GET", _tmp28_, NULL, NULL);
#line 649 "../src/data/sources/gog/GOGGame.vala"
			checksum_root = _tmp29_;
#line 650 "../src/data/sources/gog/GOGGame.vala"
			_tmp30_ = checksum_root;
#line 650 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp30_ != NULL) {
#line 8304 "GOGGame.c"
				xmlNode* checksum_file_node = NULL;
				xmlDoc* _tmp31_;
				xmlNode* _tmp32_;
				xmlNode* _tmp33_;
				xmlDoc* _tmp38_;
#line 652 "../src/data/sources/gog/GOGGame.vala"
				_tmp31_ = checksum_root;
#line 652 "../src/data/sources/gog/GOGGame.vala"
				_tmp32_ = xmlDocGetRootElement (_tmp31_);
#line 652 "../src/data/sources/gog/GOGGame.vala"
				checksum_file_node = _tmp32_;
#line 653 "../src/data/sources/gog/GOGGame.vala"
				_tmp33_ = checksum_file_node;
#line 653 "../src/data/sources/gog/GOGGame.vala"
				if (_tmp33_ != NULL) {
#line 8320 "GOGGame.c"
					xmlNode* _tmp34_;
					gchar* _tmp35_;
					xmlNode* _tmp36_;
					gchar* _tmp37_;
#line 655 "../src/data/sources/gog/GOGGame.vala"
					_tmp34_ = checksum_file_node;
#line 655 "../src/data/sources/gog/GOGGame.vala"
					_tmp35_ = (gchar*) xmlGetProp (_tmp34_, (xmlChar*) "md5");
#line 655 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (hash);
#line 655 "../src/data/sources/gog/GOGGame.vala"
					hash = _tmp35_;
#line 656 "../src/data/sources/gog/GOGGame.vala"
					_tmp36_ = checksum_file_node;
#line 656 "../src/data/sources/gog/GOGGame.vala"
					_tmp37_ = (gchar*) xmlGetProp (_tmp36_, (xmlChar*) "name");
#line 656 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (local_filename);
#line 656 "../src/data/sources/gog/GOGGame.vala"
					local_filename = _tmp37_;
#line 8341 "GOGGame.c"
				}
#line 659 "../src/data/sources/gog/GOGGame.vala"
				_tmp38_ = checksum_root;
#line 659 "../src/data/sources/gog/GOGGame.vala"
				_xmlFreeDoc0 (_tmp38_);
#line 8347 "GOGGame.c"
			}
#line 662 "../src/data/sources/gog/GOGGame.vala"
			_tmp40_ = local_filename;
#line 662 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp40_ == NULL) {
#line 8353 "GOGGame.c"
				const gchar* _tmp41_;
#line 662 "../src/data/sources/gog/GOGGame.vala"
				_tmp41_ = url;
#line 662 "../src/data/sources/gog/GOGGame.vala"
				_tmp39_ = string_contains (_tmp41_, "/namespaces/website/download?path=");
#line 8359 "GOGGame.c"
			} else {
#line 662 "../src/data/sources/gog/GOGGame.vala"
				_tmp39_ = FALSE;
#line 8363 "GOGGame.c"
			}
#line 662 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp39_) {
#line 8367 "GOGGame.c"
				gchar* remote_path_encoded = NULL;
				const gchar* _tmp42_;
				gchar** _tmp43_;
				gchar** _tmp44_;
				gchar** _tmp45_;
				gint _tmp45__length1;
				const gchar* _tmp46_;
				gchar** _tmp47_;
				gchar** _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				const gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* remote_path = NULL;
				const gchar* _tmp53_;
				gchar* _tmp54_;
				const gchar* _tmp55_;
				GFile* _tmp56_;
				GFile* _tmp57_;
				gchar* _tmp58_;
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp42_ = url;
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp44_ = _tmp43_ = g_strsplit (_tmp42_, "/namespaces/website/download?path=", 0);
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp45_ = _tmp44_;
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp45__length1 = _vala_array_length (_tmp43_);
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp46_ = _tmp45_[1];
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp48_ = _tmp47_ = g_strsplit (_tmp46_, "&", 0);
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp49_ = _tmp48_;
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp49__length1 = _vala_array_length (_tmp47_);
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp50_ = _tmp49_[0];
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp51_ = g_strdup (_tmp50_);
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp52_ = _tmp51_;
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp49_ = (_vala_array_free (_tmp49_, _tmp49__length1, (GDestroyNotify) g_free), NULL);
#line 664 "../src/data/sources/gog/GOGGame.vala"
				_tmp45_ = (_vala_array_free (_tmp45_, _tmp45__length1, (GDestroyNotify) g_free), NULL);
#line 664 "../src/data/sources/gog/GOGGame.vala"
				remote_path_encoded = _tmp52_;
#line 665 "../src/data/sources/gog/GOGGame.vala"
				_tmp53_ = remote_path_encoded;
#line 665 "../src/data/sources/gog/GOGGame.vala"
				_tmp54_ = g_uri_unescape_string (_tmp53_, NULL);
#line 665 "../src/data/sources/gog/GOGGame.vala"
				remote_path = _tmp54_;
#line 666 "../src/data/sources/gog/GOGGame.vala"
				_tmp55_ = remote_path;
#line 666 "../src/data/sources/gog/GOGGame.vala"
				_tmp56_ = g_file_new_for_path (_tmp55_);
#line 666 "../src/data/sources/gog/GOGGame.vala"
				_tmp57_ = _tmp56_;
#line 666 "../src/data/sources/gog/GOGGame.vala"
				_tmp58_ = g_file_get_basename (_tmp57_);
#line 666 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (local_filename);
#line 666 "../src/data/sources/gog/GOGGame.vala"
				local_filename = _tmp58_;
#line 666 "../src/data/sources/gog/GOGGame.vala"
				_g_object_unref0 (_tmp57_);
#line 662 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (remote_path);
#line 662 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (remote_path_encoded);
#line 8441 "GOGGame.c"
			}
#line 669 "../src/data/sources/gog/GOGGame.vala"
			_tmp60_ = local_filename;
#line 669 "../src/data/sources/gog/GOGGame.vala"
			_tmp61_ = g_strdup (_tmp60_);
#line 669 "../src/data/sources/gog/GOGGame.vala"
			_tmp59_ = _tmp61_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp59_ == NULL) {
#line 8451 "GOGGame.c"
				GameHubDataSourcesGOGGOGGame* _tmp62_;
				const gchar* _tmp63_;
				const gchar* _tmp64_;
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
				const gchar* _tmp69_;
				const gchar* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				const gchar* _tmp75_;
				gchar* _tmp76_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp62_ = self->priv->game;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp63_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) _tmp62_);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp64_ = _tmp63_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp65_ = g_strconcat ("gog_", _tmp64_, NULL);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp66_ = _tmp65_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp67_ = g_strconcat (_tmp66_, "_", NULL);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp68_ = _tmp67_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp69_ = game_hub_data_runnable_installer_get_id ((GameHubDataRunnableInstaller*) self);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp70_ = _tmp69_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp71_ = g_strconcat (_tmp68_, _tmp70_, NULL);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp72_ = _tmp71_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp73_ = g_strconcat (_tmp72_, "_", NULL);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp74_ = _tmp73_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp75_ = _data17_->id;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp76_ = g_strconcat (_tmp74_, _tmp75_, NULL);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp59_);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_tmp59_ = _tmp76_;
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp74_);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp72_);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp68_);
#line 669 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp66_);
#line 8509 "GOGGame.c"
			}
#line 669 "../src/data/sources/gog/GOGGame.vala"
			_tmp77_ = self->priv->installers_dir;
#line 669 "../src/data/sources/gog/GOGGame.vala"
			_tmp78_ = g_file_get_child (_tmp77_, _tmp59_);
#line 669 "../src/data/sources/gog/GOGGame.vala"
			local = _tmp78_;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp79_ = game_hub_data_runnable_downloadable_installer_get_parts ((GameHubDataRunnableDownloadableInstaller*) self);
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp80_ = _tmp79_;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp81_ = _data17_->id;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp82_ = url;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp83_ = remote;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp84_ = local;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp85_ = hash;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp86_ = game_hub_data_runnable_downloadable_installer_part_new (_tmp81_, _tmp82_, _data17_->size, _tmp83_, _tmp84_, _tmp85_, hash_type);
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_tmp87_ = _tmp86_;
#line 671 "../src/data/sources/gog/GOGGame.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp80_, _tmp87_);
#line 671 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (_tmp87_);
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (local);
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_tmp59_);
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (hash);
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (local_filename);
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_g_object_unref0 (remote);
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (checksum_url);
#line 638 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (url);
#line 8553 "GOGGame.c"
		}
#line 635 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (root);
#line 8557 "GOGGame.c"
	}
#line 675 "../src/data/sources/gog/GOGGame.vala"
	_tmp88_ = _data16_->loading_count;
#line 675 "../src/data/sources/gog/GOGGame.vala"
	_data16_->loading_count = _tmp88_ - 1;
#line 676 "../src/data/sources/gog/GOGGame.vala"
	if (_data16_->loading_count == 0) {
#line 678 "../src/data/sources/gog/GOGGame.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_co_gsource_func, _data16_->_async_data_, NULL);
#line 8567 "GOGGame.c"
	}
#line 631 "../src/data/sources/gog/GOGGame.vala"
	__vala_JsonNode_free0 (root_node);
#line 8571 "GOGGame.c"
}

static void
______lambda90__game_hub_utils_future (gpointer self)
{
#line 631 "../src/data/sources/gog/GOGGame.vala"
	_____lambda90_ (self);
#line 8579 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_installer_real_fetch_parts_co (GameHubDataSourcesGogGogGameInstallerFetchPartsData* _data_)
{
#line 616 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 616 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 8589 "GOGGame.c"
		goto _state_0;
#line 616 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 8593 "GOGGame.c"
		goto _state_1;
		default:
#line 616 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 8598 "GOGGame.c"
	}
	_state_0:
#line 616 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data16_ = g_slice_new0 (Block16Data);
#line 616 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data16_->_ref_count_ = 1;
#line 616 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data16_->self = game_hub_data_runnable_installer_ref (_data_->self);
#line 616 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data16_->_async_data_ = _data_;
#line 618 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->self->priv->fetched) {
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp2_ = TRUE;
#line 8613 "GOGGame.c"
	} else {
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp3_ = _data_->self->priv->installers_dir;
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp2_ = _data_->_tmp3_ == NULL;
#line 8619 "GOGGame.c"
	}
#line 618 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp2_) {
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp1_ = TRUE;
#line 8625 "GOGGame.c"
	} else {
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp4_ = _data_->self->priv->json;
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp1_ = !json_object_has_member (_data_->_tmp4_, "files");
#line 8631 "GOGGame.c"
	}
#line 618 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp1_) {
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = TRUE;
#line 8637 "GOGGame.c"
	} else {
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp5_ = _data_->self->priv->json;
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp6_ = json_object_get_member (_data_->_tmp5_, "files");
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = json_node_get_node_type (_data_->_tmp6_) != JSON_NODE_ARRAY;
#line 8645 "GOGGame.c"
	}
#line 618 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp0_) {
#line 618 "../src/data/sources/gog/GOGGame.vala"
		block16_data_unref (_data_->_data16_);
#line 618 "../src/data/sources/gog/GOGGame.vala"
		_data_->_data16_ = NULL;
#line 618 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 618 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 618 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 618 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8661 "GOGGame.c"
			}
		}
#line 618 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 618 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 8668 "GOGGame.c"
	}
#line 620 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data16_->loading_count = 0;
#line 622 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp7_ = _data_->self->priv->json;
#line 622 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp8_ = json_object_get_array_member (_data_->_tmp7_, "files");
#line 622 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp9_ = json_array_get_elements (_data_->_tmp8_);
#line 8678 "GOGGame.c"
	{
#line 622 "../src/data/sources/gog/GOGGame.vala"
		_data_->file_node_collection = _data_->_tmp9_;
#line 622 "../src/data/sources/gog/GOGGame.vala"
		for (_data_->file_node_it = _data_->file_node_collection; _data_->file_node_it != NULL; _data_->file_node_it = _data_->file_node_it->next) {
#line 622 "../src/data/sources/gog/GOGGame.vala"
			_data_->file_node = (JsonNode*) _data_->file_node_it->data;
#line 8686 "GOGGame.c"
			{
#line 624 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp12_ = _data_->file_node;
#line 624 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp12_ != NULL) {
#line 624 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp13_ = _data_->file_node;
#line 624 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp11_ = json_node_get_node_type (_data_->_tmp13_) == JSON_NODE_OBJECT;
#line 8696 "GOGGame.c"
				} else {
#line 624 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp11_ = FALSE;
#line 8700 "GOGGame.c"
				}
#line 624 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp11_) {
#line 624 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp14_ = _data_->file_node;
#line 624 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp15_ = json_node_get_object (_data_->_tmp14_);
#line 624 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp10_ = _data_->_tmp15_;
#line 8710 "GOGGame.c"
				} else {
#line 624 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp10_ = NULL;
#line 8714 "GOGGame.c"
				}
#line 624 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp16_ = _json_object_ref0 (_data_->_tmp10_);
#line 624 "../src/data/sources/gog/GOGGame.vala"
				_data_->file = _data_->_tmp16_;
#line 625 "../src/data/sources/gog/GOGGame.vala"
				_data_->_tmp17_ = _data_->file;
#line 625 "../src/data/sources/gog/GOGGame.vala"
				if (_data_->_tmp17_ != NULL) {
#line 625 "../src/data/sources/gog/GOGGame.vala"
					_data_->_data17_ = g_slice_new0 (Block17Data);
#line 625 "../src/data/sources/gog/GOGGame.vala"
					_data_->_data17_->_ref_count_ = 1;
#line 625 "../src/data/sources/gog/GOGGame.vala"
					_data_->_data17_->_data16_ = block16_data_ref (_data_->_data16_);
#line 627 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp18_ = _data_->file;
#line 627 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp19_ = json_object_get_string_member (_data_->_tmp18_, "id");
#line 627 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp20_ = g_strdup (_data_->_tmp19_);
#line 627 "../src/data/sources/gog/GOGGame.vala"
					_data_->_data17_->id = _data_->_tmp20_;
#line 628 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp21_ = _data_->file;
#line 628 "../src/data/sources/gog/GOGGame.vala"
					_data_->_data17_->size = json_object_get_int_member (_data_->_tmp21_, "size");
#line 629 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp22_ = _data_->file;
#line 629 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp23_ = json_object_get_string_member (_data_->_tmp22_, "downlink");
#line 629 "../src/data/sources/gog/GOGGame.vala"
					_data_->_tmp24_ = g_strdup (_data_->_tmp23_);
#line 629 "../src/data/sources/gog/GOGGame.vala"
					_data_->_data17_->downlink_url = _data_->_tmp24_;
#line 631 "../src/data/sources/gog/GOGGame.vala"
					game_hub_utils_thread ("GOGGame.Installer.fetch_part", ______lambda90__game_hub_utils_future, block17_data_ref (_data_->_data17_), block17_data_unref, TRUE);
#line 625 "../src/data/sources/gog/GOGGame.vala"
					block17_data_unref (_data_->_data17_);
#line 625 "../src/data/sources/gog/GOGGame.vala"
					_data_->_data17_ = NULL;
#line 8756 "GOGGame.c"
				}
#line 622 "../src/data/sources/gog/GOGGame.vala"
				_json_object_unref0 (_data_->file);
#line 8760 "GOGGame.c"
			}
		}
#line 622 "../src/data/sources/gog/GOGGame.vala"
		(_data_->file_node_collection == NULL) ? NULL : (_data_->file_node_collection = (g_list_free (_data_->file_node_collection), NULL));
#line 8765 "GOGGame.c"
	}
#line 684 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 1;
#line 684 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 8771 "GOGGame.c"
	_state_1:
	;
#line 685 "../src/data/sources/gog/GOGGame.vala"
	_data_->self->priv->fetched = TRUE;
#line 616 "../src/data/sources/gog/GOGGame.vala"
	block16_data_unref (_data_->_data16_);
#line 616 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data16_ = NULL;
#line 616 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 616 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 616 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 616 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8788 "GOGGame.c"
		}
	}
#line 616 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 616 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 8795 "GOGGame.c"
}

static gchar*
game_hub_data_sources_gog_gog_game_installer_real_get_name (GameHubDataRunnableInstaller* base)
{
	gchar* result;
	GameHubDataSourcesGOGGOGGameInstaller* self;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 581 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameInstaller*) base;
#line 581 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = game_hub_data_runnable_installer_get_version ((GameHubDataRunnableInstaller*) self);
#line 581 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = _tmp1_;
#line 581 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp2_ != NULL) {
#line 8816 "GOGGame.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_tmp3_ = game_hub_data_runnable_installer_get_version ((GameHubDataRunnableInstaller*) self);
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_tmp4_ = _tmp3_;
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_tmp5_ = g_strconcat (": ", _tmp4_, NULL);
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp0_);
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _tmp5_;
#line 8830 "GOGGame.c"
	} else {
		gchar* _tmp6_;
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = g_strdup ("");
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp0_);
#line 581 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _tmp6_;
#line 8839 "GOGGame.c"
	}
#line 581 "../src/data/sources/gog/GOGGame.vala"
	_tmp7_ = self->lang_full;
#line 581 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = g_strconcat (_tmp7_, _tmp0_, NULL);
#line 581 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp8_;
#line 581 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp0_);
#line 581 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 8851 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_installer_class_init (GameHubDataSourcesGOGGOGGameInstallerClass * klass,
                                                         gpointer klass_data)
{
#line 571 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_installer_parent_class = g_type_class_peek_parent (klass);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_sources_gog_gog_game_installer_finalize;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataSourcesGOGGOGGameInstaller_private_offset);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableDownloadableInstallerClass *) klass)->fetch_parts = (void (*) (GameHubDataRunnableDownloadableInstaller*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_gog_gog_game_installer_real_fetch_parts;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableDownloadableInstallerClass *) klass)->fetch_parts_finish = (void (*) (GameHubDataRunnableDownloadableInstaller*, GAsyncResult*)) game_hub_data_sources_gog_gog_game_installer_fetch_parts_finish;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (klass)->get_name = game_hub_data_sources_gog_gog_game_installer_real_get_name;
#line 8870 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_installer_instance_init (GameHubDataSourcesGOGGOGGameInstaller * self,
                                                            gpointer klass)
{
#line 571 "../src/data/sources/gog/GOGGame.vala"
	self->priv = game_hub_data_sources_gog_gog_game_installer_get_instance_private (self);
#line 575 "../src/data/sources/gog/GOGGame.vala"
	self->priv->fetched = FALSE;
#line 8881 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataSourcesGOGGOGGameInstaller * self;
#line 571 "../src/data/sources/gog/GOGGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_INSTALLER, GameHubDataSourcesGOGGOGGameInstaller);
#line 573 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->game);
#line 574 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (self->priv->json);
#line 576 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->installers_dir);
#line 578 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->lang);
#line 579 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->lang_full);
#line 571 "../src/data/sources/gog/GOGGame.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (game_hub_data_sources_gog_gog_game_installer_parent_class)->finalize (obj);
#line 8902 "GOGGame.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_installer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesGOGGOGGameInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_gog_gog_game_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesGOGGOGGameInstaller), 0, (GInstanceInitFunc) game_hub_data_sources_gog_gog_game_installer_instance_init, NULL };
	GType game_hub_data_sources_gog_gog_game_installer_type_id;
	game_hub_data_sources_gog_gog_game_installer_type_id = g_type_register_static (GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, "GameHubDataSourcesGOGGOGGameInstaller", &g_define_type_info, 0);
	GameHubDataSourcesGOGGOGGameInstaller_private_offset = g_type_add_instance_private (game_hub_data_sources_gog_gog_game_installer_type_id, sizeof (GameHubDataSourcesGOGGOGGameInstallerPrivate));
	return game_hub_data_sources_gog_gog_game_installer_type_id;
}

GType
game_hub_data_sources_gog_gog_game_installer_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_installer_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_installer_type_id;
		game_hub_data_sources_gog_gog_game_installer_type_id = game_hub_data_sources_gog_gog_game_installer_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_installer_type_id__volatile, game_hub_data_sources_gog_gog_game_installer_type_id);
	}
	return game_hub_data_sources_gog_gog_game_installer_type_id__volatile;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 8946 "GOGGame.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 8950 "GOGGame.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 8956 "GOGGame.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 8960 "GOGGame.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 8964 "GOGGame.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 8972 "GOGGame.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 9000 "GOGGame.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 9009 "GOGGame.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 9023 "GOGGame.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 9032 "GOGGame.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 9046 "GOGGame.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 9055 "GOGGame.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 9064 "GOGGame.c"
}

static GType*
_g_type_dup (GType* self)
{
	GType* dup;
#line 709 "../src/data/sources/gog/GOGGame.vala"
	dup = g_new0 (GType, 1);
#line 709 "../src/data/sources/gog/GOGGame.vala"
	memcpy (dup, self, sizeof (GType));
#line 709 "../src/data/sources/gog/GOGGame.vala"
	return dup;
#line 9077 "GOGGame.c"
}

static gpointer
__g_type_dup0 (gpointer self)
{
#line 709 "../src/data/sources/gog/GOGGame.vala"
	return self ? _g_type_dup (self) : NULL;
#line 9085 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameRunnableAction*
game_hub_data_sources_gog_gog_game_runnable_action_construct (GType object_type,
                                                              GameHubDataSourcesGOGGOGGame* game,
                                                              JsonObject* json)
{
	GameHubDataSourcesGOGGOGGameRunnableAction* self = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* type = NULL;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
#line 691 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 691 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (json != NULL, NULL);
#line 691 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameRunnableAction*) game_hub_data_runnable_runnable_action_construct (object_type);
#line 693 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_runnable_action_set_runnable ((GameHubDataRunnableRunnableAction*) self, (GameHubDataRunnable*) game);
#line 694 "../src/data/sources/gog/GOGGame.vala"
	if (json_object_has_member (json, "isPrimary")) {
#line 694 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = json_object_get_boolean_member (json, "isPrimary");
#line 9116 "GOGGame.c"
	} else {
#line 694 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = FALSE;
#line 9120 "GOGGame.c"
	}
#line 694 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_runnable_action_set_is_primary ((GameHubDataRunnableRunnableAction*) self, _tmp0_);
#line 695 "../src/data/sources/gog/GOGGame.vala"
	if (json_object_has_member (json, "isHidden")) {
#line 695 "../src/data/sources/gog/GOGGame.vala"
		_tmp1_ = json_object_get_boolean_member (json, "isHidden");
#line 9128 "GOGGame.c"
	} else {
#line 695 "../src/data/sources/gog/GOGGame.vala"
		_tmp1_ = FALSE;
#line 9132 "GOGGame.c"
	}
#line 695 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_runnable_action_set_is_hidden ((GameHubDataRunnableRunnableAction*) self, _tmp1_);
#line 696 "../src/data/sources/gog/GOGGame.vala"
	if (json_object_has_member (json, "name")) {
#line 9138 "GOGGame.c"
		const gchar* _tmp3_;
#line 696 "../src/data/sources/gog/GOGGame.vala"
		_tmp3_ = json_object_get_string_member (json, "name");
#line 696 "../src/data/sources/gog/GOGGame.vala"
		_tmp2_ = _tmp3_;
#line 9144 "GOGGame.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 696 "../src/data/sources/gog/GOGGame.vala"
		_tmp4_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 696 "../src/data/sources/gog/GOGGame.vala"
		_tmp5_ = _tmp4_;
#line 696 "../src/data/sources/gog/GOGGame.vala"
		_tmp2_ = _tmp5_;
#line 9154 "GOGGame.c"
	}
#line 696 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_runnable_action_set_name ((GameHubDataRunnableRunnableAction*) self, _tmp2_);
#line 698 "../src/data/sources/gog/GOGGame.vala"
	if (json_object_has_member (json, "type")) {
#line 9160 "GOGGame.c"
		const gchar* _tmp7_;
#line 698 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = json_object_get_string_member (json, "type");
#line 698 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = _tmp7_;
#line 9166 "GOGGame.c"
	} else {
#line 698 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = "filetask";
#line 9170 "GOGGame.c"
	}
#line 698 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = g_strdup (_tmp6_);
#line 698 "../src/data/sources/gog/GOGGame.vala"
	type = _tmp8_;
#line 700 "../src/data/sources/gog/GOGGame.vala"
	_tmp9_ = type;
#line 700 "../src/data/sources/gog/GOGGame.vala"
	_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) -1);
#line 700 "../src/data/sources/gog/GOGGame.vala"
	_tmp11_ = _tmp10_;
#line 700 "../src/data/sources/gog/GOGGame.vala"
	_tmp12_ = g_strcmp0 (_tmp11_, "filetask") == 0;
#line 700 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp11_);
#line 700 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp12_) {
#line 9188 "GOGGame.c"
		const gchar* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
		gboolean _tmp16_ = FALSE;
		GFile* _tmp17_;
		GFile* _tmp18_;
#line 702 "../src/data/sources/gog/GOGGame.vala"
		_tmp13_ = json_object_get_string_member (json, "path");
#line 702 "../src/data/sources/gog/GOGGame.vala"
		_tmp14_ = game_hub_data_sources_gog_gog_game_runnable_action_find_file (self, _tmp13_);
#line 702 "../src/data/sources/gog/GOGGame.vala"
		_tmp15_ = _tmp14_;
#line 702 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_runnable_runnable_action_set_file ((GameHubDataRunnableRunnableAction*) self, _tmp15_);
#line 702 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp15_);
#line 703 "../src/data/sources/gog/GOGGame.vala"
		_tmp17_ = game_hub_data_runnable_runnable_action_get_file ((GameHubDataRunnableRunnableAction*) self);
#line 703 "../src/data/sources/gog/GOGGame.vala"
		_tmp18_ = _tmp17_;
#line 703 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp18_ != NULL) {
#line 9211 "GOGGame.c"
			GFile* _tmp19_;
			GFile* _tmp20_;
#line 703 "../src/data/sources/gog/GOGGame.vala"
			_tmp19_ = game_hub_data_runnable_runnable_action_get_file ((GameHubDataRunnableRunnableAction*) self);
#line 703 "../src/data/sources/gog/GOGGame.vala"
			_tmp20_ = _tmp19_;
#line 703 "../src/data/sources/gog/GOGGame.vala"
			_tmp16_ = g_file_query_exists (_tmp20_, NULL);
#line 9220 "GOGGame.c"
		} else {
#line 703 "../src/data/sources/gog/GOGGame.vala"
			_tmp16_ = FALSE;
#line 9224 "GOGGame.c"
		}
#line 703 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp16_) {
#line 9228 "GOGGame.c"
			GFile* _tmp21_;
			GFile* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gboolean _tmp27_;
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_tmp21_ = game_hub_data_runnable_runnable_action_get_file ((GameHubDataRunnableRunnableAction*) self);
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_tmp22_ = _tmp21_;
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_tmp23_ = g_file_get_basename (_tmp22_);
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_tmp24_ = _tmp23_;
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_tmp26_ = _tmp25_;
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_tmp27_ = g_str_has_suffix (_tmp26_, ".exe");
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_tmp26_);
#line 705 "../src/data/sources/gog/GOGGame.vala"
			_g_free0 (_tmp24_);
#line 705 "../src/data/sources/gog/GOGGame.vala"
			if (_tmp27_) {
#line 9256 "GOGGame.c"
				const gchar* _tmp28_ = NULL;
				GFile* _tmp30_;
				GFile* _tmp31_;
				gchar* _tmp32_ = NULL;
				GType _tmp37_;
				GType* _tmp38_;
				GType** _tmp39_;
				GType** _tmp40_;
				gint _tmp40__length1;
#line 707 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (json, "workingDir")) {
#line 9268 "GOGGame.c"
					const gchar* _tmp29_;
#line 707 "../src/data/sources/gog/GOGGame.vala"
					_tmp29_ = json_object_get_string_member (json, "workingDir");
#line 707 "../src/data/sources/gog/GOGGame.vala"
					_tmp28_ = _tmp29_;
#line 9274 "GOGGame.c"
				} else {
#line 707 "../src/data/sources/gog/GOGGame.vala"
					_tmp28_ = "";
#line 9278 "GOGGame.c"
				}
#line 707 "../src/data/sources/gog/GOGGame.vala"
				_tmp30_ = game_hub_data_sources_gog_gog_game_runnable_action_find_file (self, _tmp28_);
#line 707 "../src/data/sources/gog/GOGGame.vala"
				_tmp31_ = _tmp30_;
#line 707 "../src/data/sources/gog/GOGGame.vala"
				game_hub_data_runnable_runnable_action_set_workdir ((GameHubDataRunnableRunnableAction*) self, _tmp31_);
#line 707 "../src/data/sources/gog/GOGGame.vala"
				_g_object_unref0 (_tmp31_);
#line 708 "../src/data/sources/gog/GOGGame.vala"
				if (json_object_has_member (json, "arguments")) {
#line 9290 "GOGGame.c"
					const gchar* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_tmp33_ = json_object_get_string_member (json, "arguments");
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_tmp34_ = string_replace (_tmp33_, "\\", "/");
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_tmp35_ = _tmp34_;
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_tmp36_ = string_strip (_tmp35_);
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_tmp32_);
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_tmp32_ = _tmp36_;
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_tmp35_);
#line 9309 "GOGGame.c"
				} else {
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_g_free0 (_tmp32_);
#line 708 "../src/data/sources/gog/GOGGame.vala"
					_tmp32_ = NULL;
#line 9315 "GOGGame.c"
				}
#line 708 "../src/data/sources/gog/GOGGame.vala"
				game_hub_data_runnable_runnable_action_set_args ((GameHubDataRunnableRunnableAction*) self, _tmp32_);
#line 709 "../src/data/sources/gog/GOGGame.vala"
				_tmp37_ = GAME_HUB_DATA_COMPAT_TYPE_WINE;
#line 709 "../src/data/sources/gog/GOGGame.vala"
				_tmp38_ = __g_type_dup0 (&_tmp37_);
#line 709 "../src/data/sources/gog/GOGGame.vala"
				_tmp39_ = g_new0 (GType*, 1);
#line 709 "../src/data/sources/gog/GOGGame.vala"
				_tmp39_[0] = _tmp38_;
#line 709 "../src/data/sources/gog/GOGGame.vala"
				_tmp40_ = _tmp39_;
#line 709 "../src/data/sources/gog/GOGGame.vala"
				_tmp40__length1 = 1;
#line 709 "../src/data/sources/gog/GOGGame.vala"
				game_hub_data_runnable_runnable_action_set_compat_tools ((GameHubDataRunnableRunnableAction*) self, _tmp40_, 1);
#line 709 "../src/data/sources/gog/GOGGame.vala"
				_tmp40_ = (_vala_array_free (_tmp40_, _tmp40__length1, (GDestroyNotify) g_free), NULL);
#line 705 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp32_);
#line 9337 "GOGGame.c"
			} else {
				GFile* _tmp41_;
				GFile* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
#line 713 "../src/data/sources/gog/GOGGame.vala"
				_tmp41_ = game_hub_data_runnable_runnable_action_get_file ((GameHubDataRunnableRunnableAction*) self);
#line 713 "../src/data/sources/gog/GOGGame.vala"
				_tmp42_ = _tmp41_;
#line 713 "../src/data/sources/gog/GOGGame.vala"
				_tmp43_ = g_file_get_uri (_tmp42_);
#line 713 "../src/data/sources/gog/GOGGame.vala"
				_tmp44_ = _tmp43_;
#line 713 "../src/data/sources/gog/GOGGame.vala"
				game_hub_data_runnable_runnable_action_set_uri ((GameHubDataRunnableRunnableAction*) self, _tmp44_);
#line 713 "../src/data/sources/gog/GOGGame.vala"
				_g_free0 (_tmp44_);
#line 714 "../src/data/sources/gog/GOGGame.vala"
				game_hub_data_runnable_runnable_action_set_file ((GameHubDataRunnableRunnableAction*) self, NULL);
#line 9357 "GOGGame.c"
			}
		}
	} else {
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gboolean _tmp48_;
#line 718 "../src/data/sources/gog/GOGGame.vala"
		_tmp45_ = type;
#line 718 "../src/data/sources/gog/GOGGame.vala"
		_tmp46_ = g_utf8_strdown (_tmp45_, (gssize) -1);
#line 718 "../src/data/sources/gog/GOGGame.vala"
		_tmp47_ = _tmp46_;
#line 718 "../src/data/sources/gog/GOGGame.vala"
		_tmp48_ = g_strcmp0 (_tmp47_, "urltask") == 0;
#line 718 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp47_);
#line 718 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp48_) {
#line 9377 "GOGGame.c"
			const gchar* _tmp49_ = NULL;
#line 720 "../src/data/sources/gog/GOGGame.vala"
			if (json_object_has_member (json, "link")) {
#line 9381 "GOGGame.c"
				const gchar* _tmp50_;
#line 720 "../src/data/sources/gog/GOGGame.vala"
				_tmp50_ = json_object_get_string_member (json, "link");
#line 720 "../src/data/sources/gog/GOGGame.vala"
				_tmp49_ = _tmp50_;
#line 9387 "GOGGame.c"
			} else {
#line 720 "../src/data/sources/gog/GOGGame.vala"
				_tmp49_ = NULL;
#line 9391 "GOGGame.c"
			}
#line 720 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_runnable_runnable_action_set_uri ((GameHubDataRunnableRunnableAction*) self, _tmp49_);
#line 9395 "GOGGame.c"
		}
	}
#line 691 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (type);
#line 691 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 9402 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameRunnableAction*
game_hub_data_sources_gog_gog_game_runnable_action_new (GameHubDataSourcesGOGGOGGame* game,
                                                        JsonObject* json)
{
#line 691 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_runnable_action_construct (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_RUNNABLE_ACTION, game, json);
#line 9411 "GOGGame.c"
}

static GFile*
game_hub_data_sources_gog_gog_game_runnable_action_find_file (GameHubDataSourcesGOGGOGGameRunnableAction* self,
                                                              const gchar* path)
{
	gboolean _tmp0_ = FALSE;
	GameHubDataRunnable* _tmp1_;
	GameHubDataRunnable* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	GameHubDataRunnable* _tmp11_;
	GameHubDataRunnable* _tmp12_;
	GFile* dir = NULL;
	GFile* _tmp31_;
	gboolean _tmp32_ = FALSE;
	GFile* _tmp33_;
	gchar* p = NULL;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	GFile* _tmp44_;
	const gchar* _tmp45_;
	GFile* _tmp46_;
	GFile* result = NULL;
#line 724 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 724 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 726 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = game_hub_data_runnable_runnable_action_get_runnable ((GameHubDataRunnableRunnableAction*) self);
#line 726 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = _tmp1_;
#line 726 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = game_hub_data_runnable_get_install_dir (_tmp2_);
#line 726 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = _tmp3_;
#line 726 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp4_ == NULL) {
#line 726 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = TRUE;
#line 9461 "GOGGame.c"
	} else {
		GameHubDataRunnable* _tmp5_;
		GameHubDataRunnable* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
#line 726 "../src/data/sources/gog/GOGGame.vala"
		_tmp5_ = game_hub_data_runnable_runnable_action_get_runnable ((GameHubDataRunnableRunnableAction*) self);
#line 726 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = _tmp5_;
#line 726 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = game_hub_data_runnable_get_install_dir (_tmp6_);
#line 726 "../src/data/sources/gog/GOGGame.vala"
		_tmp8_ = _tmp7_;
#line 726 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = !g_file_query_exists (_tmp8_, NULL);
#line 9477 "GOGGame.c"
	}
#line 726 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp0_) {
#line 726 "../src/data/sources/gog/GOGGame.vala"
		result = NULL;
#line 726 "../src/data/sources/gog/GOGGame.vala"
		return result;
#line 9485 "GOGGame.c"
	}
#line 727 "../src/data/sources/gog/GOGGame.vala"
	_tmp11_ = game_hub_data_runnable_runnable_action_get_runnable ((GameHubDataRunnableRunnableAction*) self);
#line 727 "../src/data/sources/gog/GOGGame.vala"
	_tmp12_ = _tmp11_;
#line 727 "../src/data/sources/gog/GOGGame.vala"
	if (GAME_HUB_DATA_IS_GAME (_tmp12_)) {
#line 9493 "GOGGame.c"
		GameHubDataRunnable* _tmp13_;
		GameHubDataRunnable* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 727 "../src/data/sources/gog/GOGGame.vala"
		_tmp13_ = game_hub_data_runnable_runnable_action_get_runnable ((GameHubDataRunnableRunnableAction*) self);
#line 727 "../src/data/sources/gog/GOGGame.vala"
		_tmp14_ = _tmp13_;
#line 727 "../src/data/sources/gog/GOGGame.vala"
		_tmp15_ = game_hub_data_game_get_overlays_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GAME_HUB_DATA_TYPE_GAME, GameHubDataGame));
#line 727 "../src/data/sources/gog/GOGGame.vala"
		_tmp16_ = _tmp15_;
#line 727 "../src/data/sources/gog/GOGGame.vala"
		_tmp10_ = _tmp16_;
#line 9508 "GOGGame.c"
	} else {
#line 727 "../src/data/sources/gog/GOGGame.vala"
		_tmp10_ = FALSE;
#line 9512 "GOGGame.c"
	}
#line 727 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp10_) {
#line 9516 "GOGGame.c"
		GameHubDataRunnable* _tmp17_;
		GameHubDataRunnable* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp17_ = game_hub_data_runnable_runnable_action_get_runnable ((GameHubDataRunnableRunnableAction*) self);
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp18_ = _tmp17_;
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp19_ = game_hub_data_runnable_get_install_dir (_tmp18_);
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp20_ = _tmp19_;
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp21_ = g_file_get_child (_tmp20_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp22_ = _tmp21_;
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp23_ = g_file_get_child (_tmp22_, "_overlay");
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp24_ = _tmp23_;
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp25_ = g_file_get_child (_tmp24_, "merged");
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp9_);
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_tmp9_ = _tmp25_;
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp24_);
#line 728 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp22_);
#line 9552 "GOGGame.c"
	} else {
		GameHubDataRunnable* _tmp26_;
		GameHubDataRunnable* _tmp27_;
		GFile* _tmp28_;
		GFile* _tmp29_;
		GFile* _tmp30_;
#line 729 "../src/data/sources/gog/GOGGame.vala"
		_tmp26_ = game_hub_data_runnable_runnable_action_get_runnable ((GameHubDataRunnableRunnableAction*) self);
#line 729 "../src/data/sources/gog/GOGGame.vala"
		_tmp27_ = _tmp26_;
#line 729 "../src/data/sources/gog/GOGGame.vala"
		_tmp28_ = game_hub_data_runnable_get_install_dir (_tmp27_);
#line 729 "../src/data/sources/gog/GOGGame.vala"
		_tmp29_ = _tmp28_;
#line 729 "../src/data/sources/gog/GOGGame.vala"
		_tmp30_ = _g_object_ref0 (_tmp29_);
#line 729 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp9_);
#line 729 "../src/data/sources/gog/GOGGame.vala"
		_tmp9_ = _tmp30_;
#line 9573 "GOGGame.c"
	}
#line 727 "../src/data/sources/gog/GOGGame.vala"
	_tmp31_ = _g_object_ref0 (_tmp9_);
#line 727 "../src/data/sources/gog/GOGGame.vala"
	dir = _tmp31_;
#line 730 "../src/data/sources/gog/GOGGame.vala"
	_tmp33_ = dir;
#line 730 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp33_ == NULL) {
#line 730 "../src/data/sources/gog/GOGGame.vala"
		_tmp32_ = TRUE;
#line 9585 "GOGGame.c"
	} else {
		GFile* _tmp34_;
#line 730 "../src/data/sources/gog/GOGGame.vala"
		_tmp34_ = dir;
#line 730 "../src/data/sources/gog/GOGGame.vala"
		_tmp32_ = !g_file_query_exists (_tmp34_, NULL);
#line 9592 "GOGGame.c"
	}
#line 730 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp32_) {
#line 730 "../src/data/sources/gog/GOGGame.vala"
		result = NULL;
#line 730 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (dir);
#line 730 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp9_);
#line 730 "../src/data/sources/gog/GOGGame.vala"
		return result;
#line 9604 "GOGGame.c"
	}
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_tmp35_ = string_replace (path, "//", "/");
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_tmp36_ = _tmp35_;
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_tmp37_ = string_replace (_tmp36_, "\\", "/");
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_tmp38_ = _tmp37_;
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_tmp39_ = string_strip (_tmp38_);
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_tmp40_ = _tmp39_;
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp38_);
#line 731 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp36_);
#line 731 "../src/data/sources/gog/GOGGame.vala"
	p = _tmp40_;
#line 732 "../src/data/sources/gog/GOGGame.vala"
	_tmp41_ = p;
#line 732 "../src/data/sources/gog/GOGGame.vala"
	_tmp42_ = strlen (_tmp41_);
#line 732 "../src/data/sources/gog/GOGGame.vala"
	_tmp43_ = _tmp42_;
#line 732 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp43_ == 0) {
#line 732 "../src/data/sources/gog/GOGGame.vala"
		result = dir;
#line 732 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (p);
#line 732 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_tmp9_);
#line 732 "../src/data/sources/gog/GOGGame.vala"
		return result;
#line 9640 "GOGGame.c"
	}
#line 733 "../src/data/sources/gog/GOGGame.vala"
	_tmp44_ = dir;
#line 733 "../src/data/sources/gog/GOGGame.vala"
	_tmp45_ = p;
#line 733 "../src/data/sources/gog/GOGGame.vala"
	_tmp46_ = game_hub_utils_fs_utils_find_case_insensitive (_tmp44_, _tmp45_, NULL, (gint) 0);
#line 733 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp46_;
#line 733 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (p);
#line 733 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (dir);
#line 733 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_tmp9_);
#line 733 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 9658 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_runnable_action_class_init (GameHubDataSourcesGOGGOGGameRunnableActionClass * klass,
                                                               gpointer klass_data)
{
#line 689 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_runnable_action_parent_class = g_type_class_peek_parent (klass);
#line 9667 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_runnable_action_instance_init (GameHubDataSourcesGOGGOGGameRunnableAction * self,
                                                                  gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_runnable_action_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesGOGGOGGameRunnableActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_gog_gog_game_runnable_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesGOGGOGGameRunnableAction), 0, (GInstanceInitFunc) game_hub_data_sources_gog_gog_game_runnable_action_instance_init, NULL };
	GType game_hub_data_sources_gog_gog_game_runnable_action_type_id;
	game_hub_data_sources_gog_gog_game_runnable_action_type_id = g_type_register_static (GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, "GameHubDataSourcesGOGGOGGameRunnableAction", &g_define_type_info, 0);
	return game_hub_data_sources_gog_gog_game_runnable_action_type_id;
}

GType
game_hub_data_sources_gog_gog_game_runnable_action_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_runnable_action_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_runnable_action_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_runnable_action_type_id;
		game_hub_data_sources_gog_gog_game_runnable_action_type_id = game_hub_data_sources_gog_gog_game_runnable_action_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_runnable_action_type_id__volatile, game_hub_data_sources_gog_gog_game_runnable_action_type_id);
	}
	return game_hub_data_sources_gog_gog_game_runnable_action_type_id__volatile;
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_bonus_content_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_NOT_DOWNLOADED, "GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_NOT_DOWNLOADED", "not-downloaded"}, {GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADING, "GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADING", "downloading"}, {GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADED, "GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADED", "downloaded"}, {0, NULL, NULL}};
	GType game_hub_data_sources_gog_gog_game_bonus_content_state_type_id;
	game_hub_data_sources_gog_gog_game_bonus_content_state_type_id = g_enum_register_static ("GameHubDataSourcesGOGGOGGameBonusContentState", values);
	return game_hub_data_sources_gog_gog_game_bonus_content_state_type_id;
}

GType
game_hub_data_sources_gog_gog_game_bonus_content_state_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_bonus_content_state_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_bonus_content_state_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_bonus_content_state_type_id;
		game_hub_data_sources_gog_gog_game_bonus_content_state_type_id = game_hub_data_sources_gog_gog_game_bonus_content_state_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_bonus_content_state_type_id__volatile, game_hub_data_sources_gog_gog_game_bonus_content_state_type_id);
	}
	return game_hub_data_sources_gog_gog_game_bonus_content_state_type_id__volatile;
}

GameHubDataSourcesGOGGOGGameBonusContent*
game_hub_data_sources_gog_gog_game_bonus_content_construct (GType object_type,
                                                            GameHubDataSourcesGOGGOGGame* game,
                                                            JsonObject* json,
                                                            JsonObject* bonus_map)
{
	GameHubDataSourcesGOGGOGGameBonusContent* self = NULL;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	JsonArray* _tmp6_;
	JsonObject* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GameHubUtilsDownloaderDownloadInfo* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gboolean _tmp26_ = FALSE;
#line 791 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 791 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (json != NULL, NULL);
#line 791 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameBonusContent*) g_type_create_instance (object_type);
#line 793 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 793 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->game);
#line 793 "../src/data/sources/gog/GOGGame.vala"
	self->game = _tmp0_;
#line 794 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, json_object_get_int_member (json, "id"));
#line 794 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->id);
#line 794 "../src/data/sources/gog/GOGGame.vala"
	self->id = _tmp1_;
#line 795 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = json_object_get_string_member (json, "name");
#line 795 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 795 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->name);
#line 795 "../src/data/sources/gog/GOGGame.vala"
	self->name = _tmp3_;
#line 796 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = json_object_get_string_member (json, "type");
#line 796 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 796 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->type);
#line 796 "../src/data/sources/gog/GOGGame.vala"
	self->type = _tmp5_;
#line 797 "../src/data/sources/gog/GOGGame.vala"
	self->count = json_object_get_int_member (json, "count");
#line 798 "../src/data/sources/gog/GOGGame.vala"
	_tmp6_ = json_object_get_array_member (json, "files");
#line 798 "../src/data/sources/gog/GOGGame.vala"
	_tmp7_ = json_array_get_object_element (_tmp6_, (guint) 0);
#line 798 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = json_object_get_string_member (_tmp7_, "downlink");
#line 798 "../src/data/sources/gog/GOGGame.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 798 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->file);
#line 798 "../src/data/sources/gog/GOGGame.vala"
	self->file = _tmp9_;
#line 799 "../src/data/sources/gog/GOGGame.vala"
	self->size = json_object_get_int_member (json, "total_size");
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp10_ = game_hub_data_sources_gog_gog_game_bonus_content_get_text (self);
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp11_ = _tmp10_;
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp12_ = _tmp11_;
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp13_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp14_ = _tmp13_;
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp15_ = game_hub_data_game_get_icon ((GameHubDataGame*) game);
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp16_ = _tmp15_;
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp17_ = game_hub_data_sources_gog_gog_game_bonus_content_get_icon (self);
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp18_ = _tmp17_;
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_tmp19_ = game_hub_utils_downloader_download_info_new (_tmp12_, _tmp14_, _tmp16_, NULL, NULL, _tmp18_);
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->dl_info);
#line 800 "../src/data/sources/gog/GOGGame.vala"
	self->dl_info = _tmp19_;
#line 800 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp12_);
#line 802 "../src/data/sources/gog/GOGGame.vala"
	_tmp20_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) game);
#line 802 "../src/data/sources/gog/GOGGame.vala"
	_tmp21_ = _tmp20_;
#line 802 "../src/data/sources/gog/GOGGame.vala"
	_tmp22_ = string_to_string (_tmp21_);
#line 802 "../src/data/sources/gog/GOGGame.vala"
	_tmp23_ = self->id;
#line 802 "../src/data/sources/gog/GOGGame.vala"
	_tmp24_ = string_to_string (_tmp23_);
#line 802 "../src/data/sources/gog/GOGGame.vala"
	_tmp25_ = g_strconcat ("gog_", _tmp22_, "_bonus_", _tmp24_, NULL);
#line 802 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->filename);
#line 802 "../src/data/sources/gog/GOGGame.vala"
	self->filename = _tmp25_;
#line 803 "../src/data/sources/gog/GOGGame.vala"
	if (bonus_map != NULL) {
#line 9846 "GOGGame.c"
		const gchar* _tmp27_;
#line 803 "../src/data/sources/gog/GOGGame.vala"
		_tmp27_ = self->id;
#line 803 "../src/data/sources/gog/GOGGame.vala"
		_tmp26_ = json_object_has_member (bonus_map, _tmp27_);
#line 9852 "GOGGame.c"
	} else {
#line 803 "../src/data/sources/gog/GOGGame.vala"
		_tmp26_ = FALSE;
#line 9856 "GOGGame.c"
	}
#line 803 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp26_) {
#line 9860 "GOGGame.c"
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		const gchar* _tmp33_;
		GFile* _tmp34_;
		GameHubDataSourcesGOGGOGGameBonusContentState _tmp35_ = 0;
		gboolean _tmp36_ = FALSE;
		GFile* _tmp37_;
		GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp39_;
		GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp40_;
#line 805 "../src/data/sources/gog/GOGGame.vala"
		_tmp28_ = self->id;
#line 805 "../src/data/sources/gog/GOGGame.vala"
		_tmp29_ = json_object_get_string_member (bonus_map, _tmp28_);
#line 805 "../src/data/sources/gog/GOGGame.vala"
		_tmp30_ = g_strdup (_tmp29_);
#line 805 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (self->filename);
#line 805 "../src/data/sources/gog/GOGGame.vala"
		self->filename = _tmp30_;
#line 806 "../src/data/sources/gog/GOGGame.vala"
		_tmp31_ = game_hub_data_sources_gog_gog_game_get_bonus_content_dir (game);
#line 806 "../src/data/sources/gog/GOGGame.vala"
		_tmp32_ = _tmp31_;
#line 806 "../src/data/sources/gog/GOGGame.vala"
		_tmp33_ = self->filename;
#line 806 "../src/data/sources/gog/GOGGame.vala"
		_tmp34_ = g_file_get_child (_tmp32_, _tmp33_);
#line 806 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (self->downloaded_file);
#line 806 "../src/data/sources/gog/GOGGame.vala"
		self->downloaded_file = _tmp34_;
#line 807 "../src/data/sources/gog/GOGGame.vala"
		_tmp37_ = self->downloaded_file;
#line 807 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp37_ != NULL) {
#line 9899 "GOGGame.c"
			GFile* _tmp38_;
#line 807 "../src/data/sources/gog/GOGGame.vala"
			_tmp38_ = self->downloaded_file;
#line 807 "../src/data/sources/gog/GOGGame.vala"
			_tmp36_ = g_file_query_exists (_tmp38_, NULL);
#line 9905 "GOGGame.c"
		} else {
#line 807 "../src/data/sources/gog/GOGGame.vala"
			_tmp36_ = FALSE;
#line 9909 "GOGGame.c"
		}
#line 807 "../src/data/sources/gog/GOGGame.vala"
		if (_tmp36_) {
#line 807 "../src/data/sources/gog/GOGGame.vala"
			_tmp35_ = GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADED;
#line 9915 "GOGGame.c"
		} else {
#line 807 "../src/data/sources/gog/GOGGame.vala"
			_tmp35_ = GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_NOT_DOWNLOADED;
#line 9919 "GOGGame.c"
		}
#line 807 "../src/data/sources/gog/GOGGame.vala"
		_tmp39_ = game_hub_data_sources_gog_gog_game_bonus_content_status_new (_tmp35_, NULL);
#line 807 "../src/data/sources/gog/GOGGame.vala"
		_tmp40_ = _tmp39_;
#line 807 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_set_status (self, _tmp40_);
#line 807 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_sources_gog_gog_game_bonus_content_status_unref0 (_tmp40_);
#line 9929 "GOGGame.c"
	}
#line 791 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 9933 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameBonusContent*
game_hub_data_sources_gog_gog_game_bonus_content_new (GameHubDataSourcesGOGGOGGame* game,
                                                      JsonObject* json,
                                                      JsonObject* bonus_map)
{
#line 791 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_bonus_content_construct (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT, game, json, bonus_map);
#line 9943 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_download_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameBonusContentDownloadData* _data_;
	_data_ = _data;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->result);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_sources_gog_gog_game_bonus_content_unref0 (_data_->self);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameBonusContentDownloadData, _data_);
#line 9957 "GOGGame.c"
}

static gpointer
_game_hub_data_sources_gog_gog_game_bonus_content_ref0 (gpointer self)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return self ? game_hub_data_sources_gog_gog_game_bonus_content_ref (self) : NULL;
#line 9965 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_bonus_content_download (GameHubDataSourcesGOGGOGGameBonusContent* self,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameBonusContentDownloadData* _data_;
	GameHubDataSourcesGOGGOGGameBonusContent* _tmp0_;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameBonusContentDownloadData);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_bonus_content_download_data_free);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _game_hub_data_sources_gog_gog_game_bonus_content_ref0 (self);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_download_co (_data_);
#line 9989 "GOGGame.c"
}

GFile*
game_hub_data_sources_gog_gog_game_bonus_content_download_finish (GameHubDataSourcesGOGGOGGameBonusContent* self,
                                                                  GAsyncResult* _res_)
{
	GFile* result;
	GameHubDataSourcesGogGogGameBonusContentDownloadData* _data_;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	result = _data_->result;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	_data_->result = NULL;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 10006 "GOGGame.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 811 "../src/data/sources/gog/GOGGame.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 811 "../src/data/sources/gog/GOGGame.vala"
	return _data18_;
#line 10016 "GOGGame.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 811 "../src/data/sources/gog/GOGGame.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 10026 "GOGGame.c"
		GameHubDataSourcesGOGGOGGameBonusContent* self;
#line 811 "../src/data/sources/gog/GOGGame.vala"
		self = _data18_->self;
#line 811 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_data18_->remote);
#line 811 "../src/data/sources/gog/GOGGame.vala"
		_game_hub_data_sources_gog_gog_game_bonus_content_unref0 (self);
#line 811 "../src/data/sources/gog/GOGGame.vala"
		g_slice_free (Block18Data, _data18_);
#line 10036 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_download_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameBonusContentDownloadData* _data_;
#line 821 "../src/data/sources/gog/GOGGame.vala"
	_data_ = _user_data_;
#line 821 "../src/data/sources/gog/GOGGame.vala"
	_data_->_source_object_ = source_object;
#line 821 "../src/data/sources/gog/GOGGame.vala"
	_data_->_res_ = _res_;
#line 821 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_download_co (_data_);
#line 10054 "GOGGame.c"
}

static void
__lambda124_ (GameHubDataSourcesGOGGOGGameBonusContent* self,
              GameHubUtilsDownloaderDownloadStatus* s)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp0_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp1_;
#line 857 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = game_hub_data_sources_gog_gog_game_bonus_content_get_status (self);
#line 857 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _tmp0_;
#line 857 "../src/data/sources/gog/GOGGame.vala"
	g_signal_emit (self, game_hub_data_sources_gog_gog_game_bonus_content_signals[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS_CHANGE_SIGNAL], 0, _tmp1_);
#line 10069 "GOGGame.c"
}

static void
___lambda124__game_hub_utils_downloader_download_status_change (GameHubUtilsDownloaderDownload* _sender,
                                                                GameHubUtilsDownloaderDownloadStatus* status,
                                                                gpointer self)
{
#line 856 "../src/data/sources/gog/GOGGame.vala"
	__lambda124_ ((GameHubDataSourcesGOGGOGGameBonusContent*) self, status);
#line 10079 "GOGGame.c"
}

static void
__lambda123_ (Block18Data* _data18_,
              GameHubUtilsDownloaderFileDownload* dl)
{
	GameHubDataSourcesGOGGOGGameBonusContent* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp2_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp3_;
#line 853 "../src/data/sources/gog/GOGGame.vala"
	self = _data18_->self;
#line 853 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (dl != NULL);
#line 854 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = dl->remote;
#line 854 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _data18_->remote;
#line 854 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp0_ != _tmp1_) {
#line 854 "../src/data/sources/gog/GOGGame.vala"
		return;
#line 10103 "GOGGame.c"
	}
#line 855 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = game_hub_data_sources_gog_gog_game_bonus_content_status_new (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADING, (GameHubUtilsDownloaderDownload*) dl);
#line 855 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = _tmp2_;
#line 855 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_set_status (self, _tmp3_);
#line 855 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_sources_gog_gog_game_bonus_content_status_unref0 (_tmp3_);
#line 856 "../src/data/sources/gog/GOGGame.vala"
	g_signal_connect ((GameHubUtilsDownloaderDownload*) dl, "status-change", (GCallback) ___lambda124__game_hub_utils_downloader_download_status_change, self);
#line 10115 "GOGGame.c"
}

static void
___lambda123__game_hub_utils_downloader_download_manager_file_download_started (GameHubUtilsDownloaderDownloadManager* _sender,
                                                                                GameHubUtilsDownloaderFileDownload* download,
                                                                                gpointer self)
{
#line 853 "../src/data/sources/gog/GOGGame.vala"
	__lambda123_ (self, download);
#line 10125 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_bonus_content_download_co (GameHubDataSourcesGogGogGameBonusContentDownloadData* _data_)
{
#line 811 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 811 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 10135 "GOGGame.c"
		goto _state_0;
#line 811 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 10139 "GOGGame.c"
		goto _state_1;
#line 811 "../src/data/sources/gog/GOGGame.vala"
		case 2:
#line 10143 "GOGGame.c"
		goto _state_2;
#line 811 "../src/data/sources/gog/GOGGame.vala"
		case 3:
#line 10147 "GOGGame.c"
		goto _state_3;
		default:
#line 811 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 10152 "GOGGame.c"
	}
	_state_0:
#line 811 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data18_ = g_slice_new0 (Block18Data);
#line 811 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data18_->_ref_count_ = 1;
#line 811 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data18_->self = game_hub_data_sources_gog_gog_game_bonus_content_ref (_data_->self);
#line 811 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data18_->_async_data_ = _data_;
#line 813 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp0_ = _data_->self->game;
#line 813 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp1_ = game_hub_data_sources_gog_gog_game_get_bonus_content_dir (_data_->_tmp0_);
#line 813 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 813 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp2_ == NULL) {
#line 813 "../src/data/sources/gog/GOGGame.vala"
		_data_->result = NULL;
#line 813 "../src/data/sources/gog/GOGGame.vala"
		block18_data_unref (_data_->_data18_);
#line 813 "../src/data/sources/gog/GOGGame.vala"
		_data_->_data18_ = NULL;
#line 813 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 813 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 813 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 813 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10185 "GOGGame.c"
			}
		}
#line 813 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 813 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 10192 "GOGGame.c"
	}
#line 815 "../src/data/sources/gog/GOGGame.vala"
	_data_->root_node = NULL;
#line 817 "../src/data/sources/gog/GOGGame.vala"
	while (TRUE) {
#line 819 "../src/data/sources/gog/GOGGame.vala"
		_data_->status = (guint) 0;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp3_ = _data_->self->file;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp4_ = _data_->self->game;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp5_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->_tmp4_);
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG)->user_token;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp8_ = 0U;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_state_ = 1;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		game_hub_utils_parser_parse_remote_json_file_async (_data_->_tmp3_, "GET", _data_->_tmp7_, NULL, NULL, game_hub_data_sources_gog_gog_game_bonus_content_download_ready, _data_);
#line 821 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 10218 "GOGGame.c"
		_state_1:
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp9_ = game_hub_utils_parser_parse_remote_json_file_finish (_data_->_res_, &_data_->_tmp8_);
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->status = _data_->_tmp8_;
#line 821 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (_data_->root_node);
#line 821 "../src/data/sources/gog/GOGGame.vala"
		_data_->root_node = _data_->_tmp9_;
#line 823 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->status == ((guint) SOUP_STATUS_UNAUTHORIZED)) {
#line 825 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp10_ = _data_->self->game;
#line 825 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp11_ = game_hub_data_game_get_source ((GameHubDataGame*) _data_->_tmp10_);
#line 825 "../src/data/sources/gog/GOGGame.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 825 "../src/data/sources/gog/GOGGame.vala"
			_data_->_state_ = 2;
#line 825 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_sources_gog_gog_refresh_token (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG), game_hub_data_sources_gog_gog_game_bonus_content_download_ready, _data_);
#line 825 "../src/data/sources/gog/GOGGame.vala"
			return FALSE;
#line 10242 "GOGGame.c"
			_state_2:
#line 825 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_sources_gog_gog_refresh_token_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG, GameHubDataSourcesGOGGOG), _data_->_res_);
#line 10246 "GOGGame.c"
		} else {
#line 827 "../src/data/sources/gog/GOGGame.vala"
			break;
#line 10250 "GOGGame.c"
		}
	}
#line 830 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp14_ = _data_->root_node;
#line 830 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp14_ == NULL) {
#line 830 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp13_ = TRUE;
#line 10259 "GOGGame.c"
	} else {
#line 830 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp15_ = _data_->root_node;
#line 830 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp13_ = json_node_get_node_type (_data_->_tmp15_) != JSON_NODE_OBJECT;
#line 10265 "GOGGame.c"
	}
#line 830 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp13_) {
#line 830 "../src/data/sources/gog/GOGGame.vala"
		_data_->result = NULL;
#line 830 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (_data_->root_node);
#line 830 "../src/data/sources/gog/GOGGame.vala"
		block18_data_unref (_data_->_data18_);
#line 830 "../src/data/sources/gog/GOGGame.vala"
		_data_->_data18_ = NULL;
#line 830 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 830 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 830 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 830 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10285 "GOGGame.c"
			}
		}
#line 830 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 830 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 10292 "GOGGame.c"
	}
#line 831 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp16_ = _data_->root_node;
#line 831 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp17_ = json_node_get_object (_data_->_tmp16_);
#line 831 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp18_ = _json_object_ref0 (_data_->_tmp17_);
#line 831 "../src/data/sources/gog/GOGGame.vala"
	_data_->root = _data_->_tmp18_;
#line 832 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp20_ = _data_->root;
#line 832 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp20_ == NULL) {
#line 832 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp19_ = TRUE;
#line 10308 "GOGGame.c"
	} else {
#line 832 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp21_ = _data_->root;
#line 832 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp19_ = !json_object_has_member (_data_->_tmp21_, "downlink");
#line 10314 "GOGGame.c"
	}
#line 832 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp19_) {
#line 832 "../src/data/sources/gog/GOGGame.vala"
		_data_->result = NULL;
#line 832 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (_data_->root);
#line 832 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (_data_->root_node);
#line 832 "../src/data/sources/gog/GOGGame.vala"
		block18_data_unref (_data_->_data18_);
#line 832 "../src/data/sources/gog/GOGGame.vala"
		_data_->_data18_ = NULL;
#line 832 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 832 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 832 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 832 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10336 "GOGGame.c"
			}
		}
#line 832 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 832 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 10343 "GOGGame.c"
	}
#line 834 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp22_ = _data_->root;
#line 834 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp23_ = json_object_get_string_member (_data_->_tmp22_, "downlink");
#line 834 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp24_ = g_strdup (_data_->_tmp23_);
#line 834 "../src/data/sources/gog/GOGGame.vala"
	_data_->url = _data_->_tmp24_;
#line 835 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp25_ = _data_->root;
#line 835 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp26_ = json_object_get_string_member (_data_->_tmp25_, "checksum");
#line 835 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp27_ = g_strdup (_data_->_tmp26_);
#line 835 "../src/data/sources/gog/GOGGame.vala"
	_data_->checksum_url = _data_->_tmp27_;
#line 836 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp28_ = _data_->url;
#line 836 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp29_ = g_file_new_for_uri (_data_->_tmp28_);
#line 836 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data18_->remote = _data_->_tmp29_;
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp31_ = _data_->self->filename;
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp32_ = _data_->self->game;
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp33_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) _data_->_tmp32_);
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp35_ = string_to_string (_data_->_tmp34_);
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp36_ = _data_->self->id;
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp37_ = string_to_string (_data_->_tmp36_);
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp38_ = g_strconcat ("gog_", _data_->_tmp35_, "_bonus_", _data_->_tmp37_, NULL);
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp39_ = _data_->_tmp38_;
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp40_ = g_strcmp0 (_data_->_tmp31_, _data_->_tmp39_) == 0;
#line 838 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_data_->_tmp39_);
#line 838 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp40_) {
#line 838 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp41_ = _data_->url;
#line 838 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp30_ = string_contains (_data_->_tmp41_, "/namespaces/website/download?path=");
#line 10395 "GOGGame.c"
	} else {
#line 838 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp30_ = FALSE;
#line 10399 "GOGGame.c"
	}
#line 838 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp30_) {
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp42_ = _data_->url;
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp44_ = _data_->_tmp43_ = g_strsplit (_data_->_tmp42_, "/namespaces/website/download?path=", 0);
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp45__length1 = _vala_array_length (_data_->_tmp43_);
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp46_ = _data_->_tmp45_[1];
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp48_ = _data_->_tmp47_ = g_strsplit (_data_->_tmp46_, "&", 0);
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp49__length1 = _vala_array_length (_data_->_tmp47_);
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp50_ = _data_->_tmp49_[0];
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp51_ = g_strdup (_data_->_tmp50_);
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp49_ = (_vala_array_free (_data_->_tmp49_, _data_->_tmp49__length1, (GDestroyNotify) g_free), NULL);
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp45_ = (_vala_array_free (_data_->_tmp45_, _data_->_tmp45__length1, (GDestroyNotify) g_free), NULL);
#line 840 "../src/data/sources/gog/GOGGame.vala"
		_data_->remote_path_encoded = _data_->_tmp52_;
#line 841 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp53_ = _data_->remote_path_encoded;
#line 841 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp54_ = g_uri_unescape_string (_data_->_tmp53_, NULL);
#line 841 "../src/data/sources/gog/GOGGame.vala"
		_data_->remote_path = _data_->_tmp54_;
#line 842 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp55_ = _data_->remote_path;
#line 842 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp56_ = g_file_new_for_path (_data_->_tmp55_);
#line 842 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp57_ = _data_->_tmp56_;
#line 842 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp58_ = g_file_get_basename (_data_->_tmp57_);
#line 842 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->self->filename);
#line 842 "../src/data/sources/gog/GOGGame.vala"
		_data_->self->filename = _data_->_tmp58_;
#line 842 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_data_->_tmp57_);
#line 838 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->remote_path);
#line 838 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->remote_path_encoded);
#line 10455 "GOGGame.c"
	}
#line 845 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp59_ = _data_->self->filename;
#line 845 "../src/data/sources/gog/GOGGame.vala"
	g_warning ("GOGGame.vala:845: [filename] %s", _data_->_tmp59_);
#line 847 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp60_ = game_hub_utils_fs_utils_paths_gog_get_Games ();
#line 847 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp61_ = _data_->_tmp60_;
#line 847 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp62_ = _data_->_tmp61_;
#line 847 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp63_ = game_hub_utils_fs_utils_mkdir (_data_->_tmp62_, NULL, NULL);
#line 847 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp64_ = _data_->_tmp63_;
#line 847 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp64_);
#line 847 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_data_->_tmp62_);
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp65_ = _data_->self->game;
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp66_ = game_hub_data_sources_gog_gog_game_get_bonus_content_dir (_data_->_tmp65_);
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp67_ = _data_->_tmp66_;
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp68_ = g_file_get_path (_data_->_tmp67_);
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp69_ = _data_->_tmp68_;
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp70_ = game_hub_utils_fs_utils_mkdir (_data_->_tmp69_, NULL, NULL);
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp71_ = _data_->_tmp70_;
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp71_);
#line 848 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_data_->_tmp69_);
#line 850 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp72_ = _data_->self->game;
#line 850 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp73_ = game_hub_data_sources_gog_gog_game_get_bonus_content_dir (_data_->_tmp72_);
#line 850 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp74_ = _data_->_tmp73_;
#line 850 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp75_ = _data_->self->filename;
#line 850 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp76_ = g_file_get_child (_data_->_tmp74_, _data_->_tmp75_);
#line 850 "../src/data/sources/gog/GOGGame.vala"
	_data_->local = _data_->_tmp76_;
#line 852 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp77_ = game_hub_data_sources_gog_gog_game_bonus_content_status_new (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADING, NULL);
#line 852 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp78_ = _data_->_tmp77_;
#line 852 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_set_status (_data_->self, _data_->_tmp78_);
#line 852 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_sources_gog_gog_game_bonus_content_status_unref0 (_data_->_tmp78_);
#line 853 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp79_ = game_hub_utils_downloader_download_manager ();
#line 853 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp80_ = _data_->_tmp79_;
#line 853 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp81_ = g_signal_connect_data (_data_->_tmp80_, "file-download-started", (GCallback) ___lambda123__game_hub_utils_downloader_download_manager_file_download_started, block18_data_ref (_data_->_data18_), (GClosureNotify) block18_data_unref, 0);
#line 853 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp82_ = _data_->_tmp81_;
#line 853 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp80_);
#line 853 "../src/data/sources/gog/GOGGame.vala"
	_data_->ds_id = _data_->_tmp82_;
#line 861 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp83_ = g_date_time_new_now_local ();
#line 861 "../src/data/sources/gog/GOGGame.vala"
	_data_->start_date = _data_->_tmp83_;
#line 10529 "GOGGame.c"
	{
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp85_ = _data_->_data18_->remote;
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp86_ = _data_->local;
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp87_ = _data_->self->dl_info;
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_state_ = 3;
#line 865 "../src/data/sources/gog/GOGGame.vala"
		game_hub_utils_downloader_download_file (_data_->_tmp85_, _data_->_tmp86_, _data_->_tmp87_, TRUE, FALSE, game_hub_data_sources_gog_gog_game_bonus_content_download_ready, _data_);
#line 865 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 10543 "GOGGame.c"
		_state_3:
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp88_ = game_hub_utils_downloader_download_file_finish (_data_->_res_, &_data_->_inner_error0_);
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp84_ = _data_->_tmp88_;
#line 865 "../src/data/sources/gog/GOGGame.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 10551 "GOGGame.c"
			goto __catch0_g_error;
		}
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp89_ = _data_->_tmp84_;
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp84_ = NULL;
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_data_->self->downloaded_file);
#line 865 "../src/data/sources/gog/GOGGame.vala"
		_data_->self->downloaded_file = _data_->_tmp89_;
#line 863 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_data_->_tmp84_);
#line 10564 "GOGGame.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 863 "../src/data/sources/gog/GOGGame.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 10571 "GOGGame.c"
	}
	__finally0:
#line 863 "../src/data/sources/gog/GOGGame.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 863 "../src/data/sources/gog/GOGGame.vala"
		_g_date_time_unref0 (_data_->start_date);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (_data_->local);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->checksum_url);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_data_->url);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (_data_->root);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (_data_->root_node);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		block18_data_unref (_data_->_data18_);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		_data_->_data18_ = NULL;
#line 863 "../src/data/sources/gog/GOGGame.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 863 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 10600 "GOGGame.c"
	}
#line 869 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp90_ = game_hub_utils_downloader_download_manager ();
#line 869 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp91_ = _data_->_tmp90_;
#line 869 "../src/data/sources/gog/GOGGame.vala"
	g_signal_handler_disconnect ((GObject*) _data_->_tmp91_, _data_->ds_id);
#line 869 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp91_);
#line 871 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_save_filename (_data_->self);
#line 873 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp94_ = _data_->self->downloaded_file;
#line 873 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp94_ != NULL) {
#line 873 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp95_ = _data_->self->downloaded_file;
#line 873 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp93_ = g_file_query_exists (_data_->_tmp95_, NULL);
#line 10620 "GOGGame.c"
	} else {
#line 873 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp93_ = FALSE;
#line 10624 "GOGGame.c"
	}
#line 873 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp93_) {
#line 873 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp92_ = GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_DOWNLOADED;
#line 10630 "GOGGame.c"
	} else {
#line 873 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp92_ = GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_NOT_DOWNLOADED;
#line 10634 "GOGGame.c"
	}
#line 873 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp96_ = game_hub_data_sources_gog_gog_game_bonus_content_status_new (_data_->_tmp92_, NULL);
#line 873 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp97_ = _data_->_tmp96_;
#line 873 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_set_status (_data_->self, _data_->_tmp97_);
#line 873 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_sources_gog_gog_game_bonus_content_status_unref0 (_data_->_tmp97_);
#line 875 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp98_ = g_date_time_new_now_local ();
#line 875 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp99_ = _data_->_tmp98_;
#line 875 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp100_ = _data_->start_date;
#line 875 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp101_ = g_date_time_difference (_data_->_tmp99_, _data_->_tmp100_);
#line 875 "../src/data/sources/gog/GOGGame.vala"
	_g_date_time_unref0 (_data_->_tmp99_);
#line 875 "../src/data/sources/gog/GOGGame.vala"
	_data_->elapsed = _data_->_tmp101_;
#line 877 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->elapsed <= (10 * G_TIME_SPAN_SECOND)) {
#line 877 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_open (_data_->self);
#line 10660 "GOGGame.c"
	}
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp102_ = _data_->self->downloaded_file;
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp103_ = _g_object_ref0 (_data_->_tmp102_);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_data_->result = _data_->_tmp103_;
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_g_date_time_unref0 (_data_->start_date);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->local);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_data_->checksum_url);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_data_->url);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (_data_->root);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	__vala_JsonNode_free0 (_data_->root_node);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	block18_data_unref (_data_->_data18_);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	_data_->_data18_ = NULL;
#line 879 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 879 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 879 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10692 "GOGGame.c"
		}
	}
#line 879 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 879 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 10699 "GOGGame.c"
}

static gboolean
___lambda125_ (GameHubDataSourcesGOGGOGGameBonusContent* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean result = FALSE;
#line 887 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->downloaded_file;
#line 887 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = g_file_get_uri (_tmp0_);
#line 887 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = _tmp1_;
#line 887 "../src/data/sources/gog/GOGGame.vala"
	game_hub_utils_open_uri (_tmp2_);
#line 887 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_tmp2_);
#line 888 "../src/data/sources/gog/GOGGame.vala"
	result = G_SOURCE_REMOVE;
#line 888 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 10723 "GOGGame.c"
}

static gboolean
____lambda125__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda125_ ((GameHubDataSourcesGOGGOGGameBonusContent*) self);
#line 886 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 10733 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_bonus_content_open (GameHubDataSourcesGOGGOGGameBonusContent* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
#line 882 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 884 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = self->downloaded_file;
#line 884 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp1_ != NULL) {
#line 10747 "GOGGame.c"
		GFile* _tmp2_;
#line 884 "../src/data/sources/gog/GOGGame.vala"
		_tmp2_ = self->downloaded_file;
#line 884 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = g_file_query_exists (_tmp2_, NULL);
#line 10753 "GOGGame.c"
	} else {
#line 884 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = FALSE;
#line 10757 "GOGGame.c"
	}
#line 884 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp0_) {
#line 886 "../src/data/sources/gog/GOGGame.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda125__gsource_func, game_hub_data_sources_gog_gog_game_bonus_content_ref (self), game_hub_data_sources_gog_gog_game_bonus_content_unref);
#line 10763 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_save_filename (GameHubDataSourcesGOGGOGGameBonusContent* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GameHubDataSourcesGOGGOGGame* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp7_;
	gchar* _tmp8_;
	GFile* file = NULL;
	GameHubDataSourcesGOGGOGGame* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	JsonNode* root_node = NULL;
	JsonObject* root = NULL;
	gboolean _tmp13_ = FALSE;
	GFile* _tmp14_;
	gboolean _tmp20_ = FALSE;
	JsonNode* _tmp21_;
	JsonObject* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	JsonNode* _tmp31_;
	JsonObject* _tmp32_;
	gchar* json = NULL;
	JsonNode* _tmp33_;
	gchar* _tmp34_;
	GError* _inner_error0_ = NULL;
#line 893 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 895 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = self->game;
#line 895 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = game_hub_data_sources_gog_gog_game_get_bonus_content_dir (_tmp2_);
#line 895 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = _tmp3_;
#line 895 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp4_ == NULL) {
#line 895 "../src/data/sources/gog/GOGGame.vala"
		_tmp1_ = TRUE;
#line 10809 "GOGGame.c"
	} else {
		GFile* _tmp5_;
#line 895 "../src/data/sources/gog/GOGGame.vala"
		_tmp5_ = self->downloaded_file;
#line 895 "../src/data/sources/gog/GOGGame.vala"
		_tmp1_ = _tmp5_ == NULL;
#line 10816 "GOGGame.c"
	}
#line 895 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp1_) {
#line 895 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = TRUE;
#line 10822 "GOGGame.c"
	} else {
		GFile* _tmp6_;
#line 895 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = self->downloaded_file;
#line 895 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = !g_file_query_exists (_tmp6_, NULL);
#line 10829 "GOGGame.c"
	}
#line 895 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp0_) {
#line 895 "../src/data/sources/gog/GOGGame.vala"
		return;
#line 10835 "GOGGame.c"
	}
#line 897 "../src/data/sources/gog/GOGGame.vala"
	_tmp7_ = self->downloaded_file;
#line 897 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = g_file_get_basename (_tmp7_);
#line 897 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->filename);
#line 897 "../src/data/sources/gog/GOGGame.vala"
	self->filename = _tmp8_;
#line 899 "../src/data/sources/gog/GOGGame.vala"
	_tmp9_ = self->game;
#line 899 "../src/data/sources/gog/GOGGame.vala"
	_tmp10_ = game_hub_data_sources_gog_gog_game_get_bonus_content_dir (_tmp9_);
#line 899 "../src/data/sources/gog/GOGGame.vala"
	_tmp11_ = _tmp10_;
#line 899 "../src/data/sources/gog/GOGGame.vala"
	_tmp12_ = g_file_get_child (_tmp11_, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_FILEMAP_NAME);
#line 899 "../src/data/sources/gog/GOGGame.vala"
	file = _tmp12_;
#line 901 "../src/data/sources/gog/GOGGame.vala"
	root_node = NULL;
#line 902 "../src/data/sources/gog/GOGGame.vala"
	root = NULL;
#line 904 "../src/data/sources/gog/GOGGame.vala"
	_tmp14_ = file;
#line 904 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp14_ != NULL) {
#line 10863 "GOGGame.c"
		GFile* _tmp15_;
#line 904 "../src/data/sources/gog/GOGGame.vala"
		_tmp15_ = file;
#line 904 "../src/data/sources/gog/GOGGame.vala"
		_tmp13_ = g_file_query_exists (_tmp15_, NULL);
#line 10869 "GOGGame.c"
	} else {
#line 904 "../src/data/sources/gog/GOGGame.vala"
		_tmp13_ = FALSE;
#line 10873 "GOGGame.c"
	}
#line 904 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp13_) {
#line 10877 "GOGGame.c"
		GFile* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		JsonNode* _tmp19_;
#line 906 "../src/data/sources/gog/GOGGame.vala"
		_tmp16_ = file;
#line 906 "../src/data/sources/gog/GOGGame.vala"
		_tmp17_ = g_file_get_path (_tmp16_);
#line 906 "../src/data/sources/gog/GOGGame.vala"
		_tmp18_ = _tmp17_;
#line 906 "../src/data/sources/gog/GOGGame.vala"
		_tmp19_ = game_hub_utils_parser_parse_json_file (_tmp18_, "");
#line 906 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (root_node);
#line 906 "../src/data/sources/gog/GOGGame.vala"
		root_node = _tmp19_;
#line 906 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp18_);
#line 10896 "GOGGame.c"
	}
#line 909 "../src/data/sources/gog/GOGGame.vala"
	_tmp21_ = root_node;
#line 909 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp21_ == NULL) {
#line 909 "../src/data/sources/gog/GOGGame.vala"
		_tmp20_ = TRUE;
#line 10904 "GOGGame.c"
	} else {
		JsonNode* _tmp22_;
#line 909 "../src/data/sources/gog/GOGGame.vala"
		_tmp22_ = root_node;
#line 909 "../src/data/sources/gog/GOGGame.vala"
		_tmp20_ = json_node_get_node_type (_tmp22_) != JSON_NODE_OBJECT;
#line 10911 "GOGGame.c"
	}
#line 909 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp20_) {
#line 10915 "GOGGame.c"
		JsonNode* _tmp23_;
		JsonObject* _tmp24_;
#line 911 "../src/data/sources/gog/GOGGame.vala"
		_tmp23_ = json_node_new (JSON_NODE_OBJECT);
#line 911 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (root_node);
#line 911 "../src/data/sources/gog/GOGGame.vala"
		root_node = _tmp23_;
#line 912 "../src/data/sources/gog/GOGGame.vala"
		_tmp24_ = json_object_new ();
#line 912 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (root);
#line 912 "../src/data/sources/gog/GOGGame.vala"
		root = _tmp24_;
#line 10930 "GOGGame.c"
	} else {
		JsonNode* _tmp25_;
		JsonObject* _tmp26_;
		JsonObject* _tmp27_;
#line 916 "../src/data/sources/gog/GOGGame.vala"
		_tmp25_ = root_node;
#line 916 "../src/data/sources/gog/GOGGame.vala"
		_tmp26_ = json_node_get_object (_tmp25_);
#line 916 "../src/data/sources/gog/GOGGame.vala"
		_tmp27_ = _json_object_ref0 (_tmp26_);
#line 916 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (root);
#line 916 "../src/data/sources/gog/GOGGame.vala"
		root = _tmp27_;
#line 10945 "GOGGame.c"
	}
#line 919 "../src/data/sources/gog/GOGGame.vala"
	_tmp28_ = root;
#line 919 "../src/data/sources/gog/GOGGame.vala"
	_tmp29_ = self->id;
#line 919 "../src/data/sources/gog/GOGGame.vala"
	_tmp30_ = self->filename;
#line 919 "../src/data/sources/gog/GOGGame.vala"
	json_object_set_string_member (_tmp28_, _tmp29_, _tmp30_);
#line 920 "../src/data/sources/gog/GOGGame.vala"
	_tmp31_ = root_node;
#line 920 "../src/data/sources/gog/GOGGame.vala"
	_tmp32_ = root;
#line 920 "../src/data/sources/gog/GOGGame.vala"
	json_node_set_object (_tmp31_, _tmp32_);
#line 922 "../src/data/sources/gog/GOGGame.vala"
	_tmp33_ = root_node;
#line 922 "../src/data/sources/gog/GOGGame.vala"
	_tmp34_ = json_to_string (_tmp33_, TRUE);
#line 922 "../src/data/sources/gog/GOGGame.vala"
	json = _tmp34_;
#line 10967 "GOGGame.c"
	{
		GFile* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
#line 926 "../src/data/sources/gog/GOGGame.vala"
		_tmp35_ = file;
#line 926 "../src/data/sources/gog/GOGGame.vala"
		_tmp36_ = g_file_get_path (_tmp35_);
#line 926 "../src/data/sources/gog/GOGGame.vala"
		_tmp37_ = _tmp36_;
#line 926 "../src/data/sources/gog/GOGGame.vala"
		_tmp38_ = json;
#line 926 "../src/data/sources/gog/GOGGame.vala"
		g_file_set_contents (_tmp37_, _tmp38_, (gssize) -1, &_inner_error0_);
#line 926 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp37_);
#line 926 "../src/data/sources/gog/GOGGame.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10987 "GOGGame.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp39_;
		const gchar* _tmp40_;
#line 924 "../src/data/sources/gog/GOGGame.vala"
		e = _inner_error0_;
#line 924 "../src/data/sources/gog/GOGGame.vala"
		_inner_error0_ = NULL;
#line 930 "../src/data/sources/gog/GOGGame.vala"
		_tmp39_ = e;
#line 930 "../src/data/sources/gog/GOGGame.vala"
		_tmp40_ = _tmp39_->message;
#line 930 "../src/data/sources/gog/GOGGame.vala"
		g_warning ("GOGGame.vala:930: [GOGGame.BonusContent.save_filename] %s", _tmp40_);
#line 924 "../src/data/sources/gog/GOGGame.vala"
		_g_error_free0 (e);
#line 11009 "GOGGame.c"
	}
	__finally0:
#line 924 "../src/data/sources/gog/GOGGame.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 924 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (json);
#line 924 "../src/data/sources/gog/GOGGame.vala"
		_json_object_unref0 (root);
#line 924 "../src/data/sources/gog/GOGGame.vala"
		__vala_JsonNode_free0 (root_node);
#line 924 "../src/data/sources/gog/GOGGame.vala"
		_g_object_unref0 (file);
#line 924 "../src/data/sources/gog/GOGGame.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 924 "../src/data/sources/gog/GOGGame.vala"
		g_clear_error (&_inner_error0_);
#line 924 "../src/data/sources/gog/GOGGame.vala"
		return;
#line 11028 "GOGGame.c"
	}
#line 893 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (json);
#line 893 "../src/data/sources/gog/GOGGame.vala"
	_json_object_unref0 (root);
#line 893 "../src/data/sources/gog/GOGGame.vala"
	__vala_JsonNode_free0 (root_node);
#line 893 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (file);
#line 11038 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameBonusContentStatus*
game_hub_data_sources_gog_gog_game_bonus_content_get_status (GameHubDataSourcesGOGGOGGameBonusContent* self)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus* result;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp0_;
#line 757 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 757 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->_status;
#line 757 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp0_;
#line 757 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 11054 "GOGGame.c"
}

static gpointer
_game_hub_data_sources_gog_gog_game_bonus_content_status_ref0 (gpointer self)
{
#line 758 "../src/data/sources/gog/GOGGame.vala"
	return self ? game_hub_data_sources_gog_gog_game_bonus_content_status_ref (self) : NULL;
#line 11062 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_bonus_content_set_status (GameHubDataSourcesGOGGOGGameBonusContent* self,
                                                             GameHubDataSourcesGOGGOGGameBonusContentStatus* value)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp0_;
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp1_;
#line 758 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 758 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _game_hub_data_sources_gog_gog_game_bonus_content_status_ref0 (value);
#line 758 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_sources_gog_gog_game_bonus_content_status_unref0 (self->_status);
#line 758 "../src/data/sources/gog/GOGGame.vala"
	self->_status = _tmp0_;
#line 758 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = self->_status;
#line 758 "../src/data/sources/gog/GOGGame.vala"
	g_signal_emit (self, game_hub_data_sources_gog_gog_game_bonus_content_signals[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS_CHANGE_SIGNAL], 0, _tmp1_);
#line 11083 "GOGGame.c"
}

gchar*
game_hub_data_sources_gog_gog_game_bonus_content_get_text (GameHubDataSourcesGOGGOGGameBonusContent* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 765 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 765 "../src/data/sources/gog/GOGGame.vala"
	if (self->count > ((gint64) 1)) {
#line 11095 "GOGGame.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, self->count);
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp2_ = _tmp1_;
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp3_ = self->name;
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp4_ = string_to_string (_tmp3_);
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp5_ = g_strconcat (_tmp2_, " ", _tmp4_, NULL);
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp0_);
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _tmp5_;
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp2_);
#line 11117 "GOGGame.c"
	} else {
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp6_ = self->name;
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_g_free0 (_tmp0_);
#line 765 "../src/data/sources/gog/GOGGame.vala"
		_tmp0_ = _tmp7_;
#line 11129 "GOGGame.c"
	}
#line 765 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp0_;
#line 765 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 11135 "GOGGame.c"
}

const gchar*
game_hub_data_sources_gog_gog_game_bonus_content_get_icon (GameHubDataSourcesGOGGOGGameBonusContent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	static GQuark _tmp2_label0 = 0;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	static GQuark _tmp2_label1 = 0;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	static GQuark _tmp2_label2 = 0;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	static GQuark _tmp2_label3 = 0;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	static GQuark _tmp2_label4 = 0;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	static GQuark _tmp2_label5 = 0;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	static GQuark _tmp2_label6 = 0;
#line 769 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 771 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->type;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _tmp0_;
#line 771 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 771 "../src/data/sources/gog/GOGGame.vala"
	if ((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("wallpapers")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("images"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("avatars"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("artworks"))))) {
#line 771 "../src/data/sources/gog/GOGGame.vala"
		switch (0) {
#line 11171 "GOGGame.c"
			default:
			{
#line 777 "../src/data/sources/gog/GOGGame.vala"
				result = "folder-pictures-symbolic";
#line 777 "../src/data/sources/gog/GOGGame.vala"
				return result;
#line 11178 "GOGGame.c"
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("audio")))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("soundtrack"))))) {
#line 771 "../src/data/sources/gog/GOGGame.vala"
		switch (0) {
#line 11184 "GOGGame.c"
			default:
			{
#line 781 "../src/data/sources/gog/GOGGame.vala"
				result = "folder-music-symbolic";
#line 781 "../src/data/sources/gog/GOGGame.vala"
				return result;
#line 11191 "GOGGame.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("video")))) {
#line 771 "../src/data/sources/gog/GOGGame.vala"
		switch (0) {
#line 11197 "GOGGame.c"
			default:
			{
#line 784 "../src/data/sources/gog/GOGGame.vala"
				result = "folder-videos-symbolic";
#line 784 "../src/data/sources/gog/GOGGame.vala"
				return result;
#line 11204 "GOGGame.c"
			}
		}
	} else {
#line 771 "../src/data/sources/gog/GOGGame.vala"
		switch (0) {
#line 11210 "GOGGame.c"
			default:
			{
#line 786 "../src/data/sources/gog/GOGGame.vala"
				result = "folder-documents-symbolic";
#line 786 "../src/data/sources/gog/GOGGame.vala"
				return result;
#line 11217 "GOGGame.c"
			}
		}
	}
}

static void
g_cclosure_user_marshal_VOID__GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS (GClosure * closure,
                                                                                       GValue * return_value,
                                                                                       guint n_param_values,
                                                                                       const GValue * param_values,
                                                                                       gpointer invocation_hint,
                                                                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (n_param_values == 2);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		data1 = closure->data;
#line 737 "../src/data/sources/gog/GOGGame.vala"
		data2 = param_values->data[0].v_pointer;
#line 11245 "GOGGame.c"
	} else {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		data1 = param_values->data[0].v_pointer;
#line 737 "../src/data/sources/gog/GOGGame.vala"
		data2 = closure->data;
#line 11251 "GOGGame.c"
	}
#line 737 "../src/data/sources/gog/GOGGame.vala"
	callback = (GMarshalFunc_VOID__GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS) (marshal_data ? marshal_data : cc->callback);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	callback (data1, game_hub_data_sources_gog_gog_game_bonus_content_value_get_status (param_values + 1), data2);
#line 11257 "GOGGame.c"
}

static gpointer
_game_hub_utils_downloader_download_ref0 (gpointer self)
{
#line 943 "../src/data/sources/gog/GOGGame.vala"
	return self ? game_hub_utils_downloader_download_ref (self) : NULL;
#line 11265 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameBonusContentStatus*
game_hub_data_sources_gog_gog_game_bonus_content_status_construct (GType object_type,
                                                                   GameHubDataSourcesGOGGOGGameBonusContentState state,
                                                                   GameHubUtilsDownloaderDownload* download)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus* self = NULL;
	GameHubUtilsDownloaderDownload* _tmp0_;
#line 940 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameBonusContentStatus*) g_type_create_instance (object_type);
#line 942 "../src/data/sources/gog/GOGGame.vala"
	self->state = state;
#line 943 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _game_hub_utils_downloader_download_ref0 (download);
#line 943 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_utils_downloader_download_unref0 (self->download);
#line 943 "../src/data/sources/gog/GOGGame.vala"
	self->download = _tmp0_;
#line 940 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 11287 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameBonusContentStatus*
game_hub_data_sources_gog_gog_game_bonus_content_status_new (GameHubDataSourcesGOGGOGGameBonusContentState state,
                                                             GameHubUtilsDownloaderDownload* download)
{
#line 940 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_bonus_content_status_construct (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS, state, download);
#line 11296 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_value_status_init (GValue* value)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	value->data[0].v_pointer = NULL;
#line 11304 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_value_status_free_value (GValue* value)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (value->data[0].v_pointer) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_status_unref (value->data[0].v_pointer);
#line 11314 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_value_status_copy_value (const GValue* src_value,
                                                                          GValue* dest_value)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (src_value->data[0].v_pointer) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		dest_value->data[0].v_pointer = game_hub_data_sources_gog_gog_game_bonus_content_status_ref (src_value->data[0].v_pointer);
#line 11326 "GOGGame.c"
	} else {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		dest_value->data[0].v_pointer = NULL;
#line 11330 "GOGGame.c"
	}
}

static gpointer
game_hub_data_sources_gog_gog_game_bonus_content_value_status_peek_pointer (const GValue* value)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	return value->data[0].v_pointer;
#line 11339 "GOGGame.c"
}

static gchar*
game_hub_data_sources_gog_gog_game_bonus_content_value_status_collect_value (GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (collect_values[0].v_pointer) {
#line 11350 "GOGGame.c"
		GameHubDataSourcesGOGGOGGameBonusContentStatus * object;
		object = collect_values[0].v_pointer;
#line 934 "../src/data/sources/gog/GOGGame.vala"
		if (object->parent_instance.g_class == NULL) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11357 "GOGGame.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11361 "GOGGame.c"
		}
#line 934 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = game_hub_data_sources_gog_gog_game_bonus_content_status_ref (object);
#line 11365 "GOGGame.c"
	} else {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = NULL;
#line 11369 "GOGGame.c"
	}
#line 934 "../src/data/sources/gog/GOGGame.vala"
	return NULL;
#line 11373 "GOGGame.c"
}

static gchar*
game_hub_data_sources_gog_gog_game_bonus_content_value_status_lcopy_value (const GValue* value,
                                                                           guint n_collect_values,
                                                                           GTypeCValue* collect_values,
                                                                           guint collect_flags)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus ** object_p;
	object_p = collect_values[0].v_pointer;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (!object_p) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 11388 "GOGGame.c"
	}
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (!value->data[0].v_pointer) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		*object_p = NULL;
#line 11394 "GOGGame.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		*object_p = value->data[0].v_pointer;
#line 11398 "GOGGame.c"
	} else {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		*object_p = game_hub_data_sources_gog_gog_game_bonus_content_status_ref (value->data[0].v_pointer);
#line 11402 "GOGGame.c"
	}
#line 934 "../src/data/sources/gog/GOGGame.vala"
	return NULL;
#line 11406 "GOGGame.c"
}

GParamSpec*
game_hub_data_sources_gog_gog_game_bonus_content_param_spec_status (const gchar* name,
                                                                    const gchar* nick,
                                                                    const gchar* blurb,
                                                                    GType object_type,
                                                                    GParamFlags flags)
{
	GameHubDataSourcesGOGGOGGameBonusContentParamSpecStatus* spec;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS), NULL);
#line 934 "../src/data/sources/gog/GOGGame.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 934 "../src/data/sources/gog/GOGGame.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	return G_PARAM_SPEC (spec);
#line 11425 "GOGGame.c"
}

gpointer
game_hub_data_sources_gog_gog_game_bonus_content_value_get_status (const GValue* value)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS), NULL);
#line 934 "../src/data/sources/gog/GOGGame.vala"
	return value->data[0].v_pointer;
#line 11435 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_bonus_content_value_set_status (GValue* value,
                                                                   gpointer v_object)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus * old;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS));
#line 934 "../src/data/sources/gog/GOGGame.vala"
	old = value->data[0].v_pointer;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (v_object) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS));
#line 934 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 934 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = v_object;
#line 934 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_status_ref (value->data[0].v_pointer);
#line 11457 "GOGGame.c"
	} else {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = NULL;
#line 11461 "GOGGame.c"
	}
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (old) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_status_unref (old);
#line 11467 "GOGGame.c"
	}
}

void
game_hub_data_sources_gog_gog_game_bonus_content_value_take_status (GValue* value,
                                                                    gpointer v_object)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus * old;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS));
#line 934 "../src/data/sources/gog/GOGGame.vala"
	old = value->data[0].v_pointer;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (v_object) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS));
#line 934 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 934 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = v_object;
#line 11488 "GOGGame.c"
	} else {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = NULL;
#line 11492 "GOGGame.c"
	}
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (old) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_status_unref (old);
#line 11498 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_status_class_init (GameHubDataSourcesGOGGOGGameBonusContentStatusClass * klass,
                                                                    gpointer klass_data)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_status_parent_class = g_type_class_peek_parent (klass);
#line 934 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataSourcesGOGGOGGameBonusContentStatusClass *) klass)->finalize = game_hub_data_sources_gog_gog_game_bonus_content_status_finalize;
#line 11510 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_status_instance_init (GameHubDataSourcesGOGGOGGameBonusContentStatus * self,
                                                                       gpointer klass)
{
#line 934 "../src/data/sources/gog/GOGGame.vala"
	self->ref_count = 1;
#line 11519 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_status_finalize (GameHubDataSourcesGOGGOGGameBonusContentStatus * obj)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus * self;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS, GameHubDataSourcesGOGGOGGameBonusContentStatus);
#line 934 "../src/data/sources/gog/GOGGame.vala"
	g_signal_handlers_destroy (self);
#line 938 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_utils_downloader_download_unref0 (self->download);
#line 11532 "GOGGame.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_bonus_content_status_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { game_hub_data_sources_gog_gog_game_bonus_content_value_status_init, game_hub_data_sources_gog_gog_game_bonus_content_value_status_free_value, game_hub_data_sources_gog_gog_game_bonus_content_value_status_copy_value, game_hub_data_sources_gog_gog_game_bonus_content_value_status_peek_pointer, "p", game_hub_data_sources_gog_gog_game_bonus_content_value_status_collect_value, "p", game_hub_data_sources_gog_gog_game_bonus_content_value_status_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesGOGGOGGameBonusContentStatusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_gog_gog_game_bonus_content_status_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesGOGGOGGameBonusContentStatus), 0, (GInstanceInitFunc) game_hub_data_sources_gog_gog_game_bonus_content_status_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_hub_data_sources_gog_gog_game_bonus_content_status_type_id;
	game_hub_data_sources_gog_gog_game_bonus_content_status_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataSourcesGOGGOGGameBonusContentStatus", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return game_hub_data_sources_gog_gog_game_bonus_content_status_type_id;
}

GType
game_hub_data_sources_gog_gog_game_bonus_content_status_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_bonus_content_status_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_bonus_content_status_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_bonus_content_status_type_id;
		game_hub_data_sources_gog_gog_game_bonus_content_status_type_id = game_hub_data_sources_gog_gog_game_bonus_content_status_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_bonus_content_status_type_id__volatile, game_hub_data_sources_gog_gog_game_bonus_content_status_type_id);
	}
	return game_hub_data_sources_gog_gog_game_bonus_content_status_type_id__volatile;
}

gpointer
game_hub_data_sources_gog_gog_game_bonus_content_status_ref (gpointer instance)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus * self;
	self = instance;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	g_atomic_int_inc (&self->ref_count);
#line 934 "../src/data/sources/gog/GOGGame.vala"
	return instance;
#line 11567 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_bonus_content_status_unref (gpointer instance)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus * self;
	self = instance;
#line 934 "../src/data/sources/gog/GOGGame.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 934 "../src/data/sources/gog/GOGGame.vala"
		GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS_GET_CLASS (self)->finalize (self);
#line 934 "../src/data/sources/gog/GOGGame.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 11581 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_value_bonus_content_init (GValue* value)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	value->data[0].v_pointer = NULL;
#line 11590 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_value_bonus_content_free_value (GValue* value)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (value->data[0].v_pointer) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_unref (value->data[0].v_pointer);
#line 11600 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_value_bonus_content_copy_value (const GValue* src_value,
                                                                   GValue* dest_value)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (src_value->data[0].v_pointer) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		dest_value->data[0].v_pointer = game_hub_data_sources_gog_gog_game_bonus_content_ref (src_value->data[0].v_pointer);
#line 11612 "GOGGame.c"
	} else {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		dest_value->data[0].v_pointer = NULL;
#line 11616 "GOGGame.c"
	}
}

static gpointer
game_hub_data_sources_gog_gog_game_value_bonus_content_peek_pointer (const GValue* value)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return value->data[0].v_pointer;
#line 11625 "GOGGame.c"
}

static gchar*
game_hub_data_sources_gog_gog_game_value_bonus_content_collect_value (GValue* value,
                                                                      guint n_collect_values,
                                                                      GTypeCValue* collect_values,
                                                                      guint collect_flags)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (collect_values[0].v_pointer) {
#line 11636 "GOGGame.c"
		GameHubDataSourcesGOGGOGGameBonusContent * object;
		object = collect_values[0].v_pointer;
#line 737 "../src/data/sources/gog/GOGGame.vala"
		if (object->parent_instance.g_class == NULL) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11643 "GOGGame.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11647 "GOGGame.c"
		}
#line 737 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = game_hub_data_sources_gog_gog_game_bonus_content_ref (object);
#line 11651 "GOGGame.c"
	} else {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = NULL;
#line 11655 "GOGGame.c"
	}
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return NULL;
#line 11659 "GOGGame.c"
}

static gchar*
game_hub_data_sources_gog_gog_game_value_bonus_content_lcopy_value (const GValue* value,
                                                                    guint n_collect_values,
                                                                    GTypeCValue* collect_values,
                                                                    guint collect_flags)
{
	GameHubDataSourcesGOGGOGGameBonusContent ** object_p;
	object_p = collect_values[0].v_pointer;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (!object_p) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 11674 "GOGGame.c"
	}
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (!value->data[0].v_pointer) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		*object_p = NULL;
#line 11680 "GOGGame.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		*object_p = value->data[0].v_pointer;
#line 11684 "GOGGame.c"
	} else {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		*object_p = game_hub_data_sources_gog_gog_game_bonus_content_ref (value->data[0].v_pointer);
#line 11688 "GOGGame.c"
	}
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return NULL;
#line 11692 "GOGGame.c"
}

GParamSpec*
game_hub_data_sources_gog_gog_game_param_spec_bonus_content (const gchar* name,
                                                             const gchar* nick,
                                                             const gchar* blurb,
                                                             GType object_type,
                                                             GParamFlags flags)
{
	GameHubDataSourcesGOGGOGGameParamSpecBonusContent* spec;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT), NULL);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return G_PARAM_SPEC (spec);
#line 11711 "GOGGame.c"
}

gpointer
game_hub_data_sources_gog_gog_game_value_get_bonus_content (const GValue* value)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT), NULL);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return value->data[0].v_pointer;
#line 11721 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_value_set_bonus_content (GValue* value,
                                                            gpointer v_object)
{
	GameHubDataSourcesGOGGOGGameBonusContent * old;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT));
#line 737 "../src/data/sources/gog/GOGGame.vala"
	old = value->data[0].v_pointer;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (v_object) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT));
#line 737 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 737 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = v_object;
#line 737 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_ref (value->data[0].v_pointer);
#line 11743 "GOGGame.c"
	} else {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = NULL;
#line 11747 "GOGGame.c"
	}
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (old) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_unref (old);
#line 11753 "GOGGame.c"
	}
}

void
game_hub_data_sources_gog_gog_game_value_take_bonus_content (GValue* value,
                                                             gpointer v_object)
{
	GameHubDataSourcesGOGGOGGameBonusContent * old;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT));
#line 737 "../src/data/sources/gog/GOGGame.vala"
	old = value->data[0].v_pointer;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (v_object) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT));
#line 737 "../src/data/sources/gog/GOGGame.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 737 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = v_object;
#line 11774 "GOGGame.c"
	} else {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		value->data[0].v_pointer = NULL;
#line 11778 "GOGGame.c"
	}
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (old) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_bonus_content_unref (old);
#line 11784 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_class_init (GameHubDataSourcesGOGGOGGameBonusContentClass * klass,
                                                             gpointer klass_data)
{
#line 737 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_parent_class = g_type_class_peek_parent (klass);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataSourcesGOGGOGGameBonusContentClass *) klass)->finalize = game_hub_data_sources_gog_gog_game_bonus_content_finalize;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_bonus_content_signals[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS_CHANGE_SIGNAL] = g_signal_new ("status-change", GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATUS, G_TYPE_NONE, 1, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_TYPE_STATUS);
#line 11798 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_instance_init (GameHubDataSourcesGOGGOGGameBonusContent * self,
                                                                gpointer klass)
{
	GameHubDataSourcesGOGGOGGameBonusContentStatus* _tmp0_;
#line 752 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = game_hub_data_sources_gog_gog_game_bonus_content_status_new (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_STATE_NOT_DOWNLOADED, NULL);
#line 752 "../src/data/sources/gog/GOGGame.vala"
	self->_status = _tmp0_;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	self->ref_count = 1;
#line 11812 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_bonus_content_finalize (GameHubDataSourcesGOGGOGGameBonusContent * obj)
{
	GameHubDataSourcesGOGGOGGameBonusContent * self;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT, GameHubDataSourcesGOGGOGGameBonusContent);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_signal_handlers_destroy (self);
#line 741 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->game);
#line 743 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->id);
#line 744 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->name);
#line 745 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->type);
#line 747 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->file);
#line 750 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (self->filename);
#line 752 "../src/data/sources/gog/GOGGame.vala"
	_game_hub_data_sources_gog_gog_game_bonus_content_status_unref0 (self->_status);
#line 761 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->dl_info);
#line 763 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->downloaded_file);
#line 11841 "GOGGame.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_bonus_content_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { game_hub_data_sources_gog_gog_game_value_bonus_content_init, game_hub_data_sources_gog_gog_game_value_bonus_content_free_value, game_hub_data_sources_gog_gog_game_value_bonus_content_copy_value, game_hub_data_sources_gog_gog_game_value_bonus_content_peek_pointer, "p", game_hub_data_sources_gog_gog_game_value_bonus_content_collect_value, "p", game_hub_data_sources_gog_gog_game_value_bonus_content_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesGOGGOGGameBonusContentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_gog_gog_game_bonus_content_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesGOGGOGGameBonusContent), 0, (GInstanceInitFunc) game_hub_data_sources_gog_gog_game_bonus_content_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType game_hub_data_sources_gog_gog_game_bonus_content_type_id;
	game_hub_data_sources_gog_gog_game_bonus_content_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataSourcesGOGGOGGameBonusContent", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return game_hub_data_sources_gog_gog_game_bonus_content_type_id;
}

GType
game_hub_data_sources_gog_gog_game_bonus_content_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_bonus_content_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_bonus_content_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_bonus_content_type_id;
		game_hub_data_sources_gog_gog_game_bonus_content_type_id = game_hub_data_sources_gog_gog_game_bonus_content_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_bonus_content_type_id__volatile, game_hub_data_sources_gog_gog_game_bonus_content_type_id);
	}
	return game_hub_data_sources_gog_gog_game_bonus_content_type_id__volatile;
}

gpointer
game_hub_data_sources_gog_gog_game_bonus_content_ref (gpointer instance)
{
	GameHubDataSourcesGOGGOGGameBonusContent * self;
	self = instance;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	g_atomic_int_inc (&self->ref_count);
#line 737 "../src/data/sources/gog/GOGGame.vala"
	return instance;
#line 11876 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_bonus_content_unref (gpointer instance)
{
	GameHubDataSourcesGOGGOGGameBonusContent * self;
	self = instance;
#line 737 "../src/data/sources/gog/GOGGame.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 737 "../src/data/sources/gog/GOGGame.vala"
		GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_GET_CLASS (self)->finalize (self);
#line 737 "../src/data/sources/gog/GOGGame.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 11890 "GOGGame.c"
	}
}

GameHubDataSourcesGOGGOGGameDLC*
game_hub_data_sources_gog_gog_game_dlc_construct (GType object_type,
                                                  GameHubDataSourcesGOGGOGGame* game,
                                                  JsonNode* json_node)
{
	GameHubDataSourcesGOGGOGGameDLC * self = NULL;
	GameHubDataGameSource* _tmp0_;
	GameHubDataGameSource* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	GameHubDataSourcesGOGGOGGame* _tmp16_;
#line 965 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 965 "../src/data/sources/gog/GOGGame.vala"
	g_return_val_if_fail (json_node != NULL, NULL);
#line 967 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = game_hub_data_game_get_source ((GameHubDataGame*) game);
#line 967 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = _tmp0_;
#line 967 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameDLC*) game_hub_data_sources_gog_gog_game_construct (object_type, GAME_HUB_DATA_SOURCES_GOG_IS_GOG (_tmp1_) ? ((GameHubDataSourcesGOGGOG*) _tmp1_) : NULL, json_node);
#line 969 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = game_hub_data_game_get_icon ((GameHubDataGame*) game);
#line 969 "../src/data/sources/gog/GOGGame.vala"
	_tmp3_ = _tmp2_;
#line 969 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_icon ((GameHubDataGame*) self, _tmp3_);
#line 970 "../src/data/sources/gog/GOGGame.vala"
	_tmp4_ = game_hub_data_game_get_image ((GameHubDataGame*) game);
#line 970 "../src/data/sources/gog/GOGGame.vala"
	_tmp5_ = _tmp4_;
#line 970 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_image ((GameHubDataGame*) self, _tmp5_);
#line 972 "../src/data/sources/gog/GOGGame.vala"
	_tmp6_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) game);
#line 972 "../src/data/sources/gog/GOGGame.vala"
	_tmp7_ = _tmp6_;
#line 972 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) self, _tmp7_);
#line 973 "../src/data/sources/gog/GOGGame.vala"
	_tmp8_ = game_hub_data_runnable_get_work_dir ((GameHubDataRunnable*) game);
#line 973 "../src/data/sources/gog/GOGGame.vala"
	_tmp9_ = _tmp8_;
#line 973 "../src/data/sources/gog/GOGGame.vala"
	_tmp10_ = _tmp9_;
#line 973 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_work_dir ((GameHubDataRunnable*) self, _tmp10_);
#line 973 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_tmp10_);
#line 974 "../src/data/sources/gog/GOGGame.vala"
	_tmp11_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) game);
#line 974 "../src/data/sources/gog/GOGGame.vala"
	_tmp12_ = _tmp11_;
#line 974 "../src/data/sources/gog/GOGGame.vala"
	_tmp13_ = _tmp12_;
#line 974 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_executable ((GameHubDataRunnable*) self, _tmp13_);
#line 974 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_tmp13_);
#line 976 "../src/data/sources/gog/GOGGame.vala"
	_tmp14_ = game_hub_data_runnable_get_platforms ((GameHubDataRunnable*) game);
#line 976 "../src/data/sources/gog/GOGGame.vala"
	_tmp15_ = _tmp14_;
#line 976 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_platforms ((GameHubDataRunnable*) self, _tmp15_);
#line 978 "../src/data/sources/gog/GOGGame.vala"
	_tmp16_ = _g_object_ref0 (game);
#line 978 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->game);
#line 978 "../src/data/sources/gog/GOGGame.vala"
	self->game = _tmp16_;
#line 979 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 965 "../src/data/sources/gog/GOGGame.vala"
	return self;
#line 11981 "GOGGame.c"
}

GameHubDataSourcesGOGGOGGameDLC*
game_hub_data_sources_gog_gog_game_dlc_new (GameHubDataSourcesGOGGOGGame* game,
                                            JsonNode* json_node)
{
#line 965 "../src/data/sources/gog/GOGGame.vala"
	return game_hub_data_sources_gog_gog_game_dlc_construct (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, game, json_node);
#line 11990 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData* _data_;
	_data_ = _data;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->self);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData, _data_);
#line 12002 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_dlc_update_downloads_info (GameHubDataSourcesGOGGOGGameDLC* self,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData* _data_;
	GameHubDataSourcesGOGGOGGameDLC* _tmp0_;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	g_return_if_fail (self != NULL);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_data_free);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_co (_data_);
#line 12026 "GOGGame.c"
}

void
game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_finish (GameHubDataSourcesGOGGOGGameDLC* self,
                                                                     GAsyncResult* _res_)
{
	GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData* _data_;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 12036 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData* _data_;
#line 986 "../src/data/sources/gog/GOGGame.vala"
	_data_ = _user_data_;
#line 986 "../src/data/sources/gog/GOGGame.vala"
	_data_->_source_object_ = source_object;
#line 986 "../src/data/sources/gog/GOGGame.vala"
	_data_->_res_ = _res_;
#line 986 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_co (_data_);
#line 12053 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_co (GameHubDataSourcesGogGogGameDlcUpdateDownloadsInfoData* _data_)
{
#line 983 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 983 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 12063 "GOGGame.c"
		goto _state_0;
#line 983 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 12067 "GOGGame.c"
		goto _state_1;
		default:
#line 983 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 12072 "GOGGame.c"
	}
	_state_0:
#line 985 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp0_ = game_hub_data_game_get_info ((GameHubDataGame*) _data_->self);
#line 985 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 985 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_info_detailed ((GameHubDataGame*) _data_->self, _data_->_tmp1_);
#line 986 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 1;
#line 986 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_update_game_info ((GameHubDataGame*) _data_->self, game_hub_data_sources_gog_gog_game_dlc_update_downloads_info_ready, _data_);
#line 986 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12087 "GOGGame.c"
	_state_1:
#line 986 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_update_game_info_finish ((GameHubDataGame*) _data_->self, _data_->_res_);
#line 987 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_set_info_detailed ((GameHubDataGame*) _data_->self, NULL);
#line 983 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 983 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 983 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 983 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 12101 "GOGGame.c"
		}
	}
#line 983 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 983 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12108 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_real_update_status (GameHubDataRunnable* base)
{
	GameHubDataSourcesGOGGOGGameDLC * self;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
#line 990 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameDLC*) base;
#line 992 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->game;
#line 992 "../src/data/sources/gog/GOGGame.vala"
	if (_tmp0_ == NULL) {
#line 992 "../src/data/sources/gog/GOGGame.vala"
		return;
#line 12124 "GOGGame.c"
	}
#line 994 "../src/data/sources/gog/GOGGame.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (game_hub_data_sources_gog_gog_game_dlc_parent_class)->update_status ((GameHubDataRunnable*) G_TYPE_CHECK_INSTANCE_CAST (self, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame));
#line 12128 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_real_install_data_free (gpointer _data)
{
	GameHubDataSourcesGogGogGameDlcInstallData* _data_;
	_data_ = _data;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->self);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	g_slice_free (GameHubDataSourcesGogGogGameDlcInstallData, _data_);
#line 12140 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_real_install (GameHubDataRunnable* base,
                                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	GameHubDataSourcesGOGGOGGameDLC * self;
	GameHubDataSourcesGogGogGameDlcInstallData* _data_;
	GameHubDataSourcesGOGGOGGameDLC* _tmp0_;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameDLC*) base;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_slice_new0 (GameHubDataSourcesGogGogGameDlcInstallData);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_sources_gog_gog_game_dlc_real_install_data_free);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_->self = _tmp0_;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_->install_mode = install_mode;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_dlc_real_install_co (_data_);
#line 12168 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_install_finish (GameHubDataRunnable* base,
                                                       GAsyncResult* _res_)
{
	GameHubDataSourcesGogGogGameDlcInstallData* _data_;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 12178 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_install_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	GameHubDataSourcesGogGogGameDlcInstallData* _data_;
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	_data_ = _user_data_;
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	_data_->_source_object_ = source_object;
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	_data_->_res_ = _res_;
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_dlc_real_install_co (_data_);
#line 12195 "GOGGame.c"
}

static gboolean
game_hub_data_sources_gog_gog_game_dlc_real_install_co (GameHubDataSourcesGogGogGameDlcInstallData* _data_)
{
#line 997 "../src/data/sources/gog/GOGGame.vala"
	switch (_data_->_state_) {
#line 997 "../src/data/sources/gog/GOGGame.vala"
		case 0:
#line 12205 "GOGGame.c"
		goto _state_0;
#line 997 "../src/data/sources/gog/GOGGame.vala"
		case 1:
#line 12209 "GOGGame.c"
		goto _state_1;
#line 997 "../src/data/sources/gog/GOGGame.vala"
		case 2:
#line 12213 "GOGGame.c"
		goto _state_2;
#line 997 "../src/data/sources/gog/GOGGame.vala"
		case 3:
#line 12217 "GOGGame.c"
		goto _state_3;
#line 997 "../src/data/sources/gog/GOGGame.vala"
		case 4:
#line 12221 "GOGGame.c"
		goto _state_4;
#line 997 "../src/data/sources/gog/GOGGame.vala"
		case 5:
#line 12225 "GOGGame.c"
		goto _state_5;
		default:
#line 997 "../src/data/sources/gog/GOGGame.vala"
		g_assert_not_reached ();
#line 12230 "GOGGame.c"
	}
	_state_0:
#line 999 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp1_ = _data_->self->game;
#line 999 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp2_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->_tmp1_);
#line 999 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 999 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp3_ == NULL) {
#line 999 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = TRUE;
#line 12243 "GOGGame.c"
	} else {
#line 999 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp4_ = _data_->self->game;
#line 999 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp5_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->_tmp4_);
#line 999 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 999 "../src/data/sources/gog/GOGGame.vala"
		_data_->_tmp0_ = !g_file_query_exists (_data_->_tmp6_, NULL);
#line 12253 "GOGGame.c"
	}
#line 999 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_tmp0_) {
#line 999 "../src/data/sources/gog/GOGGame.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 999 "../src/data/sources/gog/GOGGame.vala"
		if (_data_->_state_ != 0) {
#line 999 "../src/data/sources/gog/GOGGame.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 999 "../src/data/sources/gog/GOGGame.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 12265 "GOGGame.c"
			}
		}
#line 999 "../src/data/sources/gog/GOGGame.vala"
		g_object_unref (_data_->_async_result);
#line 999 "../src/data/sources/gog/GOGGame.vala"
		return FALSE;
#line 12272 "GOGGame.c"
	}
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp7_ = _data_->self->game;
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 1;
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_umount_overlays ((GameHubDataGame*) _data_->_tmp7_, game_hub_data_sources_gog_gog_game_dlc_install_ready, _data_);
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12282 "GOGGame.c"
	_state_1:
#line 1001 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_umount_overlays_finish ((GameHubDataGame*) _data_->_tmp7_, _data_->_res_);
#line 1002 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp8_ = _data_->self->game;
#line 1002 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_enable_overlays ((GameHubDataGame*) _data_->_tmp8_);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp9_ = _data_->self->game;
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp10_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) _data_->self);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp12_ = g_strconcat ("dlc_", _data_->_tmp11_, NULL);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp14_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) _data_->self);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp16_ = g_strdup_printf (_ ("DLC: %s"), _data_->_tmp15_);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp18_ = game_hub_data_game_overlay_new ((GameHubDataGame*) _data_->_tmp9_, _data_->_tmp13_, _data_->_tmp17_, TRUE);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_data_->_tmp17_);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_g_free0 (_data_->_tmp13_);
#line 1003 "../src/data/sources/gog/GOGGame.vala"
	_data_->overlay = _data_->_tmp19_;
#line 1005 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp20_ = _data_->self->game;
#line 1005 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp21_ = _data_->overlay;
#line 1005 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp22_ = _data_->_tmp21_->directory;
#line 1005 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 2;
#line 1005 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) _data_->_tmp20_, _data_->_tmp22_, game_hub_data_sources_gog_gog_game_dlc_install_ready, _data_);
#line 1005 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12330 "GOGGame.c"
	_state_2:
#line 1005 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays_finish ((GameHubDataGame*) _data_->_tmp20_, _data_->_res_);
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp23_ = _data_->self->game;
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp24_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->_tmp23_);
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp26_ = g_file_get_child (_data_->_tmp25_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp27_ = _data_->_tmp26_;
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp28_ = g_file_get_child (_data_->_tmp27_, "_overlay");
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp30_ = g_file_get_child (_data_->_tmp29_, "merged");
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp31_ = _data_->_tmp30_;
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_runnable_set_install_dir ((GameHubDataRunnable*) _data_->self, _data_->_tmp31_);
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp31_);
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp29_);
#line 1007 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->_tmp27_);
#line 1009 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 3;
#line 1009 "../src/data/sources/gog/GOGGame.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (game_hub_data_sources_gog_gog_game_dlc_parent_class)->install ((GameHubDataRunnable*) G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame), _data_->install_mode, game_hub_data_sources_gog_gog_game_dlc_install_ready, _data_);
#line 1009 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12366 "GOGGame.c"
	_state_3:
#line 1009 "../src/data/sources/gog/GOGGame.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (game_hub_data_sources_gog_gog_game_dlc_parent_class)->install_finish ((GameHubDataRunnable*) G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame), _data_->_res_);
#line 1011 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp32_ = _data_->self->game;
#line 1011 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 4;
#line 1011 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_umount_overlays ((GameHubDataGame*) _data_->_tmp32_, game_hub_data_sources_gog_gog_game_dlc_install_ready, _data_);
#line 1011 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12378 "GOGGame.c"
	_state_4:
#line 1011 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_umount_overlays_finish ((GameHubDataGame*) _data_->_tmp32_, _data_->_res_);
#line 1013 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp33_ = _data_->self->game;
#line 1013 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp34_ = ((GameHubDataGame*) _data_->_tmp33_)->overlays;
#line 1013 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp35_ = _data_->overlay;
#line 1013 "../src/data/sources/gog/GOGGame.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp34_, _data_->_tmp35_);
#line 1014 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp36_ = _data_->self->game;
#line 1014 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_save_overlays ((GameHubDataGame*) _data_->_tmp36_);
#line 1015 "../src/data/sources/gog/GOGGame.vala"
	_data_->_tmp37_ = _data_->self->game;
#line 1015 "../src/data/sources/gog/GOGGame.vala"
	_data_->_state_ = 5;
#line 1015 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays ((GameHubDataGame*) _data_->_tmp37_, NULL, game_hub_data_sources_gog_gog_game_dlc_install_ready, _data_);
#line 1015 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12402 "GOGGame.c"
	_state_5:
#line 1015 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_game_mount_overlays_finish ((GameHubDataGame*) _data_->_tmp37_, _data_->_res_);
#line 997 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (_data_->overlay);
#line 997 "../src/data/sources/gog/GOGGame.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 997 "../src/data/sources/gog/GOGGame.vala"
	if (_data_->_state_ != 0) {
#line 997 "../src/data/sources/gog/GOGGame.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 997 "../src/data/sources/gog/GOGGame.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 12416 "GOGGame.c"
		}
	}
#line 997 "../src/data/sources/gog/GOGGame.vala"
	g_object_unref (_data_->_async_result);
#line 997 "../src/data/sources/gog/GOGGame.vala"
	return FALSE;
#line 12423 "GOGGame.c"
}

static GFile*
game_hub_data_sources_gog_gog_game_dlc_real_get_default_install_dir (GameHubDataRunnable* base)
{
	GFile* result;
	GameHubDataSourcesGOGGOGGameDLC* self;
	GameHubDataSourcesGOGGOGGame* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 959 "../src/data/sources/gog/GOGGame.vala"
	self = (GameHubDataSourcesGOGGOGGameDLC*) base;
#line 961 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = self->game;
#line 961 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = game_hub_data_runnable_get_default_install_dir ((GameHubDataRunnable*) _tmp0_);
#line 961 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = _tmp1_;
#line 961 "../src/data/sources/gog/GOGGame.vala"
	result = _tmp2_;
#line 961 "../src/data/sources/gog/GOGGame.vala"
	return result;
#line 12446 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_class_init (GameHubDataSourcesGOGGOGGameDLCClass * klass,
                                                   gpointer klass_data)
{
#line 953 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_dlc_parent_class = g_type_class_peek_parent (klass);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableClass *) klass)->update_status = (void (*) (GameHubDataRunnable*)) game_hub_data_sources_gog_gog_game_dlc_real_update_status;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableClass *) klass)->install = (void (*) (GameHubDataRunnable*, GameHubDataRunnableInstallerInstallMode, GAsyncReadyCallback, gpointer)) game_hub_data_sources_gog_gog_game_dlc_real_install;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableClass *) klass)->install_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_sources_gog_gog_game_dlc_install_finish;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->get_default_install_dir = game_hub_data_sources_gog_gog_game_dlc_real_get_default_install_dir;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_sources_gog_gog_game_dlc_get_property;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_sources_gog_gog_game_dlc_finalize;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_DEFAULT_INSTALL_DIR_PROPERTY, game_hub_data_sources_gog_gog_game_dlc_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_DEFAULT_INSTALL_DIR_PROPERTY] = g_param_spec_object ("default-install-dir", "default-install-dir", "default-install-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12469 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_dlc_instance_init (GameHubDataSourcesGOGGOGGameDLC * self,
                                                      gpointer klass)
{
}

static void
game_hub_data_sources_gog_gog_game_dlc_finalize (GObject * obj)
{
	GameHubDataSourcesGOGGOGGameDLC * self;
#line 953 "../src/data/sources/gog/GOGGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLC);
#line 955 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->game);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	G_OBJECT_CLASS (game_hub_data_sources_gog_gog_game_dlc_parent_class)->finalize (obj);
#line 12488 "GOGGame.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_dlc_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesGOGGOGGameDLCClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_gog_gog_game_dlc_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesGOGGOGGameDLC), 0, (GInstanceInitFunc) game_hub_data_sources_gog_gog_game_dlc_instance_init, NULL };
	GType game_hub_data_sources_gog_gog_game_dlc_type_id;
	game_hub_data_sources_gog_gog_game_dlc_type_id = g_type_register_static (GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, "GameHubDataSourcesGOGGOGGameDLC", &g_define_type_info, 0);
	return game_hub_data_sources_gog_gog_game_dlc_type_id;
}

GType
game_hub_data_sources_gog_gog_game_dlc_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_dlc_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_dlc_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_dlc_type_id;
		game_hub_data_sources_gog_gog_game_dlc_type_id = game_hub_data_sources_gog_gog_game_dlc_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_dlc_type_id__volatile, game_hub_data_sources_gog_gog_game_dlc_type_id);
	}
	return game_hub_data_sources_gog_gog_game_dlc_type_id__volatile;
}

static void
_vala_game_hub_data_sources_gog_gog_game_dlc_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	GameHubDataSourcesGOGGOGGameDLC * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLC);
#line 953 "../src/data/sources/gog/GOGGame.vala"
	switch (property_id) {
#line 953 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_DEFAULT_INSTALL_DIR_PROPERTY:
#line 953 "../src/data/sources/gog/GOGGame.vala"
		g_value_take_object (value, game_hub_data_runnable_get_default_install_dir ((GameHubDataRunnable*) self));
#line 953 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 12528 "GOGGame.c"
		default:
#line 953 "../src/data/sources/gog/GOGGame.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 953 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 12534 "GOGGame.c"
	}
}

static void
game_hub_data_sources_gog_gog_game_class_init (GameHubDataSourcesGOGGOGGameClass * klass,
                                               gpointer klass_data)
{
#line 25 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataSourcesGOGGOGGame_private_offset);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGameClass *) klass)->update_game_info = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_gog_gog_game_real_update_game_info;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGameClass *) klass)->update_game_info_finish = (void (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_sources_gog_gog_game_update_game_info_finish;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableClass *) klass)->install = (void (*) (GameHubDataRunnable*, GameHubDataRunnableInstallerInstallMode, GAsyncReadyCallback, gpointer)) game_hub_data_sources_gog_gog_game_real_install;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableClass *) klass)->install_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_sources_gog_gog_game_install_finish;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGameClass *) klass)->uninstall = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_gog_gog_game_real_uninstall;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGameClass *) klass)->uninstall_finish = (void (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_sources_gog_gog_game_uninstall_finish;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataRunnableClass *) klass)->update_status = (void (*) (GameHubDataRunnable*)) game_hub_data_sources_gog_gog_game_real_update_status;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGameClass *) klass)->load_achievements = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_sources_gog_gog_game_real_load_achievements;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	((GameHubDataGameClass *) klass)->load_achievements_finish = (GeeArrayList* (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_sources_gog_gog_game_load_achievements_finish;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->get_default_install_dir = game_hub_data_sources_gog_gog_game_real_get_default_install_dir;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_sources_gog_gog_game_get_property;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_sources_gog_gog_game_set_property;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_sources_gog_gog_game_finalize;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TWEAKS_PROPERTY, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TWEAKS_PROPERTY] = g_param_spec_boxed ("tweaks", "tweaks", "tweaks", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLERS_PROPERTY, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLERS_PROPERTY] = g_param_spec_object ("installers", "installers", "installers", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_PROPERTY, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_PROPERTY] = g_param_spec_object ("bonus-content", "bonus-content", "bonus-content", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_PROPERTY, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_PROPERTY] = g_param_spec_object ("dlc", "dlc", "dlc", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_DIR_PROPERTY, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_DIR_PROPERTY] = g_param_spec_object ("bonus-content-dir", "bonus-content-dir", "bonus-content-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_HAS_UPDATES_PROPERTY, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_HAS_UPDATES_PROPERTY] = g_param_spec_boolean ("has-updates", "has-updates", "has-updates", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/data/sources/gog/GOGGame.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DEFAULT_INSTALL_DIR_PROPERTY, game_hub_data_sources_gog_gog_game_properties[GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DEFAULT_INSTALL_DIR_PROPERTY] = g_param_spec_object ("default-install-dir", "default-install-dir", "default-install-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12586 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_game_hub_data_tweakable_game_interface_init (GameHubDataTweakableGameIface * iface,
                                                                                gpointer iface_data)
{
#line 25 "../src/data/sources/gog/GOGGame.vala"
	game_hub_data_sources_gog_gog_game_game_hub_data_tweakable_game_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	iface->get_tweaks = game_hub_data_sources_gog_gog_game_real_get_tweaks;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	iface->set_tweaks = game_hub_data_sources_gog_gog_game_real_set_tweaks;
#line 12599 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_instance_init (GameHubDataSourcesGOGGOGGame * self,
                                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	self->priv = game_hub_data_sources_gog_gog_game_get_instance_private (self);
#line 27 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_tweaks = NULL;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_tweaks_length1 = 0;
#line 27 "../src/data/sources/gog/GOGGame.vala"
	self->priv->__tweaks_size_ = self->priv->_tweaks_length1;
#line 29 "../src/data/sources/gog/GOGGame.vala"
	_tmp0_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, (GBoxedCopyFunc) game_hub_data_runnable_installer_ref, (GDestroyNotify) game_hub_data_runnable_installer_unref, NULL, NULL, NULL);
#line 29 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_installers = _tmp0_;
#line 30 "../src/data/sources/gog/GOGGame.vala"
	_tmp1_ = gee_array_list_new (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_BONUS_CONTENT, (GBoxedCopyFunc) game_hub_data_sources_gog_gog_game_bonus_content_ref, (GDestroyNotify) game_hub_data_sources_gog_gog_game_bonus_content_unref, NULL, NULL, NULL);
#line 30 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_bonus_content = _tmp1_;
#line 31 "../src/data/sources/gog/GOGGame.vala"
	_tmp2_ = gee_array_list_new (GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 31 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_dlc = _tmp2_;
#line 33 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_bonus_content_dir = NULL;
#line 35 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_has_updates = FALSE;
#line 45 "../src/data/sources/gog/GOGGame.vala"
	self->priv->game_info_updating = FALSE;
#line 46 "../src/data/sources/gog/GOGGame.vala"
	self->priv->game_info_updated = FALSE;
#line 461 "../src/data/sources/gog/GOGGame.vala"
	self->priv->loading_achievements = FALSE;
#line 12639 "GOGGame.c"
}

static void
game_hub_data_sources_gog_gog_game_finalize (GObject * obj)
{
	GameHubDataSourcesGOGGOGGame * self;
#line 25 "../src/data/sources/gog/GOGGame.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame);
#line 27 "../src/data/sources/gog/GOGGame.vala"
	self->priv->_tweaks = (_vala_array_free (self->priv->_tweaks, self->priv->_tweaks_length1, (GDestroyNotify) g_free), NULL);
#line 29 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->_installers);
#line 30 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->_bonus_content);
#line 31 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->_dlc);
#line 33 "../src/data/sources/gog/GOGGame.vala"
	_g_object_unref0 (self->priv->_bonus_content_dir);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	G_OBJECT_CLASS (game_hub_data_sources_gog_gog_game_parent_class)->finalize (obj);
#line 12660 "GOGGame.c"
}

 G_GNUC_NO_INLINE static GType
game_hub_data_sources_gog_gog_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameHubDataSourcesGOGGOGGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_sources_gog_gog_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataSourcesGOGGOGGame), 0, (GInstanceInitFunc) game_hub_data_sources_gog_gog_game_instance_init, NULL };
	static const GInterfaceInfo game_hub_data_tweakable_game_info = { (GInterfaceInitFunc) game_hub_data_sources_gog_gog_game_game_hub_data_tweakable_game_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType game_hub_data_sources_gog_gog_game_type_id;
	game_hub_data_sources_gog_gog_game_type_id = g_type_register_static (GAME_HUB_DATA_TYPE_GAME, "GameHubDataSourcesGOGGOGGame", &g_define_type_info, 0);
	g_type_add_interface_static (game_hub_data_sources_gog_gog_game_type_id, GAME_HUB_DATA_TYPE_TWEAKABLE_GAME, &game_hub_data_tweakable_game_info);
	GameHubDataSourcesGOGGOGGame_private_offset = g_type_add_instance_private (game_hub_data_sources_gog_gog_game_type_id, sizeof (GameHubDataSourcesGOGGOGGamePrivate));
	return game_hub_data_sources_gog_gog_game_type_id;
}

GType
game_hub_data_sources_gog_gog_game_get_type (void)
{
	static volatile gsize game_hub_data_sources_gog_gog_game_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_sources_gog_gog_game_type_id__volatile)) {
		GType game_hub_data_sources_gog_gog_game_type_id;
		game_hub_data_sources_gog_gog_game_type_id = game_hub_data_sources_gog_gog_game_get_type_once ();
		g_once_init_leave (&game_hub_data_sources_gog_gog_game_type_id__volatile, game_hub_data_sources_gog_gog_game_type_id);
	}
	return game_hub_data_sources_gog_gog_game_type_id__volatile;
}

static void
_vala_game_hub_data_sources_gog_gog_game_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	GameHubDataSourcesGOGGOGGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	switch (property_id) {
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TWEAKS_PROPERTY:
#line 12699 "GOGGame.c"
		{
			int length;
#line 25 "../src/data/sources/gog/GOGGame.vala"
			g_value_set_boxed (value, game_hub_data_tweakable_game_get_tweaks ((GameHubDataTweakableGame*) self, &length));
#line 12704 "GOGGame.c"
		}
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLERS_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		g_value_set_object (value, game_hub_data_sources_gog_gog_game_get_installers (self));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		g_value_set_object (value, game_hub_data_sources_gog_gog_game_get_bonus_content (self));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		g_value_set_object (value, game_hub_data_sources_gog_gog_game_get_dlc (self));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_DIR_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		g_value_set_object (value, game_hub_data_sources_gog_gog_game_get_bonus_content_dir (self));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_HAS_UPDATES_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		g_value_set_boolean (value, game_hub_data_sources_gog_gog_game_get_has_updates (self));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DEFAULT_INSTALL_DIR_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		g_value_take_object (value, game_hub_data_runnable_get_default_install_dir ((GameHubDataRunnable*) self));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 12744 "GOGGame.c"
		default:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 12750 "GOGGame.c"
	}
}

static void
_vala_game_hub_data_sources_gog_gog_game_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	GameHubDataSourcesGOGGOGGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame);
#line 25 "../src/data/sources/gog/GOGGame.vala"
	switch (property_id) {
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TWEAKS_PROPERTY:
#line 12766 "GOGGame.c"
		{
			gpointer boxed;
#line 25 "../src/data/sources/gog/GOGGame.vala"
			boxed = g_value_get_boxed (value);
#line 25 "../src/data/sources/gog/GOGGame.vala"
			game_hub_data_tweakable_game_set_tweaks ((GameHubDataTweakableGame*) self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 12773 "GOGGame.c"
		}
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_INSTALLERS_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_set_installers (self, g_value_get_object (value));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_set_bonus_content (self, g_value_get_object (value));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_set_dlc (self, g_value_get_object (value));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_BONUS_CONTENT_DIR_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_set_bonus_content_dir (self, g_value_get_object (value));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 25 "../src/data/sources/gog/GOGGame.vala"
		case GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_HAS_UPDATES_PROPERTY:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		game_hub_data_sources_gog_gog_game_set_has_updates (self, g_value_get_boolean (value));
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 12807 "GOGGame.c"
		default:
#line 25 "../src/data/sources/gog/GOGGame.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/data/sources/gog/GOGGame.vala"
		break;
#line 12813 "GOGGame.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

